local _app = Fenix.App.GetInstance()
local _traceback = _app.debug

return class {
    gameObject = {
        getter = function (self)
            return _app.gameObject
        end, 
    },

    traceback = {
        getter = function (self) return _traceback end , 
        setter = function (self, newValue)
            if newValue ~= _traceback then 
                _traceback = newValue
                Fenix.App.SetTracebackEnabled(_traceback)
            end
        end, 
    },

    quit = function (self)
        Application.Quit()
    end, 

    addSearchPath = function (self, searchPath)
        Fenix.App.AddSearchPath(searchPath)
    end, 
    
    startCoroutine = function (self, func)
        --Fenix.Scripting.Helper.StartCoroutine(_app, func)
        return _app:StartCoroutine(func)
    end, 

    stopCoroutine = function(self, coroutine)
        log.info("### stopCoroutine!")
        log.info(debug.traceback())

        _app:StopCoroutine(coroutine)
    end,

    -- 是否勾了 GameApp 上的 debug
    isDebug = function(self)
        return Fenix.App.GetInstance().debug
    end,

    -- 是否启用小内存模式
    isSmallMemory = function(self)
        --return true
        return Fenix.App.GetInstance().isSmallMemory
    end,

    -- 调用 java
    callJava = function(self, strFuncName)
        return Fenix.App.GetInstance():CallJava(strFuncName)
    end,

    -- 在服务器打点记 log
    logEvent = function(self, _action, _event)
        if self.use_sdk_login == nil then
            self.use_sdk_login = Fenix.App.GetInstance().m_UseSDKLogin
        end

        if self.use_sdk_login then
            Fenix.App.GetInstance():LogEvent(_action, _event)
        end
    end,


}.new()
