-- local dispatcher = require "base.dispatcher"
-- local d = dispatcher.new()
-- d:register("test", function (a)
--     print("on_test", a)
--   end)
-- d:dispatch("test", 123)
-- local s = "OnEvent"
-- print(string.sub(s, 0, 2))
-- for k, v in pairs(string) do 
--   print(k, v)
-- end

return class {
    ctor = function (self)
        self._events = {}
    end, 

    get_event = function (self, evt)
        local t = self._events[evt]
        if t == nil then 
            t = { __size = 0, __handle = {} }
            self._events[evt] = t
        end
        return t
    end, 
    
    clear = function (self, evt)
      local t = self._events[evt]
      if t then 
        self._events[evt] = nil
      end
    end,

    dispatch = function (self, evt, ...)
        local evt_t = self._events[evt]
        if evt_t then 
            local h = evt_t.__handle
            local k, v
            for k,v in pairs(h) do 
                k(...)
            end
        end
    end,

    register = function (self, evt, handler)
        local evt_t = self:get_event(evt)
        
        evt_t.__size = evt_t.__size + 1
        evt_t.__handle[handler] = true
    end, 

    unregister = function (self, evt, handler)
        local evt_t = self:get_event(evt)
        
        evt_t.__size = evt_t.__size - 1
        evt_t.__handle[handler] = nil
    end, 
}
