local super = require("bt.node")
local states = super.states
local log = logger.get("Game", "BT")

return class {
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
        self.children = {}
        self.curr_child_idx = 1  -- 当前子结点(正运行中的)索引
    end, 

    setContext = function (self, ctx)
        for _, child in ipairs(self.children) do 
            --log.info(child.typename)
            child:setContext(ctx)
        end
    end, 

    add = function (self, node)

        table.insert(self.children, node)
        return self
    end, 

    reset = function(self)
        local c = self.children[self.curr_child_idx]
        if c then
            c:reset()
        end
        self.curr_child_idx = 1
    end,

    clone = function (self)
        local inst = self.class.new()
        for _, child in ipairs(self.children) do 
            inst:add(child:clone())
        end
        return inst
    end, 

    isComposite= function(self)
        return true
    end,
}
