local super = require("bt.action")
local log = logger.get("Game", "Delay")
local states = super.states

return class {
    super = super, 

    ctor = function (self, min, max)
        super.ctor(self)
        self.min = min
        self.max = max or min

        self:resetTime()
    end, 

    update = function (self, dt)
        self.elapsed = self.elapsed - dt
        if self.elapsed < 0 then 
            -- delay 结束，重置时间
            self:resetTime()
            return states.SUCCESS
        end
        return states.RUNNING
    end, 

    resetTime = function (self)
        if self.min ~= self.max then
            --log.info('delay!!')
            self.elapsed = self.min + math.random() * (self.max - self.min)
        else
            self.elapsed = self.min
        end
    end, 

    clone = function (self)
        return self.class.new(self.min, self.max)
    end, 
}