local log = logger.get("Game", "BT")
local super = require("bt.node")
local states = super.states

-- 依次执行子结点，发现有失败就返回失败。执行完成后返回成功
return class {
    typename = "取反节点", 
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
        self.child = select(1, ...)
    end,

    setContext = function (self, ctx)
        self.ctx = ctx
        self.child:setContext(ctx)
    end, 

    -- 重置
    reset = function(self)
        self.child:reset()
    end,

    update = function (self, dt)
        --log.info("sequence update.")
        self.state = self.child:update(dt)
        if self.state == states.FAILURE then 
            -- log.info('sequence failed')
            return states.SUCCESS
        elseif self.state == states.RUNNING then
            -- log.info('sequence running')
            return states.RUNNING
        else -- success
            return states.FAILURE
        end
    end, 

    clone = function (self)
        local inst = self.class.new(self.child:clone())
        return inst
    end, 
}