local log = logger.get("Game", "BT")
local super = require("bt.sequence")
local states = super.states

-- 依次执行子结点，发现有失败就返回失败。执行完成后返回成功
return class {
    typename = "循环结点", 
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
        self.condition = select(1, ...)
    end,

    setContext = function (self, ctx)
        self.ctx = ctx
        self.condition:setContext(ctx)
        super.setContext(self, ctx)
    end, 

    update = function (self, dt)

        local state = self.condition:update(dt)

        if state == states.SUCCESS then
            return states.SUCCESS
        else
            -- 执行 sequence 的 update
            local rst = super.update(self, dt)
            return states.RUNNING
        end
    end, 
}