local log = logger.get("Game", "BT")

-- 行为树基本结点
return class {

    typename = "行为树基本结点",

    -- 行为树结点执行结果
    states = enum {
        "SUCCESS",  -- 成功
        "FAILURE",  -- 失败
        "RUNNING",  -- 执行中
    }, 


    setContext = function (self, ctx)
        self.ctx = ctx
    end, 

    destroy = function (self)
        if self.__mgr then 
            self.__mgr:add(self)
        end
    end, 

    -- 重置
    reset = function(self)
    end,

    -- 执行一次,返回执行状态 只有当前结点及其父结点的 update 会被执行
    update = function(self, dt)
        log.error('子类应该重写 update 函数')
        return self.states.SUCCESS
    end,

    --  是否是条件结点
    isCondition = function(self)
        return false
    end,

    -- 是否是行为结点
    isAction = function(self)
        return false
    end,

    -- 是否是组合结点
    isComposite = function(self)
        return false
    end,
}
