local super = require("bt.composite")
local states = super.states
local log = logger.get("Game", "BT")

return class {
    typename = "并发节点", 
    super = super, 

    ctor = function(self, ...)
        super.ctor(self, ...)

        self.inited = false
        self.child_states = {}
    end,

    update = function (self, dt)

        --log.info('parallel update!!')
        if not self.inited then
            for i = 1, #self.children, 1 do
                self.child_states[i] = states.RUNNING
            end

            self.inited = true
        end

        local finished = true
        for i,child in ipairs(self.children) do
            if self.child_states[i] == states.RUNNING then
                self.child_states[i] = child:update(dt)
                --log.info('parallel child update:'..tostring(self.child_states[i]))
                if self.child_states[i] == states.RUNNING then
                    finished = false
                end
            end
        end

        if finished then
            self.inited = false
            return states.SUCCESS
        else
            return states.RUNNING
        end
    end, 
}