local log = logger.get("Game", "BT")
local super = require("bt.sequence")
local states = super.states

-- 依次执行子结点，发现有失败就返回失败。执行完成后返回成功
return class {
    typename = "作为随机选择结点子结点的顺序节点", 
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
        self.random_rate = select(1, ...) or 100
    end,

    clone = function (self)
        local inst = self.class.new()
        for _, child in ipairs(self.children) do 
            inst:add(child:clone())
        end
        return inst
    end, 
}