local log = logger.get("Game", "BT")
local super = require("bt.composite")
local states = super.states

-- 依次执行子结点。子结点失败继续执行。发现成功就返回成功
return class {
    typename = "随机选择结点", 
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
        self.curr_child = nil
    end,

    update = function (self, dt)
        --log.debug("select update.")

        if not self.curr_child then
            if not self.sum_rate then
                self.sum_rate = 0
                for k,v in ipairs(self.children) do
                    self.sum_rate = self.sum_rate + (v.random_rate or 0)
                end
            end

            local value = math.random(0, self.sum_rate)
            for k,v in ipairs(self.children) do
                value = value - (v.random_rate or 0)
                if value <= 0 then
                    self.curr_child = v
                    break
                end
            end
        end

        if self.curr_child then 
            self.state = self.curr_child:update(dt)
            if self.state ~= states.RUNNING then
                self.curr_child = nil
            end
            return self.state
        else  
            return states.FAILURE
        end
    end, 

    clone = function (self)
        local inst = self.class.new()
        for _, child in ipairs(self.children) do 
            inst:add(child:clone())
        end
        return inst
    end, 
}