local log = logger.get("Game", "BT")
local super = require("bt.composite")
local states = super.states

-- 依次执行子结点。子结点失败继续执行。发现成功就返回成功
return class {
    typename = "选择结点", 
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
    
    end,

    update = function (self, dt)
        --log.debug("select update.")
        
        local child = self.children[self.curr_child_idx]
        if child then 
            self.state = child:update(dt)
            if self.state == states.FAILURE then -- 执行失败，继续执行下个结点
                self.curr_child_idx = self.curr_child_idx + 1
                if self.curr_child_idx > #self.children then    -- 如果已经是最后一个结点，整个选择结点执行失败
                    self.curr_child_idx = 1
                    return states.FAILURE
                else
                    return states.RUNNING
                end
            elseif self.state == states.RUNNING then
                return states.RUNNING
            else -- success
                -- 发现执行成功的结点
                self.curr_child_idx = 1 
                return states.SUCCESS
            end
        else  
            if (self.curr_child_idx ~= 1) then
                self.curr_child_idx = 1
                return self:update(dt)
            else
                -- 没有子结点
                return states.FAILURE
            end
        end
    end, 

    clone = function (self)
        local inst = self.class.new()
        for _, child in ipairs(self.children) do 
            inst:add(child:clone())
        end
        return inst
    end, 
}