local log = logger.get("Game", "BT")
local super = require("bt.composite")
local states = super.states

-- 依次执行子结点，发现有失败就返回失败。执行完成后返回成功
return class {
    typename = "顺序节点", 
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
    
    end,

    update = function (self, dt)
        --log.info("sequence update.")
        
        local child = self.children[self.curr_child_idx]
        if child then 
            self.state = child:update(dt)
           -- log.info('seq child update:'..child.typename..', rst:'..tostring(self.state))
            if self.state == states.FAILURE then 
                self.curr_child_idx = 1 
               -- log.info('sequence failed')
                return states.FAILURE
            elseif self.state == states.RUNNING then
               -- log.info('sequence running')
                return states.RUNNING
            else -- success
               -- log.info('sequence success')
                -- 执行成功，执行下个结点
                self.curr_child_idx = self.curr_child_idx + 1
                if self.curr_child_idx > #self.children then    -- 已经执行到最后一个子结点，整个结点执行完成
                    self.curr_child_idx = 1
                    return states.SUCCESS
                else
                    if child:isCondition() then -- 条件结点不占用 tick，继续执行下个结点
                        return self:update(dt)
                    else 
                        return states.RUNNING
                    end
                end
            end
        else  -- 没有找到当前索引的子结点
            if (self.curr_child_idx ~= 1) then
                self.curr_child_idx = 1
                return self:update(dt)
            else
                -- 空的顺序结点
                return states.SUCCESS
            end
        end
    end, 

    clone = function (self)
        local inst = self.class.new()
        for _, child in ipairs(self.children) do 
            inst:add(child:clone())
        end
        return inst
    end, 
}