
return class {
    typename = "WrapWidget", 
    
    ctor = function (self, native)
        self.__base = native
    end, 

    visible = {
        getter = function (self)
            return self:GetActive()
        end, 
        setter = function (self, value)
            self:SetActive(value)
        end, 
    }, 

    animator = {
        getter = function (self)
            if self._animator == nil then
                self._animator = self:GetComponent(UnityEngine.Animator)
                if self._animator == nil then
                    self._animator = false 
                end  
            end
            return self._animator 
        end, 
    },

    Play = function (self, anim)
        if self.animator then
            self.animator:Play(anim)
        end
    end, 

    Stop = function (self)
        -- print(self.animator)
        if self.animator then
            self.animator:Stop() 
        end
    end, 

    SetAnimatorEnabled = function (self, enabled)
        if self.animator then
            self.animator.enabled = enabled 
        end
    end, 
}