local log = logger.get("Game", "Actor State")
local super = require('RTS.actor_states.actor_state_base')

-- 移动状态
return class {
    super = super,
    ctor = function(self, ...)
        super.ctor(self, ...)
    end,

    onEnter = function(self, params)
        self.start_pos = self.owner:getPosition()
        if params then
            
            self.offset = params.offset
            self.speed = params.speed
            self.elapsed = 0.0
            self.end_pos = self.start_pos + self.offset
  
            self.total_time = self.offset.magnitude / self.speed
        end
        if self.total_time and self.total_time > 0.001 then
            self:playAnimation(self.anim_names.move, true)-- 播放 move 动画
        end

    end,

    onUpdate = function(self, dt)
        if not self.total_time then
            return
        end

        self.elapsed = self.elapsed + dt
        local t = self.elapsed / self.total_time
        if t > 1.0 then t = 1.0 end
        local pos = Vector3.Lerp(self.start_pos, self.end_pos, t)
        self.owner:setPosition(pos)
    end,

    canChangeTo = function(self, next_state_name, args)
        return true
    end,

    onExit = function(self)
 
    end,
}