local log = logger.get("Game", "Actor State")
local super = require('RTS.actor_states.actor_state_base')

-- 逃脱状态
return class {
    super = super,
    onEnter = function(self, args)
        self:playAnimation(self.anim_names.move, true)
        --self.destination = args

        --self:moveTo(self.destination)
        self.state_elapsed = 0.0
        self.is_finished = false
        self.owner.is_escape = true
    end,

    onUpdate = function(self, dt)
        if self.is_finished then return end

        super.onUpdate(self, dt)

        -- 逃逸超时
        self.state_elapsed = self.state_elapsed + dt
        if self.state_elapsed > 20 then
            self:finish()
        end
    end,

    finish = function(self)
        self.is_finished = true
        self.owner.events:dispatch('actor_escaped', self.owner)
    end,

    canChangeTo = function(self)
        return false
    end,

    onExit = function(self)
    end,
}