local log = logger.get("Game", "Actor State")
local super = require('RTS.actor_states.actor_state_base')

-- 角色击退状态
return class {
    super = super,
    onEnter = function(self, args)
        self.speed = args[1]
        self.time = args[2]
        self.direction = args[3]

        --self:playAnimation(self.anim_names.idle)-- 播放待机动画
        --self:stopMove()
        self.owner.cs_inst:BeginHitBack(self.speed, self.time, self.direction)
        self.elapsed = 0.0
    end,

    onUpdate = function(self, dt)
        self.elapsed = self.elapsed + dt
        if not self.owner:isAlive() and self.elapsed > self.time then
            self.owner:changeState("die")
        end
    end,

    canChangeTo = function(self, next_state_name, ...)
        if next_state_name == 'preskill' or next_state_name == 'die' then
            return true;
        else
            return self.elapsed > self.time
        end
    end,

    onExit = function(self)
        self.owner.cs_inst:StopHitBack()
        self:stopMove()
    end,
}