local log = logger.get("Game", "Actor State")
local super = require('RTS.actor_states.actor_state_base')
local actor_types = require('RTS.enums').actor_types

-- 角色待机状态
return class {
    super = super,
    onEnter = function(self, args)
        self:playAnimation(self.anim_names.idle, true)-- 播放待机动画
        self:stopMove()
        
    end,

    onUpdate = function(self, dt)
        super.onUpdate(self, dt)
        if not self.owner:isAlive()  then
            if not battle_helper:isReplay() or self.owner.actor_type == actor_types.SOLDIER then
                self.owner:changeState('die')
            end
        end
    end,

    canChangeTo = function(self, next_state_name, ...)
        if next_state_name == 'idle' then
            return false
        else
            return true
        end

    end,

    onExit = function(self)
    end,
}