local log = logger.get("Game", "Actor State")
local super = require('RTS.actor_states.actor_state_base')

-- 移动状态
return class {
    super = super,
    ctor = function(self, ...)
        super.ctor(self, ...)

        self.destination = nil -- Vector3
        self.target_actor = nil -- actor base
        self.move_elapsed = 0.0
    end,

    onEnter = function(self, args)

        self:playAnimation(self.anim_names.move, true)-- 播放 move 动画
        -- 判断 args 是 actor 还是 Vector3
        if not args.x then
            self.target_actor = args
            self.destination = self.target_actor:getPosition()
        else
            self.target_actor = nil
            self.destination = args
        end

        self:moveTo(self.destination)
    end,

    onUpdate = function(self, dt)
        super.onUpdate(self, dt)
        self.move_elapsed = self.move_elapsed + dt
        if self.target_actor and self.move_elapsed > 0.5   then
            if self.target_actor:isAlive() then
                self.destination = self.target_actor:getPosition()
                self:moveTo(self.destination)
            else
                self:stopMove()
            end
            self.move_elapsed = 0.0
        end
    end,

    canChangeTo = function(self, next_state_name, args)
        if next_state_name == 'move' and args == self.target_actor then
            return false
        end

        return true
    end,

    onExit = function(self)
        self.targte_actor = nil
        self.destination = nil
    end,
}