local log = logger.get("Game", "Actor State")
local super = require('RTS.actor_states.actor_state_base')

-- 士兵组逃逸状态
return class {
    super = super,
    onEnter = function(self, args)
        self.soldiers = self.owner.soldiers
        self:escape()
        self.owner.is_escape = true
    end,

    -- 脱离战场, 假设场景中心点在 0,0
    escape = function(self)
        for k,v in pairs(self.soldiers) do
            if v:isAlive() then
                v:changeState('escape')
            end
        end

        self.owner.events:dispatch('actor_escaped', self)
    end,

    canChangeTo = function(self, next_state_name, args)
        return false
    end,

    onUpdate = function(self, dt)

    end,

    onExit = function(self)
    end,
}