local log = logger.get("Game", "Group State")
local super = require('RTS.actor_states.actor_state_base')

-- 士兵组 向敌人移动，进入射程就开始攻击 
return class {
    super = super,

    onEnter = function(self, args)
        if not args then
            info.error('move to and attack, target is nil')
            return
        end

        if self.owner.target_actor ~= args then
            self.owner:ai_setTargetActor(args)
        end

        self.target_actor = self.owner.target_actor
        self.soldiers = self.owner.soldiers

        -- 会反复执行 onEnter, 防止数值被重复初始化
        if not self.check_elapsed then
            self.check_elapsed = 0.1
            self.check_time = math.random() * 0.1 + 0.1
            self.check_idx = 1
        end
    end,

    onUpdate = function(self, dt)
        self.check_elapsed = self.check_elapsed + dt
        if self.check_elapsed >= self.check_time then 
            -- 判断 soldier 的 target 是否合法
            if self.target_actor:isEscape() then 
                self.owner:clearTargetActor()
                return
            end

            if self.check_idx > #self.soldiers then
                self.check_idx = 1
            end

            -- 判断 每个 soldier 应该'向敌人移动'还是'进行攻击'
            local soldier = self.soldiers[self.check_idx]

            if soldier:isAlive() then

                if self.owner.group_target_actor  then
                    local t = soldier.target_actor
                    if not soldier.target_actor or not soldier.target_actor:isAlive() then
                        soldier.target_actor = battle_helper:selectRandomFromGroup(self.owner.group_target_actor)
                    end
                else

                end
                
                if not soldier.target_actor then 
                    soldier:changeState('idle')
                elseif not soldier.target_actor:isAlive() then
                    soldier:changeState('idle')
                else
                    if soldier:castSkill(soldier:getCommonAtkID(), soldier.target_actor) then
                        --log.info('soldier attack target:'..tostring(soldier.target_actor:getActorType()))
                    else
                        soldier:changeState('idle')
                    end
                end
            end

            self.check_elapsed = 0
            self.check_time = math.random() * 0.2 + 0.2
            self.check_idx = self.check_idx + 1
        end
    end,

    onExit = function(self)
    end,
}