local log = logger.get("Game", "AI Agent")
-- AI 代理， 会对应一个 NavMeshAgent用于寻路
-- 一组士兵可以共用一个 AI 代理

return class {
    ctor = function(self, world, id, ai_name, team, actor_type, update_interval, attack_range, min_attack_range, safe_range)
        self.world = world  -- ai world
        self.id = id        -- 关卡中的唯一 id
        self.team = team    -- 所属哪队
        self.update_interval = update_interval
       
        self.pos = {0,0}  -- 2D pos, ignore y
        self.cd = 0
        self.enemy = nil    -- RTS enemy
        self.is_alive = true
        self.attack_cd = 2
        self.attack_range = attack_range or 20
        self.attack_range_sq = self.attack_range * self.attack_range
        self.min_attack_range = min_attack_range or 0
        self.safe_range = safe_range or 0
        self.radius = 0.0   -- 半径
        self.actor_type = actor_type
        
        self.removed = false    -- 是否已经被移除
        self.is_sneak = false   -- 是否在潜行
        
        ai_name = ai_name or 'tank'
        self.bt = require('RTS.ai.bt')[ai_name](self)
    end,

    reset = function(self)
        self.bt:reset()
    end,

    setPosition = function(self, pos)
        self.pos[1], self.pos[2] = pos.x, pos.z
    end,

    update = function(self, dt)
        if not self.removed then
            for i=0,2 do
                self.bt:update(dt)
            end
        end

        if self.timer then
            self.timer = self.timer + dt
        end
    end,

    isAlive = function(self)
        return self.is_alive
    end,
}