local super = require("bt.action")
local states = super.states

return class {
    super = super, 

    ctor = function (self, min, max)
        super.ctor(self)
        self.min = min
        self.max = max
    end, 

    setContext = function(self, context)
        super.setContext(self, context) -- 调用父类函数，需要把 self 手动传进去
        self:resetTime()
    end,

    update = function (self, dt)
        self.elapsed = self.elapsed - dt
        if self.elapsed < 0 then 
            -- delay 结束，重置时间
            self:resetTime()
            return states.SUCCESS
        end
        return states.RUNNING
    end, 

    resetTime = function (self)
        local agent = self.ctx
        if self.ctx == nil then
            log.error('context is nil!')
        end
        log.info('reset Time')

        self.elapsed = agent.attack_cd + self.min + math.random() * (self.max - self.min)
    end, 

    clone = function (self)
        return self.class.new(self.min, self.max)
    end, 
}