local super = require("bt.condition")
local states = super.states
local vec2 = require('base.vec2')
local log = logger.get("Game", "BT")

-- 判断敌人是否在安全范围之外
return class {
    typename = 'condition: ai is enemy out safe range',
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
    end,

    update = function(self)
        local self_agent = self.ctx
        local enemy = self_agent.enemy
        if enemy == nil then
            return states.FAILURE
        else
            if vec2.dist(self_agent.pos, enemy.pos) > self_agent.safe_range + enemy.radius then --Pathfinder半径略小于实际填写半径
                return states.SUCCESS
            else
                return states.FAILURE
            end
        end
    end,
}
