local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

-- 标记减小1
return class {
    typename = 'action: dec mark',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
        self.mark_name = select(1, ...) -- 标记的名称
        self.is_global = select(2, ...) -- 是否全局 mark
    end,

    -- 攻击敌人
    update = function(self, dt)
        local agent = self.ctx
        local world = agent.world

        -- 添加一个标记
        world:agentDecMark(agent, self.mark_name, self.is_global)

        return states.SUCCESS
    end,
}