local super = require("bt.condition")
local states = super.states
local vec2 = require('base.vec2')
local log = logger.get("Game", "BT")

-- 判断是否存在 Mark
return class {
    typename = 'condition: is mark exist',
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
        self.mark_name = select(1, ...)
        self.is_global = select(2, ...)
    end,

    update = function(self)
        local agent = self.ctx
        local world = agent.world

        if  world:isMarkExist(agent, self.mark_name, self.is_global) then
            return states.SUCCESS
        else
            return states.FAILURE
        end

    end,
}
