local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states
local vec2 = require('base.vec2')

return class {
    typename = 'action: move to enemy and attack',
    super = super,
    ctor = function(self)
        super.ctor(self)
    end,

    -- 移动到敌人，进入射程后开始攻击
    update = function(self, dt)
        local agent = self.ctx
        local world = agent.world
        local enemy = agent.enemy

        if enemy == nil then
            log.error('move to enemy and attack, enemy is nil!!')
            return states.FAILURE
        else
            --log.info('move to enemy')
            world:agentMoveToEnemyAndAttack(agent)
            return states.SUCCESS
        end
        
    end,
}