local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states
local vec2 = require('base.vec2')

return class {
    typename = 'action: select enemy',
    super = super,
    ctor = function(self, only_attackable, keep_old_if_nil)
        super.ctor(self)
        self.only_attackable = only_attackable
        self.keep_old_if_nil = keep_old_if_nil
    end,

    -- 选择敌人
    update = function(self, dt)
        local agent = self.ctx
        local world = agent.world

        --local self_team = agent.team
        --local enemy_team = 0
        --if self_team == 0 then enemy_team = 1 end
        
        --local enemy, dist = world:getNearestAgent(agent.pos, enemy_team, self.enemy_type)

        -- 根据优先级选择敌人
        local enemy = world:selectEnemyByPriority(agent, self.only_attackable)

        if not enemy and self.keep_old_if_nil then
        else
            if agent.enemy ~= enemy then
                agent.enemy = enemy
                -- 通知  world enemy 改变了
                world:enemyChanged(agent, enemy)
            end
        end

        if enemy == nil then
            --log.debug(self.typename..' return failure.')
            return states.FAILURE
        else
            --log.debug(self.typename..' return success.')
            return states.SUCCESS
        end
        
    end,
}