local log = logger.get("Game", "TB")
local super = require('bt.action')
local states = super.states
local vec2 = require('base.vec2')

return class {
    typename = 'action: select enemy',
    super = super,
    ctor = function(self, enemy_type)
        super.ctor(self)
    end,

    -- 选择敌人
    update = function(self, dt)
        local agent = self.ctx
        local world = agent.world

        -- 根据回合制规则选择敌人
        local tb_enemys = world:selectEnemyAgent(agent)

        local rst, cur_length = self:judgeEnemyChange(tb_enemys, agent.tb_enemys)
        if rst then
            agent.tb_enemys = tb_enemys
            world:enemyChangedTb(agent, tb_enemys)
        end

        -- 当前没有敌人
        if cur_length == 0 then
            return states.FAILURE
        else
            return states.SUCCESS
        end
    end,

    -- 判断目标目标是否变化
    judgeEnemyChange = function(self, cur_enemys, ex_enemys)
        local cur_length = 0
        local ex_length = 0
        local rst = false

        for __, enemy in pairs(cur_enemys) do
            if enemy then
                cur_length = cur_length + 1
            end
        end

        for __, enemy in pairs(ex_enemys) do
            if enemy then
                ex_length = ex_length + 1
            end
        end

        if cur_length ~= ex_length then
            rst = true
            return rst, cur_length
        end

        for __, enemy in pairs(cur_enemys) do
            if not ex_enemys[__] then
                rst = true
                break
            end
        end

        return rst, cur_length
    end,
}