local log = logger.get("Game", "Area")
local super = require('RTS.areas.area_base')

-- 角色基类,只定义子类必须要实现的一些函数
return class{ 
    super = super,    
    ctor = function(self, team, pos, rot, half_extents)
        super.ctor(self, team)
        self.position = pos
        self.rotation = rot
        self.half_extents = half_extents
    end,

    -- 获取有重叠的角色, actors 是以 id 为下标的角色数组，就是 stage 中的 actors
    intersectActors = function(self, actors)
        local colliders = Physics.OverlapBox(self.position, self.half_extents, self.rotation) -- , core.layers["Tank"]
        --log.info('collider len:'..colliders.Length..','..tostring(colliders))
        if colliders.Length == 0 then return nil end

        local rst_actors = {}
        local tab = colliders.Table
        for _,col in pairs(tab) do 
            local cs_actor = col:GetComponent('ActorBase')
            if cs_actor then 
                local actor = actors[cs_actor.m_ID]
                --log.info('find lua actor:'..actor.name)
                if actor and actor:isAlive() and actor.team == self.team then
                    --log.info('add lua actor to table')
                    table.insert(rst_actors, actor)
                end     
            else
               -- log.info('can not find actor base!!'..col.name)
            end   
        end

        return rst_actors
    end,

}