buff_info = {

    events = require("base.event").new(),

    buffs = {},

    setBuff = function(self, buff_id, left_time, total_time)
        local buff_data = {
            buff_id = buff_id,
            left_time = left_time,
            total_time = total_time,
            rmb_time = Time.realtimeSinceStartup, -- 记下收到消息的时间点
        }
        table.insert(self.buffs, buff_data)

        print("收到buff消息:", buff_data.buff_id, buff_data.left_time, buff_data.total_time)
    end,

    getBuffNum = function(self)
        return self.buffs and #self.buffs or 0
    end,

    getBuffByBuffId = function(self, buff_id)
        for __, value in ipairs(self.buffs) do
            if value.buff_id == buff_id then
                return value
            end
        end
        return nil
    end,

    getLeftTimeByBuffId = function(self, buff_id)
        local buff_data = self:getBuffByBuffId(buff_id)
        if buff_data and buff_data.rmb_time and buff_data.left_time > 0 then
            local pass_time = Time.realtimeSinceStartup - buff_data.rmb_time
            local real_left_time = buff_data.left_time - pass_time
            return real_left_time >= 0 and real_left_time or 0, true
        end
        return 0, false
    end,

    clearInfo = function(self)
        self.buffs = {}
    end,

    dispatch = function(self)
        self.events:dispatch("BUFF_INFO_CHANGE")
    end,
}