local super = require("RTS.home_sys.home_entity_base")

return class
{
    super = super,

    ctor = function(self, owner, grid_id, events, root)
        self.home_map = owner
        self.grid_id = grid_id
        self.events = events
        self.root = root
        self.pos = self:getPos(grid_id)
        self.transform, self.gameObject = self:createTransform()
    end,

    getPos = function(self, grid_id)
        local cfg = config.home_config_grids[grid_id]
        return { x = cfg.X, y = cfg.Y, z = cfg.Z }
    end,

    hasBuild = function(self)
        return false
    end,

    createTransform = function(self)
        local gameObject = GameObject()
        gameObject.name = "grid id:" .. self.grid_id
        local transform = gameObject.transform
        transform.parent = self.root.transform
        frame_helper:resetTransform(transform)
        transform.localPosition = Vector3(self.pos.x, self.pos.y, self.pos.z)
        return transform, gameObject
    end,

    getModelPath = function(self)
    end,

    exit = function(self)
        self.transform.name = "obsolete grid id:" .. self.grid_id
        super.exit(self)
    end,
}