local super = require("RTS.home_sys.home_entity_base")
log = logger.get("Game", "home_entity_group")

return class
{
    super = super,

    ctor = function(self, owner, events, root, group_id)
        super.ctor(self, owner, events, root)

        self.group_id = group_id
        
        self:createModel()
    end,

    getPos = function(self)
        local cfg = config.home_config_grid_groups[self.group_id]
        return { x = cfg.X, y = cfg.Y, z = cfg.Z }
    end,

    getModelPath = function(self)
        local cfg = config.home_config_grid_groups[self.group_id]
        return cfg.field_model
    end,

    createModel = function(self)
        local model_path = self:getModelPath()
        local callback = function (model_go)
            if model_go then
                self.model = model_go
                model_go.transform.parent = self.transform
                frame_helper:resetTransform(model_go.transform)
                local bc = model_go:GetComponentInChildren(UnityEngine.Collider)
                if bc then
                    self.mono = bc.gameObject:GetComponent(HomeEntity)
                    if not self.mono then
                        self.mono = bc.gameObject:AddComponent(HomeEntity)
                    end
                    self.mono.id = self.group_id
                    self.mono.is_group = true
                    frame_helper:setChildLayer(self.model.transform, "Home")
                end
            else
                log.error("加载模型失败:", model_path)
            end
        end
        local new_uobject = game_director.pool:instantiate(model_path)
        if not new_uobject then
            log.error("Failed to find model:"..tostring(model_path))
            return
        end
        if new_uobject.isLoaded then 
            callback(new_uobject)
        else 
            new_uobject.onLoaded = callback
        end
    end,

    interactEntity = function(self)
        print("interactEntity:", "区域")
    end,
}