local log = logger.get("Game", "prop")
require('RTS.prop_sys.prop_enum')
local super = require('RTS.prop_sys.actor_props_base')
local prop_group_class = require('RTS.prop_sys.prop_group')

-- 坦克属性，包含若干属性组
return class {
    super = super,
    
    ctor = function(self, tank_cfg, level)
        super.ctor(self, tank_cfg, level)
        self:init()
    end,

    init = function(self)
        -- 创建所有属性组
        for name,idx in pairs(prop_group_types) do
            self.groups[idx] = prop_group_class(name, idx)
        end

        self.base_group = self.groups[prop_group_types.BASE]
        self.static_group = self.groups[prop_group_types.STATIC]
        self.buff_group = self.groups[prop_group_types.BUFF]
        self.final_group = self.groups[prop_group_types.FINAL]

        -- 将 cfg 里的属性值复制到 base_group 中
        self.base_group:copyFromCfg(self.cfg)
        --self.base_group:log()

    end,

    computeStatic = function(self, level)
        local level = level or self.level
        self.static_group:clear()
        -- 累加 static 前的所有组
        for i=1, prop_group_types['STATIC']-1, 1 do
            local other = self.groups[i]
            self.static_group:accumulate(other)
        end

        --self.static_group:log()
        self.static_group:computeStatic(level)
    end,

    computeFinal = function(self)
    
        self.final_group:clear()
        self.final_group:accumulate(self.static_group)
        self.final_group:accumulate(self.buff_group)
        self.final_group:computeFinal()

    end,

}