local log = logger.get("Game", "prop")
require('RTS.prop_sys.prop_enum')
local super = require('RTS.prop_sys.actor_props_base')
local prop_group_class = require('RTS.prop_sys.prop_group')

return class {
    super = super,
    ctor = function(self, soldier_cfg, level)
        super.ctor(self, soldier_cfg, level)

        self:init()
    end,

    init = function(self)

        local createGroup = function(name)
            local idx = prop_group_types[name]
            self.groups[idx] = prop_group_class(name, idx)

            return self.groups[idx]
        end

        self.base_group = createGroup('BASE')
        self.static_group = createGroup('STATIC')
        self.buff_group = createGroup('BUFF')   
        self.final_group = createGroup('FINAL')

        -- 将士兵配置表值复制到属性 
        self.base_group:copyFromCfg(self.cfg)
    end, 

    computeStatic = function(self, level)
        local level = level or self.level

        self.static_group:clear()
        self.static_group:accumulate(self.base_group)
        self.static_group:computeStatic(level)
    end,

    computeFinal = function(self)
        self.final_group:clear()
        self.final_group:accumulate(self.static_group)
        self.final_group:accumulate(self.buff_group)
        self.final_group:computeFinal()
    end,
}