local log = logger.get("Game", "RTSStage")

-- 战斗状态
return class {
    super = require("common/state"),
    
    onEnter = function(self)
        log.info('###### ship battle state approach onEnter')
        --self.owner:setPaused(false)    
        self.ship = self.owner.level_manager.ship
        self.ship:SetInteger("stage", 2)    -- 第一阶段动画后直接播第二阶段动画
        self.elapsed = 0.0
        self.isBeginBattle = false
    end,

    onUpdate = function(self, dt)
        self.elapsed = self.elapsed + dt
        -- 总时长 8 秒
        if self.elapsed > 8.0 then
            -- 进入第二阶段
            self.owner:changeState("break_wall")
        end

        -- 7 秒开始战斗
        if self.elapsed > 7.0 then
            if not self.isBeginBattle then
                self.isBeginBattle = true
                self.owner:createActorsAI(0)
                -- 创建 1 队炮塔的 AI
                self.owner:createCannonsAI()

                self.owner:setPaused(false)                
            end
            self.owner:updateTurnTimeBreakWall()
        end

    end,

    onExit = function(self)
    end,

}