local log = logger.get("Game", "RTSStage")

-- 战斗状态
return class {
    super = require("common/state"),
    
    onEnter = function(self)
        log.info('ship battle state landing onEnter')
        self.ship = self.owner.level_manager.ship
        self.ship:SetInteger("stage", 3) 

        self.owner:initSecondPart()
        self.elapsed = 0.0
        self.is_entrance = false

        self.entrance_total_time = 0.0

        self.owner:removeCannonAI()
    end,

    onUpdate = function(self, dt)
        self.elapsed = self.elapsed + dt
        if not self.is_entrance  then
            -- 等待两船接舷动画时长
            if self.elapsed > 12 then
                self.is_entrance = true
                self.entrance_total_time = self.owner:beginEntrance()
                self.elapsed = 0.0
            end
        else
            if self.elapsed >= self.entrance_total_time then
                -- 结束进场
                self.owner:endEntrance()
                self.owner:changeState('occupy')
            end
        end
    end,

    onExit = function(self)
    end,

}