local log = logger.get("Game", "RTS Helper")

-- rts 辅助函数, 相当于单件
local rts_helper_inst =
{
    init = function(self)
        self:initCommonVars()
    end,

    initCommonVars = function(self)
        self.common_vars = {}
        for i=1,#gConfig.commonvars_vars,1 do 
            local v = config.commonvars_vars[i]
            if not v then
                break
            end

            self.common_vars[v.name] = v.value
        end
    end,

    -- 获取 commonvars 中配置的公共值 
    getCommonVar = function(self, var_name)
        if not self.common_vars then
            self:initCommonVars()
        end

        local value = self.common_vars[var_name]
        return value
    end,

    -- 根据车体 prefab 和 武器 id 获取武器的缩放
    getWeaponScale = function(self, prefab, weapon_id)
        local zoom_cfg = config.tankzoom_guides[prefab]
        if zoom_cfg then
            local scale = 10000
            local tab = nil
            if zoom_cfg.type == "Heavy" then
                tab = config.tankzoom_Heavys
            elseif zoom_cfg.type == "Assult" then
                tab = config.tankzoom_Assults
            elseif zoom_cfg.type == "Tank" then
                tab = config.tankzoom_Tanks
            elseif zoom_cfg.type == "Artillery" then
                tab = config.tankzoom_Artillerys
            end

            local cfg = tab[weapon_id]
            if cfg then
                scale = cfg[zoom_cfg.id] or 10000
            else
                log.error("## Failed to find zoom cfg, prefab:"..prefab..", weapon:"..weapon_id)
            end

            scale = scale / 10000
            return scale
        else
            log.error("Failed to find tankzoom_guides cfg:"..tostring(prefab))
            return 1.0
        end       
    end,

}

return rts_helper_inst