local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

-- 进行矩形范围的伤害
return class {
    typename = 'action: add buff',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
        self.buff_target = select(1, ...)-- buff 的释放对象枚举
        self.buff_id = select(2, ...)    -- buff cfg id
        --log.info(self.offset..","..self.length..','..self.width)
    end,

    setContext = function (self, ctx)
        self.ctx = ctx
        self.skill_cfg = ctx.skill_cfg
    end, 

    update = function(self, dt)
        local actor = self.ctx
        local skill_state = actor.curr_state
        assert(skill_state.name == 'skill')

        local actors = battle_helper:getBuffTargetActors(actor, self.buff_target)

        for k,v in pairs(actors) do
            v.buff_handler:addBuff(actor, self.buff_id)
        end

        return states.SUCCESS
     end,
}