local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

return class {
    super = super, 
    typename = 'action: call function',
    ctor = function (self, func)
        super.ctor(self)
        self.func = func
    end, 

    setContext = function (self, ctx)
        self.ctx = ctx
    end, 

    update = function (self, dt)
        
        if self.func then
            self.func()
        end
        return states.SUCCESS
    end, 

    clone = function (self)
        return self.class.new(self.func)
    end, 
}