local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

return class {
    super = super, 
    typename = 'action: cast post skill',
    ctor = function (self, skill_id)
        super.ctor(self)
        self.skill_id = skill_id
    end, 

    setContext = function (self, ctx)
        self.ctx = ctx
    end, 

    update = function (self, dt)
        local actor = self.ctx
        actor:sk_finished()
        local target = actor.target_actor
        actor:changeStateImmediate('skill', {id=self.skill_id, ta=target, p=target:getPosition(), r=actor:getRotation()})

        return states.SUCCESS
    end, 

    clone = function (self)
        return self.class.new(self.skill_id)
    end, 
}