local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

return class {
    super = super, 
    typename = 'action: delay_px',
    ctor = function (self, px)
        super.ctor(self)
        self.px = px
        self.elapsed = -1.0

        if type(self.px) ~= 'string' then
            log.error('action: delay_px param error, '..tostring(self.px))
        end
    end, 

    setContext = function (self, ctx)
        self.ctx = ctx
    end, 

    update = function (self, dt)
        
        if self.elapsed < 0.0 then
            self.time = self.ctx.skill_cfg[self.px]
            self.elapsed = 0.0
        end

        self.elapsed = self.elapsed + dt
        if self.elapsed >= self.time then 
            self.elapsed = -1.0
            return states.SUCCESS
        end
        return states.RUNNING
    end, 

    clone = function (self)
        return self.class.new(self.min, self.max)
    end, 
}