local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

-- 面向技能方向
return class {
    typename = 'action: facing_skill_direction',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
        self.threshold = select(1, ...) or 5
        self.max_time = select(2, ...) or 4
        --log.info('threshold:'..self.threshold..', max_time'..self.max_time)

        self.inited = false
        self.elapsed = 0.0
        self.target_point = nil
    end,

    -- 面向敌人
    update = function(self, dt)
        local actor = self.ctx
       

        if not self.inited then
            --if not actor.cs_inst:IsFacingTarget(target:getPosition(), self.threshold) then
            --log.info('facing target on the spot')
            
            self.target_point = actor.curr_state.skill_position
            if not self.target_point then
                return states.SUCCESS
            end
            actor.cs_inst:FacingTargetOnTheSpot(self.target_point)
            --end
            self.elapsed = 0.0
            self.inited = true
        end

        self.elapsed = self.elapsed + dt
        if self.elapsed >= self.max_time or actor.cs_inst:IsFacingTarget(self.target_point, self.threshold) then
            self.inited = false

            --[[
            if actor.team == 0 then
                log.info('facing target finished')
            end]]
            --log.info('facing target SUCCESS, elapsed:'..self.elapsed)
            return states.SUCCESS
        else
            --log.info('facing target RUNNING:'..self.elapsed)
            return states.RUNNING
        end
     end,
}