local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states
local actor_types = require('RTS.enums').actor_types

-- 面向目标
return class {
    typename = 'action: facing_target',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
        self.threshold = select(1, ...) or 5
        self.max_time = select(2, ...) or 2

        if game_info.is_replay then
            self.threshold = 45
            self.max_time = 0.5
        end

        self.inited = false
        self.elapsed = 0.0
    end,

    -- 面向敌人
    update = function(self, dt)
        local actor = self.ctx
        local target = actor.target_actor

        if not target then
            return states.FAILURE
        end

        --[[
        if actor.team == 0 then
            log.info('facing target')
        end]]
--[[
        if not self.inited then
            --if not actor.cs_inst:IsFacingTarget(target:getPosition(), self.threshold) then
            --log.info('facing target on the spot')
            actor.cs_inst:FacingTargetOnTheSpot(target:getPosition())
            --end
            self.elapsed = 0.0
            self.inited = true
        end]]

        if not target then
            return states.FAILURE
        end

        self.elapsed = self.elapsed + dt

        local thres = self.threshold
        --[[
        if actor.main_weapon then
            thres = thres + actor.main_weapon.cfg.rotate_angle * 0.75
        end]]

        if self.elapsed >= self.max_time or actor.cs_inst:IsFacingTarget(target:getPosition(), thres) then
            if actor.actor_type == actor_types.SOLDIER then
                actor.cs_inst:FacingTargetOnTheSpot(target:getPosition())
            end

            self.inited = false

            --[[
            if actor.team == 0 then
                log.info('facing target finished')
            end]]

            return states.SUCCESS
        else
            if not self.inited then
                --if not actor.cs_inst:IsFacingTarget(target:getPosition(), self.threshold) then
                --log.info('facing target on the spot')
                actor.cs_inst:FacingTargetOnTheSpot(target:getPosition())
                --end
                self.elapsed = 0.0
                self.inited = true
            end

            return states.RUNNING
        end
     end,
}