
local super = require("bt.condition")
local states = super.states
local vec2 = require('base.vec2')
local log = logger.get("Game", "BT")

-- 判断敌人是否在射程内
return class {
    typename = 'condition: is enemy in attack range',
    super = super, 

    ctor = function (self, ...)
        super.ctor(self, ...)
    end,

    update = function(self)
        local actor = self.ctx
        local enemy = actor:getTargetActor()
        if not enemy  then
            return states.FAILURE
        else
            if Vector3.Distance(actor:getPosition(), enemy:getPosition()) < actor.attack_range + enemy.radius * 0.8 then
                return states.SUCCESS
            else
                return states.FAILURE
            end
        end
    end,
}