local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states
local damage_calculator = require('RTS.prop_sys.damage_calculator')

-- 冲锋
return class {
    typename = 'action: skill move to enemy',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
        self.dist = select(1, ...) 
    end,

    setContext = function (self, ctx)
        self.ctx = ctx
        self.skill_cfg = ctx.skill_cfg
    end, 

    reset = function(self)
        if self.inited then
            self.inited = false
        end
    end,

    update = function(self, dt)
        local actor = self.ctx
        local skill_state = actor.curr_state
        assert(skill_state.name == 'skill')

        if actor.init_rot then
            local dest = actor:getPosition() + (actor.init_rot * Vector3.forward) * self.dist
            actor.cs_inst:SetDestination(dest)
        else
        end

        return states.SUCCESS
    end,
}