local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states
local damage_calculator = require('RTS.prop_sys.damage_calculator')

-- 冲锋
return class {
    typename = 'action: skill move to enemy',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
    end,

    setContext = function (self, ctx)
        self.ctx = ctx
        self.skill_cfg = ctx.skill_cfg
    end, 

    reset = function(self)
        if self.inited then
            self.inited = false
        end
    end,

    update = function(self, dt)
        local actor = self.ctx
        local skill_state = actor.curr_state
        assert(skill_state.name == 'skill')

        if actor.target_actor then
            actor.cs_inst:SetDestination(actor.target_actor:getPosition())
        else
        end

        return states.SUCCESS
    end,
}