local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

-- 播放特效
return class {
    typename = 'action: play vfx',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
        self.sfx = select(1, ...) -- 如果是整数，读 shoot_effect 表。否则认为是特效路径
        self.on_self = select(2, ...)
    end,

    setContext = function (self, ctx)
        self.ctx = ctx
    end, 

    update = function(self, dt)
        local actor = self.ctx
        if self.on_self then
            SoundEngine.PostEvent(self.sfx, actor.gameObject)
        else
            SoundEngine.PostEvent(self.sfx, app.gameObject)
        end

        return states.SUCCESS
     end,
}