local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states

-- 播放特效
return class {
    typename = 'action: play vfx if have bone',
    super = super,
    ctor = function(self, ...)
        super.ctor(self)
        self.effect_id = select(1, ...) -- 如果是整数，读 shoot_effect 表。否则认为是特效路径
        self.bind_bone = select(2, ...)
        self.time = select(3, ...)
        self.force = select(4, ...)
    end,

    setContext = function (self, ctx)
        self.ctx = ctx

        -- 如果传入的是 P1 ... 参数，从配置中读值
        if type(self.time) == 'string' then
            self.time = skill_cfg[self.time]
        end
    end, 

    update = function(self, dt)
        local actor = self.ctx
        
        local bone = actor.cs_inst:FindChild(self.bind_bone)
        if  bone then
            if type(self.effect_id) == 'number' then
                local effect = config.shoot_effect_effect_libs[self.effect_id]
                -- 判断是否重要特效
                local force = effect.effect_important > 0
                actor:sk_playVfx(effect.effect_path, self.bind_bone, effect.effect_time, force, true)
            else
                actor:sk_playVfx(self.effect_id, self.bind_bone, self.time, self.force, true)
            end
        end
        return states.SUCCESS
     end,
}