local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states
local vec2 = require('base.vec2')

-- 根据距离选择多个目标
return class {
    typename = 'action: select multiple enemy by range',
    super = super,
    ctor = function(self, num, only_attackable)
        super.ctor(self)
        self.num = num
        self.only_attackable = only_attackable

    end,

    update = function(self, dt)
        local actor = self.ctx
        local id = actor.id

        --[[
        if game_info.is_replay or not ai_world then
            if not actor.enemy_list then
                log.error("Failed to find enemy_list in replay!")
            end
            return states.SUCCESS
        end]]

        -- 根据距离选择敌人

        local agent = ai_world.agents[id]
        local enemy_list = ai_world:selectMultipleEnemyByRange(agent, self.num, self.only_attackable)
        actor.enemy_list = enemy_list

        if enemy_list == nil then
            --log.info(self.typename..' return failure.')
            return states.FAILURE
        else
            --log.info(self.typename..' return success.')
            return states.SUCCESS
        end
        
    end,
}