local log = logger.get("Game", "BT")
local super = require('bt.action')
local states = super.states
local vec2 = require('base.vec2')

-- 从多个目标中选择一个作为当前敌人
return class {
    typename = 'action: set enemy from multiple',
    super = super,
    ctor = function(self, index)
        super.ctor(self)
        self.index_param = index
        self.index = nil
    end,

    -- 选择敌人
    update = function(self, dt)
        --[[
        if game_info.is_replay then
            return states.SUCCESS
        end]]

        local actor = self.ctx
        local agent = ai_world.agents[actor.id]

        if type(self.index_param) == 'function' then
            self.index = self.index_param()
        else
            self.index = self.index_param
        end

        if agent and actor.enemy_list and #actor.enemy_list >= self.index then
            local enemy = actor.enemy_list[self.index]  -- enemy agent
            --log.info("### index:"..self.index..", enemy.id"..enemy.id)

            ai_world:enemyChanged(agent, enemy)
            local enemy_actor = ai_world.actors[enemy.id]

            --actor:ai_setTargetActor(enemy)
            actor.skill_state:setTargetActor(enemy_actor)

            --log.info(self.typename..' return SUCCESS.')
            return states.SUCCESS
        else
            --log.info(self.typename..' return FAILURE.')
            return states.FAILURE
        end
        
    end,
}