local log = logger.get("Game", "RTSStage")
local actor_types = require('RTS.enums').actor_types

-- 入场状态
return class {
    super = require("common/state"),

    onEnter = function(self)
        self.stage = self.owner
        self.ai_world = self.owner.ai_world
        self.stage:setPaused(true)

        local v0 = self.stage.stage_cfg.vectorT0
        local v1 = self.stage.stage_cfg.vectorT1
        v0 = Vector3.New(v0[1], v0[2], v0[3])
        v1 = Vector3.New(v1[1], v1[2], v1[3])
        local s0 = self.stage.stage_cfg.speedT0
        local s1 = self.stage.stage_cfg.speedT1

        for _, actor in pairs(self.stage.actors) do
            local at = actor:getActorType()
            if at == actor_types.VEHICLE or at == actor_types.SOLDIER then
                if actor.team == 0 then
                    actor:changeState('entrance', {offset=v0, speed=s0})
                else 
                    if not level_info.is_attack_from_back then
                        actor:changeState('entrance', {offset=v1, speed=s1})
                    else
                        actor:changeState('idle')
                    end
                end
            end
        end

        self.total_time = v0.magnitude / s0
        self.elapsed = 0.0
    end,

    onUpdate = function(self, dt)
        self.elapsed = self.elapsed + dt
        if self.elapsed > self.total_time then
            for _, actor in pairs(self.stage.actors) do
                actor:cs_init()
                --actor:changeState('idle')
            end

            self.stage:changeState('battle')
        end
    end,

    onExit = function(self)

    end,

}