local log = logger.get('Game', 'activeness')

return class{
    ctor = function(self)
        self.value = 0
        self.stages = {}
    end,

    refresh = function(self, info)
        self.value = info.activeValue
        for _, v in ipairs(info.getPhase) do
            self.stages[v] = true
        end

        if #info.getPhase == 0 then
            self:resetStages()
        end
    end,

    resetStages = function(self)
        self.stages = {}
    end,

    -- 获取活跃值百分比
    getPersent = function(self)
        local len = #gConfig.task_dailyactives
        for i=1, len do
            local needactive = config.task_dailyactives[i].needactive
            if self.value <= needactive then
                if i < 2 then
                    return (self.value/needactive) *(i/len)
                else
                    local pre_value = config.task_dailyactives[i-1].needactive
                    local dt = needactive - pre_value
                    return ((self.value - pre_value)/dt + (i-1))/len
                end
            end
        end
        return 1
    end,

    getReward = function(self, stage)
        local cfg = config.task_dailyactives[stage]

        if cfg then
            local rewards = loadstring("return "..cfg.reward)()
            
            return rewards
        end
    end,
}