local log = logger.get("Game", "task")
local frame_helper = require("gui.tool.frame_helper")

--[[
enum TASK_STATUS
{
  TS_NONE       = 0;  //未开始
  TS_GETAWARD   = 1;  //已完成未领取
  TS_DOING      = 2;  //未完成
  TS_TODAYOVER  = 3;  //已领取(只有日常任务中存在)
  TS_OVER       = 4;  //一次性的任务永久完成
}]]
return class{
    ctor = function( self, task_info )
        self.id = task_info.Id
        self.state = task_info.Ts   -- TASK_STATUS 1-已完成未领取  2-进行中  
        --log.info("### task:"..self.id..", "..self.state)
        self.progress = {}
        self.cfg = task_manager:getTaskCfg(self.id)
        self:setProgress(task_info.taskProger)
    end,

    refresh = function(self, task_info)
        self.state = task_info.Ts
        self:setProgress(task_info.taskProger)
    end,

    setProgress = function(self, progress)
        local tab = frame_helper:getJsonTab(self.cfg.p1)
        for k, v in ipairs(progress) do
            --if self.cfg.type == 2 then
            --   log.info("## task id:"..self.id)
            --    log.info("## progress id:"..v.num..", "..v.id)
            --end

            local total_num = v.id
            self.progress = {prog = v.num, total = total_num}

            --[[
            for id, num in pairs(tab) do
                if v.id == id then
                    self.progress[id] = {prog = v.num, total = num}
                end
            end]]
        end
    end,

}