return {

    events = require("base.event").new(),

    setActives = function(self, actives)
        self.actives = {}
        for __, value in ipairs(actives) do
            local act = {}
            act.id = value.instId
            act.cfg_id = value.cfgId
            act.detail_cfg_id = value.cfgDetailId
            act.left_time = value.leftTime
            act.score = value.score
            act.state = value.state
            act.rmb_time = Time.realtimeSinceStartup
            self.actives[value.instId] = act

            -- log.error("新增活动", act.id, "状态:", value.state,"得分:", value.score, "剩余时间:", value.leftTime, "配置id:", value.cfgId, value.cfgDetailId)
        end
        self.events:dispatch("ACTIVITY_INFO_CHANGE")
    end,

    deleteActives = function(self, id_list)
        for __, instId in ipairs(id_list) do
            self.actives[instId] = nil
            -- log.error("删除活动", act.id)
        end
        self.events:dispatch("ACTIVITY_INFO_CHANGE")
    end,

    refreshActives = function(self, actives)
        for __, value in ipairs(actives) do
            local act = {}
            act.id = value.instId
            act.cfg_id = value.cfgId
            act.detail_cfg_id = value.cfgDetailId
            act.left_time = value.leftTime
            act.score = value.score
            act.state = value.state
            act.rmb_time = Time.realtimeSinceStartup
            self.actives[value.instId] = act

            -- log.error("活动刷新", act.id, "状态:", value.state,"得分:", value.score, "剩余时间:", value.leftTime, "配置id:", value.cfgId, value.cfgDetailId)
        end
        self.events:dispatch("ACTIVITY_INFO_CHANGE")
    end,

    onTick = function(self)
        if self.actives then
            for id, act in pairs(self.actives) do
                local elpased = act.left_time - Time.realtimeSinceStartup + act.rmb_time
                if elpased <= 0 then
                    network_sender:getActiveList()
                else
                    self.events:dispatch("ACTIVITY_TIME_TICK", id, elpased)
                end
            end
        end
    end,

    getAllActivitys = function(self)
        return self.actives
    end,

    getActivityById = function(self, id)
        return self.actives[id]
    end,

    getActivityElpased = function(self, id)
        local act = self.actives[id]
        return act.left_time - Time.realtimeSinceStartup + act.rmb_time
    end,

    getCount = function(self)
        local count = 0
        if self.actives then
            for id, act in pairs(self.actives) do
                count = count + 1
            end
        end
        return count
    end,

    getActivityByIdx = function(self, idx)
        local count = 0
        if self.actives then
            for id, act in pairs(self.actives) do
                count = count + 1
                if count == idx then
                    return act
                end
            end
        end
        return nil
    end,
}
