-- message SCNotifyBuildExpend
-- {
-- 	optional uint32 reBuildExpend	= 1;//建筑消耗减少  都为万分比
-- 	optional uint32 buildSpeed		= 2;//建筑建造速度
-- 	optional uint32 techSpeed		= 3;//科技研发速度
-- 	optional uint32 reTechExpend	= 4;//科技消耗减少
-- 	optional uint32 barracksSpeed	= 5;//军营工厂建造速度
-- 	optional uint32 weaponSpeed		= 6;//武器制造速度
-- 	optional uint32 armourSpeed		= 7;//装甲制造速度
-- 	optional uint32 carBodySpeed	= 8;//车体强化速度
-- 	optional uint32 reArsenalExpend = 9;//兵工厂生产消耗
-- 	optional uint32 reRepairBagExpend=10;//修理厂生产消耗减少 
-- }

return {
    set = function(self, msg)
        self.build_res =        msg.reBuildExpend	    / 10000
        self.build_time =       msg.buildSpeed		    / 10000
        self.tech_res =         msg.techSpeed		    / 10000
        self.tech_time =        msg.reTechExpend	    / 10000
        self.barracks_time =    msg.barracksSpeed	    / 10000
        self.weapon_time =      msg.weaponSpeed		    / 10000
        self.armour_time =      msg.armourSpeed		    / 10000
        self.car_time =         msg.carBodySpeed	    / 10000
        self.arsenal_res =      msg.reArsenalExpend     / 10000
        self.repair_bag_res =   msg.reRepairBagExpend   / 10000 
    end,

    -- 建筑的升级配置
    getBuildUpgradeCfg = function(self, cfg_id, level)
        local rst = nil
        local max_level = 1
        config.home_config_upgrades:foreach(
            function(k, v)
                if v.building_id == cfg_id then
                    if v.level == level then rst = v end
                    if v.level > max_level then max_level = v.level end
                end
            end
        )
        return rst, max_level
    end,

    -- 建筑升级的资源消耗
    getBuildCostRes = function(self, cfg_id, level)
        local cfg = self:getBuildUpgradeCfg(cfg_id, level)
        local cost_tab = {}
        local temp = loadstring("return " .. cfg.cost)()
        for item_id, cost in pairs(temp) do
            local rst = cost * (1-self.build_res)
            if rst <= 0 then
                cost_tab[item_id] = 0
            else
                rst = math.floor(rst)
                cost_tab[item_id] = rst == 0 and 1 or rst    
            end
        end
        return cost_tab
    end,

    -- 建筑升级的时间消耗
    getBuildCostTime = function(self, cfg_id, level)
        local cfg = self:getBuildUpgradeCfg(cfg_id, level)
        local time = cfg.time / (1 + self.build_time)
        if time == 0 then
            return time
        else
            time = math.floor(time)
            time = time == 0 and 1 or time
            return time
        end
    end,

    -- 科技升级配置
    getTechDetailCfg = function(self, cfg_id, level)
        local cfg = nil
        config.home_config_research_details:foreach(function(k, v)
            if v.list_id == cfg_id and v.level == level then
                cfg = v
            end
        end)
        return cfg
    end,

    getTechCostRes = function(self, cfg_id, level)
        local cfg = self:getTechDetailCfg(cfg_id, level)
        local cost_tab = {}
        local temp = loadstring("return " .. cfg.cost)()
        for item_id, cost in pairs(temp) do
            local rst = cost * (1-self.tech_res)
            if rst <= 0 then
                cost_tab[item_id] = 0
            else
                rst = math.floor(rst)
                cost_tab[item_id] = rst == 0 and 1 or rst    
            end
        end
        return cost_tab
    end,

    getTechCostTime = function(self, cfg_id, level)
        local cfg = self:getTechDetailCfg(cfg_id, level)
        local time = cfg.time / (1 + self.tech_time)
        if time == 0 then
            return time
        else
            time = math.floor(time)
            time = time == 0 and 1 or time
            return time
        end
    end,
}