-- 全局游戏信息
game_info = {
    role_list = nil,    -- 角色列表
    role_info = nil,    -- 
    player_id = 0,      -- rold_info 里的 playerid
    player_pos = {x=0, y = 0},
    
    events = require("base.event").new(),

    --[[
    //英雄布阵信息
    message MHeroFormation  
    { 
        required uint32     heroId               = 1; //英雄id
        required uint32     location             = 2; //位置
    }
    //回应玩家出战信息
    message SCChapterAttendHeroes
    {
        required uint32  chapterId           = 1;
        repeated MHeroFormation formations   = 3; //布阵信息
        optional uint32  skillId           	 = 4; //所选的技能
    }
    ]]
    chapter_attend_heros = {},   -- 普通关卡，每章出战的英雄列表 [chapter_id] - {SCChapterAttendHeroes}
    level_attend_heros = {},     -- 剧情关卡的出战英雄列表 [level_id] - {SCChapterAttendHeroes}

    -- 上次战斗的信息
    replay_battle_mail_id = nil,    -- 播放战报，战报对应的邮件 id
    replay_battle_from_state = nil, -- 当前 game state

    attack_monster_id = 0,  -- 攻击的怪物 id
    battle_result = 0,  -- 战斗是否胜利 0-失败 非0 成功
    drop_items = {},       -- 掉落 [entity_id] - {items}
    offline_mode = false,
    is_replay = false,      -- 是否是重播
    is_auto_skill = false,  -- 是否自动放技能

    -- 预警信息
    warning_info = {},

    createWarnInfo = function(self, data)
        local tab = {}

        tab.instId = data.instId
        tab.type = data.type
        tab.teamInfo = data.teamInfo
        tab.mass = data.mass
        tab.baseIfno = data.baseIfno
        tab.leftTime = data.leftTime
        tab.totalTime = data.totalTime
        tab.dstInfo = data.dstInfo
        tab.receive_time = os.time()

        local key = "Warning_"..data.instId
        tab.is_off = PlayerPrefs.HasKey(key)

        self.warning_info[data.instId] = tab
    end,

    deleteWarnInfo = function(self, id)
        local key = "Warning_"..id

        if PlayerPrefs.HasKey(key) then
            PlayerPrefs.DeleteKey(key)
        end

        self.warning_info[id] = nil
    end,

    warnStateChanged = function(self, id)
        local info = self.warning_info[id]

        if info then
            info.is_off = not info.is_off
            game_director.events:dispatch("WARNSTATECHANGED", id)
        end
    end,
}

require ("level.level_info")
require ("world_map.world_map_info")
require ("world_map.own_hold_info")
--return game_info