require("game.unlock_manager")

return {

    init = function(self)
        self.scheduler = require("base.scheduler").new()
        self.events = require("base.event").new()

        local time = frame_helper.max_number
        self.scheduler:create(1, time, function()
            home_info:onTick()
            activity_manager:onTick()
            local_lord:onTick()
            army_queue_manager:onTick(1)

            self:onFoodTick()
        end)

        unlock_manager:init()
    end,

    update = function(self, dt)
        self.scheduler:update(dt)
    end,

    exit = function(self)
        self.scheduler:destroy()
    end,

    addHomeMapEvent = function(self, grid_id, build_btn_type)
        self.home_map_event = {
            grid_id = grid_id,
            build_btn_type = build_btn_type,
        }
    end,

    excuteHomeMapEvent = function(self, home_map)
        if self.home_map_event then
            home_map:clickEntityByGridId(self.home_map_event.grid_id, self.home_map_event.build_btn_type)
            self.home_map_event = nil
        end
    end,

    onFoodTick = function(self)
        if not local_player then
            return
        end
        if not local_player.props then
            return
        end
        if not local_player.food_rmb_time then
            return
        end

        local rst = local_player.props[protocol_pb.PROP_FOOD] - (Time.realtimeSinceStartup - local_player.food_rmb_time) * local_player.props[protocol_pb.PROP_REDUCEFOOD] 
        rst = rst < 0 and 0 or math.floor(rst)
        self.events:dispatch("RES_FOOD_CHANGE", rst)
        -- print("rst:", rst, local_player.props[protocol_pb.PROP_REDUCEFOOD], Time.realtimeSinceStartup - local_player.food_rmb_time)
    end,
}