super = require('game.game_state_base')
local stage_class = require('RTS.stage.rts_stage')

return class {
    super = super,

    ctor = function(self, ...)
        super.ctor(self, ...)
    end,

    onEnter = function(self, args)
        self.stage_id = args.stage_id
        self.battle_id = args.battle_id
       -- self.is_replay = args.is_replay
        battle_helper = require('RTS.battle_helper')
        game_state_battle = self

        local battle_types = require('RTS.enums').battle_types
        local temp = battle_types.TEST
        if not level_info.is_simple_battle then
            temp = battle_types.LEVEL
        end
        self.stage = stage_class(temp, {
            stage_id = self.stage_id, 
            battle_id = self.battle_id, 
        })
        
        self.stage:init()
        self.check_elapsed = 0
        network:registerMessageHandler(self)
       
    end,

    onUpdate = function(self, dt)

        self.stage:update(dt)

        self.check_elapsed = self.check_elapsed + dt
        if self.check_elapsed >= 5.0 then

            -- 战斗结束，回到关卡场景
            if self.stage:isFinished() then
               -- if network:isConnected() then
                if not level_info.is_simple_battle then
                    if not self.killMonster_pending then 
                        self.killMonster_pending = true

                        local fightUId = "1"
                        if level_info.map_attack_info then
                            fightUId = level_info.map_attack_info.FightUId
                        end
                        local result = self.stage.result
                        local herosHp = self.stage:getHerosHp()
                        
                        if result == 3 then 
                            result = math.random(3)
                        end
                        logger.warn("killMonster", fightUId, result, #herosHp)
                        network_sender:killMonster(fightUId, result, herosHp)

                        game_info.battle_result = result
                    end
                    -- log.info("killMonster", fightUId, result, #herosHp)
                else
                    --game_director:changeState('battle', {stage_id=1, battle_id="1"})
                end
            else
                
            end
            
            self.check_elapsed = 0.0
        end
    end,

    onMessage = function(self, cmd, msg)
        if cmd == protocol_pb.KILLMONSTER then
            -- 攻击怪物结果 

            if msg.respCode == 0 then 
                -- 获得的关卡资源
                local str = "[KILLMONSTER]\n"
                for k, v in ipairs(msg.copyRes) do 
                    str = str .. "copyRes" .. k .. "= ItemTemId:" .. v.ItemTemId .. " Count:" .. v.Count .. "\n"
                end
                -- boost信息
                for k, v in ipairs(msg.boostList) do 
                    str = str .. "boostList" .. k .. "= boostLevel:" .. v.boostLevel .. " boostId:" .. v.boostId .. "\n"
                end
                -- 奖励信息
                for k, v in ipairs(msg.rewardItems) do 
                    str = str .. "rewardItems" .. k .. "= ItemTemId:" .. v.ItemTemId .. " Count:" .. v.Count .. "\n"
                end
                game_info.drop_items = msg.rewardItems
                
                logger.info(str)
                
                self.stmt = frame_manager:show('battle_settle', self, msg)
            else
                logger.warn("TODO: implementation. KILLMONSTER", msg)
            end
            --[[
        elseif cmd == protocol_pb.BUYBOOST then
            if msg.RespCode == 0 then
                frame_manager:hide('stmt')
                --game_director:changeState('loading', { next_state ='level', scene_name='guanqian', level_id = 1 })
                -- game_director:changeState('loading', {next_state = 'level', scene_name = level_cfg.level_cfg.Map, level_id = game_info.level_info.mapId})
                game_director:changeState('loading', {next_state = 'level', scene_name = level_cfg.level_cfg.Map, level_id = game_info.level_info.mapId})
                network_sender:enterMap(level_info.map_info.mapId)
            end

        elseif cmd == protocol_pb.BOOSTPROPINFO then
            game_info.ParPropIdValues = msg.ParPropIdValues
            frame_manager:show('boost')]]
        end
    end, 

    -- 返回关卡
    backToLevel = function(self)
        game_director:changeState('loading', {next_state = 'level', scene_name = level_info.level_cfg.Map, level_id = level_info.map_id, battle_back = true})
    end,

    onExit = function(self)
        self.killMonster_pending = false
        network:unregisterMessageHandler(self)
        game_state_battle = nil
        if self.stage then
            self.stage:destroy()
            self.stage = nil
        end
        game_director.pool:destroy()
    end,
}