super = require('game.game_state_base')
local log = logger.get("Game", "CreateRole")
local player = require('game.player')

require('game.shop')
require('game.chat')

return class {
    super = super,

    ctor = function(self, ...)
        super.ctor(self, ...)
    end,

    onEnter = function(self, args)
        log.info("#### GameState create role!!")
        -- 创建角色界面
        --[[
        self.gui = CreateFrame {
            class = "gui.create_role_frame", 
            parent = game_director.gameObject, 
            name = "创建角色界面", 
            frame_name = ""
            asset = 'Assets/Frames/CreateRoleFrame.prefab',
            owner = self,
        }]]
        if not Fenix.Game.GameApp.IsSDKLogin() then
            self.gui = frame_manager:show('create_role', self)
        else
            self:createRole(game_info.account)  -- 账号作为用户名
        end

        network:registerMessageHandler(self)
    end,

    onUpdate = function(self, dt)
    end,

    -- 创建角色或者选择角色
    createRole = function(self, role_name)
        if #game_info.role_list == 0 then
            network_sender:createRole(role_name)
        else
            game_info.role_info =  game_info.role_list[1]
            --assert(role_name == game_info.role_info.rolename)
            network_sender:selectRole(game_info.role_list[1].playerid)
            game_info.player_id = game_info.role_list[1].playerid

            network_sender:reqChapterAchievementList()
            network_sender:reqNotifyGuide()
            --log.info('###select player:'..game_info.role_info.playerid)
        end
    end,

    -- 删除角色
    deleteRole = function(self)
        assert(#game_info.role_list > 0)
        log.info('send delete role')
        network_sender:deleteRole(game_info.role_list[1].playerid)
    end,

    -- 网络消息 
    onMessage = function(self, cmd, msg)
        if cmd == protocol_pb.CREATEROLE then
            -- 创建成功 
            if msg.RespCode == 0 then
                 log.info('### receive create role')
                 network_sender:selectRole(msg.ri.playerid)
                 game_info.role_info = msg.ri
                 game_info.player_id = msg.ri.playerid
                 network_sender:reqChapterAchievementList()
                 network_sender:reqNotifyGuide()
            else
                --log.info('create role failed, RespCode:'..msg.RespCode)
            end
        elseif cmd == protocol_pb.SELECTROLE then
            -- 选择角色成功 
            if msg.RespCode == 0 then
                -- 进世界地图
                log.info('### receive select role')
                -- 初始化 player 中的值
                player.id = msg.playerid
                player.name = msg.rolename
                player.props[protocol_pb.PROP_LEVEL] = msg.level
                player.props[protocol_pb.PROP_CUREXP] = msg.curExp
                player.props[protocol_pb.PROP_GOLD] = msg.gold
                player.props[protocol_pb.PROP_DIAMOND] = msg.diamond
                player.props[protocol_pb.PROR_STEEL] = msg.steel
                player.props[protocol_pb.PROP_WOOD] = msg.wood
                player.props[protocol_pb.PROP_BRICK] = msg.brick
                player.props[protocol_pb.PROP_NUCLEAR] = msg.nuclear
                player.props[protocol_pb.PROP_BAG_CAPACITY] = msg.equipBagCap
                player.props[protocol_pb.PROP_PLAYER_STRENGTH] = msg.totalStrength

                -- 发送一些消息
                self:sendSomeMsg()
                
                --game_director:changeState('loading', {next_state = 'world_map', scene_name = 'hex_map'})

                app:startCoroutine(
                    function()
                        while not game_director.is_shader_warmup do
                            coroutine.yield(WaitForSeconds(0.1))
                            log.info("## Wait shader warmup..")
                        end

                        --if msg.hasShareCity == 1 then
                            -- 选择角色后进个人基地
                            game_director:changeState('loading', {next_state = 'home', scene_name = 'home'})
                        --else
                            -- 选择公共基地
                        --    game_director:changeState('select_base')
                        --end
                    end
                )

            else
                --log.info('select role failed, RespCode:'..msg.RespCode)
            end
        end
    end,

    sendSomeMsg = function(self)
        network_sender:getChatChannelList()
    end,

    onExit = function(self)
        --self.gui:destroy()
        if self.gui then
            frame_manager:hide('create_role')
            self.gui = nil
        end
        network:unregisterMessageHandler(self)
    end,
}