local super = require('game.game_state_map_base')
local log = logger.get("Game", "game_state_world_map")

return class {
    super = super,

    ctor = function(self, ...)
        super.ctor(self, ...)
        self.map_type = protocol_pb.MAP_ISLAND
    end,

    onEnter = function(self, args)
        self.gui = frame_manager:show('island', self)
        super.onEnter(self, args)
        network_sender:enterWorldMap(self.map_type)
    end,

    onMessage = function(self, cmd, msg)
        super.onMessage(self, cmd, msg)
        --[[
        -- 创建工会
        if cmd == protocol_pb.CREATEFAMILY then 
            if msg.RespCode == 0 then
                frame_manager:hide('guild_apply')
            end
        -- 获得工会列表
        elseif cmd == protocol_pb.GETFAMILYLIST then
            self.guild_apply = frame_manager:show('guild_apply', self.owner, {msg = msg})
        -- 申请 or 取消
        elseif cmd == protocol_pb.FAMILYJOINORCANCEL then
            -- print("RespCode", msg.RespCode, msg.status, msg.familyid, msg.lefttime)
        -- 工会详情
        elseif cmd == protocol_pb.GETFAMILYINFO then
            if self.guild_info then
                self.guild_info:refreshInfo(msg)
            else
                self.guild_info = frame_manager:show('guild_info', self, {msg = msg})
            end
        -- 工会通知
        elseif cmd == protocol_pb.NOTIFYFAMILYINFO then
            local_player:setGuildId(msg.familyId)
            if local_player:isInGuild() then
                frame_manager:hide('guild_apply')
            end
        -- 工会成员
        elseif cmd == protocol_pb.GETMEMBERLIST then
            if msg.respCode == 0 then
                frame_manager:show('guild_members', self, {msg = msg})
            end
        -- 获取邀请我的工会列表
        elseif cmd == protocol_pb.GETINVITEDFAMILYLIST then
            -- print("##### 获取邀请我的工会列表:", #msg.familyInfo, msg.respCode)
            if msg.respCode == 0 then
                if self.guild_apply then
                    self.guild_apply:showInviteGuildList(msg)
                end
            end
        -- 工会成员升阶降阶
        elseif cmd == protocol_pb.FAMILYMEMBERPROMOTE then
            -- print("FAMILYMEMBERPROMOTE respCode:", msg.respCode)
            if msg.respCode == 0 then
                game_director.events:dispatch("FAMILYMEMBERPROMOTE", msg)
            end
        -- 开除工会成员
        elseif cmd == protocol_pb.EXPELFAMILYMEMBER then
            -- print("EXPELFAMILYMEMBER respCode:", msg.respCode)
            if msg.respCode == 0 then
                game_director.events:dispatch("EXPELFAMILYMEMBER", msg)
            end
        -- 获取工会日志
        elseif cmd == protocol_pb.GETFAMILYOG then
            -- print("收到服务器消息 获取工会日志")
            if msg.respCode == 0 then
                self.guild_logs = frame_manager:show('guild_logs', self, {msg = msg})
            end
        -- 获取工会留言
        elseif cmd == protocol_pb.GETFAMILYLEAVEWORD then
            if msg.respCode == 0 then
                self.guild_notes = frame_manager:show('guild_notes', self, {msg = msg})
            end
        -- 通知玩家新留言
        elseif cmd == protocol_pb.NOTIFYNEWLEAVEWORD then
            if self.guild_notes and frame_manager:isDisplay('guild_notes') then
                self.guild_notes:addWordList(msg.leaveWord)
            end
        -- 工会留言
        elseif cmd == protocol_pb.FAMILYLEAVEWORD then
            if msg.respCode == 0 then
                -- network_sender:getFamilyLeaveWord(local_player:getGuildId())
            end
        -- 修改工会信息
        elseif cmd == protocol_pb.MODIFYFAMILYINFO then
            if msg.respCode == 0 then
                print("工会信息界面修改，同步信息")
                network_sender:getFamilyInfo(local_guild:getId())
            end
        elseif cmd == protocol_pb.QUITFAMILY then
            if msg.respCode == 0 then
                frame_manager:hide('guild_set')
                frame_manager:hide('guild_info')
            end
        -- 搬迁返回结果
        elseif cmd == protocol_pb.MOVEPERSONALBASE then
            if msg.respCode == 0 then
                frame_manager:hideAll()
                game_director:changeState('loading', {next_state = 'world_map', scene_name = 'hex_map', next_state_ui_name = 'worldMap'})
            end
        end
        ]]
    end,
}
