super = require('game.game_state_base')
local log = logger.get("Game", "game_state_loading")

return class {
    super = super,

    ctor = function(self, ...)
        super.ctor(self, ...)
    end,

    onEnter = function(self, args)
        -- 释放上个场景的 ab
        if self.scene_asset_name then
            Fenix.Assets.Helper.UnloadSceneAB(self.scene_asset_name)
            self.scene_asset_name = nil
        end

        log.info('loading on enter next_state:'..args.next_state)
        self.args = args
        self.scene_name = args.scene_name
        self.next_state = args.next_state
        self.next_state_ui_name = args.ui_name

        if self.next_state == 'world_map' or 
            self.next_state == 'home' or 
            self.next_state == 'battle' or 
            self.next_state == 'battle_replay' or 
            self.next_state == 'level' then
                Fenix.Assets.Helper.ms_SyncLoad = true
        end 

        -- 恢复界面
        frame_manager:setFloorVisibility(0, true)
        frame_manager:setFloorVisibility(1, true)
        frame_manager:setFloorVisibility(2, true)
        frame_manager:setFloorVisibility(3, true)

        Time.timeScale = 1.0
        --[[
        self.gui = CreateFrame{
            class = "gui.loading_frame", 
            parent = game_director.gameObject, 
            name = "资源加载界面", 
            asset = 'Assets/Frames/LoadingFrame.prefab',
            owner = self,
        }]]

        if self.next_state == 'level' and not args.battle_back then
            log.info('####  frame_manager:show(level_loading)')
            -- 关卡 loading 界面
            self.gui = frame_manager:show('level_loading')
        else
            -- 通用 loading
            self.gui = frame_manager:show('loading')
        end

        app:startCoroutine(
            function()
                -- 加载场景中查一个空场景，释放前场景资源
                SceneManager.LoadScene("empty")
                coroutine.yield()

                if Fenix.App.GetInstance():IsUseAssetDatabase() or self.scene_name == 'main'  then
                    -- main 场景放在主包中
                    self.AsyncOp = SceneManager.LoadSceneAsync(self.scene_name);
                else
                    log.info("### Start ReadSceneInMemory:"..self.scene_name)
                    self.scene_asset_name = 'scene_'..self.scene_name..".unity3d"
                    app:startCoroutine(function()
                        -- 加载 ab 中的场景
                        coroutine.yield(
                            Fenix.Assets.Helper.ReadSceneInMemory(self.scene_asset_name, function()
                                log.info("### End ReadSceneInMemory:"..self.scene_name)
                                self.AsyncOp = SceneManager.LoadSceneAsync(self.scene_name)
                            end)
                        )
                    end)
                end

            end
        )


        --[[
        if Fenix.App.GetInstance():IsUseAssetDatabase() or self.scene_name == 'main'  then
            -- main 场景放在主包中
            self.AsyncOp = SceneManager.LoadSceneAsync(self.scene_name);
        else
            log.info("### Start ReadStreamingAssetSceneInMemory:"..self.scene_name)
            app:startCoroutine(function()
                -- 加载 ab 中的场景
                coroutine.yield(
                    Fenix.Assets.Helper.ReadStreamingAssetSceneInMemory('scene_'..self.scene_name..".unity3d", function()
                        log.info("### End ReadStreamingAssetSceneInMemory:"..self.scene_name)
                        self.AsyncOp = SceneManager.LoadSceneAsync(self.scene_name)
                    end)
                )
            end)
        end]]
        
    end,

    onUpdate = function(self, dt)
        if self.AsyncOp ~= nil then
            -- 场景加载中

            if self.AsyncOp.isDone then -- 判断场景是否加载完成
                -- 加载完成
                print('scene load finished.')
                self.AsyncOp = nil

                app:startCoroutine(
                    function()  
                        coroutine.yield(nil)

                        -- 显示下个状态的 UI
                        if self.next_state_ui_name then
                            local next_frame = frame_manager:show(self.next_state_ui_name)
                            app:startCoroutine(
                                function()
                                    while true do
                                        if next_frame.gameObject ~= nil then
                                            break
                                        end
                                    end
                                    game_director:changeState(self.next_state, self.args)

                                    coroutine.yield(WaitForSeconds(0.5))
                                    collectgarbage("collect")
                                    Fenix.Game.GameApp.GC()
                                end
                            )
                        else
                            game_director:changeState(self.next_state, self.args)
                            coroutine.yield(WaitForSeconds(0.5))
                            collectgarbage("collect")
                            Fenix.Game.GameApp.GC()
                        end

                    end
                )

            else
                if self.next_state == 'level' then
                    self.gui:setProgress(self.AsyncOp.progress)
                end
            end
        end

    end,

    onExit = function(self)
        -- 下一个界面打开后再关闭 loading
        --frame_manager:hide('loading')

    end,
}