﻿super = require('game.game_state_base')
local log = logger.get("Game", "game_state_login")

local ip = "112.124.10.221" -- 外网
local port = 7226

ip = "192.168.11.192"
port = 18228

--[[
ip = "47.90.214.96"
port = 7356
]]

if UnityEngine.Application.isEditor then
    --ip = "192.168.11.192"
    --port = 18228
    --ip = "192.168.0.119"  -- 石峰
    --port = 6226  --6227 7226
    -- ip = "192.168.0.101" -- 张少东
    -- port = 6226
    --ip = "192.168.0.122" -- 叶利勇
    --port = 7226
    -- ip = "192.168.0.75" -- 龙君
    -- port = 6666
    -- ip = "192.168.0.138" -- 刘晓-15261634436
    -- port = 7226
    -- ip = "127.0.0.1" -- 本机
    -- ip = "192.168.1.110"  -- 胖老师
    -- port = 7226 
    -- ip = "192.168.11.192" -- 测试服
    -- port = 6226
end

return class {
    super = super,

    -- 子状态
    sub_states = {
        UNKNOW = 0,
        CONNECT = 1,
        CONNECTING = 2,
        LOGIN = 3,
        WAIT_LOGIN = 4,     -- 等待  Login 完成
    },

    ctor = function(self, ...)
        super.ctor(self, ...)
        self.elapsed = 0.0
    end,

    onEnter = function(self, args)
       log.info('### game_state_login onEnter')

        -- 创建 login 界面
        -- self.gui = CreateFrame {
        --     class = "gui.login_frame", 
        --     parent = game_director.gameObject, 
        --     name = "登陆界面", 
        --     asset = 'Assets/Arts/ui/Frames/LoginFrame.prefab',
        --     owner = self,
        -- }

        log.info("### hide StartBG")
        Fenix.Game.GameApp.GetInstance().m_StartBG:SetActive(false)

        self.sub_state = self.sub_states.UNKNOW
        if not Fenix.Game.GameApp.IsSDKLogin() then
            self.gui = frame_manager:show('login', self)
        else
            if args.platform_id then
                game_info.account = args.platform_id
            else
                local app_inst = Fenix.Game.GameApp.GetInstance()  
                game_info.account =  app_inst:GetPlatformID()
            end

            if game_info.server_ip and game_info.server_port then
                ip = game_info.server_ip
                port = tonumber(game_info.server_port)
                log.info("### IP:"..ip..", port:"..port)              
            else
                Log.Error("No server ip or server port!!")

            end

            Fenix.Game.GameApp.account = game_info.account
            log.info("##### account:"..game_info.account)
            game_director:additionalInit()
            self:connect()
        end

        -- 开始同步加载
        Fenix.Assets.Helper.ms_SyncLoad = true
        network:registerMessageHandler(self)
    end,

    -- 进行连接 
    connect = function(self)
        log.info('## connect!')
        if not network:isConnected() then
            local rst = self:goToSubState(self.sub_states.CONNECT) 
            if not rst then
                self:failed(true)
            end
            return rst
        else
            network:close()
            app:startCoroutine(
            function()
                coroutine.yield(WaitForSeconds(1))
                if not self:goToSubState(self.sub_states.CONNECT) then
                    self:failed()
                end
            end)    
            return true
        end
    end,

    -- 进入子状态
    goToSubState = function(self, state)
        log.info("login goToSubState:"..tostring(state))

        if state == self.sub_states.CONNECT then
            --if self.sub_state == self.sub_states.UNKNOW then
                -- 进行连接 
                if not network:connect(ip, port) then
                    log.error("## network:connect failed!!")
                    return false
                end
            --else
            --    return false
           -- end
        elseif state == self.sub_states.LOGIN then
            log.info('### login:'..game_info.account)
            network_sender:login(game_info.account)
            app:logEvent("client_login", tostring(game_info.account))
        end

        self.sub_state = state
        log.info("sub state:"..tostring(state))
        return true
    end,

    canChangeTo = function(self, name, args) 
        return true
    end,

    onUpdate = function(self, dt)
        
        if not self.update_elapsed then
            self.update_elapsed = 0.0
        else
            self.update_elapsed = self.update_elapsed + dt
            if self.update_elapsed >= 1.0 and self.sub_state ~= 0 then
                self.update_elapsed = 0.0
                log.info("#### onUpdate, sub_state:"..tostring(self.sub_state))
            end
        end


        if self.sub_state == self.sub_states.CONNECT then
            self:goToSubState(self.sub_states.CONNECTING)

        elseif self.sub_state == self.sub_states.CONNECTING then
            -- todo 计算连接超时 
            if network:isConnected() then
                self:goToSubState(self.sub_states.LOGIN)
            end
        elseif self.sub_state == self.sub_states.LOGIN then
            self:goToSubState(self.sub_states.WAIT_LOGIN)
        else
        end

       -- log.info("curr sub state:"..tostring(self.sub_state)..", elapsed:"..self.elapsed)
        if self.sub_state ~= self.sub_states.UNKNOW then
            self.elapsed = self.elapsed + Time.unscaledDeltaTime
            if self.elapsed > 5.0 then
                self:failed()
            end
        end
    end,

    -- 网络消息 
    onMessage = function(self, cmd, msg)
        log.info("onMessage:"..tostring(cmd))
        if cmd == protocol_pb.LOGIN then
            -- 登陆成功 
            if msg.RespCode == 0 then
                game_info.role_list = msg.rolelist
                --log.info('role_list len:'..#game_info.role_list)
                game_director:changeState('create_role')
                --game_director:changeState('loading', {next_state = 'world_map', scene_name = 'world_map'})
            else
                log.info('login failed, RespCode:'..msg.RespCode)
                
                self:failed(RestCode)
            end
        end
    end,

    -- 连接/登陆失败了
    failed = function(self, is_too_fast, RstCode)


        if is_too_fast then
            hint:setText(NativeText.GetLangStr(999006)) --"connect too fast, try later!"
        else
            hint:setText(NativeText.GetLangStr(999007)) -- "connect server failed!"
        end

        if network:isConnected() then
            network:close()
        end

        self.elapsed = 0.0
        self.sub_state = self.sub_states.UNKNOW

        app:logEvent("client_loginfailed", tostring(RestCode or 'overtime'))

        if Fenix.App.GetInstance().m_UseSDKLogin then
            if not self.retry_count then
                self.retry_count = 0
            end
            self.retry_count = self.retry_count + 1

            if self.retry_count < 4 then
                -- 重新尝试连接
                self:retryConnect()
            else
                gui_helper:showMessageBox(
                    NativeText.GetLangStr(999001),
                    function()
                        self.retry_count = 0
                        self:retryConnect()
                    end
                )
            end
        else
            frame_manager:hide("loading")            
        end
    end,

    retryConnect = function(self)

        self.app_inst = Fenix.Game.GameApp.GetInstance()  
        local platform_id = self.app_inst:GetPlatformID()

        app:startCoroutine(
            function()
                coroutine.yield(WaitForSeconds(1.0))
                game_director:changeState('login', {platform_id = platform_id})               
            end
        )
    end,

    onExit = function(self, to_state_name)
        log.info('state onExit '..self.name)
        network:unregisterMessageHandler(self)
        
        if self.gui then
            frame_manager:hide("login")
            self.gui = nil
        end
    end,
}