super = require('game.game_state_base')
local stage_class = require('RTS.stage.rts_stage')

return class {
    super = super,

    ctor = function(self, ...)
        super.ctor(self, ...)
    end,

    onEnter = function(self, recruit_data)
        network:registerMessageHandler(self)
        self.recruit_data = recruit_data
        local battle_types = require('RTS.enums').battle_types
        self.stage = stage_class(battle_types.RECRUIT,{
            recruit_data = recruit_data,
        }) 
        self.stage:init()
    end,

    onUpdate = function(self, dt)
        self.stage:update(dt)
        self.check_elapsed = self.check_elapsed and self.check_elapsed + dt or 0.0
        if self.check_elapsed >= 5.0 then
            -- 战斗结束，回到个人基地场景
            if self.stage:isFinished() then
                print('战斗结束...')
                local result = self.stage.result
                local is_win = true
                if result == 0 then
                    is_win = false
                end

                local vsb, frame = frame_manager:isDisplay('recruit_settle')
                if not vsb then
                    frame_manager:show('recruit_settle', nil, {
                        is_win = is_win,
                        callback = function()
                            game_director:changeState('loading', {
                                next_state = 'home', 
                                scene_name = 'home', 
                                recruit_hero_id = self.recruit_data.recruit_hero_id,
                                recruit_rst = is_win and 1 or 0,
                            })
                        end
                    })
                end
            end
            self.check_elapsed = 0.0
        end
    end,

    onMessage = function(self, cmd, msg)
        if cmd == protocol_pb.ENDRECRUITFIGHT then
            
        end
    end, 
  
    onExit = function(self)
        network:unregisterMessageHandler(self)
        if self.stage then
            self.stage:destroy()
            self.stage = nil
        end
        game_director.pool:destroy()
    end,
}