super = require('game.game_state_base')
local log = logger.get("Game", "state sdk login")
localization_manager = require('game.localization_manager')

-- 手机平台才执行这个状态,等待平台登陆完成
return class {
    super = super,

    ctor = function(self, ...)
        super.ctor(self, ...)
    end,

    onEnter = function(self, args)
        self.elapsed = 0.0
        self.wait_ip_elapsed = 0.0

        self.count = 0
        self.app_inst = Fenix.Game.GameApp.GetInstance()  
        Fenix.Assets.Helper.ms_SyncLoad = true
        --self.gui = frame_manager:show('loading', self, {is_login = true, start = 0.0, max_progress = 1.0, inc_speed = 0.1})
    end,

    onUpdate = function(self, dt)
        self.wait_ip_elapsed = self.wait_ip_elapsed + Time.deltaTime
        if self.wait_ip_elapsed < 0.5 then
            return
        end
        self.wait_ip_elapsed = 0.0

        -- 等待申请到 platform_id 
        local platform_id = self.app_inst:GetPlatformID()
        local server_ip = self.app_inst:GetServerIP()
        local server_port = self.app_inst:GetServerPort()

        if not server_ip then
            log.info("## getServerIP 11")
            app:callJava("getServerIP")
        else
            game_info.server_ip = server_ip
        end

        if not server_port then
            log.info("## getServerPort 11")
            app:callJava("getServerPort")
        else
            game_info.server_port = server_port
        end

        if not platform_id then
            if not hint then
                hint = frame_manager:show('hint')
            end

            self.elapsed = self.elapsed + 0.5
            if self.elapsed > 2.0 then
                self.elapsed = 0.0
                log.error("### Wait sdk login for a long time!")
                self.count = self.count + 1

                if self.count > 3 then
                    self.count = 0
                    log.info("## initMobySDK")
                    app:callJava("initMobySDK") -- 超时重新初始化 sdk  

                    if hint then
                        Fenix.Game.GameApp.GetInstance().m_StartBG:SetActive(false)
                        hint:setText(NativeText.GetLangStr(9000107))
                    end
                end
            end                 
        end

        if platform_id and server_ip and server_port then
            log.info("### change state login, platform_id:"..tostring(platform_id)..","..server_ip..", "..server_port)
            -- 给平台发 token
            Fenix.App.GetInstance():SendNotifyTokenToSDKPlatform()

            --self.gui:setProgress(0.1)
            game_director:changeState('login', {platform_id = platform_id, ip = server_ip, port = server_port})
        end

        -- 走进度条
        --[[
        local progress = self.gui:getProgress()
        if progress < 0.1 then
            progress = progress + Time.deltaTime * 0.1
            self.gui:setProgress(progress)
        end]]
    end,

    onExit = function(self)

    end,
}