local log = logger.get("Game", "game_state_world_map")
local super = require('game.game_state_map_base')

return class {
    super = super,

    ctor = function(self, ...)
        super.ctor(self, ...)
        self.map_type = protocol_pb.MAP_WORLDMAP
    end,

    -- 初始化装饰物配置
    initDecorateCfg = function(self)
        -- 初始化世界地图装饰物信息
        if not self.world_map.cs_inst:IsWorldMapDecorateInited() then
            require('config.world_map_coords')

            local temp = {} 
            local arrPrefabs = {}
            local len = 0
            config.world_map_coords_partss:foreach(
                function(k,v)
                    temp[k] = v.path
                    len = len + 1
                end
            )
            for i = 1,len do
                table.insert(arrPrefabs, temp[i])
            end
            self.world_map.cs_inst:WorldMapDecorateParts(arrPrefabs)

            local arrX = {}
            local arrZ = {}
            local arrPartID = {}

            config.world_map_coords_coordss:foreach(
                function(k, v)
                    table.insert(arrX, v.x)
                    table.insert(arrZ, v.z)
                    table.insert(arrPartID, v.part)
                end
            )

            self.world_map.cs_inst:WorldMapDecorate(arrX, arrZ, arrPartID)
        end
    end,

    onEnter = function(self, args)
        game_state_world_map = self
        self.gui = frame_manager:show('worldMap', self)
       --frame_manager:hide("loading")
        super.onEnter(self, args)
        -- network_sender:enterWorldMap(self.map_type)
        self:initDecorateCfg()

        -- 显示队列
        frame_manager:show('summary_queue', nil)
    end,

    onExit = function(self, args)
        game_state_world_map = nil
        frame_manager:hide('worldMap')
        self.gui = nil
        super.onExit(self, args)
    end
}