local log = logger.get("Game", "guild")

guild_cls = class {
    ctor = function(self)
        self.events = require("base.event").new()
        self.id = ""
        self.info = nil -- common_pb.FamilyDetailInfo
        self.build_cfg = {} --联盟建筑配置
        self.build_cfg = self:getBuildCfg()
    end,

    clear = function(self)
        self.id = ""
        self.info = nil
        self.self_info = {}
    end,

    getId = function(self)
        return self.id
    end,

    setId = function(self, id, self_info)
        self.id = id
        self.self_info = self_info
        local_guild.events:dispatch("MEMBERINFOCHANGE", {memberInfo = self_info})
    end,

    setInfo = function(self, info)
        -- print(" 工会消息", info.familyName)
        self.info = info
        self.events:dispatch("guild_info_change")
    end,

    getInfo = function(self)
        return self.info
    end,

    inGuild = function(self, id)
        if id == "0" or id == "" or id == nil then
            return false
        else
            return true
        end
    end,

    isSelfInGuild = function(self)
        return self:inGuild(self:getId())
    end,

    isOwnGuild = function(self, id)
        if self:isSelfInGuild() then
            return self.id == id
        end

        return false
    end,

    -- MD_R1 	= 1;
    -- MD_R2 	= 2;
    -- MD_R3 	= 3;
    -- MD_R4 	= 4;
    -- MD_LEADER = 5;   //盟主
    getGuildLevel = function(self)
        if self:isSelfInGuild() then
            return true, self.self_info.degree
        else
            return false, 999
        end
    end,

    canEnterWorldMap = function(self)
        return true
        --[[
        if self:inGuild(self.id) and self.is_remove then
            return true
        else
            return false
        end
        ]]
    end,

    getBuildCfg = function(self)
        local tab = {}
        config.camp_buildings:foreach(
            function(k, v)
                if v.isguild == 1 then
                    tab[v.id] = {}
                    tab[v.id].curr_level = 0
                end
            end
        )

        config.union_building_buildingdetailss:foreach(
            function(k, v)
                tab[v.id][v.level] = v
            end
        )

        return tab
    end,

    -- 建造权限
    buildPermission = function(self)
        local _, lv = self:getGuildLevel()
        local need = config.union_others[1].BuildPermission

        if lv > need then
            hint:setText(NativeText.GetLangStr(190092))
        end

        return lv <= need
    end,

    -- 拆除权限
    destroyPermission = function(self)
        local _, lv = self:getGuildLevel()
        local need = config.union_others[1].RismantlePermission

        if lv > need then
            hint:setText(NativeText.GetLangStr(190092))
        end

        return lv <= need
    end,

    canDismiss = function(self)
        if self.info.familyLevel > 5 then
            hint:setText(NativeText.GetLangStr(999028))
            return false
        end

        if self.info.memberNum > 1 then
            hint:setText(NativeText.GetLangStr(999029))
            return false
        end

        return true
    end,
}

-- 本地玩家唯一实例
local_guild = guild_cls()
return local_guild
