local str_key = "localization_int"
local log = logger.get("Game", "Log")

return {
    init = function(self)
        self.lang_list = {
            UnityEngine.SystemLanguage.ChineseSimplified,
            UnityEngine.SystemLanguage.English,
        }

        local custom_value = self:get()
        CSVFileHelper.Init(custom_value)
    end,

    get = function(self)
        --[[
        local value = UnityEngine.PlayerPrefs.GetInt(str_key, -1)
        if value > 0 then
            return value
        else
            local value = self:convertToCustom(UnityEngine.Application.systemLanguage)
            self:set(value)
            return value
        end
        ]]
        return 2
    end,

    set = function(self, value)
        UnityEngine.PlayerPrefs.SetInt(str_key, value)
    end,

    -- 把系统语言转换成自己定义的枚举值
    convertToCustom = function(self, lang)
        for k, v in ipairs(self.lang_list) do
            if v == lang then
                return k
            end
        end
        return 1
    end,
}
