local log = logger.get("Game", "shop")

local shop_cls = class {
    ctor = function(self)
        self.events = require("base.event").new()
    end,

    setRefreshCountTime = function(self, count_time)
        self.count_time = count_time
    end,

    setShopTypes = function(self, shop_types)
        self.shop_types = shop_types
    end,

    setShopItems = function(self, shop_type, items)
        self.shop = self.shop or {}
        self.shop[shop_type] = items
        self.events:dispatch("shop_item_change")
    end,

    setRefreshInfo = function(self, shop_type, info)
        self.refresh_info = self.refresh_info or {}
        self.refresh_info[shop_type] = info
    end,

    getRefreshInfo = function(self, shop_type)
        return self.refresh_info[shop_type]
    end,

    isReady = function(self)
        if self.shop and self.shop_types then
            for __, shop_type in ipairs(self.shop_types) do
                -- print("@@@@:", shop_type, self.shop[shop_type] and #self.shop[shop_type])
                if not self.shop[shop_type] then
                    return false
                end
            end
            return true
        end
        return false
    end,

    clear = function(self)
        self.shop = nil
        self.refresh_info = nil
    end,

    clearItems = function(self, shop_type)
         if self.shop then
            self.shop[shop_type] = nil
         end
    end,

    setItemSold = function(self, shop_type, index)
        if self.shop[shop_type] then
            for __, item in ipairs(self.shop[shop_type]) do
                if item.index == index then
                    item.isCanBuy = 0
                end
            end
        end
        self.events:dispatch("shop_item_change")
    end,
}

local_shop = shop_cls()
return local_shop
