local item_cls = require('RTS.bag_sys.item')
local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.cfg_id = self.args.data

        clickEvents = {
            "closeBtn",
        }

        -- 注册点击事件
        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    click_closeBtn = function(self)
        frame_manager:hide('activity_detail_info')
    end,

    init = function(self)
        local path = "info/Scroll View (1)/Viewport/Content/"
        local tplt_path = "info/Scroll View (1)/Viewport/Content/tplt"
        frame_helper:hideAllChild(self, path)
        local cfg_list = self:getCfgList()
        for idx, cfg in ipairs(cfg_list) do
            local child = frame_helper:getChildByTemplatePath(self, idx, path, tplt_path)
            child:SetActive(true)

            local title = child:Find("bar/common_panel_26 (1)/text1_Static[T2]_3"):GetComponent(UnityEngine.UI.Text)
            if cfg.MinRank == cfg.MaxRank then
                title.text = cfg.MaxRank .. "st"
            else
                title.text = string.format("%sst - %sst", cfg.MinRank, cfg.MaxRank)
            end

            local icon = child:Find("rwd/icon"):GetComponent(UnityEngine.UI.Image)
            local num = child:Find("rwd/icon/num"):GetComponent(UnityEngine.UI.Text)
            local price = child:Find("rwd/price"):GetComponent(UnityEngine.UI.Text)
            price.text = string.format(NativeText.GetLangStr(680019), cfg.AwardPrice)

            local rwd = loadstring("return " .. cfg.RmbAward)()
            for item_id, item_num in pairs(rwd) do
                icon:SetSprite(frame_helper:getItemIcon(item_id))
                num.text = frame_helper:itemNumFormat(item_num)
            end

            local item_path = path .. child.name .. "/item layout"
            frame_helper:hideAllChild(self, item_path, true)
            local rwd = loadstring("return " .. cfg.Award)()
            local temp_idx = 0
            for item_id, count in pairs(rwd) do
                temp_idx = temp_idx + 1
                local item = frame_helper:getChild(self, temp_idx, item_path)
                item:SetActive(true)

                local quality = item:GetComponent(UnityEngine.UI.Image)
                local icon = item:Find("icon"):GetComponent(UnityEngine.UI.Image)
                local num = item:Find("num"):GetComponent(UnityEngine.UI.Text)
                num.text = count
                icon:SetSprite(frame_helper:getItemIcon(item_id))
                quality:SetSprite(frame_helper:getItemQualityIcon(item_id))

                local btn = item:Find("icon"):GetComponent(UnityEngine.UI.Button)
                btn.onClick:RemoveAllListeners()
                btn.onClick:AddListener(function()
                    local item_inst = item_cls({cfgId = item_id, count = count})
                    frame_manager:show("itemInfo", nil, {item = item_inst})
                end)
            end
        end
    end,

    getCfgList = function(self)
        local cfg_list = {}
        config.active_rank_awards:foreach(function(id, cfg)
            if cfg.ActiveType == self.cfg_id then
                table.insert(cfg_list, cfg)
            end
        end)
        local sortFunc = function(a, b)
            return a.id < b.id
        end
        table.sort(cfg_list, sortFunc)
        return cfg_list
    end,
}
