local gui_helper = require('gui.gui_helper')

-- 宝箱信息 panel
return class {
    ctor = function(self, info_panel, owner)
        self.panel = info_panel
        self.owner = owner
        self.parent = self.panel.parent
        self.helper = require("gui.tool.frame_helper")

        self.grade = info_panel:Find('Top/Grade'):GetComponent(UnityEngine.UI.Image)
        self.icon = info_panel:Find('Top/Icon'):GetComponent(UnityEngine.UI.Image)
        self.name = info_panel:Find('Top/Name'):GetComponent(UnityEngine.UI.Text)
        self.use_level = info_panel:Find('Top/TitleUseLevel/UseLevel'):GetComponent(UnityEngine.UI.Text)
        --self.count = info_panel:Find('Top/Count'):GetComponent(UnityEngine.UI.Text)
        self.slot_root = info_panel:Find('Center/Scroll View/Viewport/Content')

        self.item = nil

        self.btn_use = info_panel:Find("Bottom/ButtonUsed")
        self.btn_sell = info_panel:Find("Bottom/ButtonSell")

        if self.btn_use and self.btn_sell then
            self.pos = self.btn_use.localPosition
        end

        self:hide()
    end,

    showItem = function(self, item)
        self.helper.showTrans(self.parent)
        self.helper.showTrans(self.panel)      

        self.item = item
        
        self.grade:SetSprite(gui_helper:getQualityIconPath(item.cfg.color))
        self.icon:SetSprite(gui_helper:getItemIconPath(item.cfg))
        self.name.text = self.helper:getLangCfg(item.cfg.name_id)
        self.name.color = gui_helper:quality2UnityColor(item.cfg.color)
        self.use_level.text = tostring(item.cfg.uselevel)
        --self.count.text = tostring(item.count)
        self:setDropItems()

        if self.btn_use and self.btn_sell then
            self:setButtonPosition(item)
        end
    end,

    setDropItems = function(self)
        local items = gui_helper:getDropItems(self.item.cfg.drop_id)
        
        if not items then
            return
        end

        for k, v in ipairs(items) do
            local slot = nil
            if self.slot_root.childCount < k then
                slot = GameObject.Instantiate(self.owner.slot_prefab).transform
                slot:SetParent(self.slot_root)
                makeRectTransformIdentity(slot)
            else
                slot = self.slot_root:GetChild(k-1)
            end

            local item = nil
        
            if slot.childCount == 0 then
                item = GameObject.Instantiate(self.owner.item_prefab).transform
                item:SetParent(slot)
                makeRectTransformIdentity(item) 
            else
                item = slot:GetChild(0)
                item:SetActive(true)
            end

            local icon = item:Find('Icon')
            item:Find('Num'):SetActive(false)
            item:Find('Level'):SetActive(false)

            -- 设置 icon
            local img = icon:GetComponent(UnityEngine.UI.Image)
            img.color = Color.white
            local icon_path = gui_helper:getItemIconPath(v)
            img:SetSprite(icon_path)
        end

        for i = #items, self.slot_root.childCount-1 do
            local slot = self.slot_root:GetChild(i)
            if slot.childCount > 0 then
                local item = slot:GetChild(0)
                item:SetActive(false)
            end
        end
    end,

    setButtonPosition = function(self, item)
        if item.cfg.saleprice == 0 then
            self.btn_sell:SetActive(false)
            local pos = self.btn_use.localPosition
            pos.x = 0
            self.btn_use.localPosition = pos
        else
            self.btn_sell:SetActive(true)
            self.btn_use.localPosition = self.pos
        end
    end,

    hide = function(self)
        self.helper.hideTrans(self.parent)
        self.helper.hideTrans(self.panel)
    end,

}