local gui_helper = require('gui.gui_helper')

-- 消耗品信息 panel
return class {
    ctor = function(self, info_panel)
        self.panel = info_panel
        self.parent = self.panel.parent
        self.helper = require("gui.tool.frame_helper")

        self.grade = info_panel:Find('Top/Grade'):GetComponent(UnityEngine.UI.Image)
        self.icon = info_panel:Find('Top/Icon'):GetComponent(UnityEngine.UI.Image)
        self.name = info_panel:Find('Top/Name'):GetComponent(UnityEngine.UI.Text)
        self.count = info_panel:Find('Top/TitleCount/Count'):GetComponent(UnityEngine.UI.Text)
        self.des = info_panel:Find('Center/PropDes'):GetComponent(UnityEngine.UI.Text)

        self.btn_use = info_panel:Find("Bottom/ButtonUsed")
        self.btn_sell = info_panel:Find("Bottom/ButtonSell")

        if self.btn_use and self.btn_sell then
            self.pos = self.btn_use.localPosition
        end

        self:hide()
    end,

    showItem = function(self, item)
        self.helper.showTrans(self.parent)
        self.helper.showTrans(self.panel)      

        self.grade:SetSprite(gui_helper:getQualityIconPath(item.cfg.color))
        self.icon:SetSprite(gui_helper:getItemIconPath(item.cfg))
        self.name.text = self.helper:getLangCfg(item.cfg.name_id)
        self.name.color = gui_helper:quality2UnityColor(item.cfg.color)
        self.count.text = tostring(item.count)
        self.des.text = self.helper:getLangCfg(item.cfg.des_id)

        if self.btn_use and self.btn_sell then
            self:setButtonPosition(item)
        end
    end,

    setButtonPosition = function(self, item)
        if item.cfg.saleprice == 0 then
            self.btn_sell:SetActive(false)
            local pos = self.btn_use.localPosition
            pos.x = 0
            self.btn_use.localPosition = pos
        else
            self.btn_sell:SetActive(true)
            self.btn_use.localPosition = self.pos
        end
    end,

    hide = function(self)
        self.helper.hideTrans(self.parent)
        self.helper.hideTrans(self.panel)
    end,
}