local log = logger.get("Game", "fast resolve panel")

return class{
    ctor = function(self, panel)
        self.panel = panel
        self.owner = owner
        self.helper = require("gui.tool.frame_helper")

        self.toggle_root = self.panel:Find('Panel/BG')
        self.toggle_white = panel:Find('Panel/BG/Toggle_White'):GetComponent(UnityEngine.UI.Toggle)
        self.toggle_green = panel:Find('Panel/BG/Toggle_Green'):GetComponent(UnityEngine.UI.Toggle)
        self.toggle_blue = panel:Find('Panel/BG/Toggle_Blue'):GetComponent(UnityEngine.UI.Toggle)
        self.toggle_purple = panel:Find('Panel/BG/Toggle_Purple'):GetComponent(UnityEngine.UI.Toggle)
        self.toggle_orange = panel:Find('Panel/BG/Toggle_Orange'):GetComponent(UnityEngine.UI.Toggle)

        self.is_visible = false
        self:hide()
    end,

    show = function(self)
        self.helper.showTrans(self.panel)
        self.is_visible = true
        gui_helper:setToggleState(self.toggle_root, "fast_resolve_toggles")
    end,

    hide = function(self)
        self.helper.hideTrans(self.panel)
        self.is_visible = false
    end,

    -- 获取选择品质的道具
    getSelectedItems = function(self)
        local items = {}
        local weapon_bag_type = 1
        local bag = bag_manager:getBag(weapon_bag_type)

        -- 白绿蓝紫橙 1,2,3,4,5
        if self.toggle_white.isOn then
            --log.info('### white is on!!')
            bag:getItemsByQuality(1, items)
        end
        if self.toggle_green.isOn then
            --log.info('### green is on!!')
            bag:getItemsByQuality(2, items)
        end
        if self.toggle_blue.isOn then
            --log.info('### blue is on!!')
            bag:getItemsByQuality(3, items)
        end
        if self.toggle_purple.isOn then
            --log.info('### purple is on!!')
            bag:getItemsByQuality(4, items)
        end
        if self.toggle_orange.isOn then
            --log.info('### orange is on!!')
            bag:getItemsByQuality(5, items)
        end
        
        gui_helper:saveToggleState(self.toggle_root, "fast_resolve_toggles")

        return item_helper:getUnlockedItems(items)
    end,
}