local gui_helper = require('gui.gui_helper')

-- 使用道具 panel
return class {
    ctor = function(self, info_panel, owner)
        self.panel = info_panel
        self.parent = self.panel.parent
        self.helper = require("gui.tool.frame_helper")

        self.grade = info_panel:Find('Top/Grade'):GetComponent(UnityEngine.UI.Image)
        self.icon = info_panel:Find('Top/Icon'):GetComponent(UnityEngine.UI.Image)
        self.name = info_panel:Find('Top/Name'):GetComponent(UnityEngine.UI.Text)
        self.des = info_panel:Find('Top/Des'):GetComponent(UnityEngine.UI.Text)
        self.total_count = info_panel:Find('Center/CountLayout/Amount'):GetComponent(UnityEngine.UI.Text)
        self.slider = info_panel:Find("Center/CountLayout"):GetComponent(UnityEngine.UI.Slider)

        self.slider.onValueChanged:RemoveAllListeners()
        self.slider.onValueChanged:AddListener(
            function ()
                self:onValueChanged()
            end
        )

        local path_root = "Frame/UsedInfo/ItemUsed/Center/CountLayout/"
        owner:setScript("click", path_root.."Minus", functor.rmake(self.onClick_Minus, self))
        owner:setScript("click", path_root.."Plus", functor.rmake(self.onClick_Plus, self))

        self:hide()
    end,

    onValueChanged = function(self)
        if not self.changed then
            self.count = math.ceil(self.slider.value * self.item.count)
            self:limit()
        else
            self.changed = false
        end
        self:updateTotalCount()
    end,

    showItem = function(self, item)
        self.helper.showTrans(self.parent)
        self.helper.showTrans(self.panel)      

        self.item = item
        self.count = 1

        self.grade:SetSprite(gui_helper:getQualityIconPath(item.cfg.color))
        self.icon:SetSprite(gui_helper:getItemIconPath(item.cfg))
        self.name.text = self.helper:getLangCfg(item.cfg.name_id)
        self.name.color = gui_helper:quality2UnityColor(item.cfg.color)
        self.des.text = self.helper:getLangCfg(item.cfg.des_id)
        --self:updateTotalCount()
        self:changeCount(0)
    end,

    updateTotalCount = function(self)
        self.total_count.text = string.format( "%d/%d", self.count, self.item.count )
        gui_helper.used_item_count = self.count
    end,

    changeCount = function(self, val)
        --self.slider.value = val/self.item.count + self.slider.value
        self.count = self.count + val
        self.changed = true
        self.slider.value = self.count/self.item.count
        self:limit()
    end,

    onClick_Minus = function(self)
        if self.item_used_panel.count > 0 then
            self.item_used_panel:changeCount(-1)
        end
    end,

    onClick_Plus = function(self)
        if self.item_used_panel.count < self.item_used_panel.item.count then
            self.item_used_panel:changeCount(1)
        end
    end,

    hide = function(self)
        self.helper.hideTrans(self.parent)
        self.helper.hideTrans(self.panel)
    end,

    limit = function(self)
        if self.item.cfg_id ~= 90003 then
            return
        end
        
        local curr_cnt = hero_manager:getHeroAmount()
        local max_cnt = local_player:getMaxHeroCnt()
        if curr_cnt + self.count > max_cnt then
            self.count = max_cnt - curr_cnt
            self:changeCount(0)
        end
    end,
}