local gui_helper = require('gui.gui_helper')

-- 配件信息 panel
return class {
    ctor = function(self, info_panel)
        self.panel = info_panel
        self.parent = self.panel.parent
        self.helper = require("gui.tool.frame_helper")

        self.grade = info_panel:Find('Top/Grade'):GetComponent(UnityEngine.UI.Image)
        self.icon = info_panel:Find('Top/Icon'):GetComponent(UnityEngine.UI.Image)
        self.name = info_panel:Find('Top/Name'):GetComponent(UnityEngine.UI.Text)
        --self.use_level = info_panel:Find('Top/UseLevel'):GetComponent(UnityEngine.UI.Text)
        --self.des = info_panel:Find('Center/PropDes'):GetComponent(UnityEngine.UI.Text)
        self.type_text = info_panel:Find("Top/Type"):GetComponent(UnityEngine.UI.Text)

        self.btn_sell = info_panel:Find("Bottom/ButtonSell")

        self:hide()
    end,

    showItem = function(self, item)
        self.helper.showTrans(self.parent)
        self.helper.showTrans(self.panel)      

        self.grade:SetSprite(gui_helper:getQualityIconPath(item.cfg.color))
        self.icon:SetSprite(gui_helper:getItemIconPath(item.cfg))
        self.name.text = self.helper:getLangCfg(item.cfg.name_id)
        self.name.color = gui_helper:quality2UnityColor(item.cfg.color)
        --self.use_level.text = tostring(item.cfg.uselevel) 
        --self.des.text = self.helper:getLangCfg(item.cfg.des_id)
        self.type_text.text = gui_helper:getWeaponType(item.cfg)

        local prop_node = self.panel:Find('Center')
        gui_helper:showUpgradeProps(prop_node, item.props, nil, true)

        if self.btn_sell then
            self.btn_sell:SetActive(item.cfg.saleprice ~= 0)
        end
    end,

    hide = function(self)
        self.helper.hideTrans(self.parent)
        self.helper.hideTrans(self.panel)
    end
}