local log = logger.get("Game", "weapon info panel")
local gui_helper = require('gui.gui_helper')

-- 武器信息 panel
return class {
    
    ctor = function(self, panel)
        self.panel = panel
        self.parent = self.panel:GetParent()
        self.helper = require("gui.tool.frame_helper")

        self:hide()
    end,

    showItem = function(self, equipment)
        self.helper.showTrans(self.parent)
        self.helper.showTrans(self.panel)

        self:setEquipInfo(self.panel, equipment)
    end,

    setEquipInfo = function(self, node, equip)
        local name = node:Find('Top/Name'):GetComponent(UnityEngine.UI.Text)
        local type = node:Find('Top/Type'):GetComponent(UnityEngine.UI.Text)
        local props_node = node:Find('Props')
        local grade = node:Find('Grade'):GetComponent(UnityEngine.UI.Image)
        local icon = node:Find('Grade/Icon'):GetComponent(UnityEngine.UI.Image)

        name.text = self.helper:getLangCfg(equip.cfg.name_id)
        type.text = gui_helper:getWeaponType(equip.cfg)
        name.color = gui_helper:quality2UnityColor(equip.cfg.color)

        local icon_path = gui_helper:getItemIconPath(equip.cfg)
        icon:SetSprite(icon_path)
        grade:SetSprite(gui_helper:getQualityIconPath(equip.cfg.color))

        local cnt = 0
        for k, v in pairs(equip.cfg.basic_attr) do
            local cfg = config.player_config_attrs[k]
            if cfg then
                if cnt < props_node.childCount then
                    local elem = props_node:GetChild(cnt)
                    elem:SetActive(true)

                    local des = elem:GetComponent(UnityEngine.UI.Text)

                    local value = v
                    if cfg.isfloat > 0 then
                        value = value * 0.0001
                    end

                    if cfg.showpercent > 0 then
                        value = value*100 .."%"
                    end

                    des.text = string.format( "%s <color=#0BFF78FF>+%s</color>", frame_helper:getLangCfg(cfg.name_id), tostring(value) )
                end

                cnt = cnt + 1
            end
        end

        for i=cnt, props_node.childCount - 1 do
            local elem = props_node:GetChild(i)
            elem:SetActive(false)
        end
    end,

    hide = function(self)
        self.helper.hideTrans(self.parent)
        self.helper.hideTrans(self.panel)
    end,
}