local log = logger.get("Game", "Battle Settlement")
local super = require("ui.frame")

return class{
    super = super,

    onLoaded = function (self)
        super.onLoaded(self)

        self.owner = self.args.owner
        self.msg = self.args.data
        
        clickEvents = {
            "BG",
        }

        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)
        
        self.win = self.transform:Find("BG/victory")
        self.defeat = self.transform:Find("BG/defeat")

        self:init()
    end,

    onUnload = function(self)

    end,

    init = function(self)
        local skeleton_graphic = nil
        if game_info.battle_result == 0 or not game_info.battle_result then
            self.win:SetActive(false)
            self.defeat:SetActive(true)
            skeleton_graphic = self.defeat:GetComponent(Spine.Unity.SkeletonGraphic)

        else
            self.win:SetActive(true)
            self.defeat:SetActive(false)
            skeleton_graphic = self.win:GetComponent(Spine.Unity.SkeletonGraphic)
        end

        local anim_state = skeleton_graphic.AnimationState
        if anim_state then
            anim_state:SetAnimation(0, 'enter', false)
            app:startCoroutine(
                function()
                    coroutine.yield(WaitForSeconds(1.67))
                    anim_state:SetAnimation(0, 'idle', true)
                end
            )
        else
            log.error("Failed to find anim state")
        end   

    end,

    click_BG = function(self)
        frame_manager:hide("battle_settle")

        if game_state_battle then
            game_state_battle:backToLevel()
        elseif game_state_battle_replay then
            game_state_battle_replay:backToWorldMap()
        else
            log.error("战斗结束，不在战斗状态")
        end

    end,
}