local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        -- self.msg = self.args.data

        clickEvents = 
        {
            "content/close",
            "content/Window/confirmBtn",
            "content/Window/cancelBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        -- self.language_id = self.msg.familyInfo.settingInfo.familylanguage
        -- self:initLanguageUI(self.language_id)

        self:initUI()
    end,

    onUnload = function (self)
    end,

    click_close = function(self)
        frame_manager:hide('chat_channel')
    end,

    click_confirmBtn = function(self)
        local_chat:setDefaultChannel(self.default_channel)
        frame_manager:hide('chat_channel')
    end,

    click_cancelBtn = function(self)
        frame_manager:hide('chat_channel')
    end,

    -- 初始化语言选择界面
    initUI = function(self)
        local list = local_chat:getChannelList()
        if not list then
            return
        end

        local parent_path = "content/Window/Scroll View/Viewport/Content/"
        for __, value in ipairs(list) do
            local child = self.helper:getChild(self, __, parent_path)
            local button = child:GetComponent(UnityEngine.UI.Button)
            button.onClick:AddListener(
                function ()
                    self:click_select(value)
                end
            )

            local des_text = child.transform:Find("Text"):GetComponent(UnityEngine.UI.Text)
            des_text.text = value.name

            local select_bg = child.transform:Find("select_bg"):GetComponent(UnityEngine.UI.Image)
            local select_point = child.transform:Find("select_point"):GetComponent(UnityEngine.UI.Image)
            
            self.cache = self.cache or {}
            table.insert(self.cache, {value = value, trans = child, select_bg = select_bg, select_point = select_point})
        end

        local default_channel = local_chat:getDefaultChannel()
        self:click_select(default_channel)
    end,

    -- 选择语言
    click_select = function(self, value)
        self.default_channel = value
        for __, item in ipairs(self.cache) do
            if item.value.id == value.id then
                item.select_bg.enabled = true
                item.select_point.enabled = true
            else
                item.select_bg.enabled = false
                item.select_point.enabled = false
            end
        end
    end,
}
