local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")
local num = 4

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)
        
        self.MCollectionPos = self.args.data.pos
        self.is_edit = self.args.data.is_edit
    
        clickEvents = 
        {
            "closeBtn",
            "content/collectBtn",
        }

        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init(self.MCollectionPos)
    end,

    onUnload = function (self)
    end,

    init = function(self, pos)
        local title_text = self:findText("content/bg/text1_Static[T2]_7")
        local btn_text = self:findText("content/collectBtn/text1_Static[T4]_1")
        local coord_text = self:findText("content/cur_coord")
        local input = self.transform:Find("content/InputField"):GetComponent(UnityEngine.UI.InputField)

        local place_holder = self.transform:Find("content/InputField/Placeholder"):GetComponent(UnityEngine.UI.Text)

        coord_text.text = gui_helper:coordFormat(world_map_info:getServerId(), pos.posX, pos.posY) 
        input.onValueChanged:AddListener(function()
                pos.strDesc = input.text
            end)

        if self.is_edit then
            title_text.text = NativeText.GetLangStr(510006)
            btn_text.text = NativeText.GetLangStr(510007)
        else
            title_text.text = NativeText.GetLangStr(510001)
            btn_text.text = NativeText.GetLangStr(510005)
        end

        for i = 1, num do 
            local path = "content/layout/item (" .. i .. ")"
            self:setScript("click", path, functor.rmake(self.click_coord_tab, i))
        end

        if pos.strDesc == nil or pos.strDesc == "" then
            place_holder.text = NativeText.GetLangStr(100043)
        else
            input.text = pos.strDesc
        end
        self:click_coord_tab(nil, self:convertEtable2Tag(pos.eTable))
    end,

    refresh = function(self)
    end,

    convertEtable2Tag = function(self, eTable)
        if eTable == 0 then
            return 1
        elseif eTable == 1 then
            return 4
        elseif eTable == 2 then
            return 3
        elseif eTable == 3 then
            return 2
        end
    end,

    convertTag2Etable = function(self, index)
        if index == 1 then
            return 0
        elseif index == 2 then
            return 3
        elseif index == 3 then
            return 2
        elseif index == 4 then
            return 1
        end
    end,

    click_coord_tab = function(self, hander, index)
        self.MCollectionPos.eTable = self:convertTag2Etable(index)
        for i = 1, num do 
            local path = "content/layout/item (" .. i .. ")"
            self:findButton(path).interactable = index ~= i
        end
    end,

    click_closeBtn = function(self)
        frame_manager:hide('collect_coord')
    end,

    click_collectBtn = function(self)
        if self.MCollectionPos then
            local tmp = self.MCollectionPos
            if not self.is_edit then
                print("新增..坐标")
                network_sender:worldMapCollectionAdd(tmp.eTable, tmp.strDesc, tmp.iconId, tmp.posX, tmp.posY, world_map_info:getServerId())
            else
                print("修改..坐标")
                network_sender:worldMapCollectionMod(tmp.id, tmp.eTable, tmp.strDesc)
            end
        end 

        frame_manager:hide('collect_coord')
    end,
}
