--[[
    local tb = {
            title = "标题",
            content = "升级资源不够",

            onClose = function(){

            }
        }

    frame_manager:show('common_box_2', nil, tb)
]]

local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.owner = self.args.owner
        self.content = self.args.data

        clickEvents = {
            "content/closeBoxBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)
        
        self:init(self.content)
    end,

    init = function(self, content)
        local title = NativeText.GetLangStr(999002)
        if content.title and string.len(content.title) > 0 then
            title = content.title
        end
        self:findText("content/bg/title").text = title
        self:findText("content/bg/bg/content").text = content.content or ""
    end,

    onUnload = function (self)
    end,

    click_closeBoxBtn = function(self)
        frame_manager:hide('common_box_2')
        if self.content.onClose then
            self.content.onClose()
        end
    end,
}
