--[[
    local tb = {
            title = "标题",
            content = "升级资源不够",
            buttons =
            {
                {
                    btn_name = "取消",
                    callback = function() print("取消") end
                },
                {
                    btn_name = "打开背包",
                    callback = function() print("打开背包") end
                },
            },
            onClose = function(){

            }
        }

    frame_manager:show('common_box', nil, tb)
]]

local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.owner = self.args.owner
        self.content = self.args.data

        clickEvents = {
            "content/closeBoxBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)
        
        self:init(self.content)
    end,

    init = function(self, content)
        local title = NativeText.GetLangStr(999002)
        if content.title and string.len(content.title) > 0 then
            title = content.title
        end
        self:findText("content/bg/title").text = title
        self:findText("content/bg/bg/content").text = content.content or ""


        local layout_trans = self.transform:Find("content/bg/layout")
        for i = 0, layout_trans.childCount - 1 do
            layout_trans:GetChild(i).gameObject:SetActive(false)
        end

        for i, v in ipairs(content.buttons) do
            local btn_trans = layout_trans:GetChild(i - 1)
            btn_trans.gameObject:SetActive(true)
            self:findText("content/bg/layout/" .. btn_trans.name .. "/Text").text = v.btn_name
            if v.callback then self:setScript("click", "content/bg/layout/" .. btn_trans.name, v.callback) end
        end
    end,

    onUnload = function (self)
    end,

    click_closeBoxBtn = function(self)
        frame_manager:hide('common_box')
        if self.content.onClose then
            self.content.onClose()
        end
    end,
}
