local super = require("ui.frame")
local log = logger.get("Game", "Create Role Frame")

return class {
    super = super,

    onLoaded = function(self)
        log.info('create role Frame onLoaded!!')

        super.onLoaded(self)
        self:setScript("click", "Panel/ButtonCreateRole", self.onClickCreateRole)
        self:setScript("click", "Panel/ButtonDeleteRole", self.onClickDeleteRole)

        local trans = self.transform:Find("Panel/ButtonDeleteRole")
        self.btn_delete_role = trans.gameObject:GetComponent(UnityEngine.UI.Button)


        if #game_info.role_list > 0 then
            game_info.role_info = game_info.role_list[1]
            self:setRoleName(game_info.role_info.rolename)
            self.btn_delete_role.interactable = true
        else
            self.btn_delete_role.interactable = false
        end

         frame_manager:hide('loading')
    end,

    onClickCreateRole = function(self)
        local trans = self.transform:Find("Panel/InputFieldRoleName")
        local input_field = trans.gameObject:GetComponent(UnityEngine.UI.InputField)

        local t = input_field.text
        local t0 = string.gsub(t, " ", "")
        if t ~= t0 then
            input_field.text = t0
            t = t0
        end

        log.info('RoleName:'..t)
        self.owner:createRole(t)

        --super.setButtonCD(self, "Panel/ButtonCreateRole", 1.0)
    end,

    onClickDeleteRole = function(self)
    end,
    
    setRoleName = function(self, name)
        local trans = self.transform:Find("Panel/InputFieldRoleName")
        local input_field = trans.gameObject:GetComponent(UnityEngine.UI.InputField)
        log.info('RoleName:'..input_field.text)
        input_field.text = name

        trans = self.transform:Find("Panel/ButtonCreateRole/Text")
        text_role_name = trans.gameObject:GetComponent(UnityEngine.UI.Text)
        text_role_name.text = NativeText.GetLangStr(9000003)

    end

}