local log = logger.get("Game", "Dialog script")

return class{
    ctor = function(self, dialog_frame)
        self.dialog_frame = dialog_frame
        self.transform = dialog_frame.transform
        self.left_item = self.transform:Find("BG/LeftItem")
        self.right_item = self.transform:Find("BG/RightItem")
        self.center_item = self.transform:Find("BG/CenterItem")

        self.left_item_pos = self.left_item.transform.localPosition
        self.center_item_pos = self.center_item.transform.localPosition
        self.right_item_pos = self.right_item.transform.localPosition
        
        self.left_npc_pos = self.dialog_frame.left_orig
        self.center_npc_pos = self.dialog_frame.center_orig
        self.right_npc_pos = self.dialog_frame.right_orig
--[[
        log.info("### left npc pos:"..tostring( self.left_npc_pos))
        log.info("### center npc pos:"..tostring( self.center_npc_pos))
        log.info("### right npc pos:"..tostring( self.right_npc_pos))

        log.info("### left anchored pos:"..tostring( self.dialog_frame.left_npc.anchoredPosition))
        log.info("### center npc pos:"..tostring(self.dialog_frame.center_npc.anchoredPosition))
        log.info("### right npc pos:"..tostring(self.dialog_frame.right_npc.anchoredPosition))]]

        self.image_bg = self.transform:Find("BG/BGImage"):GetComponent(UnityEngine.UI.Image)
        self.overlayer = self.transform:Find("BG/Overlayer"):GetComponent(UnityEngine.UI.Image)

        dialog = self
        -- 测试
        
        --local func = require("gui.dialog_perform")[0]
        --app:startCoroutine(func)
    end,

    dtor = function(self)

    end,

    runPerformance = function(self, id)

        local func = require("gui.dialog_perform")[id]
        if func then
            self.is_running = true
            app:startCoroutine(func)
        else
            log.error("Failed to run performance:"..tostring(id))
        end

    end,

    -- 运行字符串对话脚本
    runScript = function(self, script)
        local func = loadstring("return function(self) "..script.." end")
        app:startCoroutine(func(self))
    end,
    
    aa = function(self, param)
        log.info("## aa".. tostring(param))
        coroutine.yield(WaitForSeconds(1))
    end,

    bb = function(self, param)
        log.info("## bb".. tostring(param))
        coroutine.yield(WaitForSeconds(1))
    end,

    -- 道具 icon 操作
    showLeftIcon = function(self, path)
        self.left_item:SetActive(true)
        local image = self.left_item:GetComponent(UnityEngine.UI.Image)
        if path then
            image:SetSprite(path)
        end

        image.color = Color(1,1,1,0.5)
        local lt = LeanTween.color(self.left_item, Color(1,1,1,1), 0.5)
        lt.loopType = LeanTweenType.once

        --log.info("#### rect width:" .. self.left_item.rect.width)
        local start = self.left_item.transform.localPosition.x
        local stop = start + self.left_item.rect.width*0.5
        lt = LeanTween.moveLocalX(self.left_item.gameObject, stop, 0.4)
        lt.loopType = LeanTweenType.once

    end,

    showRightIcon = function(self, path)
        self.right_item:SetActive(true)
        local image = self.right_item:GetComponent(UnityEngine.UI.Image)
        if path then
            image:SetSprite(path)
        end

        image.color = Color(1,1,1,0.5)
        local lt = LeanTween.color(self.right_item, Color(1,1,1,1), 0.5)
        lt.loopType = LeanTweenType.once

        --log.info("#### rect width:" .. self.right_item.rect.width)
        local start = self.right_item.transform.localPosition.x
        local stop = start - self.right_item.rect.width*0.5
        lt = LeanTween.moveLocalX(self.right_item.gameObject, stop, 0.4)
        lt.loopType = LeanTweenType.once

    end,

    showCenterIcon = function(self, path)
        self.center_item:SetActive(true)
        local image = self.center_item:GetComponent(UnityEngine.UI.Image)
        if path then
            image:SetSprite(path)
        end

        image.color = Color(1,1,1,0.5)
        local lt = LeanTween.color(self.center_item, Color(1,1,1,1), 0.5)
        lt.loopType = LeanTweenType.once

        --[[
        local start = self.right_item.transform.localPosition.x
        local stop = start - self.right_item.rect.width*0.5
        lt = LeanTween.moveLocalX(self.right_item.gameObject, stop, 0.4)
        lt.loopType = LeanTweenType.once]]

    end,

    hideLeftIcon = function(self, inverse)
        if self.left_item then
    
            local lt = LeanTween.color(self.left_item, Color(1,1,1,0.0), 0.5)
            lt.loopType = LeanTweenType.once

            local start = self.left_item.transform.localPosition.x
            local stop = nil
            if not inverse then
                stop = start - self.left_item.rect.width*0.5
            else
                stop = start + self.left_item.rect.width*0.5
            end
            
            lt = LeanTween.moveLocalX(self.left_item.gameObject, stop, 0.5)
            lt.loopType = LeanTweenType.once

            lt:setOnComplete(function()
                self.left_item:SetActive(false)
            end)

        end
    end,

    hideRightIcon = function(self, inverse)
        if self.right_item then
            
            local lt = LeanTween.color(self.right_item, Color(1,1,1,0.0), 0.5)
            lt.loopType = LeanTweenType.once

            local start = self.right_item.transform.localPosition.x
            local stop = start
            if not inverse then
                stop = start + self.right_item.rect.width*0.5
            else
                stop = start - self.right_item.rect.width*0.5
            end
            lt = LeanTween.moveLocalX(self.right_item.gameObject, stop, 0.5)
            lt.loopType = LeanTweenType.once

            lt:setOnComplete(function()
                self.right_item:SetActive(false)
            end)

        end
    end,

    hideCenterIcon = function(self, path)
        if self.center_item then
    
            local lt = LeanTween.color(self.center_item, Color(1,1,1,0.0), 0.5)
            lt.loopType = LeanTweenType.once

            lt:setOnComplete(function()
                self.center_item:SetActive(false)
            end)
        end      
    end,

    leftIconFly = function(self, to, time)
        local lt = LeanTween.moveLocal(self.left_item.gameObject, to, time)
        lt.loopType = LeanTweenType.once

    end,

    rightIconFly = function(self, to, time)
        local lt = LeanTween.moveLocal(self.right_item.gameObject, to, time)
        lt.loopType = LeanTweenType.once

    end,

    centerIconFly = function(self, to, time)
        local lt = LeanTween.moveLocal(self.center_item.gameObject, to, time)
        lt.loopType = LeanTweenType.once

    end,

    leftIconThrow = function(self, to, height, time)
        local lt = LeanTween.moveLocal(self.left_item.gameObject, to, time)
        lt.loopType = LeanTweenType.once

        local y = self.left_item.transform.localPosition.y + height
        lt = LeanTween.moveLocalY(self.left_item.gameObject, y, time * 0.5)
        lt.loopType = LeanTweenType.pingPong
        lt:setEase(LeanTweenType.easeOutQuad)
        lt.loopCount = 2
    end,

    centerIconThrow = function(self, to, height, time)
        local lt = LeanTween.moveLocal(self.center_item.gameObject, to, time)
        lt.loopType = LeanTweenType.once

        local y = self.center_item.transform.localPosition.y + height
        lt = LeanTween.moveLocalY(self.center_item.gameObject, y, time * 0.5)
        lt.loopType = LeanTweenType.pingPong
        lt:setEase(LeanTweenType.easeOutQuad)
        lt.loopCount = 2
    end,

    rightIconThrow = function(self, to, height, time)
        local lt = LeanTween.moveLocal(self.right_item.gameObject, to, time)
        lt.loopType = LeanTweenType.once

        local y = self.right_item.transform.localPosition.y + height
        lt = LeanTween.moveLocalY(self.right_item.gameObject, y, time * 0.5)
        lt.loopType = LeanTweenType.pingPong
        lt:setEase(LeanTweenType.easeOutQuad)
        lt.loopCount = 2

    end,

    -- 显示背景
    showBG = function(self, path)
        self.image_bg:SetSprite(path)
        self.image_bg.gameObject:SetActive(true)
        self.image_bg.color = Color(1,1,1,0)
        local lt = LeanTween.color(self.image_bg.transform, Color(1,1,1,1), 1.0)
        lt.loopType = LeanTweenType.once
    end,

    -- 隐藏背景
    hideBG = function(self, path)
        local lt = LeanTween.color(self.image_bg.transform, Color(1,1,1,0), 1.0)
        lt.loopType = LeanTweenType.once
        lt:setOnComplete(
            function()
                self.image_bg:SetActive(false)
            end
        )
    end,

    -- 背景震动
    shakeBG = function(self, time)
        app:startCoroutine(
            function()
                self:_DoShake(self.image_bg.transform, time or 0.5, 30)
            end
        )
    end,

    -- 左  NPC 震动 
    shakeLeft = function(self, time)
        app:startCoroutine(
            function()
                self:_DoShake(self.dialog_frame.left_npc, time or 0.5, 15)
            end
        )
    end,

    -- 右 npc 震动
    shakeRight = function(self, time)
        app:startCoroutine(
            function()
                self:_DoShake(self.dialog_frame.right_npc, time or 0.5, 15)
            end
        )
    end,

    -- 中间 npc 震动
    shakeCenter = function(self, time)
        app:startCoroutine(
            function()
                self:_DoShake(self.dialog_frame.center_npc, time or 0.5, 15)
            end
        )
    end,

    _DoShake = function(self, trans, _time, _strength)
        local elapsed = 0.0
        local orig = trans.localPosition
        while true do
            trans.localPosition = orig + Vector3.New(math.random(-_strength, _strength), math.random(-_strength, _strength), 0)
            coroutine.yield(nil)

            elapsed = elapsed + Time.deltaTime
            if elapsed >= _time then
                trans.localPosition = orig
                break
            end
        end
    end,

    -- 
    -- 显示遮盖层
    showOverlayer = function(self, fade_in_time)
        self.overlayer.gameObject:SetActive(true)
        self.overlayer.color = Color(0,0,0,0)
        local lt = LeanTween.color( self.overlayer.transform, Color(0,0,0,1), fade_in_time or 1.0)
        lt.loopType = LeanTweenType.once
    end,

    -- 隐藏遮盖曾
    hideOverlayer = function(self, fade_out_time)
        local lt = LeanTween.color( self.overlayer.transform, Color(0,0,0,0), fade_out_time or 1.0)
        lt.loopType = LeanTweenType.once
        lt:setOnComplete(
            function()
                self.overlayer.gameObject:SetActive(false)
            end
        )
    end,

    -- 设置遮盖层颜色
    setOverlayerColor = function(self, color, fade_time)
        if not fade_time or fade_time == 0 then
            self.overlayer.color = color
        else
            local lt = LeanTween.color( self.overlayer.transform, color, fade_time)
            lt.loopType = LeanTweenType.once
        end

    end,

    -- npc 移动
    leftNpcMove = function(self, pos, time)
        local lt = LeanTween.moveLocal(self.dialog_frame.left_npc.gameObject, pos, time or 1.0)
        lt.loopType = LeanTweenType.once
    end,

    rightNpcMove = function(self, pos, time)
        local lt = LeanTween.moveLocal(self.dialog_frame.right_npc.gameObject, pos, time or 1.0)
        lt.loopType = LeanTweenType.once
    end,

    centerNpcMove = function(self, pos, time)
        local lt = LeanTween.moveLocal(self.dialog_frame.center_npc.gameObject, pos, time or 1.0)
        lt.loopType = LeanTweenType.once
    end,

    wait = function(self, param)
        if param then
            coroutine.yield(WaitForSeconds(param))
        end
    end,

    setLeftEmotion = function(self, emotion_name)
        self.dialog_frame:setNpcEmotion(self.dialog_frame.left_npc, emotion_name)       
    end,

    setRightEmotion = function(self, emotion_name)
        self.dialog_frame:setNpcEmotion(self.dialog_frame.right_npc, emotion_name)       
    end,

    setCenterEmotion = function(self, emotion_name)
        self.dialog_frame:setNpcEmotion(self.dialog_frame.center_npc, emotion_name)       
    end,

    -- 在屏幕位置显示图片
    showImage = function(self, path, pos, fade_in_time, elapsed, fade_out_time)
        self.dialog_frame:showCustomImage(
                path, pos, fade_in_time or 0.1, elapsed or 1.0, fade_out_time or 0.1)
    end,

    performEnd = function(self)
        self.is_running = false
    end,

}