local super = require("ui.frame")
local cheat = require('RTS.cheat')
local log = logger.get("Game", "GM")
local PlayerPrefs = UnityEngine.PlayerPrefs

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)
        frame_gm = self

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "send"
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.inputText = self.transform:Find("InputField").gameObject:GetComponent(UnityEngine.UI.InputField)
        self.inputText.text = PlayerPrefs.GetString('last_cheat')
        self.pingText = self.transform:Find("TextPing").gameObject:GetComponent(UnityEngine.UI.Text)

    end,

    setPing = function(self, ping)
        self.pingText.text = tostring(ping).." ms"
        if ping > 200 then
            self.pingText.color = Color.red
        else
            self.pingText.color = Color.green
        end
    end,

    onUnload = function (self)
        frame_gm = nil
    end,

    click_send = function(self)
        print("GM:", self.inputText.text)
        local text = self.inputText.text

        -- 保存上次的命令
        PlayerPrefs.SetString('last_cheat', text)

        if string.sub(text,1,1) == "!" then
            local fun_name = string.sub(text, 2, -1)
            local str = "return function() require('RTS.cheat'):"..fun_name..' end'
            local fun = loadstring(str)()
            log.info(str)
            fun()
            --cheat[fun_name]()
        else
            network_sender:gm(text)
        end
        -- self.inputText.text = ""
    end,

    show = function(self)
        self.inputText:SetActive(true)
        self.transform:Find("send"):SetActive(true)
    end,

    hide = function(self)
        self.inputText:SetActive(false)
        self.transform:Find("send"):SetActive(false)
    end,
}
