local log = logger.get("Game", "Guild Build Dispatch Frame")
local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function(self)
        super.onLoaded(self)

        self.build = self.args.data.info

        clickEvents = 
        {
            "closeBoxBtn",
            "bg/Dispatch",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function(self)
        
    end,

    init = function(self)
        local count = self.transform:Find('bg/FillBG/Count'):GetComponent(UnityEngine.UI.Text)
        local fill = self.transform:Find('bg/FillBG/Fill'):GetComponent(UnityEngine.UI.Image)

        if self.build.info.curSoldierNum == 0 then
            local max = local_player:massSoldierMax()
            count.text = "0/"..self.helper:itemNumFormat(max)
            fill.fillAmount = 0
        else
            count.text = self.helper:itemNumFormat(self.build.info.curSoldierNum).."/"..self.helper:itemNumFormat(self.build.info.maxSoldierNum)
            fill.fillAmount = self.build.info.curSoldierNum / self.build.info.maxSoldierNum
        end
    end,

    click_closeBoxBtn = function(self)
        frame_manager:hide("guild_build_dispatch")
    end,

    click_Dispatch = function(self)
        if self.build.info.curSoldierNum == 0 then
            frame_manager:show("guild_building_launch", nil, {build = self.build, action = common_pb.EMARCH_BUILD})
        else
            frame_manager:show("guild_building_info", nil, {build = self.build})
        end
        self:click_closeBoxBtn()
    end,
}
