local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        -- self.game_state_island = self.args.owner
        self.msg = self.args.data.msg -- SCGetFamilyInfo
        self.is_in_notice = self.args.data.is_in_notice

        clickEvents = 
        {
            "close",
            "content/Window/cancelBtn",
            "content/Window/confirmBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        local cfg = config.union_others[1]
        self.title_text = self:findText("content/Window/title_text")
        self.title_text.text = self.is_in_notice and NativeText.GetLangStr(190050) or NativeText.GetLangStr(190051)

        self.des_text = self:findText("content/Window/des_text")
        self.des_text.text = string.format(self.is_in_notice and NativeText.GetLangStr(190082) or NativeText.GetLangStr(190083), self.is_in_notice and cfg.announcementlen or cfg.declarationlen )
        
        self.input_field = self.transform:Find("content/Window/InputField"):GetComponent(UnityEngine.UI.InputField)
        self.input_field.characterLimit = self.is_in_notice and cfg.announcementlen or cfg.declarationlen
        self.input_field.text = self.is_in_notice and self.msg.familyInfo.settingInfo.innotice or self.msg.familyInfo.settingInfo.outnotice
    end,

    click_confirmBtn = function(self)
        if self.is_in_notice then
            network_sender:modifyFamilyInfoInNotice(self.input_field.text)
        else
            network_sender:modifyFamilyInfoOutNotice(self.input_field.text)
        end
        frame_manager:hide('guild_edit_notice')
    end,

    click_cancelBtn = function(self)
        frame_manager:hide('guild_edit_notice')
    end,

    click_close = function(self)
        frame_manager:hide('guild_edit_notice')
    end,
}
