local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.msg = self.args.data.msg

        clickEvents = 
        {
            "content/cancelBtn",
            "content/confirmBtn",
            "content/Switch2",
            "content/Switch1",
            "closeBtn",
       }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.level_text =   self.transform:Find('content/guild_panel_9'):GetComponent(UnityEngine.UI.InputField)
        self.ability_text = self.transform:Find('content/guild_panel_10'):GetComponent(UnityEngine.UI.InputField)

        self.anyAddBtn = self.transform:Find("content/Switch1/okBtn")
        self.anyNotBtn = self.transform:Find("content/Switch1/noBtn")

        self.superviseAddBtn = self.transform:Find("content/Switch2/okBtn")
        self.superviseNotBtn = self.transform:Find("content/Switch2/noBtn")

        self:initUI()
    end,

    onUnload = function (self)

    end,

    initUI = function(self)
        -- 公会相关设置
        -- message FamilySetingsData
        -- {
        --     required MFamilyEmblem emblem	= 1;//徽章
        --     required string leaderId 		= 2;//会长id
        --     required uint32 familylanguage  = 3;//工会语言
        --     optional uint32 swordLimit		= 4;//加入工会战力限制	
        --     required uint32 lvLimit 		= 5;//加入工会等级的条件限制
        --     optional string outnotice 		= 6;//对外公告
        --     optional string innotice 		= 7;//对内公告
        --     required uint32 m_allowedAnyone = 8;//是否允许所有人加入 -- 是否需要审核
        --     optional uint32 livevalue 		= 9; //活跃度
        --     optional uint32 selfInviting	=10;//1表示开启自动邀请,0表示未开启
        -- }

        local setCfg = self.msg.familyInfo.settingInfo
        self.voluntarily_add_state = setCfg.selfInviting
        self.supervise_state = setCfg.m_allowedAnyone

        -- print("initUI:", setCfg.selfInviting, setCfg.m_allowedAnyone)

        self.invite_on = self.voluntarily_add_state == 1
        self.check_on = self.supervise_state == 1

        self.anyAddBtn:SetActive(self.invite_on)
        -- self.anyNotBtn:SetActive(not self.invite_on)

        self.superviseAddBtn:SetActive(self.check_on)
        -- self.superviseNotBtn:SetActive(not self.check_on)

        print("setCfg.lvLimit", setCfg.lvLimit, setCfg.swordLimit)
        self.level_text.text = tonumber(setCfg.lvLimit)
        self.ability_text.text = tonumber(setCfg.swordLimit)

        self:setTextColor(self.check_on)
    end,

    click_Switch1 = function(self)
        self.invite_on = not self.invite_on
        self.anyAddBtn:SetActive(self.invite_on)
    end,

    click_Switch2 = function(self)
        self.check_on = not self.check_on
        self.superviseAddBtn:SetActive(self.check_on)
        self:setTextColor(self.check_on)
    end,

    setTextColor = function(self, check_on)
        local text = self:findText('content/Formation_panel_20/text1_Static[T3]_3')
        text.color = check_on and Color.white or Color.grey

        local text = self:findText('content/Formation_panel_20/text1_Static[T5]_4')
        text.color = check_on and Color(64/255, 197/255, 252/255, 1) or Color.grey

        local text = self:findText('content/Formation_panel_20/text1_Static[T5]_4 (1)')
        text.color = check_on and Color(64/255, 197/255, 252/255, 1) or Color.grey
    end,

    click_cancelBtn = function(self)
        frame_manager:hide('guild_enlist')
    end,

    click_confirmBtn = function(self)
        
        local level = self.level_text.text
        if level then

        else
            level = 0
        end

        local voluntarily = self.ability_text.text
        if voluntarily then

        else
            voluntarily = 0
        end

        if tonumber(level) < 0 or tonumber(voluntarily) < 0 then
            return
        end

        -- 	optional uint32 invitingSetting		= 8;//自动邀请设置1表示开启，0表示关闭
        -- 	optional uint32 joinLimit			= 9;//加入工会限制，1表示需要达到等级和战力限制，2表示无限制条件
        -- 	optional uint32 levelLimit			=10;//等级限制
        -- 	optional uint32 swordLimit			=11;//战力限制

        self.voluntarily_add_state = self.invite_on and 1 or 0
        self.supervise_state = self.check_on and  1 or 2
        -- print("$", self.voluntarily_add_state, self.supervise_state)

        network_sender:modifyFamilyInfoEnlist(self.voluntarily_add_state, self.supervise_state, tonumber(level), tonumber(voluntarily))

        frame_manager:hide('guild_enlist')
    end,

    click_closeBtn = function(self)
        frame_manager:hide('guild_enlist')
    end,
}
