local super = require("ui.frame")
local log = logger.get("Game", "Guild Gift Info Frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.gift = self.args.data.msg

        clickEvents = 
        {
            "BG",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.normal_prefab = self.transform:Find("Prefabs/Normal").gameObject
        self.lucky_prefab = self.transform:Find("Prefabs/Lucky").gameObject

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        local name = self:findText("Content/text1_Static_15")
        local des = self:findText("Content/text1_Static_14")

        local item_cfg = item_helper:getItemCfg(self.gift.itemId)
        name.text = frame_helper:getLangCfg(item_cfg.name_id)

        local str = ""
        for k, v in ipairs(self.gift.luckNum) do
            if k == 1 then
                str = str..v
            else
                str = str..","..v
            end
        end
        des.text = string.format( NativeText.GetLangStr(190087), str )

        self:loadMembers()
    end,

    loadMembers = function(self)
        local content = self.transform:Find("Content/Scroll View/Viewport/Content")
        local index = 1
        for k, v in ipairs(self.gift.getInfo) do
            local elem = nil
            if k == self.gift.luckNum[index] then
                index = index + 1
                elem = Object.Instantiate(self.lucky_prefab).transform
                local panel = elem:Find("guild_panel_18/Image")
                for i=1, panel.childCount do
                    local item = v.extraReward[i]
                    local ui = panel:GetChild(i-1)
                    if item then
                        local cfg = item_helper:getItemCfg(item.ItemTemId)
                        ui:SetActive(true)
                        local icon = ui:Find("Icon"):GetComponent(UnityEngine.UI.Image)
                        icon:SetSprite(gui_helper:getItemIconPath(cfg))
                        local count = ui:Find("Count"):GetComponent(UnityEngine.UI.Text)
                        count.text = tostring(item.Count)
                    else
                        ui:SetActive(false)
                    end
                end
            else
                elem = Object.Instantiate(self.normal_prefab).transform
            end
            elem:SetActive(true)
            elem:SetParent(content)
            resetTransformZ(elem)

            local get_time = elem:Find("guild_panel_18/text1_Static_4"):GetComponent(UnityEngine.UI.Text)
            local name = elem:Find("guild_panel_18/text1_Static_5"):GetComponent(UnityEngine.UI.Text)

            get_time.text = os.date("%X",tonumber(v.getTime))
            name.text = string.format( "%d.  %s", k, v.playerName )
            log.info("time "..v.getTime.." name "..v.playerName)
        end
    end,

    click_BG = function(self)
        frame_manager:hide('guild_gift_info')
    end,
}
