local log = logger.get("Game", "Guild Invite Frame")
local super = require("ui.frame")

return class{

    super = super,

    onLoaded = function(self)
        super.onLoaded(self)

        self.guild_info = self.args.data.info

        clickEvents = 
        {
            "BG/guild_panel_10_1/AgreeBtn",
            "BG/guild_panel_10_1/CancelBtn",
            "BG/guild_panel_10_1/Top/Info",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.evts = local_guild.events:on("GUILDFRAMEHIDE", functor.make(self.onGuildFrameHide, self))

        self:init()
    end,

    onUnload = function(self)
        local_guild.events:remove("GUILDFRAMEHIDE", self.evts)
    end,

    onGuildFrameHide = function(self)
        self.helper.showTrans(self.transform)
    end,

    init = function(self)
        local name = self:findText("BG/guild_panel_10_1/Top/Name")
        local level = self:findText("BG/guild_panel_10_1/Top/Level")
        local count = self:findText("BG/guild_panel_10_1/Top/Count")
        local lang = self:findText("BG/guild_panel_10_1/Top/Lang")
        local icon = self:findImage("BG/guild_panel_10_1/Image/Icon")
        local border = self:findImage("BG/guild_panel_10_1/Border")
        local color_bg = self:findImage("BG/guild_panel_10_1/Image")
        name.text = self.guild_info.familyName.." ["..self.guild_info.familycronym.."]"
        level.text = "Lv "..self.guild_info.familyLevel
        count.text = self.guild_info.memberNum.."/"..self.guild_info.maxMemberNum
        local lang_id = config.union_langs[self.guild_info.familyLanguage].language
        lang.text = self.helper:getLangCfg(lang_id)
        local icon_cfg = config.union_icons[self.guild_info.emblem.icon]
        icon:SetSprite(icon_cfg.path..icon_cfg.icon)
        local color_cfg = config.union_icons[self.guild_info.emblem.grounding]
        color_bg:SetSprite(color_cfg.path..color_cfg.icon)
        local border_cfg = config.union_icons[self.guild_info.emblem.iconFrame]
        border:SetSprite(border_cfg.path..border_cfg.icon)
    end,

    click_AgreeBtn = function(self)
        network_sender:disposeInvite(1, self.guild_info.familyId)
        frame_manager:hide("guild_invite")
    end,

    click_CancelBtn = function(self)
        frame_manager:hide("guild_invite")
    end,

    click_Info = function(self)
        self.helper.hideTrans(self.transform)
        network_sender:getFamilyInfo(self.guild_info.familyId)
    end,
}