local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        clickEvents = 
        {
            "bgbg",
            "bg/top/ButtonBack",
            "write/Bg/mid/sendBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.title_input = self.transform:Find("write/Bg/mid/top_InputField"):GetComponent(UnityEngine.UI.InputField)
        self.content_input = self.transform:Find("write/Bg/mid/down_InputField"):GetComponent(UnityEngine.UI.InputField)

        self.send_evt = local_guild.events:on("SENDFAMILYMAIL", functor.make(self.onSend, self))
    end,

    onUnload = function (self)
    end,

    onSend = function(self)
        hint:setText(NativeText.GetLangStr(190117))
        self.title_input.text = ""
        self.content_input.text = ""
    end,

    sendCheck = function(self)
        local title = self.title_input.text
        local content = self.content_input.text

        local f = function(str)

            if string.len( str ) == 0 then
                return true
            end

            local i, j = string.find( str,"%s+" )
            if i == 1 and j == string.len( str ) then
                return true
            end

            return false
        end

        if f(title) then
            hint:setText(NativeText.GetLangStr(190118))
            return false
        end

        if f(content) then
            hint:setText(NativeText.GetLangStr(190119))
            return false
        end

        return true
    end,

    click_ButtonBack = function(self)
        if self.title_input.text ~= "" and self.content_input.text ~= "" then
            local tb = {
                title = "",
                content = NativeText.GetLangStr(190120),
                buttons =
                {
                    {
                        btn_name = NativeText.GetLangStr(110522),
                        callback = function() 
                            frame_manager:hide('common_box')
                        end
                    },
                    {
                        btn_name = NativeText.GetLangStr(110521),
                        callback = function()
                            frame_manager:hide('common_box')
                            frame_manager:hide('guild_mail')
                        end
                    },
                },
            }
    
            frame_manager:show('common_box', nil, tb)
        else
            frame_manager:hide('guild_mail')
        end
    end,

    click_sendBtn = function(self)
        if self:sendCheck() then
            network_sender:sendFamilyMail(self.title_input.text, self.content_input.text)
        end
    end,

    click_bgbg = function(self)
        self:click_ButtonBack()
    end,
}
