local super = require("ui.frame")
local gui_helper = require('gui.gui_helper')
return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.msg = self.args.data.msg

        clickEvents = 
        {
            "Close",
            "Bg/bottom/RefuseAllButton/RefuseAll",
            "Bg/bottom/RankButton/Rank",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.cloneModel = self.transform:Find("Bg/Scroll View/Viewport/Content/model")
        self.cloneModel:SetActive(false)

        self.parent = self.transform:Find("Bg/Scroll View/Viewport/Content")

        self.listViewModel = {}
        self.unusedList = {}
        self:initUI()
    end,
    
    onUnload = function (self)
    end,

    createListVive = function(self, list)
        local parent_path = "Bg/Scroll View/Viewport/Content/"
        self.helper:hideAllChild(self, parent_path)

        if not self.none_trans then
            self.none_trans = self.parent.transform:Find("Bg/MassList/none")
        end
        if list and #list > 0 then
            frame_helper.hideTrans(self.none_trans)
        else
            frame_helper.showTrans(self.none_trans)
        end
        
        for i, v in ipairs(list) do
            local trans = self.helper:getChild(self, i, parent_path)
            trans.gameObject:SetActive(true)
            local refuse = trans.transform:Find("Refuse Button/Refuse"):GetComponent(UnityEngine.UI.Button)
            refuse.onClick:RemoveAllListeners()
            refuse.onClick:AddListener(
                function ()
                    self:removeList(v.id)
                    network_sender:disposeListFamily(0, tostring(v.id))
                end
            )
            local consent = trans.transform:Find("OK Button/OK"):GetComponent(UnityEngine.UI.Button)
            consent.onClick:RemoveAllListeners()
            consent.onClick:AddListener(
                function ()
                    self:removeList(v.id)
                    network_sender:disposeListFamily(1,  tostring(v.id))
                end
            )
            local info_btn = trans.transform:Find("Info"):GetComponent(UnityEngine.UI.Button)
            info_btn.onClick:RemoveAllListeners()
            info_btn.onClick:AddListener(
                function ()
                    network_sender:getPlayerInfo(v.id)
                end
            )

            -- local icon = trans.transform:Find("Icon"):GetComponent(UnityEngine.UI.Image)
            -- icon:SetSprite(gui_helper:getItemIconPath(v.icon))

            trans:Find("guild_panel_03").gameObject:SetActive(i % 2 ~= 0)

            local sword_text = trans:Find("text1_Static_11"):GetComponent(UnityEngine.UI.Text)
            sword_text.text = string.format("<color=#06F99BFF>%s</color>  %s", NativeText.GetLangStr(190097), v.sword)

            local level_text = trans:Find("text1_Static_13"):GetComponent(UnityEngine.UI.Text)
            level_text.text = "Lv." .. v.level .. "   " .. v.name

            local player_icon = trans:Find("Head/Icon"):GetComponent(UnityEngine.UI.Image)
            player_icon:SetSprite(gui_helper:getPlayerIcon())
        end
    end,

    initUI = function(self)
        self.listInfo = {}
        -- required string	playerId	= 1;//角色id
        -- required string playerName	= 2;//角色名字
        -- required uint32 headIcon	= 3;//头像
        -- required uint32 playerlevel	= 4;//玩家等级
        -- required uint32 sword		= 5;//战斗力

        for i, v in ipairs(self.msg.playerInfo) do
            local temporarylist = {}
            temporarylist.name = v.playerName
            temporarylist.icon = v.headIcon
            temporarylist.level = v.playerlevel
            -- temporarylist.sword = v.sword
            temporarylist.sword = math.random(1, 100)
            temporarylist.id = v.playerId

            table.insert(self.listInfo, temporarylist)
        end
        self:createListVive(self.listInfo)
    end,

    -- 实力排序
    click_Rank = function(self)
        sortSword = function(a, b)
            return a.sword > b.sword 
        end
        table.sort(self.listInfo, sortSword)
        self:createListVive(self.listInfo)
    end,

    -- 拒绝所有
    click_RefuseAll = function(self)
        network_sender:disposeListFamily(0, "0")  
        self.listInfo = {} 
        self:createListVive(self.listInfo)
    end,

    click_Close = function(self)
        frame_manager:hide('guild_member_apply')
    end,

    removeList = function(self, id)
        for k, v in ipairs(self.listInfo) do
            if v.id == id then
                table.remove(self.listInfo, k)
                break
            end
        end
        self:createListVive(self.listInfo)
    end,
}
