local log = logger.get("Game", "Guild Member Operate Frame")
local super = require("ui.frame")

return class{

    super = super,

    onLoaded = function(self)
        super.onLoaded(self)

        self.owner = self.args.owner
        self.member_info = self.args.data.info

        clickEvents = 
        {
            "Window/LevelUpBtn",
            "Window/LevelDownBtn",
            "Window/LeaveBtn",
            "Window/TalkingBtn",
            "BG",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    init = function(self)
        local name = self:findText("Window/Name")
        local level = self:findText("Window/Level")
        local fight = self:findText("Window/FightTitle/Fight")
        local player_icon = self:findImage("Window/Head/PlayerIcon")
        local icon = self:findImage("Window/Icon")
        name.text = self.member_info.playerName
        level.text = "Lv."..self.member_info.playerLevel
        fight.text = tostring(self.member_info.playerSword)
        player_icon:SetSprite(gui_helper:getPlayerIcon())
    end,

    checkPower = function(self)
        if self.owner.info.degree < self.member_info.degree and self.owner.info.degree < common_pb.MD_R3 then
            return true
        end

        return false
    end,

    click_LevelUpBtn = function(self)
        if not self:checkPower() then
            hint:setText(NativeText.GetLangStr(190092))
            return
        end
        network_sender:familyMemberPromote(self.member_info.playerid, 1)
        frame_manager:hide("guild_member_operate")
    end,

    click_LevelDownBtn = function(self)
        if not self:checkPower() then
            hint:setText(NativeText.GetLangStr(190092))
            return
        end
        network_sender:familyMemberPromote(self.member_info.playerid, 0)
        frame_manager:hide("guild_member_operate")
    end,

    click_LeaveBtn = function(self)
        if not self:checkPower() then
            hint:setText(NativeText.GetLangStr(190092))
            return
        end
        network_sender:expelFamilyMember(self.member_info.playerid)
        frame_manager:hide("guild_member_operate")
    end,

    click_TalkingBtn = function(self)
        print("#member.playerid:", self.member_info.playerid, self.member_info.playerName)
        hint:setText(NativeText.GetLangStr(900002))
        --self:click_BG()
    end,

    click_BG = function(self)
        frame_manager:hide("guild_member_operate")
    end,
}