local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.msg = self.args.data.msg -- SCGetFamilyInfo
        self.is_name = self.args.data.is_name

        clickEvents = 
        {
            "close",
            "window/bg/confirmBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        self.title_text = self:findText("window/bg/title_text")
        self.name_text = self:findText("window/bg/name_text")
        self.des_text = self:findText("window/bg/des_text")
        self.input_field = self.transform:Find("window/bg/InputField"):GetComponent(UnityEngine.UI.InputField)

        self.input_field.characterLimit = self.is_name and config.union_others[1].namelen or config.union_others[1].shortnamelen

        self.title_text.text = self.is_name and NativeText.GetLangStr(190054) or NativeText.GetLangStr(190053)
        self.name_text.text = self.is_name and NativeText.GetLangStr(190011) or NativeText.GetLangStr(190012)
        self.des_text.text = string.format(self.is_name and NativeText.GetLangStr(190015) or NativeText.GetLangStr(190016), self.is_name and config.union_others[1].namelen or config.union_others[1].shortnamelen)

        self.input_field.text = self.is_name and self.msg.familyInfo.familyName or self.msg.familyInfo.familycronym
    end,

    click_close = function(self)
        frame_manager:hide('guild_modify_name')
    end,

    click_confirmBtn = function(self)
        if self.is_name then
            for key, value in pairs(self.helper:getJsonTab(config.union_others[1].modifyunionname)) do
                frame_manager:show('item_cost', nil, { item_id = key, need_num = value, callBack = function()
                    frame_manager:hide('guild_modify_name')
                    network_sender:modifyFamilyInfoName(self.input_field.text)
                end,})
            end
        else
            for key, value in pairs(self.helper:getJsonTab(config.union_others[1].modifyunionshortname)) do
                frame_manager:show('item_cost', nil, { item_id = key, need_num = value, callBack = function()
                    frame_manager:hide('guild_modify_name')
                    network_sender:modifyFamilyInfoAcronym(self.input_field.text)
                end,})
            end
        end
        
    end,
}
