local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.game_state_island = self.args.owner
        self.msg = self.args.data.msg -- SCGetFamilyInfo
        self.familyId = self.msg.familyInfo.familyId

        -- enum FAMILY_MEM_DEGREE 
        -- {
            -- MD_LEADER	= 1;
            -- MD_R4		= 2;	
            -- MD_R3 	    = 3;
            -- MD_R2 	    = 4;
            -- MD_R1 	    = 5;
        -- }
        
        -- nil 表示是游客
        -- self.identity = self.msg.familyInfo.memberInfo and self.msg.familyInfo.memberInfo.degree or nil

        self.identity = nil
        if self.familyId == local_guild:getId() then
            self.rst, self.identity = local_guild:getGuildLevel()
        end

        clickEvents = 
        {
            "closeBtn",

            -- "info/leader/leader_layout1/editInNoticeBtn",
            -- "info/leader/leader_layout1/editOutNoticeBtn",
            -- "info/leader/leader_layout2/logBtn",
            -- "info/leader/leader_layout2/modifyNickNameBtn",
            -- "info/leader/leader_layout2/modifyNameBtn",
            -- "info/leader/leader_layout2/modifyLogoBtn",
            -- "info/leader/leader_layout2/modifyLangBtn",
            -- "info/leader/leader_layout2/emailBtn",
            -- "info/leader/leader_layout2/applyListBtn",
            -- "info/leader/leader_layout3/recruitSetBtn",
            -- "info/leader/leader_layout3/transferBtn",

            -- "info/r4/leader_layout1/editInNoticeBtn",
            -- "info/r4/leader_layout1/editOutNoticeBtn",
            -- "info/r4/leader_layout2/logBtn",
            -- "info/r4/leader_layout2/emailBtn",
            -- "info/r4/leader_layout2/applyListBtn",
            -- "info/r4/leader_layout3/recruitSetBtn",
            -- "info/r4/leader_layout3/leaveBtn",

            -- "info/member/layout1/lookOutNoticeBtn",
            -- "info/member/layout2/logBtn",
            -- "info/member/layout2/emailBtn",
            -- "info/member/layout3/leaveBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        -- self.leader_trans = self.transform:Find("info/leader")
        -- self.r4_trans = self.transform:Find("info/r4")
        -- self.member_trans = self.transform:Find("info/member")

        -- self.helper.hideTrans(self.leader_trans)
        -- self.helper.hideTrans(self.r4_trans)
        -- self.helper.hideTrans(self.member_trans)

        -- print("### self.identity:", self.identity)

        -- if self.identity then
        --     if self.identity == common_pb.MD_LEADER then
        --         self.helper.showTrans(self.leader_trans)
        --     elseif self.identity == common_pb.MD_R4 then
        --         self.helper.showTrans(self.r4_trans)
        --     else
        --         self.helper.showTrans(self.member_trans)
        --     end
        -- end

        self.member_evts = local_guild.events:on("GETMEMBERLIST", functor.make(self.onGetMemberInfo, self))
        self.member_changed_evts = local_guild.events:on("MEMBERINFOCHANGE", functor.make(self.onMemberChanged, self))

        self:init()
    end,

    onUnload = function (self)
        local_guild.events:remove("GETMEMBERLIST", self.member_evts)
        local_guild.events:remove("MEMBERINFOCHANGE", self.member_changed_evts)
    end,

    init = function(self)
        local cfg = config.union_positions[self.identity]
        self.list, self.title = self:getList(cfg)

        local parent_path = 'content/Scroll View/Viewport/Content/'
        self.helper:hideAllChild(self, parent_path)

        for idx, ops in ipairs(self.list) do
            local child = self.helper:getChild(self, idx, parent_path)
            child:SetActive(true)

            local name = child:Find('name'):GetComponent(UnityEngine.UI.Text)
            name.text = self.title[idx]

            local child_path = 'content/Scroll View/Viewport/Content/' .. child.name .. "/layout"
            self.helper:hideAllChild(self, child_path)
            for __, id in ipairs(ops) do
                local c = config.union_operates[id]
                local item = self.helper:getChild(self, __, child_path)
                item:SetActive(true)

                local icon = item:Find('icon'):GetComponent(UnityEngine.UI.Image)
                local name = item:Find('name'):GetComponent(UnityEngine.UI.Text)
                local btn = item:Find('btn'):GetComponent(UnityEngine.UI.Button)

                if id == 3 then
                    self.recruit_text = name
                    self.recruit_idx = self.msg.familyInfo.status
                    if self.recruit_idx == 0 then
                        name.text = NativeText.GetLangStr(9000006)
                    else
                        name.text = NativeText.GetLangStr(9000007)
                    end
                else
                    name.text = self.helper:getLangCfg(c.operate)
                end

                icon:SetSprite(c.path .. c.name)
                icon:SetNativeSize()
                btn.onClick:RemoveAllListeners()
                btn.onClick:AddListener(
                    function ()
                        print('id:', id)
                        self:clickOperate(id)
                    end)
            end
        end
    end,

    getList = function(self, cfg)
        local list = {}
        local title_table = {}
        local tab = loadstring('return ' .. cfg["basic"])()
        if #tab > 0 then
            table.insert(list, tab)
            table.insert(title_table, NativeText.GetLangStr(190073))
        end
        local tab = loadstring('return ' .. cfg["function"])()
        if #tab > 0 then
            table.insert(list, tab)
            table.insert(title_table, NativeText.GetLangStr(190074))
        end
        local tab = loadstring('return ' .. cfg["manage"])()
        if #tab > 0 then
            table.insert(list, tab)
            table.insert(title_table, NativeText.GetLangStr(190075))
        end
        return list, title_table
    end,

    clickOperate = function(self, idx)
        -- 1   盟内公告
        -- 2   对外宣言
        -- 3   招募设定
        -- 4   盟主转让
        -- 5   申请列表
        -- 6   发送邀请
        -- 7   联盟日志
        -- 8   发送邮件
        -- 9   更换缩写
        -- 10  更换名字
        -- 11  更换徽章
        -- 12  更换语言
        -- 13  退出联盟
        if idx == 1 then
            frame_manager:show('guild_edit_notice', nil, {msg=self.msg, is_in_notice = true})
        elseif idx == 2 then
            frame_manager:show('guild_edit_notice', nil, {msg=self.msg, is_in_notice = false})
        elseif idx == 3 then
            self:click_recruitSetBtn()
        elseif idx == 4 then
            network_sender:getFamilyMemberList(self.familyId)
        elseif idx == 5 then
            network_sender:getFamilyApplyList()
        elseif idx == 6 then
            
        elseif idx == 7 then
            network_sender:getFamilyLog(self.familyId)
        elseif idx == 8 then
            --frame_manager:show('guild_mail')
            hint:setText(NativeText.GetLangStr(900002))
        elseif idx == 9 then
            frame_manager:show('guild_modify_name', nil, { msg = self.msg, is_name = false })
        elseif idx == 10 then
            frame_manager:show('guild_modify_name', nil, { msg = self.msg, is_name = true })
        elseif idx == 11 then
            frame_manager:show('guild_logo', nil, {msg=self.msg})
        elseif idx == 12 then
            frame_manager:show('guild_language', nil, {msg=self.msg})
        elseif idx == 13 then
            self:click_leaveBtn()
        elseif idx == 14 then
            self:dimissGuild()
        end
    end,

    onGetMemberInfo = function(self, msg)
        if #msg.memberList > 1 then 
            frame_manager:show('guild_transfer', self, {msg = msg})
        else
            hint:setText(NativeText.GetLangStr(900005))
        end
    end,

    onMemberChanged = function(self, msg)
        self.helper.hideTrans(self.leader_trans)
        self.helper.hideTrans(self.r4_trans)
        self.helper.hideTrans(self.member_trans)

        local info = msg.memberInfo
        if info then
            if info.degree == common_pb.MD_LEADER then
                self.helper.showTrans(self.leader_trans)
            elseif info.degree == common_pb.MD_R4 then
                self.helper.showTrans(self.r4_trans)
            else
                self.helper.showTrans(self.member_trans)
            end
        end
    end,

    refreshMsg = function(self, msg)
        self.msg = msg
    end,

    click_closeBtn = function(self)
        frame_manager:hide('guild_set')
    end,

    click_editInNoticeBtn = function(self)
        frame_manager:show('guild_edit_notice', nil, {msg=self.msg, is_in_notice = true})
    end,

    click_editOutNoticeBtn = function(self)
        frame_manager:show('guild_edit_notice', nil, {msg=self.msg, is_in_notice = false})
    end,

    click_logBtn = function(self)
        print("日志:", self.familyId)
        network_sender:getFamilyLog(self.familyId)
    end,

    click_modifyNickNameBtn = function(self)
        frame_manager:show('guild_modify_name', nil, { msg = self.msg, is_name = false })
    end,

    click_modifyNameBtn = function(self)
        frame_manager:show('guild_modify_name', nil, { msg = self.msg, is_name = true })
    end,

    click_modifyLogoBtn = function(self)
        frame_manager:show('guild_logo', nil, {msg=self.msg})
    end,

    click_modifyLangBtn = function(self)
        frame_manager:show('guild_language', nil, {msg=self.msg})
    end,

    click_emailBtn = function(self)
        frame_manager:show('guild_mail')
    end,

    -- 申请列表
    click_applyListBtn = function(self)
        network_sender:getFamilyApplyList()
        -- frame_manager:show('guild_member_apply', nil, {msg = self.msg})
    end,

    -- 招募设定界面
    click_recruitSetBtn = function(self)
        if self.recruit_text then
            if self.recruit_idx == 1 then
                self.recruit_text.text = NativeText.GetLangStr(9000006)
                self.recruit_idx = 0
            else
                self.recruit_text.text = NativeText.GetLangStr(9000007)
                self.recruit_idx = 1
            end
        end

        local value = 0
        if self.msg.familyInfo.status == 0 then
            value = 1
        end
        network_sender:modifyFamilyInfoEnlist(value)
    end,

    click_transferBtn = function(self)
        network_sender:getFamilyMemberList(self.familyId)
    end,

    click_lookOutNoticeBtn = function(self)
        print("查看对外公告")
    end,
    
    click_leaveBtn = function(self)
        local cb = function()
            network_sender:quitFamily()
        end

        gui_helper:showCommonTipBox(cb, NativeText.GetLangStr(999024), NativeText.GetLangStr(999023))
    end,

    dimissGuild = function(self)
        if local_guild:canDismiss() then
            local cb = function()
                network_sender:quitFamily()
            end
    
            gui_helper:showCommonTipBox(cb, NativeText.GetLangStr(999027), NativeText.GetLangStr(999026))
        end
    end,
}
