local super = require("ui.frame")
local log = logger.get("Game", "Hero Frame")
local gui_helper = require('gui.gui_helper')

return class
{
    super = super,
    
    onLoaded = function (self)
        super.onLoaded(self)

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "Frame/HeroListPage/ButtonHeroListBack",    -- 英雄列表页面的返回
            "Frame/HeroEquipPage/ButtonHeroEquipBack",  -- 英雄装备页面的返回
            
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        -- 
        self.slot_root = self.transform:Find('Frame/HeroListPage/Scroll View/Viewport/SlotRoot')

        -- item prefab
        self.hero_prefab = self.transform:Find('Prefabs/HeroInfo').gameObject
        self.helper.hideTrans(self.transform:Find('Prefabs'))

        self.hero_list_page = self.transform:Find('Frame/HeroListPage')
        self.hero_equip_page = self.transform:Find('Frame/HeroEquipPage')
        self.helper.hideTrans(self.hero_equip_page)

        -- 缓存所有已注册的 icon 事件，刷新时要清空
        self.icon_events = {}

        -- 当前排序，背包类型
        self.sort =  nil
        self.sort_invert = false

        self.is_dirty = false

        self:refreshHeroList('level', false)

        -- 关闭 loading
        frame_manager:hide('loading')
    end,

    onUnload = function (self)
    end,

    onRcvMsg = function(self, cmd, msg)
    end,

    -- 刷新英雄列表
    refreshHeroList = function(self, sort)
        
    end,

    click_ButtonHeroListBack = function(self)
        frame_manager:hide('hero')
    end,

    click_ButtonHeroEquipBack = function(self)
        frame_manager:showTrans(self.hero_list_page)
        frame_manager:hideTrans(self.hero_equip_page)
    end,

}