local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.home_map = self.args.owner
        self.grid_id = self.args.data

        clickEvents = {
            "closeBtn",
        }

        -- 注册点击事件
        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    click_closeBtn = function(self)
        frame_manager:hide('home_entity_create')
    end,

    init = function(self)
        local cfg = config.home_config_grids[self.grid_id]
        local list = loadstring("return " .. cfg.can_build)()

        local parent_path = "content/Scroll View/Viewport/Content"
        frame_helper:hideAllChild(self, parent_path)
        for idx, cfg_id in ipairs(list) do
            local child = frame_helper:getChild(self, idx, parent_path)
            child:SetActive(true)
            local icon = child:Find("Image"):GetComponent(UnityEngine.UI.Image) 
            local yes = child:Find("yes"):GetComponent(UnityEngine.UI.Image)
            local no = child:Find("no"):GetComponent(UnityEngine.UI.Image)
            local name = child:Find("name"):GetComponent(UnityEngine.UI.Text)
            local des = child:Find("des"):GetComponent(UnityEngine.UI.Text)
            local own = child:Find("own"):GetComponent(UnityEngine.UI.Text)
            local list_cfg = config.home_config_lists[cfg_id]
            icon:SetSprite(list_cfg.path .. list_cfg.icon)
            name.text = frame_helper:getLangCfg(list_cfg.name_id)
            des.text = frame_helper:getLangCfg(list_cfg.info_id)
            local max_num = home_info:getBuildMaxNumByCfgId(cfg_id)
            local own_num = home_info:getBuildNumByCfgId(cfg_id)
            local str = ""
            local can_build = max_num < 0 and true or ( own_num < max_num )
            if max_num < 0 then
                str = "<color=#FFFFFFFF>" .. own_num .."</color>"
            else
                str = (own_num >= max_num and "<color=#00FFFFFF>" or "<color=#FFFFFFFF>") .. own_num .. "/" .. max_num .."</color>"
            end

            own.text = string.format(NativeText.GetLangStr(520002), str)
            yes.enabled = can_build
            no.enabled = not can_build


            --local btn = child:Find("btn"):GetComponent(UnityEngine.UI.Button)
            local path = parent_path.."/"..child.name
            self:clearScript("click", path)
            self:setScript("click", path, function()
                if max_num < 0 then
                    network_sender:personBaseAdd(cfg_id, self.grid_id)
                    frame_manager:hide('home_entity_create')
                else
                    if own_num < max_num then
                        network_sender:personBaseAdd(cfg_id, self.grid_id)
                        frame_manager:hide('home_entity_create')
                    else
                        hint:setText(NativeText.GetLangStr(520003))
                    end
                end
            end)

            --[[
            local btn = child:GetComponent(UnityEngine.UI.Button)
            btn.onClick:RemoveAllListeners()
            btn.onClick:AddListener(function()
                if max_num < 0 then
                    network_sender:personBaseAdd(cfg_id, self.grid_id)
                    frame_manager:hide('home_entity_create')
                else
                    if own_num < max_num then
                        network_sender:personBaseAdd(cfg_id, self.grid_id)
                        frame_manager:hide('home_entity_create')
                    else
                        hint:setText(NativeText.GetLangStr(520003))
                    end
                end
            end)
            ]]

        end
    end,
}
