local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.cfg = self.args.data -- config.home_config_lists

        clickEvents = {
            "closeBtn",
            "content/confirmBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function(self)
    end,

    click_closeBtn = function(self)
        frame_manager:hide('home_entity_explain')
    end,

    click_confirmBtn = function(self)
        frame_manager:hide('home_entity_explain')
    end,

    init = function(self)
        local layout_path = 'content/Scroll View/Viewport/Content'
        self.helper:hideAllChild(self, layout_path)

        local str_rule = self.cfg.rule
        local tab = self.helper:split(str_rule, ';')
        for idx, str in ipairs(tab) do
            local temp = self.helper:split(str, ',')
            local child = self.helper:getChild(self, idx, layout_path)
            child:SetActive(true)
            local title = child.transform:Find("title"):GetComponent(UnityEngine.UI.Text)
            title.text = self.helper:getLangCfg(temp[1])
            local des = child.transform:Find("des"):GetComponent(UnityEngine.UI.Text)
            des.text = self.helper:getLangCfg(temp[2])
        end
    end,
}
