local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.home_entity = self.args.data

        clickEvents = 
        {
            "closeBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init(self.home_entity.id)
    end,

    onUnload = function (self)
    end,

    init = function(self, id)
        local dt = home_info:getBuildDataByGridId(id)
        if not dt then
            return
        end

        local cfg = config.home_config_lists[dt.cfgId]
        if cfg then
            local name = string.format(NativeText.GetLangStr(120006), self.helper:getLangCfg(cfg.name_id), dt.level)
            self:findText("Title/Text").text = name
            self:findText("centerLeft/Image/Image (1)/Text").text = name
            self:findText("centerLeft/des/text").text = self.helper:getLangCfg(cfg.info_id)
        end

        local tplt = self.transform:Find("centerRight/upContent/Scroll View/Viewport/Content/tplt")
        local parent = tplt.transform.parent
        tplt.gameObject:SetActive(false)

        print("#####",dt.cfgId, dt.level)
        local upgrade_cfg = self:getUpgradeCfg(dt.cfgId, dt.level)
        if upgrade_cfg then
            local args = self.helper:getPropertyDes(upgrade_cfg.effect)
            for __, map in pairs(args) do
                print(__)
                local item = Object.Instantiate(tplt.gameObject);
                item.transform.name = __
                item.transform:SetParent(parent)
                item.transform.localScale = Vector3.one
                item:SetActive(true)

                local text = item:Find("text"):GetComponent(UnityEngine.UI.Text)
                text.text = map.name_str .. " " .. map.num_str

                -- local icon = item:Find("icon"):GetComponent(UnityEngine.UI.Image)
                -- icon:SetSprite()
            end
        end
    end,

    -- 获取成绩配置
    getUpgradeCfg = function(self, cfg_id, level)
        local rst = nil
        local max_level = 1
        config.home_config_upgrades:foreach(
            function(k, v)
                if v.building_id == cfg_id then
                    if v.level == level then rst = v end
                    if v.level > max_level then max_level = v.level end
                end
            end
        )
        return rst, max_level
    end,

    -- 关闭界面事件
    click_closeBtn = function(self)
        frame_manager:hide('home_entity_garage_info')
    end,
}
