local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.is_res_build = self.args.data.is_res
        if self.is_res_build then
            self.build_data = home_info:getBuildDataById(self.args.data.content.buildId)
            self.SCGetBuildDetails = self.args.data.content
        else
            self.build_data = self.args.data.content
        end

        clickEvents = {
            "content/backBtn",
        }

        -- 注册点击事件
        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function(self)
    end,

    click_backBtn = function(self)
        frame_manager:hide('home_entity_info_detail')
    end,

    init = function(self)
        -- 全部解锁内容
        local all_unlock_cfgs, nearest_cfg = self:getAllUnlockEffect(self.build_data.cfgId, self.build_data.level)

        local name = self:findText("content/name")
        local scv = self.transform:Find("content/Scroll View"):GetComponent(UnityEngine.RectTransform)
        local res = self.transform:Find("content/res")
        frame_helper:setActive(res, self.is_res_build)
        local list_cfg = config.home_config_lists[self.build_data.cfgId]
        name.text = "Lv." .. self.build_data.level .. " " .. frame_helper:getLangCfg(list_cfg.name_id) .. "  " .. frame_helper:getLangCfg(list_cfg.brief_id)


        if self.is_res_build then
            if #all_unlock_cfgs > 0 then
                scv.anchoredPosition = Vector2(0, 107.19)
                scv.sizeDelta = Vector2(1815, 270)
            else
                scv.anchoredPosition = Vector2(0, 107.19)
                scv.sizeDelta = Vector2(1815, 594)
            end
        else
            if #all_unlock_cfgs > 0 then
                scv.anchoredPosition = Vector2(0, 268.5)
                scv.sizeDelta = Vector2(1815, 429.5)
            else
                scv.anchoredPosition = Vector2(0, 268.5)
                scv.sizeDelta = Vector2(1815, 759)
            end
        end

        

        -- des.text = frame_helper:getLangCfg(list_cfg.brief_id)

        local cfgs = self:getAllCfg(self.build_data.cfgId)

        -- 显示所有描述
        local max_cfg = cfgs[#cfgs]
        local tab = frame_helper:getPropertyDes(max_cfg.effect)
        local prop_index = {} -- 属性在第几个child
        for idx, map in ipairs(tab) do
            local child_index = idx - 1
            local name = self.transform:Find("content/Scroll View/layout_title"):GetChild(child_index):GetComponent(UnityEngine.UI.Text)
            name.text = map.name_str
            prop_index[map.id] = idx
        end

        local mono = self.transform:Find("content/Scroll View/layout_title"):GetComponent(AdjustPosInFixedRange)
        mono:SetChildCount(#tab)

        -- 每一级属性
        local layout_path = "content/Scroll View/Viewport/Content"
        local prop_target = nil
        frame_helper:hideAllChild(self, layout_path)
        for idx, c in ipairs(cfgs) do
            local child = frame_helper:getChild(self, idx, layout_path)
            child:SetActive(true)
            local level = child:Find("level"):GetComponent(UnityEngine.UI.Text)
            local power = child:Find("power"):GetComponent(UnityEngine.UI.Text)
            level.text = idx
            power.text = c.power
            local args = frame_helper:getPropertyDes(c.effect)
            for __, map in ipairs(args) do
                local bg = child:Find("select"):GetComponent(UnityEngine.UI.Image)
                bg.enabled = idx == self.build_data.level
                local path = layout_path .. "/" .. child.name .. "/" .. "layout_content"
                local name = frame_helper:getChild(self, prop_index[map.id], path):GetComponent(UnityEngine.UI.Text)
                name.text = map.num_str
                if idx == self.build_data.level then
                    prop_target = child
                end
            end
            local mono = child:Find("layout_content"):GetComponent(AdjustPosInFixedRange)
            mono:SetChildCount(#args)
        end

        -- 解锁内容
        local unlock_trans = self.transform:Find("content/unlock_info")
        local unlock_target = nil
        if all_unlock_cfgs and #all_unlock_cfgs > 0 then
            frame_helper.showTrans(unlock_trans)
            self.transform:Find("content/unlock_info/Scroll View Buttom/Viewport/Content/tplt"):SetActive(false)
            for index, cfg in ipairs(all_unlock_cfgs) do
                local child = frame_helper:copyTrans(self, "content/unlock_info/Scroll View Buttom/Viewport/Content/tplt")
                child:SetActive(true)
                local level = child:Find("level"):GetComponent(UnityEngine.UI.Text)
                local des = child:Find("des"):GetComponent(UnityEngine.UI.Text)
                local bg = child:Find("select"):GetComponent(UnityEngine.UI.Image)
                bg.enabled = nearest_cfg and nearest_cfg.level == cfg.level or false
                local effect_table = frame_helper:getPropertyDes(cfg.unlock)
                local effect_str = ""
                for __, e in ipairs(effect_table) do
                    effect_str = effect_str .. e.name_str .. " <color=#00FF00FF>+" .. e.num_str .. "</color>"
                    effect_str = effect_str .. (__ == #effect_table and "" or ", ")
                end
                level.text = cfg.level
                des.text = effect_str

                if nearest_cfg and nearest_cfg.level == cfg.level then
                    unlock_target = child
                end
            end
        else
            frame_helper.hideTrans(unlock_trans)
        end

        
        app:startCoroutine(function()
            coroutine.yield(nil)
            if prop_target then
                local viewport_trans = self.transform:Find("content/Scroll View"):GetComponent(UnityEngine.RectTransform)
                local content_trans = self.transform:Find("content/Scroll View/Viewport/Content"):GetComponent(UnityEngine.RectTransform)
                if content_trans.sizeDelta.y > viewport_trans.sizeDelta.y then
                    local offset = -33;
                    local y = - content_trans:InverseTransformPoint(prop_target.position).y + offset;
                    y = UnityEngine.Mathf.Clamp(y, 0, content_trans.sizeDelta.y - viewport_trans.sizeDelta.y);
                    content_trans.anchoredPosition = Vector2(content_trans.anchoredPosition.x, y);
                end
            end

            if unlock_target then
                local viewport_trans = self.transform:Find("content/unlock_info/Scroll View Buttom"):GetComponent(UnityEngine.RectTransform)
                local content_trans = self.transform:Find("content/unlock_info/Scroll View Buttom/Viewport/Content"):GetComponent(UnityEngine.RectTransform)
                if content_trans.sizeDelta.y > viewport_trans.sizeDelta.y then
                    local offset = -33;
                    local y = - content_trans:InverseTransformPoint(unlock_target.position).y + offset;
                    y = UnityEngine.Mathf.Clamp(y, 0, content_trans.sizeDelta.y - viewport_trans.sizeDelta.y);
                    content_trans.anchoredPosition = Vector2(content_trans.anchoredPosition.x, y);
                end
            end
        end) 
        

        -- 资源类
        if self.is_res_build then
            local getCfg = function(cfg_id, prop_id)
                local rst = nil
                config.home_config_resource_buildings:foreach(function(id, cfg)
                    if cfg.building_id == cfg_id and prop_id == cfg.attr_id then
                        rst = cfg
                    end
                end)
                return rst
            end
            local path = "content/res/layout"
            frame_helper:hideAllChild(self, path)
            for __, value in ipairs(self.SCGetBuildDetails.propList) do
                local child = frame_helper:getChild(self, __, path)
                child:SetActive(true)
                local cfg = getCfg(self.build_data.cfgId, value.PropId)
                local icon = child.transform:Find("icon"):GetComponent(UnityEngine.UI.Image)
                local name = child.transform:Find("text1_Static[T4]_1"):GetComponent(UnityEngine.UI.Text)
                icon:SetSprite(cfg.icon)
                name.text = frame_helper:getLangCfg(cfg.attr_name) .. ": " ..  frame_helper:itemNumFormat(value.PropValue) 
            end
        end
    end,

    getAllUnlockEffect = function(self, cfg_id, cur_level)
        local all = {}
        local nearest_cfg = nil
        config.home_config_upgrades:foreach(
            function(k, v)
                if v.building_id == cfg_id and #frame_helper:getPropertyDes(v.unlock) > 0 then
                    table.insert(all, v)

                    if v.level <= cur_level then
                        if not nearest_cfg then
                            nearest_cfg = v
                        elseif nearest_cfg.level < v.level then
                            nearest_cfg = v
                        end
                    end
                end
            end)

        local sortFunc = function(a, b)
            return a.id < b.id
        end
        table.sort(all, sortFunc)
        return all, nearest_cfg
    end,

    getAllCfg = function(self, cfg_id)
        local all = {}
        config.home_config_upgrades:foreach(
            function(k, v)
                if v.building_id == cfg_id then
                    table.insert(all, v)
                end
            end)

        local sort = function(a, b)
            return a.id < b.id
        end
        table.sort(all, sort)
        return all
    end,
}
