local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.home_entity = self.args.data

        clickEvents = 
        {
            "closeBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init(self.home_entity.id)
    end,

    onUnload = function (self)
    end,

    init = function(self, id)
        local dt = home_info:getBuildDataByGridId(id)
        if not dt then
            return
        end

        local cfg = config.home_config_lists[dt.cfgId]
        if cfg then
            local name = string.format(NativeText.GetLangStr(120006), self.helper:getLangCfg(cfg.name_id) ,dt.level)
            self:findText("Title/Text").text = name
            self:findText("centerLeft/Image/Image (1)/Text").text = name
            self:findText("centerLeft/des/text").text = self.helper:getLangCfg(cfg.info_id)
        end

        local parent = self.transform:Find("centerRight/upContent/layout")
        for i = 0, parent.childCount - 1 do
            parent:GetChild(i):SetActive(false)
        end

        local i = 0
        local cur_cfg = self:getUpgradeCfg(dt.cfgId, dt.level)
        if cur_cfg then
            local res_max_tb = self.helper:getJsonTab(cur_cfg.effect)
            for id, max in pairs(res_max_tb) do
                local item = parent:GetChild(i)
                item.gameObject:SetActive(true)
                item.transform.name = id
                local max_text = item.transform:Find("Text"):GetComponent(UnityEngine.UI.Text)
                max_text.text = max
                local res_icon = item.transform:Find("icon"):GetComponent(UnityEngine.UI.Image)
                -- print("id类型", type(id), id)
                local icon_name = self.helper:getItemIcon(config.home_config_storage_icons[id].item)
                res_icon:SetSprite(icon_name)
                i = i + 1
            end
        end
    end,

    getUpgradeCfg = function(self, cfg_id, level)
        local rst = nil
        local max_level = 1
        config.home_config_upgrades:foreach(
            function(k, v)
                if v.building_id == cfg_id then
                    if v.level == level then rst = v end
                    if v.level > max_level then max_level = v.level end
                end
            end
        )
        return rst, max_level
    end,

    click_closeBtn = function(self)
        frame_manager:hide('home_entity_store')
    end,
}
