local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.item_cls = self.args.data

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "content/dismantleBtn",
            "closeBtn",
        }

        -- 注册点击事件
        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        local icon = self:findImage("content/item/icon")
        local quality = self:findImage("content/item/quality")
        local equip_tag = self:findImage("content/item/equip_tag")
        local name = self:findText("content/name")
        equip_tag.enabled = crew_manager:isItemEquipped(self.item_cls.inst_id)
        local cfg = self.item_cls.cfg
        icon:SetSprite(cfg.path .. cfg.icon)
        name.text = frame_helper:getLangCfg(cfg.name_id)
        quality:SetSprite(gui_helper:getQualityIconPath(cfg.color))
        local star_path = "content/item/light stars"
        frame_helper:hideAllChild(self, star_path, true)
        for i = 1, cfg.color do
            local star = frame_helper:getChild(self, i, star_path)
            star:SetActive(true)
        end

        local path = "content/layout"
        frame_helper:hideAllChild(self, path, true)
        local idx = 1
        local tab = frame_helper:split(self.item_cls.cfg.Dismantle, "$")
        for __, s in ipairs(tab) do
            local temp = frame_helper:split(s, "_")
            local item_id = tonumber(temp[1])
            local cfg = item_helper:getItemCfg(item_id)
            if cfg then
                local child = frame_helper:getChild(self, idx, path)
                child:SetActive(true)
                idx = idx + 1
                local icon = child:Find("icon"):GetComponent(UnityEngine.UI.Image)
                local quality = child:Find("quality"):GetComponent(UnityEngine.UI.Image)
                icon:SetSprite(cfg.path .. cfg.icon)
                quality:SetSprite(gui_helper:getQualityIconPath(cfg.color))
            end
        end
    end,

    click_dismantleBtn = function(self)
        network_sender:retireProfession(self.item_cls.inst_id)
        self:click_closeBtn()
    end,

    click_closeBtn = function(self)
        frame_manager:hide('home_forge_dismantle')
    end,
}
