local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "content/bg/backBtn",
        }

        -- 注册点击事件
        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        local cfg_list = {}
        config.home_config_crew_trains:foreach(function(k, v)
            table.insert(cfg_list, v)
        end)
        sortFunc = function(a, b)
            return a.id < b.id
        end
        table.sort(cfg_list,sortFunc)

        local build_data = home_info:getBuildDataByCfgId(22)
        
        local path = "content/bg/layout"
        frame_helper:hideAllChild(self, path)

        for idx, cfg in ipairs(cfg_list) do
            local child = frame_helper:getChild(self, idx, path)
            child:SetActive(true)

            local icon = child:Find("icon"):GetComponent(UnityEngine.UI.Image)
            local name = child:Find("name"):GetComponent(UnityEngine.UI.Text)
            local des = child:Find("unlock/des"):GetComponent(UnityEngine.UI.Text)
            local unlock = child:Find("unlock")

            local temp_des = string.format(NativeText.GetLangStr(620005), frame_helper:getLangCfg(config.home_config_lists[22].name_id) .. " Lv." .. cfg.Unlock)
            icon:SetSprite(cfg.path .. cfg.icon)
            name.text = frame_helper:getLangCfg(cfg.IndexName)
            des.text = temp_des

            local rst = build_data.level >= cfg.Unlock
            frame_helper:setActive(unlock, not rst)

            local btn = child.transform:Find("icon"):GetComponent(UnityEngine.UI.Button)
            btn.onClick:RemoveAllListeners()
            btn.onClick:AddListener(function()
                if rst then
                    self:click_tag(idx)
                else
                    hint:setText(temp_des)
                end
            end)
        end
    end,

    click_tag = function(self, idx)
        if idx == 1 then
            frame_manager:show('home_forge_preview')
        elseif idx == 2 then
            frame_manager:show('home_forge_preview_plus')
        elseif idx == 3 then
            frame_manager:show('home_forge_store')
        end
    end,

    click_backBtn = function(self)
        frame_manager:hide('home_main_forge')
    end,
}
