local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.msg = self.args.data       -- MTechnology

        clickEvents = 
        {
            "content/closeBtn",
        }
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        self:showContent()
    end,

    -- enum EBubbleType
    -- {
    --     BT_REPAIR_HERO	= 1;//修理英雄完成
    --     BT_FIX_PACKAGE	= 2;//生产修理包
    --     BT_TECHNOLOGY	= 3;//科技
    -- }
    click_closeBtn = function(self)
        frame_manager:hide('home_tech_complete')
    end,

    showContent = function(self)
        local cfg = config.home_config_research_lists[self.msg.cfgId]

        local icon = self:findImage("content/content/image/icon")
        local n_bg = self:findImage("content/content/image/n_bg")
        local s_bg = self:findImage("content/content/image/s_bg")

        local name_text = self:findText("content/content/nameText")
        local cur_level_text = self:findText("content/content/curLvText")
        local next_level_text = self:findText("content/content/nextLvText")

        local des_text = self:findText("content/content/desText")
        local cur_des_text = self:findText("content/content/curDesText")
        local next_des_text = self:findText("content/content/nextDesText")

        local cur_level = self.msg.level - 1
        local next_level = self.msg.level
        local cur_detail_cfg = self:getTechDetailCfg(cfg.id, cur_level)
        local next_detail_cfg = self:getTechDetailCfg(cfg.id, next_level)

        icon:SetSprite(cfg.path .. cfg.icon)
        n_bg.enabled = cfg.quality == 1
        s_bg.enabled = cfg.quality == 2
        name_text.text = self.helper:getLangCfg(cfg.name_id)
        cur_level_text.text = "Lv." .. cur_level
        next_level_text.text = "Lv." .. next_level

        if cur_detail_cfg then
            local args = self.helper:getPropertyDes(cur_detail_cfg.effect)
            for __, map in pairs(args) do
                cur_des_text.text = map.num_str
            end
        else
            cur_des_text.text = "0"
        end

        local args = self.helper:getPropertyDes(next_detail_cfg.effect)
        for __, map in pairs(args) do
            des_text.text = map.name_str
            next_des_text.text = map.num_str
        end
    end,

    getTechDetailCfg = function(self, cfg_id, level)
        local cfg = nil
        config.home_config_research_details:foreach(function(k, v)
            if v.list_id == cfg_id and v.level == level then
                cfg = v
            end
        end)
        return cfg
    end,
}
