local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.details = self.args.data

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "content/backBtn",
        }

        -- 注册点击事件
        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        local path = "content/Scroll View Buttom/Viewport/Content"
        frame_helper:hideAllChild(self, path, true)

        for __, value in ipairs(self.details) do
            local child = frame_helper:getChild(self, __, path)
            child:SetActive(true)

            local icon = child:Find("icon"):GetComponent(UnityEngine.UI.Image)
            local production = child:Find("production"):GetComponent(UnityEngine.UI.Text)
            local total_amount = child:Find("total amount"):GetComponent(UnityEngine.UI.Text)
            local not_protected = child:Find("not protected"):GetComponent(UnityEngine.UI.Text)

            icon:SetSprite(frame_helper:getItemIcon(value.cfgId))
            production.text = string.format(NativeText.GetLangStr(640006), frame_helper:itemNumFormat(value.production))
            total_amount.text = frame_helper:itemNumFormat(value.totalAmount)
            not_protected.text = frame_helper:itemNumFormat(value.NotProtected)
        end
    end,

    click_backBtn = function(self)
        frame_manager:hide('home_vault')
    end,
}
