local super = require("ui.frame")
local log = logger.get("Game", "World Map Frame")
require('RTS.bag_sys.bag_manager')

return class {
    super = super,

    onLoaded = function(self)
        log.info('World Map Frame onLoaded!!')

        self.owner = self.args.owner

        super.onLoaded(self)

        self:onlyShowInEditorMode()

        -- 行军信息
        -- self:setScript("click", "MarchLineInfo/ButtonAccelerate", self.onClickAccelerateMarchLine)
        -- self:setScript("click", "MarchLineInfo/ButtonHoming", self.onClickMarchLineHoming)
        -- self:setScript("click", "MarchLineInfo/ButtonClose", self.onClickCloseMarchLineInfo)
        -- 玩家据点信息
        -- self:setScript("click", "PlayerHoldInfo/ButtonDetailPlayerInfo", self.onClickDetailPlayerInfo)
        -- self:setScript("click", "PlayerHoldInfo/ButtonEnterHold", self.onClickEnterHold)
        -- self:setScript("click", "PlayerHoldInfo/ButtonClose", self.onClickPlayerHoldInfoClose)

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        -- 详细信息窗口，矿产，玩家据点，行军路线
        self.none_hold_mine = self.transform:Find('MineInfo')
        self.holded_mine = self.transform:Find('holdedMine')
        self.army_trans = self.transform:Find('army')
        self.rule_trans = self.transform:Find('rule')
        self.coord_collect_trans = self.transform:Find('coordCollect')
        self.edit_coord_trans = self.transform:Find('editCoord')
        self.input_num_trans = self.transform:Find('inputNum')
        self.item_use_trans = self.transform:Find('itemUse')
        self.monsterInfo_trans = self.transform:Find('monsterInfo')
        self.accelerate_item_trans = self.transform:Find('accelerateItem')
        self.retreat_item_trans = self.transform:Find('retreatItem')
        self.playerInfo_trans = self.transform:Find('playerInfo')
        self.war_situation_trans = self.transform:Find('warSituation')
        self.march_info_trans = self.transform:Find('marchInfo')
        self.player_hold_info_dlg = self.transform:Find('PlayerHoldInfo')
        self.march_line_info_dlg = self.transform:Find('MarchLineInfo')
        self.base_trans = self.transform:Find('baseTrans')

        self.helper.hideTrans(self.none_hold_mine)
        self.helper.hideTrans(self.holded_mine)
        self.helper.hideTrans(self.army_trans)
        self.helper.hideTrans(self.rule_trans)
        self.helper.hideTrans(self.coord_collect_trans)
        self.helper.hideTrans(self.edit_coord_trans)
        self.helper.hideTrans(self.input_num_trans)
        self.helper.hideTrans(self.item_use_trans)
        self.helper.hideTrans(self.monsterInfo_trans)
        self.helper.hideTrans(self.accelerate_item_trans)
        self.helper.hideTrans(self.retreat_item_trans)
        self.helper.hideTrans(self.playerInfo_trans)
        self.helper.hideTrans(self.war_situation_trans)
        self.helper.hideTrans(self.player_hold_info_dlg)
        self.helper.hideTrans(self.march_line_info_dlg)
        self.helper.hideTrans(self.march_info_trans)
        self.helper.hideTrans(self.base_trans)

        self.steel_text = self:findText('new/topRight/asset/Asset Steel/Text')
        self.wood_text = self:findText('new/topRight/asset/Asset Wood/Text')
        self.brick_text = self:findText('new/topRight/asset/Asset Brick/Text')
        self.uranium_text = self:findText('new/topRight/asset/Asset Uranium/Text')

        -- 当前坐标显示框
        self.text_coordinate = self:findText("new/top/moveCoord/coordinateText")

        self.march_line_ui = {}

        self.transform:Find("new/topLeft/marchLineUI").gameObject:SetActive(false)
        self.left_form = self.transform:Find('new/topLeft/marchs')

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "new/buttomRight/funs/grid/homeBtn",
            "new/buttomRight/funs/grid/unionBtn",
            "new/buttomRight/funs/grid/taskBtn",
            "new/buttomRight/funs/grid/storeHouseBtn",
            "new/buttomRight/funs/grid/carBtn",
            "new/buttomRight/funs/enterLevelBtn",
            "new/buttomRight/funs/emailBtn",
            "new/buttomRight/funs/mapBtn",
            "new/buttomRight/funs/recordBtn",
            "new/topRight/lookAtHomeBtn",
            -- 野矿界面
            "MineInfo/Fight Dialog/Background/sendArmyBtn",
            "MineInfo/Fight Dialog/Background/leaveMineBtn",
            "MineInfo/Fight Dialog/Background/closeMineInfoBtn",
            "MineInfo/closeMineInfoBtn",
            "MineInfo/Fight Dialog/Background/collectCoordMineInfo",
            "MineInfo/Fight Dialog/Background/lookForMineInfoRule",
            -- 占矿界面
            "holdedMine/Fight Dialog/Background/closeHoldedMine",
            "holdedMine/closeHoldedMine",
            "holdedMine/Fight Dialog/Background/collectHoldedMine",
            "holdedMine/Fight Dialog/Background/lookForHoldedMine",
            "holdedMine/Fight Dialog/Background/sendArmyToHoldedMineBtn",
            "holdedMine/Fight Dialog/Background/leaveHoldedMineBtn",
            -- 怪物界面
            "monsterInfo/Fight Dialog/Background/leaveArmyMstBtn",
            "monsterInfo/Fight Dialog/Background/sendArmyToMstBtn",
            "monsterInfo/Fight Dialog/Background/closeMonsterInfoBtn",
            "monsterInfo/closeMonsterInfoBtn",
            "monsterInfo/Fight Dialog/Background/collectMonsterInfoBtn",
            "monsterInfo/Fight Dialog/Background/lookForMonsterInfoBtn",
            -- 行军界面
            "marchInfo/Fight Dialog/Background/layout/retreatBtn",
            "marchInfo/Fight Dialog/Background/layout/accelerateBtn",
            "marchInfo/closeMarchInfo",
            -- 玩家界面
            "playerInfo/closePlayerInfo",
            -- 规则
            "rule/closeRule",
            -- 加速道具界面
            "accelerateItem/content/closeAccelerateItem",
            "accelerateItem/closeAccelerateItem",
            -- 召回道具界面
            "retreatItem/closeRetreatItem",
            "retreatItem/content/Background/closeRetreatItem",
            "retreatItem/content/Background/useRetreatItemBtn",
            -- 编辑坐标界面
            -- "editCoord/content/remarkCoord",
            "editCoord/content/addCoordBtn",
            "editCoord/closeEditCoord",
            -- 坐标收藏界面
            "coordCollect/blackbg/background/closeCoordCollect",
            "coordCollect/closeCoordCollect",
            -- 基地界面
            "baseTrans/closeBaseTrans",
            "baseTrans/content/Background/closeBaseTrans",
            "baseTrans/content/Background/enterBaseBtn",
            "baseTrans/content/Background/otherPlayInfoBtn",
            "baseTrans/content/Background/collectOtherCoord",
            -- 修改界面
            "new/top/moveCoord",
            "new/top/collectCoord",
            "inputNum/right/layout/deleteNum",
            "inputNum/left/coordX",
            "inputNum/left/coordY",
            "inputNum/left/positioningBtn",
            "inputNum/closeInputNum",

            -- 聊天
            "new/buttomLeft/chat/bg/openChatBtn",
        }

        world_map_info.ui = self

        self.helper:regClickEvents("click", self, clickEvents)

        for i = 0, 9 do 
            local path = "inputNum/right/layout/Button (" .. i .. ")"
            self:setScript("click", path, functor.rmake(self.click_number, i))
        end

        for i = 1, 4 do 
            local path = "editCoord/content/layout/item (" .. i .. ")"
            self:setScript("click", path, functor.rmake(self.click_coord_tab, i))
        end

        for i = 1, 4 do 
            local path = "coordCollect/blackbg/background/layout/Tag (" .. i .. ")"
            self:setScript("click", path, functor.rmake(self.click_coord_lefttab, i))
        end

        -- 刷新坐标收集界面
        self:refreshCollectCoord()

        -- 当前选择的矿(包括 野矿 和 占有矿)
        self.cur_select_mine = nil
        -- 当前选择怪
        self.cur_select_mst = nil
        -- 当前选择行军
        self.cur_select_march = nil
        -- 当前选择玩家
        self.cur_select_player = nil

        self:refreshResourceNum()
        self.prop_change_event_id = local_player.events:on("onPropChange", functor.make(self.refreshResourceNum, self))

        app:startCoroutine(function()
            local interval = 0.1
            while true do
                coroutine.yield(WaitForSeconds(interval))
                self:onUpdate()
                self:onUpdateRes(interval)
            end
        end)

        self:initTask()

        self:levelOver()

        -- 关闭 loading
        frame_manager:hide('loading')

        print("玩家id:", local_player.id)
    end,

    onUpdate = function(self)
        if not self.look_home_btn then
            self.look_home_btn = self.transform:Find("new/topRight/lookAtHomeBtn").gameObject
        end

        if not self.owner.world_map then
            return
        end

        if not self.owner.world_map.my_hold then
            return
        end

        if not self.arrowOffset then
            self.arrowOffset = self.transform:Find("new/topRight/lookAtHomeBtn/offset")
        end

        local home_trans = self.owner.world_map.my_hold.transform
        if home_trans and self.arrowOffset then
            local startPos = self.helper:worldToScreenPoint(self.arrowOffset.position)
            local playerPos = Camera.main:WorldToScreenPoint(home_trans.position);
            local need_cal = true
            -- 在屏幕范围内
            if playerPos.x <= UnityEngine.Screen.width and playerPos.x >= 0 and playerPos.y <= UnityEngine.Screen.height and playerPos.y >= 0 then
                need_cal = false
            end
            -- 超出屏幕范围
            if need_cal then
                if not self.look_home_btn.activeSelf then
                    self.look_home_btn:SetActive(true)
                end

                local mask = core.mask('Tank', 'Ground')
                local r = Camera.main:ScreenPointToRay(startPos)
                local rst, hit = UnityEngine.Physics.Raycast(r, hit, 999, mask)
                if rst then
                    local center_point = GameObject.Find("Hex Map Camera").transform
                    local dir = home_trans.position - hit.point
                    local y = dir.z
                    dir = Vector3(dir.x, dir.z, 0)
                    local q = Quaternion.identity
                    q:SetFromToRotation(Vector3.up, dir)
                    self.arrowOffset.rotation = q
                end
            -- 屏幕范围内
            else
                if self.look_home_btn.activeSelf then
                    self.look_home_btn:SetActive(false)
                end
                -- playerPos.z = 0
                -- startPos.z = 0
                -- local dir = playerPos - startPos
                -- local q = Quaternion.identity;
                -- q:SetFromToRotation(Vector3.up, dir);
                -- self.arrowOffset.rotation = q
            end
        end
    end,

    -- 显示单位信息
    -- WORLD_OBJ_PLAYER = 1;
    -- WORLD_OBJ_MINE = 2;
    -- WORLD_OBJ_MARCH = 3;
    -- WORLD_OBJ_MONSTER = 4;
    showUnitInfo = function(self, msg, e_type, unit_id)
        if e_type == 1 then
            local unit_msg = world_map_info.player_holds[unit_id]
            self:setBaseInfo(unit_msg)
        elseif e_type == 2 then
            local unit_msg = world_map_info.mine_holds[unit_id]
            local cfg = config.worldmap_resources[unit_msg.resCfgId]
            local data = msg.mineHoldQuerys[1]
            -- print("unit_id:", unit_id)
            -- print("resCfgId:", unit_msg.resCfgId)
            -- print("ownerId:", unit_msg.ownerId)
            -- 野矿
            if unit_msg.ownerId == "0" then   
                self:setNoneMine(cfg, data, unit_msg)
                self.helper.showTrans(self.none_hold_mine)
            -- 自己的矿 or 别人占领的矿
            else   
                self:setHoldedMine(cfg, data, unit_msg)
                self.helper.showTrans(self.holded_mine)
            end
            self.cur_select_mine = { unit_id = unit_id, cfg = cfg, data = data, unit_msg = unit_msg }
        -- 点击车队不给服务器发送消息，从地图信息里面读取
        elseif e_type == 3 then
            local unit_msg = world_map_info.march_lines[unit_id]
            -- local data = msg.marchLineQuerys[1]
            self:setMarchInfo(msg.marchLineQuerys[1].marchLineQuery)
            -- self.cur_select_march = { data = data }
        elseif e_type == 4 then
            local unit_msg = world_map_info.monster_holds[unit_id]
            local cfg = config.worldmap_monsters[unit_msg.monsterCfgId]
            local data = msg.monsterHoldQuerys[1]
            self:setMonsterInfo(cfg, data)
            self.helper.showTrans(self.monsterInfo_trans)
            self.cur_select_mst = { unit_id = unit_id, cfg = cfg, data = data }
        end
    end,

    -- 显示被人占领的矿
    -- cfg 是 config.worldmap_resources
    -- data 是 MMineHoldQuery
    -- unit_msg 是 MMineHold
    showHoldInfo = function(self, hold)
        self.target_hold = hold
        self.helper.showTrans(self.player_hold_info_dlg)

        -- 设置坐标
        self.player_hold_info_dlg:Find('TextCoord'):GetComponent("Text").text = 'X:'..hold.coordX..' Y:'..hold.coordY
        
        -- 玩家名称
        self.player_hold_info_dlg:Find('PlayerName'):GetComponent("Text").text = tostring('玩家名称ABC')
    end,

    -- 设置行军路线
    -- data 是 MMarchLine
    setMarchInfo = function(self, unit_msg)
        print("unit_msg:", unit_msg.goHome)
        self.helper.showTrans(self.march_info_trans)
        self.cur_MMarchLine = unit_msg
        local left_time = (unit_msg.totalTime - unit_msg.elapsedTime) * 0.000001
        self:findText("marchInfo/Fight Dialog/Background/nameText").text = "玩家id:" .. unit_msg.playerId
        self:findText("marchInfo/Fight Dialog/Background/destinationText").text = "目的地: " .. "X:" .. unit_msg.dstPosX .. " Y:" .. unit_msg.dstPosY

        local clk_trans = self.transform:Find("marchInfo/Fight Dialog/Background/leftTimeText")
        local clk = clk_trans:GetComponent(Clock)
        if not clk then
            clk = clk_trans:AddComponent(Clock)
        end
        clk.prefix = "剩余时间:"
        clk:Set(left_time)

        local retreat_btn = self.transform:Find("marchInfo/Fight Dialog/Background/layout/retreatBtn")
        local accelerate_btn = self.transform:Find("marchInfo/Fight Dialog/Background/layout/accelerateBtn")
        retreat_btn.gameObject:SetActive(not unit_msg.goHome)
    end,

    -- unit_msg 是 MMonsterHold
    setBaseInfo = function(self, unit_msg)
        self.helper.showTrans(self.base_trans)
        self:findText("baseTrans/content/Background/player/bg/nameText").text = "名字"
        self:findText("baseTrans/content/Background/player/bg/powerText").text = "战斗力"
        self:findText("baseTrans/content/Background/player/bg/coordText").text = string.format("X:%d Y:%d", unit_msg.posX, unit_msg.posY)

        local btn_trans = self.transform:Find("baseTrans/content/Background/enterBaseBtn")
        btn_trans.gameObject:SetActive(unit_msg.playerId == game_info.player_id)

        btn_trans = self.transform:Find("baseTrans/content/Background/otherPlayInfoBtn")
        btn_trans.gameObject:SetActive(unit_msg.playerId ~= game_info.player_id)

        btn_trans = self.transform:Find("baseTrans/content/Background/collectOtherCoord")
        btn_trans.gameObject:SetActive(unit_msg.playerId ~= game_info.player_id)

        if unit_msg.playerId ~= game_info.player_id then
            self.cur_collection_pos = {}
            self.cur_collection_pos.eTable = 0
            self.cur_collection_pos.strDesc = "???"
            self.cur_collection_pos.posX = unit_msg.posX
            self.cur_collection_pos.posY = unit_msg.posY
            self.cur_collection_pos.iconId = 1
        else
            self.cur_collection_pos = nil
        end
    end,

    click_closeBaseTrans = function(self)
        self.helper.hideTrans(self.base_trans)
    end,

    click_enterBaseBtn = function(self)
        print("进入基地")
        game_director:changeState('loading', {scene_name = 'home', next_state = 'home'})
    end,

    click_otherPlayInfoBtn = function(self)
        print("玩家详情")
    end,

    click_collectOtherCoord = function(self)
        print("收集其他人坐标")
        self:showEditPos()
    end,

    -- 设置怪物
    -- cfg 是 config.worldmap_monsters
    -- data 是 MMonsterHoldQuery
    -- unit_msg 是 MMonsterHold
    setMonsterInfo = function(self, cfg, data)

        self.cur_collection_pos = {}
        self.cur_collection_pos.eTable = 0
        self.cur_collection_pos.strDesc = self.helper:getLangCfg(cfg.monstername)
        self.cur_collection_pos.posX = data.monsterHold.posX
        self.cur_collection_pos.posY = data.monsterHold.posY
        self.cur_collection_pos.iconId = 1

        self:findText("monsterInfo/Fight Dialog/Background/Head Bar/Text").text = self.helper:getLangCfg(cfg.monstername)
        local rwdTemplate = self.transform:Find('monsterInfo/Fight Dialog/Background/content/rwds/tplt')
        rwdTemplate.gameObject:SetActive(false)

        for i = 0, rwdTemplate.transform.parent.childCount - 1 do
            rwdTemplate.transform.parent:GetChild(i).gameObject:SetActive(false)
        end

        -- 暂时读取个人奖励
        local tmpArgs = self.helper:getJsonTab(cfg.personalreward)
        for itemId, num in pairs(tmpArgs) do
            local rwdItem = Object.Instantiate(rwdTemplate.gameObject);
            rwdItem.gameObject:SetActive(true)
            rwdItem:AttachTo(rwdTemplate.transform.parent)
            local image = rwdItem:GetComponent(UnityEngine.UI.Image)
            local icon_name = self.helper:getItemIcon(itemId)
            image:SetSprite(icon_name)
        end

        -- print("回复倒计时:", data.monsterHold.recoveryTime)
        local clk_trans = self.transform:Find("monsterInfo/Fight Dialog/Background/content/Image/desText")
        local clk = clk_trans:GetComponent(Clock)
        if not clk then
            clk = clk_trans:AddComponent(Clock)
        end
        clk.prefix = "回复倒计时"
        clk:Set(data.monsterHold.recoveryTime)
        self:findImage("monsterInfo/Fight Dialog/Background/content/Image/sliderValue").fillAmount = data.monsterHold.curHp / data.monsterHold.maxHp
        self:findText("monsterInfo/Fight Dialog/Background/Image/Text").text = string.format(NativeText.GetLangStr(100011), data.monsterHold.posX, data.monsterHold.posY)
        local tmp = math.floor(data.monsterHold.curHp / data.monsterHold.maxHp * 100)
        self:findText("monsterInfo/Fight Dialog/Background/content/Image/rateText").text = tmp .. "%"
    end,

    -- 设置没人占领的矿
    -- cfg 是 config.worldmap_resources
    -- data 是 MMineHoldQuery
    -- unit_msg 是 MMineHold
    setHoldedMine = function(self, cfg, data, unit_msg)
        self.cur_collection_pos = {}
        self.cur_collection_pos.eTable = 0
        self.cur_collection_pos.strDesc = self.helper:getLangCfg(cfg.nameid)
        self.cur_collection_pos.posX = unit_msg.posX
        self.cur_collection_pos.posY = unit_msg.posY
        self.cur_collection_pos.iconId = 1

        self:findText("holdedMine/Fight Dialog/Background/icon/curAmountText").text = "已采集 " .. data.gatherNum .. "/" .. data.gatherUpper
        self:findText("holdedMine/Fight Dialog/Background/icon/resAmountText").text = "剩余储量 " .. data.resAmount
        self:findText("holdedMine/Fight Dialog/Background/Head Bar/Text").text = self.helper:getLangCfg(cfg.nameid)
        self:findText("holdedMine/Fight Dialog/Background/Image/Text").text = "坐标 " .. 'X:'.. unit_msg.posX ..' Y:'..unit_msg.posY

        local send_army_btn = self.transform:Find("holdedMine/Fight Dialog/Background/sendArmyToHoldedMineBtn")
        local undo_army_btn = self.transform:Find("holdedMine/Fight Dialog/Background/leaveHoldedMineBtn")

        self.can_be_gather = true
        self.gather_speek = data.gatherSpeed
        self.cur_gather_num = data.gatherNum 
        self.max_gather_num = data.gatherUpper

        -- 自己占有只有撤军
        if unit_msg.ownerId == game_info.role_info.playerid then
            send_army_btn.gameObject:SetActive(false)
            undo_army_btn.gameObject:SetActive(true)
        -- 别人占领，判断自己是否正在进攻
        else
            send_army_btn.gameObject:SetActive(true)
            undo_army_btn.gameObject:SetActive(false)
        end

        local tplt = self.transform:Find("holdedMine/Fight Dialog/Background/content/tanks/tplt")
        tplt.gameObject:SetActive(false)
    end,

    onUpdateRes = function(self, interval)
        if not self.can_be_gather then
            return
        end

        if not self.gather_total_time then
            self.gather_total_time = 0
        end

        self.gather_total_time = self.gather_total_time + interval

        if self.gather_total_time >= 1 then
            local text = self:findText("holdedMine/Fight Dialog/Background/icon/curAmountText")
            self.cur_gather_num = self.cur_gather_num + self.gather_speek
            if self.cur_gather_num > self.max_gather_num then
                self.cur_gather_num = self.max_gather_num
            end
            text.text = "已采集 " .. self.cur_gather_num .. "/" .. self.max_gather_num
            self.gather_total_time = 0

            text = self:findText("holdedMine/Fight Dialog/Background/icon/resAmountText")
            text.text = "剩余储量 " .. (self.max_gather_num - self.cur_gather_num)
        end
    end,

    -- 设置没人占领的矿
    -- cfg 是 config.worldmap_resources
    -- data 是 MMineHoldQuery
    -- unit_msg 是 MMineHold
    setNoneMine = function(self, cfg, data, unit_msg)
        
        self.cur_collection_pos = {}
        self.cur_collection_pos.eTable = 0
        self.cur_collection_pos.strDesc = self.helper:getLangCfg(cfg.nameid)
        self.cur_collection_pos.posX = unit_msg.posX
        self.cur_collection_pos.posY = unit_msg.posY
        self.cur_collection_pos.iconId = 1

        self.cache_nonemine_monsters = self.cache_nonemine_monsters or {}

        local monster_cfgs = {}

        config.monster_stat_ids:foreach(function(k, v)
            if v.Group_ID == cfg.monsterGroup then
                table.insert(monster_cfgs, v)
            end
        end)

        self:findText("MineInfo/Fight Dialog/Background/icon/text").text = "剩余储量" .. data.resAmount
        self:findText("MineInfo/Fight Dialog/Background/Head Bar/text").text = self.helper:getLangCfg(cfg.nameid)
        self:findText("MineInfo/Fight Dialog/Background/Image/Text").text = "坐标 " .. 'X:'.. unit_msg.posX ..' Y:'.. unit_msg.posY

        print("行军时间:", data.marchTime)

        self.transform:Find("MineInfo/Fight Dialog/Background/sendArmyBtn").gameObject:SetActive(true)
        self.transform:Find("MineInfo/Fight Dialog/Background/leaveMineBtn").gameObject:SetActive(false)

        local tplt = self.transform:Find("MineInfo/Fight Dialog/Background/content/tanks/tplt")
        tplt.gameObject:SetActive(false)

        for k, v in ipairs(self.cache_nonemine_monsters) do
            v:SetActive(false)
        end

        for k, v in ipairs(monster_cfgs) do
            local tank = nil
            if k > #self.cache_nonemine_monsters then
                tank = Object.Instantiate(tplt.gameObject);
                tank:AttachTo(tplt.transform.parent)
                tank:SetActive(true)
                table.insert(self.cache_nonemine_monsters, tank)
            else
                tank = self.cache_nonemine_monsters[k]
                tank:SetActive(true)
            end

            local tank_cfg = config.tank_basic_ids[v.Tank_ID]
            -- 设置icon
            local icon = tank:GetComponent(UnityEngine.UI.Image)
            icon:SetSprite('Assets/Arts/ui/atlas/icon/vehicle/' .. tank_cfg.icon .. '.png')
            -- 设置等级
            local lvText = tank.transform:Find("lvText"):GetComponent(UnityEngine.UI.Text)
            lvText.text = "等级 ".. v.Tank_Level
        end

        local rwdTemplate = self.transform:Find('MineInfo/Fight Dialog/Background/content/rwds/tplt')
        rwdTemplate.gameObject:SetActive(false)

        for i = 0, rwdTemplate.transform.parent.childCount - 1 do
            rwdTemplate.transform.parent:GetChild(i).gameObject:SetActive(false)
        end

        local tmpArgs = self.helper:getJsonTab(cfg.reward)
        for itemId, num in pairs(tmpArgs) do
            local rwdItem = Object.Instantiate(rwdTemplate.gameObject);
            rwdItem.gameObject:SetActive(true)
            rwdItem:AttachTo(rwdTemplate.transform.parent)
            local image = rwdItem:GetComponent(UnityEngine.UI.Image)
            
            local icon_name = self.helper:getItemIcon(itemId)
            image:SetSprite(icon_name)
        end
    end,

    showMarchLineInfo = function(self, march_line)
        self.target_march_line = march_line
        self.helper.showTrans(self.march_line_info_dlg)

        -- 设置目的地坐标
        self.march_line_info_dlg:Find('TextTargetCoord'):GetComponent("Text").text = 
            'X:'..march_line.info.dstPosX..' Y:'..march_line.info.dstPosY

        --self.march_line_info_dlg:Find('ID'):GetComponent("Text").text = tostring(march_line.id)
    end,

    onClickLevel = function(self)

        local tmp = self.transform:Find("InputFieldSceneName")
        local inputFieldSceneName = tmp:GetComponent( UnityEngine.UI.InputField)
        local _name = inputFieldSceneName.text
        tmp = self.transform:Find("InputFieldLevelID")
        local inputFieldLevelID = tmp:GetComponent( UnityEngine.UI.InputField)
        local _id = tonumber(inputFieldLevelID.text)

        if _name and _id then
            log.info('scene:'.._name..', id:'..tostring(_id))
            game_director:changeState('loading', {next_state = 'level', scene_name = _name, level_id = _id})
        else
            log.error('请输入场景名称和关卡难度id');
        end

    end,

    click_ButtonBack = function(self)
        game_director:changeState('login')
    end,

    onClickReqEnterMap = function(self)
        local tmp = self.transform:Find("InputRequestLv")
        local inputFieldLevelID = tmp:GetComponent( UnityEngine.UI.InputField)
        local _id = tonumber(inputFieldLevelID.text)
        network_sender:enterMap(_id)   -- 关卡 id
    end,

    -- 摄像机定位到自己据点
    click_lookAtHomeBtn = function(self)
        --print("回家")
        self.owner:lookAtMyHold()
    end,

    -- 行军信息 加速
    onClickAccelerateMarchLine = function(self)
        self.target_march_line:refresh(
            self.target_march_line.src_pos,
            self.target_march_line.dest_pos,
            self.target_march_line.percent,
            20000
        )
    end,

    -- 行军信息 返回
    onClickMarchLineHoming = function(self)
        --self.target_march_line:backHome()
        if self.target_march_line then
            network_sender:worldMapGoHome(protocol_pb.WORLD_OBJ_MARCH, self.target_march_line.id, self.owner.map_type)
        else
            
        end
    end,

    -- 关闭行军信息
    onClickCloseMarchLineInfo = function(self)
        self.helper.hideTrans(self.march_line_info_dlg)
    end,

    -- 据点信息 玩家详细
    onClickDetailPlayerInfo = function(self)
    end,

    -- 据点信息 进入据点
    onClickEnterHold = function(self)
    end,

    -- 关闭玩家据点信息
    onClickPlayerHoldInfoClose = function(self)
        self.helper.hideTrans(self.player_hold_info_dlg)
    end,

    -- 设置当前坐标
    setCameraCoordant = function(self, x, y)
        if not self.text_coordinate then
            return
        end

        if self.last_x ~= x or self.last_y ~= y then
            self.text_coordinate.text = 'X:'..x..' Y:'..y
            self.last_x = x
            self.last_y = y
        end
    end,

    -- march_line 是 MMarchLine
    addMarchLineUI = function(self, march_line)
        local id = march_line.marchLineId
        if not self.march_line_ui[id] then
            local tplt = self.transform:Find("new/topLeft/marchLineUI")
            tplt.gameObject:SetActive(false)
            local go = Object.Instantiate(tplt.gameObject);
            self.march_line_ui[id] = go

            go.transform:SetParent(self.left_form)
            go.transform.localPosition = Vector3.zero
            go.transform.name = id
            go.transform.localScale = Vector3.one
            go:SetActive(true)

            local leftTime = (march_line.totalTime - march_line.elapsedTime) * 0.000001

            self:setScript("click", "new/topLeft/marchs/" .. go.transform.name, functor.rmake(self.click_march_line, id))

            local des_text = go.transform:Find('desText').gameObject:GetComponent(UnityEngine.UI.Text)
            des_text.text = ""

            -- print(march_line.objType, march_line.goHome, leftTime, march_line.cfgId)

            if march_line.goHome then
                des_text.text = self.helper:getLangCfg(config.worldmap_marchs[1].backtobaselang)
            else
                if march_line.objType == common_pb.WORLD_OBJ_PLAYER then

                elseif march_line.objType == common_pb.WORLD_OBJ_MINE then
                    local cfg = config.worldmap_resources[march_line.cfgId]
                    des_text.text = self.helper:getLangCfg(cfg.nameid)
                elseif march_line.objType == common_pb.WORLD_OBJ_MARCH then

                elseif march_line.objType == common_pb.WORLD_OBJ_MONSTER then
                    local cfg = config.worldmap_monsters[march_line.cfgId]
                    des_text.text = self.helper:getLangCfg(cfg.monstername)
                end
            end

            local time_text = go.transform:Find('timeText').gameObject:GetComponent(UnityEngine.UI.Text)
            time_text.text = self.helper:timeFormat(leftTime) 
            
            local clk_trans = go.transform:Find('timeText')
            local clk = clk_trans:GetComponent(Clock)
            if not clk then
                clk = clk_trans:AddComponent(Clock)
            end
            clk:Set(math.floor(leftTime))
        else
            print("刷新行车时间")

            local go = self.march_line_ui[id]
            local leftTime = (march_line.totalTime - march_line.elapsedTime) * 0.000001
            local clk_trans = go.transform:Find('timeText')
            local clk = clk_trans:GetComponent(Clock)
            if not clk then
                clk = clk_trans:AddComponent(Clock)
            end
            clk:Set(math.floor(leftTime))
        end
    end,

    click_march_line = function (self, handler, id) 
        print("click_march_line:", id)
        self.owner:lookAtMarchLine(id)
        network_sender:queryWorldMap(id, self.owner.map_type)
        -- local unit_msg = world_map_info.march_lines[id]
        -- self:setMarchInfo(unit_msg)
    end,

    removeMarchLineUI = function(self, id)
        local go = self.march_line_ui[id]
        if go then
            self.march_line_ui[id] = nil
            go.transform:SetParent(nil)
            Object.DestroyImmediate(go)
        end
    end,

    refreshResourceNum = function(self)
        self.steel_text.text = tostring(local_player.props[protocol_pb.PROR_STEEL])
        self.wood_text.text = tostring(local_player.props[protocol_pb.PROP_WOOD])
        self.brick_text.text = tostring(local_player.props[protocol_pb.PROP_BRICK])
        self.uranium_text.text = tostring(local_player.props[protocol_pb.PROP_NUCLEAR])
    end,

    -- ############### 换新界面 start

    -- 基地
    click_homeBtn = function(self)
        print("基地")
        game_director:changeState('loading', {scene_name = 'home', next_state = 'home'})
    end,
    
    -- 工会
    click_unionBtn = function(self)
        print("工会")
        if local_guild:inGuild(local_guild:getId()) then
            network_sender:getFamilyInfo(local_player:getGuildId())
        else
            network_sender:getFamilyList(0)
        end
    end,

    -- 任务
    click_taskBtn = function(self)
        --network_sender:getChapterTask(1)   -- 关卡 id
        -- frame_manager:show('daily_task', self)
    end,

    -- 仓库
    click_storeHouseBtn = function(self)
        -- print("仓库")
        -- frame_manager:show('bag', self)
    end,

    -- 车库
    click_carBtn = function(self)
        print("车库")
        -- frame_manager:show('hero_list', self)
    end,

    -- 进入关卡
    click_enterLevelBtn = function(self)
        frame_manager:show('chapter')
    end,

    -- 邮件
    click_emailBtn = function(self)
        print("邮件")
    end,

    -- 地图
    click_mapBtn = function(self)
        print("地图")
        -- network_sender:getShopList()
    end,

    -- 战报
    click_recordBtn = function(self)
        print("战报")
    end,

    -- 关闭占矿界面
    click_closeHoldedMine = function(self)
        self.helper.hideTrans(self.holded_mine)
    end,

    -- 收藏占矿界面
    click_collectHoldedMine = function(self)
        self:showEditPos()
    end,

    -- 查看占矿界面
    click_lookForHoldedMine = function(self)
        self.helper.showTrans(self.rule_trans)
    end,

    -- 矿点信息 派出车队
    click_sendArmyBtn = function(self)
        if self.cur_select_mine then
            self.helper.hideTrans(self.none_hold_mine)
            self.owner:sendArmyToMine(self.cur_select_mine.unit_id)
        end
    end,

    -- 撤退
    click_leaveMineBtn = function(self)
        
    end,

    -- 关闭矿点信息
    click_closeMineInfoBtn = function(self)
        self.helper.hideTrans(self.none_hold_mine)
    end,

    click_collectCoordMineInfo = function(self)
        print("收集坐标")

        -- //坐标收藏信息
        -- message MCollectionPos
        -- {
        -- required uint32 id = 1;
        -- required ECollectionTable eTable = 2;
        -- required string strDesc = 3;//描述
        -- required EWorldObjType objType = 4;
        -- required uint32 iconId = 5;//玩家对应iconid， 怪物说是资源点对应cfgId
        -- required uint32 posX = 6;
        -- required uint32 posY = 7;
        -- required uint32 marchDist = 8;//行军距离
        -- required uint32 marchTime = 9;//行军时间 
        -- }

        self:showEditPos()
    end,

    showEditPos = function(self)
        if self.cur_collection_pos then
            print("描述:", self.cur_collection_pos.strDesc)
            self.helper.showTrans(self.edit_coord_trans)
            self:findText("editCoord/content/Text").text = "坐标收集"
            self:findText("editCoord/content/Text (1)").text = "X:" .. self.cur_collection_pos.posX .. " Y:" .. self.cur_collection_pos.posY
            local input = self.transform:Find("editCoord/content/InputField"):GetComponent(UnityEngine.UI.InputField)

            input.onValueChanged:AddListener(
                function()
                    self.cur_collection_pos.strDesc = input.text
                end
            )

            input.text = self.cur_collection_pos.strDesc
            self:click_coord_tab(nil, self.cur_collection_pos.eTable + 1)
        end
    end,

    click_remarkCoord = function(self)
        print("备注 收集")
        local input = self.transform:Find("editCoord/content/InputField"):GetComponent(UnityEngine.UI.InputField)
        -- input.isFocused = true
    end,

    click_coord_tab = function(self, hander, index)
        self.cur_collection_pos.eTable = index - 1
        for i = 1, 4 do 
            self:findImage("editCoord/content/layout/item (" .. i .. ")/Image (1)").enabled = index == i
        end
    end,

    click_lookForMineInfoRule = function(self)
        self.helper.showTrans(self.rule_trans)
    end,

    click_closeRule = function(self)
        self.helper.hideTrans(self.rule_trans)
    end,

    refreshCollectCoord = function(self)
        local sv1 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (1)/Viewport/Content")
        local sv2 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (2)/Viewport/Content")
        local sv3 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (3)/Viewport/Content")
        local sv4 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (4)/Viewport/Content")

        for i = 0, sv1.childCount - 1 do
            sv1:GetChild(i).gameObject:SetActive(false)
        end
        for i = 0, sv2.childCount - 1 do
            sv2:GetChild(i).gameObject:SetActive(false)
        end
        for i = 0, sv3.childCount - 1 do
            sv3:GetChild(i).gameObject:SetActive(false)
        end
        for i = 0, sv4.childCount - 1 do
            sv4:GetChild(i).gameObject:SetActive(false)
        end

        self.collect_coord_data = self.collect_coord_data or {}

        local tplt = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (1)/Viewport/Content/tplt")
        tplt.gameObject:SetActive(false)

        if not self.owner.collections then
            return
        end

        for k, v in pairs(self.owner.collections) do
            local item = nil

            if not self.collect_coord_data[k] then
                print("####:", k)
                item = Object.Instantiate(tplt.gameObject);
                item.gameObject:SetActive(true)
                item.transform.name = k
                local path = nil

                if v.eTable == common_pb.ECOLLECTION_RES then
                item:AttachTo(sv1)
                    path = "coordCollect/blackbg/background/svs/Scroll View (1)/Viewport/Content/" .. item.transform.name
                elseif v.eTable == common_pb.ECOLLECTION_FRIEND then
                    item:AttachTo(sv2)
                    path = "coordCollect/blackbg/background/svs/Scroll View (2)/Viewport/Content/" .. item.transform.name
                elseif v.eTable == common_pb.ECOLLECTION_ENEMY then
                    item:AttachTo(sv3)
                    path = "coordCollect/blackbg/background/svs/Scroll View (3)/Viewport/Content/" .. item.transform.name
                elseif v.eTable == common_pb.ECOLLECTION_FAVORITE then
                    item:AttachTo(sv4)
                    path = "coordCollect/blackbg/background/svs/Scroll View (4)/Viewport/Content/" .. item.transform.name
                end

                self:setScript("click", path .. "/editButton", functor.rmake(self.click_edit_coord, v))
                self:setScript("click", path .. "/skipButton", functor.rmake(self.click_move_coord, v))
                self:setScript("click", path .. "/deleteButton", functor.rmake(self.click_delete_coord, v))

                self.collect_coord_data[k] = { mCollectionPos = v, trans = item }
            else
                item = self.collect_coord_data[k].trans
                item.gameObject:SetActive(true)

                if v.eTable == common_pb.ECOLLECTION_RES then
                    item:AttachTo(sv1)
                elseif v.eTable == common_pb.ECOLLECTION_FRIEND then
                    item:AttachTo(sv2)
                elseif v.eTable == common_pb.ECOLLECTION_ENEMY then
                    item:AttachTo(sv3)
                elseif v.eTable == common_pb.ECOLLECTION_FAVORITE then
                    item:AttachTo(sv4)
                end
            end

            local name_text = item.transform:Find("nameText"):GetComponent(UnityEngine.UI.Text)
            name_text.text = v.strDesc
            local dis_text = item.transform:Find("disText"):GetComponent(UnityEngine.UI.Text)
            dis_text.text = "距离:" .. v.marchDist
            local time_text = item.transform:Find("timeText"):GetComponent(UnityEngine.UI.Text)
            time_text.text = "行军时间:" .. v.marchTime
        end
    end,

    click_collectCoord = function(self)
        print("打卡坐标收集界面")
        self.helper.showTrans(self.coord_collect_trans)
        self:click_coord_lefttab(nil, 1)
    end,

    click_coord_lefttab = function(self, hander, index)
        print("左边标签:", index)
        local sv1 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (1)")
        local sv2 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (2)")
        local sv3 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (3)")
        local sv4 = self.transform:Find("coordCollect/blackbg/background/svs/Scroll View (4)")

        for i = 1, 4 do 
            local path = "coordCollect/blackbg/background/layout/Tag (" .. i .. ")/select"
            self:findImage(path).enabled = index == i
        end

        self.helper.hideTrans(sv1)
        self.helper.hideTrans(sv2)
        self.helper.hideTrans(sv3)
        self.helper.hideTrans(sv4)

        if index == 1 then
             self.helper.showTrans(sv1)
        elseif index == 2 then
            self.helper.showTrans(sv2)
        elseif index == 3 then
            self.helper.showTrans(sv3)
        elseif index == 4 then
            self.helper.showTrans(sv4)
        end
    end,

    -- //坐标收藏信息
    -- message MCollectionPos
    -- {
    -- required uint32 id = 1;
    -- required ECollectionTable eTable = 2;
    -- required string strDesc = 3;//描述
    -- required EWorldObjType objType = 4;
    -- required uint32 iconId = 5;//玩家对应iconid， 怪物说是资源点对应cfgId
    -- required uint32 posX = 6;
    -- required uint32 posY = 7;
    -- required uint32 marchDist = 8;//行军距离
    -- required uint32 marchTime = 9;//行军时间 
    -- }

    click_edit_coord = function(self, handler, mCollectionPos)
        print("编辑:", mCollectionPos.id, mCollectionPos.eTable)
        self.cur_collection_pos = mCollectionPos
        self:showEditPos()
        self.coord_edit_mode = "modify"
    end,

    click_move_coord = function(self, handler, mCollectionPos)
        print("移动:", mCollectionPos.id, mCollectionPos.posX, mCollectionPos.posY)
        self.helper.hideTrans(self.coord_collect_trans)
        self.owner:setCameraPos(mCollectionPos.posX, mCollectionPos.posY)
        -- self.cur_collection_pos = mCollectionPos
        -- self:showEditPos()
    end,

    click_delete_coord = function(self, handler, mCollectionPos)
        print("删除:", mCollectionPos.id)
        self.cur_collection_pos = mCollectionPos
        local tmp = self.cur_collection_pos
        network_sender:worldMapCollectionDel(tmp.id)
        -- self:showEditPos()
    end,

    -- 定位功能 start

    click_moveCoord = function(self)
        self.cur_input_coord = { x = tostring(self.last_x), y = tostring(self.last_y), cur = 1 }
        self:findText("inputNum/left/coordX/Text").text = self.last_x
        self:findText("inputNum/left/coordY/Text").text = self.last_y
        self.helper.showTrans(self.input_num_trans)
    end,

    click_number = function (self, handler, index)
        print("index")

        local max_X, max_Z = self.owner:getWorldMapBorder()
        print(max_X, max_Z)

        if self.cur_input_coord.cur == 1 then
            local tmp = self.cur_input_coord.x .. tostring(index)
            if tonumber(tmp) <= max_X then
                self.cur_input_coord.x = tmp
            else
                hint:setText(string.format("不能超过%d", max_X))
            end
        else
            local tmp = self.cur_input_coord.y .. tostring(index)
            if tonumber(tmp) <= max_Z then
                self.cur_input_coord.y = tmp
            else
                hint:setText(string.format("不能超过%d", max_Z))
            end
        end

        local x_text = self:findText("inputNum/left/coordX/Text")
        local y_text = self:findText("inputNum/left/coordY/Text")
        x_text.text = tonumber(self.cur_input_coord.x)
        y_text.text = tonumber(self.cur_input_coord.y)
    end, 

    click_deleteNum = function(self)
        print("删除按钮")
        if self.cur_input_coord.cur == 1 then
            self.cur_input_coord.x = string.sub(self.cur_input_coord.x, 1, -2)
            if self.cur_input_coord.x == "" then
                self.cur_input_coord.x = "0"
            end
        else
            self.cur_input_coord.y = string.sub(self.cur_input_coord.y, 1, -2)
            if self.cur_input_coord.y == "" then
                self.cur_input_coord.y = "0"
            end
        end
        self:findText("inputNum/left/coordX/Text").text = self.cur_input_coord.x
        self:findText("inputNum/left/coordY/Text").text = self.cur_input_coord.y
    end,

    click_coordX = function(self)
        self.cur_input_coord.cur = 1
    end,

    click_coordY = function(self)
        self.cur_input_coord.cur = 2
    end,

    click_positioningBtn = function(self)
        local ix = tonumber(self.cur_input_coord.x)
        local iy = tonumber(self.cur_input_coord.y)
        self.owner:setCameraPos(ix, iy)
        self.helper.hideTrans(self.input_num_trans)
    end,

    click_closeInputNum = function(self)
        self.helper.hideTrans(self.input_num_trans)
    end,

    -- 定位功能 end

    -- 发送行军，进攻别人占有的矿
    click_sendArmyToHoldedMineBtn = function(self)
        self.helper.hideTrans(self.holded_mine)
        if self.cur_select_mine then
            network_sender:startMarchLine(common_pb.WORLD_OBJ_MINE, self.cur_select_mine.unit_id, {1,2}, self.owner.map_type)
        end
    end,

    -- 召回占有的矿
    click_leaveHoldedMineBtn = function(self)
        self.helper.hideTrans(self.holded_mine)
        if self.cur_select_mine then
            network_sender:worldMapGoHome(self.cur_select_mine.unit_id, common_pb.WORLD_OBJ_MINE, "0", self.owner.map_type)
        end
    end,

    -- monster界面事件 start
    click_leaveArmyMstBtn = function(self)
    end,

    click_sendArmyToMstBtn = function(self)
        if self.cur_select_mst then
            self.helper.hideTrans(self.monsterInfo_trans)
            self.owner:sendArmyToMonster(self.cur_select_mst.unit_id)
        end
    end,

    click_closeMonsterInfoBtn = function(self)
        self.helper.hideTrans(self.monsterInfo_trans)
    end,

    click_collectMonsterInfoBtn = function(self)
        self:showEditPos()
    end,

    click_lookForMonsterInfoBtn = function(self)
        self.helper.showTrans(self.rule_trans)
    end,

    -- monster界面事件 end

    -- 行军界面 start
    click_retreatBtn = function(self)
        self.helper.showTrans(self.retreat_item_trans)
        local retreat_item_id = 60004
        local cfg = config.item_useables[retreat_item_id]
        local own_str = NativeText.GetLangStr("100020")
        local cost_str = NativeText.GetLangStr("100021")
        self:findText("retreatItem/content/Background/player/itemNameText").text = self.helper:getLangCfg(cfg.name_id)
        self:findText("retreatItem/content/Background/player/desText").text = self.helper:getLangCfg(cfg.des_id)
        self:findText("retreatItem/content/Background/player/ownText").text = string.format(own_str, bag_manager:getItemNum(retreat_item_id))
        self:findText("retreatItem/content/Background/player/costText").text = string.format(cost_str, 1)
    end,

    click_useRetreatItem = function (self, handler, item_id)
        print("使用召回道具Id:" .. item_id)
    end, 

    click_accelerateBtn = function(self)
        self.helper.showTrans(self.accelerate_item_trans)

        if not self.cache_accelerate_trans then
            self.cache_accelerate_trans = {}
            local tplt = self.transform:Find('accelerateItem/content/Scroll View/Viewport/Content/tplt')
            tplt.gameObject:SetActive(false)
            config.item_useables:foreach(function(k, v)
                if v.type == 18 then

                    local item = Object.Instantiate(tplt.gameObject);
                    item.gameObject:SetActive(true)
                    item.transform.name = k
                    item:AttachTo(tplt.transform.parent)

                    local name_text = item.transform:Find("nameText"):GetComponent(UnityEngine.UI.Text)
                    name_text.text = self.helper:getLangCfg(v.name_id)

                    local des_text = item.transform:Find("desText"):GetComponent(UnityEngine.UI.Text)
                    des_text.text = self.helper:getLangCfg(v.des_id)

                    local own_text = item.transform:Find("ownText"):GetComponent(UnityEngine.UI.Text)
                    own_text.text = "拥有:" .. bag_manager:getItemNum(k)

                    local price_text = item.transform:Find("priceText"):GetComponent(UnityEngine.UI.Text)
                    price_text.text = v.saleprice

                    local cost_text = item.transform:Find("costText"):GetComponent(UnityEngine.UI.Text)
                    cost_text.text = "消耗:1"

                    local icon = item.transform:Find("icon"):GetComponent(UnityEngine.UI.Image)
                    local icon_name = self.helper:getItemIcon(v.id)
                    icon:SetSprite(icon_name)

                    self:setScript("click", "accelerateItem/content/Scroll View/Viewport/Content/" .. item.transform.name .. "/useBtn", functor.rmake(self.click_useAccelerateItem, k))

                    table.insert(self.cache_accelerate_trans, { k = k, obj = item.gameObject })
                end
            end)
        else
            config.item_useables:foreach(function(k, v)
                if v.type == 18 then
                    for k, v in ipairs(self.cache_accelerate_trans) do
                        local own_text = v.obj.transform:Find("ownText"):GetComponent(UnityEngine.UI.Text)
                        own_text.text = "拥有:" .. bag_manager:getItemNum(v.k)
                    end
                end
            end)
        end
    end,

    click_useAccelerateItem = function (self, handler, item_id)
        print("使用加速道具Id:" .. item_id)

        if bag_manager:getItemNum(item_id) <= 0 then
            hint:setText("道具数量不够!!!")
            return
        end

        if self.cur_MMarchLine then
            print("发送服务器:", self.cur_MMarchLine.marchLineId, item_id)
            network_sender:speedUp(self.cur_MMarchLine.marchLineId, tostring(item_id), self.owner.map_type)
        end
        self.helper.hideTrans(self.accelerate_item_trans)
        self.helper.hideTrans(self.march_info_trans)
    end, 

    click_closeAccelerateItem = function(self)
        self.helper.hideTrans(self.accelerate_item_trans)
    end,

    -- 使用召回道具
    click_useRetreatItemBtn = function(self)
        print("使用召回道具", bag_manager:getItemNum(60004))
        local retreat_item_id = "60004"

        if bag_manager:getItemNum(60004) <= 0 then
            hint:setText("道具数量不够!!!")
            return
        end

        if self.cur_MMarchLine then
            print("发送服务器:", self.cur_MMarchLine.marchLineId, retreat_item_id)
            network_sender:worldMapGoHome(self.cur_MMarchLine.marchLineId, common_pb.WORLD_OBJ_MARCH, retreat_item_id, self.owner.map_type)
        end
        self.helper.hideTrans(self.retreat_item_trans)
        self.helper.hideTrans(self.march_info_trans)
    end,

    -- 关闭召回界面
    click_closeRetreatItem = function(self)
        self.helper.hideTrans(self.retreat_item_trans)
    end,

    -- 行军界面 end

    -- 玩家界面 start

    -- data 是 MPlayerHold
    setPlayerInfo = function(self, data)  
        self:findText("playerInfo/closePlayerInfo/Background/nameText").text = data.playerId
        self:findText("playerInfo/closePlayerInfo/Background/destinationText").text = "坐标: " .. "X:" .. data.posX .. "Y:" .. data.posY
        self:findText("playerInfo/closePlayerInfo/Background/leftTimeText").text = ""
    end,

    click_closePlayerInfo = function(self)
        self.helper.hideTrans(self.playerInfo_trans)
    end,

    -- 玩家界面 end

    click_closeMarchInfo = function(self)
        self.helper.hideTrans(self.march_info_trans)
    end,

    click_addCoordBtn = function(self)
        self.helper.hideTrans(self.edit_coord_trans) 
        if self.cur_collection_pos then
            local tmp = self.cur_collection_pos
            if self.coord_edit_mode ~= "modify" then
                print("新增..坐标")
                network_sender:worldMapCollectionAdd(tmp.eTable, tmp.strDesc, tmp.iconId, tmp.posX, tmp.posY)
            else
                print("修改..坐标")
                network_sender:worldMapCollectionMod(tmp.id, tmp.eTable, tmp.strDesc)
            end
        end 
    end,

    click_closeEditCoord = function(self)
        self.coord_edit_mode = nil
        self.helper.hideTrans(self.edit_coord_trans) 
    end,

    click_closeCoordCollect = function(self)
        self.helper.hideTrans(self.coord_collect_trans)
    end,

    initTask = function(self)
        local owner = self.transform:Find('new')
        frame_manager:show('main_task', owner, false)
    end,

    onlyShowInEditorMode = function(self)  
        self:setScript("click", "ButtonLevel", self.onClickLevel)
        self:setScript("click", "ButtonReqEnterMap", self.onClickReqEnterMap)
        local item_list = {"ButtonLevel","InputFieldSceneName","InputFieldLevelID","ButtonReqEnterMap","InputRequestLv"}
        local is_editor = UnityEngine.Application.isEditor
        if not is_editor then
            for __, path in ipairs(item_list) do
                local trans = self.transform:Find(path)
                if trans then
                    trans.gameObject:SetActive(false)
                end
            end
        end
    end,

    onUnload = function(self)
        local_player.events:off("onPropChange", self.prop_change_event_id)
        frame_manager:hide('main_task')
    end,

    levelOver = function(self)
        if level_info.level_over then
            frame_manager:show('chapter')
        end
    end,

    click_openChatBtn = function(self)
        print("打开聊天界面")
        frame_manager:show('chat')
    end,
}