local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.callBack = self.args.data.callBack
        self.item_id  = self.args.data.item_id
        self.need_num = self.args.data.need_num

        print("##### item_id", self.item_id)

        clickEvents = 
        {
            "close",
            "window/confirmBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        -- self.title_text = self:findText("window/bg/title_text")
        local cfg = self.helper:getItemCfg(self.item_id)
        local curr_num = bag_manager:getItemNum(self.item_id)
        local need_num = self.need_num
        local icon_name = gui_helper:getItemIconPath(cfg)
        local name = self.helper:getLangCfg(cfg.name_id)
        local des = self.helper:getLangCfg(cfg.des_id)
        local own_num = bag_manager:getItemNum(self.item_id)

        self.name_text = self:findText("window/name_text")
        self.des_text = self:findText("window/des_text")
        self.own_text = self:findText("window/own_text")
        -- self.cost_text = self:findText("window/confirmBtn/icon/num_text")

        self.name_text.text = name
        self.des_text.text = des
        self.own_text.text = string.format(NativeText.GetLangStr(190086), own_num, need_num)

        self.quality_bg = self:findImage("window/quality_bg")
        self.big_icon = self:findImage("window/quality_bg/icon")
        -- self.small_icon = self:findImage("window/confirmBtn/icon")

        self.big_icon:SetSprite(icon_name)
        self.quality_bg:SetSprite(gui_helper:getQualityIconPath(cfg.color))
    end,

    click_close = function(self)
        frame_manager:hide('item_cost')
    end,

    click_confirmBtn = function(self)
        frame_manager:hide('item_cost')
        if self.callBack then
            self.callBack()
        end
    end,
}
