local super = require("ui.frame")
local log = logger.get("Game", "Level Frame")
require("level.level_quest_manager")

return class {
    super = super,
 
    onLoaded = function(self)
        log.info('Level Frame onLoaded!!')

        super.onLoaded(self)
        -- 关闭 loading
        --frame_manager:hide('level_loading')
        Fenix.Assets.Helper.ms_SyncLoad = false
        
        level_frame = self

        self.level_id = game_state_level.level_id
        self.level_cfg = config.game_copy_levels[self.level_id]
        if self.args.data then
            self.is_back = self.args.data.back
        end

        self.helper = require("gui.tool.frame_helper")

        self:setScript("click", "Top Left/ButtonBack", self.onClickBack)
        self:setScript("click", "Top Left/ButtonGiveUp", self.onClickGiveUp)

        self:setScript("click", "Bottom Left/Chat Box/Minimize Button", self.onClickMinimizeChatBox)
        self:setScript("click", "Bottom Right/ButtonInteraction", self.onClickInteraction)  -- 调查
        self:setScript("click", "Bottom Right/ButtonStay", self.onClickStay)                -- 原地停留

        -- 阵型设置按钮
        self:setScript("click", "Bottom Right/ButtonFormation", self.onClickFormation)
        self:setScript("click", "Bottom Right/ButtonFormation/ButtonFormationHeavy", self.onClickFormationHeavy)
        self:setScript("click", "Bottom Right/ButtonFormation/ButtonFormationAssult", self.onClickFormationAssult)
        self:setScript("click", "Bottom Right/ButtonFormation/ButtonFormationArtillery", self.onClickFormationArtillery)
        self:setScript("click", "Bottom Right/ButtonFormation/ButtonFormationTank", self.onClickFormationTank)
        self.button_formation_heavy = self.transform:Find("Bottom Right/ButtonFormation/ButtonFormationHeavy").gameObject
        self.button_formation_assult = self.transform:Find("Bottom Right/ButtonFormation/ButtonFormationAssult").gameObject
        self.button_formation_artillery = self.transform:Find("Bottom Right/ButtonFormation/ButtonFormationArtillery").gameObject
        self.button_formation_tank = self.transform:Find("Bottom Right/ButtonFormation/ButtonFormationTank").gameObject
        self:hideFormatoinButtons()

        self:setScript("click", "Bottom Right/ButtonTreasureMap", self.onClickTreasureMap)  --藏宝图
        self:setScript("click", "HideTreasureMap", self.onClickHideTreasureMap)    --藏宝图点击空地关闭藏宝图
        -- 任务
        self.mission_info_prefab = self.transform:Find("Top Left/Mission/Panel/openAllMission/Prefab/MissionInfo").gameObject
        self.mission_info_layout = self.transform:Find("Top Left/Mission/Panel/openAllMission/Layout")
        self:setScript("click", "Top Left/Mission/Panel/openAllMission/Layout", self.onClickMission)
        --self:setScript("click", "Top Left/Mission/Panel/openAllMission/ButtonDetail", self.onClickMission)
        self.transform:Find("Top Left/Mission/Panel/openAllMission/Prefab"):SetActive(false)
        self:setScript("click", "Top Left/Mission/Panel/ButtonShrink", self.onClickMissionShink)
        --self.mission_red_point = self.transform:Find("Top Left/Mission/Panel/openAllMission/ButtonDetail/RedPoint")

        -- 任务进度
        self.mission_progress_image = self.transform:Find("TextMissionProgress"):GetComponent(UnityEngine.UI.Image)
        self.mission_progress_text = self.transform:Find("TextMissionProgress/Text"):GetComponent(UnityEngine.UI.Text)
        self.mission_progress_image.gameObject:SetActive(false)

        -- 任务详细
        self.mission_detail_prefab = self.transform:Find("MissionDetail/Prefab/MissionDetailInfo").gameObject
        self.transform:Find("MissionDetail/Prefab"):SetActive(false)
        self.panel_mission_detail = self.transform:Find("MissionDetail")
        self.mission_detail_layout = self.transform:Find("MissionDetail/BG/Panel/Mask/Layout")
        self:setScript("click", "MissionDetail/BG/ButtonBack", self.onClickMissionDetailBack)

        self.panel_mission_detail:SetActive(false)
        self:refreshMission()

        --Modified By Hong Feng
        --Boss距离
        self.boss_distance = self.transform:Find("Top/BossDistance"):GetComponent(UnityEngine.UI.Text)
        self.boss_distance_num = self.transform:Find("Top/BossDistance/Distance"):GetComponent(UnityEngine.UI.Text)
        self.boss_distance_bg = self.transform:Find("Top/BossDistance/BG"):GetComponent(UnityEngine.UI.Image)
        self.boss_distance_head = self.transform:Find("Top/BossDistance/Head"):GetComponent(UnityEngine.UI.Text)

        --藏宝图
        self.treasure_map = self.transform:Find("Bottom Right/ButtonTreasureMap").gameObject
        self.treasure_map_img = self.transform:Find("Bottom Right/ButtonTreasureMap/Map").gameObject
        self.treasure_map_1 = self.transform:Find("Bottom Right/ButtonTreasureMap/Map/1"):GetComponent(UnityEngine.UI.Image)
        self.treasure_map_2 = self.transform:Find("Bottom Right/ButtonTreasureMap/Map/2"):GetComponent(UnityEngine.UI.Image)
        self.treasure_map_3 = self.transform:Find("Bottom Right/ButtonTreasureMap/Map/3"):GetComponent(UnityEngine.UI.Image)
        self.treasure_map_4 = self.transform:Find("Bottom Right/ButtonTreasureMap/Map/4"):GetComponent(UnityEngine.UI.Image)
        self.treasure_map_hide = self.transform:Find("HideTreasureMap"):GetComponent(UnityEngine.UI.Button)
        self.treasure_map_notice = self.transform:Find("Bottom Right/ButtonTreasureMap/Notice"):GetComponent(UnityEngine.UI.Image)  --红点

        --黑屏文字
        self.full_screen_dialog = self.transform:Find("Center/FullScreenDialog").gameObject
        self.full_screen_dialog_bg = self.transform:Find("Center/FullScreenDialog/BG"):GetComponent(UnityEngine.UI.Image)
        self.full_screen_dialog_text = self.transform:Find("Center/FullScreenDialog/BG/Text"):GetComponent(UnityEngine.UI.Text)

        --速度测试
        self.speed = self.transform:Find("Bottom Right/Speed").gameObject
        self.speed_value = self.transform:Find("Bottom Right/Speed/Text"):GetComponent(UnityEngine.UI.Text)
        --Modify end
        
        
        -- 设置关卡道具点击回调
        self:setScript("single", "Bottom Left/ItemBar/Item_1/Icon" , functor.rmake(self.onClickItemIcon, 1))
        self:setScript("single", "Bottom Left/ItemBar/Item_2/Icon" , functor.rmake(self.onClickItemIcon, 2))
        self:setScript("single", "Bottom Left/ItemBar/Item_3/Icon" , functor.rmake(self.onClickItemIcon, 3))
        self:setScript("single", "Bottom Left/ItemBar/Item_4/Icon" , functor.rmake(self.onClickItemIcon, 4))

        self.event_ids = {}
        self.event_ids["NOTIFYGETITEM"] = game_director.events:on("NOTIFYGETITEM", functor.make(self.onGetItems, self))

        -- 刷新界面
        self:refreshHealthAndGasoline()

        self:init()
    end,

    init = function(self)

        self.interact_text = self:findText("Bottom Right/ButtonInteraction/Text")
        self.interact_button = self.transform:Find("Bottom Right/ButtonInteraction"):GetComponent(UnityEngine.UI.Button)

        self.missionTrans = self.transform:Find('Mission')


        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
           -- "Top Right/curMission/Panel/openAllMission",
            --"Mission/Fight Dialog/Background/closeMis",
            --"Bottom Right/adjustBtn",
            --"Bottom Right/propertyBtn",
           -- "Top Right/randomEvent/randomEventButton",
            --"Top Right/curMission/HideBtn",
            --"Bottom Left/BagBtn",
        }

        -- 注册点击事件
        --self.helper:regClickEvents("click", self, clickEvents)
    

        --[[
        -- 水晶
        self.crystal_tsf = self.transform:Find('Top Right/Asset Crystal/Text')
        -- 金币
        self.gold_tsf = self.transform:Find('Top Right/Asset Gold/Text')
        -- 体力
        self.ps_tsf = self.transform:Find('Top Right/Asset Ps/Text')

        -- 临时代码
        self.helper:makeNumEffect(self.crystal_tsf, local_player:getGem())
        self.helper:makeNumEffect(self.gold_tsf, local_player:getCoin())
        local ps = bag_manager:getItemNum(consts.psId) --level_info:getResouce(consts.psId)
        if ps then
            self.helper:makeNumEffect(self.ps_tsf, ps)
        end
        ]]
        
        -- 刷新上阵英雄数量
        local attend_heros = nil
        if self.level_cfg.level_type == 1 then
            attend_heros = game_info.chapter_attend_heros[level_info.cur_chapter]
        else
            attend_heros = game_info.level_attend_heros[self.level_id]
        end
        local count = 0
        for _,f in ipairs(attend_heros.formations) do
            if f.location > 0 then
                count = count + 1
            end
        end
        self:refreshAutoFormationButton(attend_heros.formationId, count)

        if level_quest_manager:isAnyQuestCanGetReward() then
            self:showMissionRedPoint(true)
        else
            self:showMissionRedPoint(false)
        end

        -- 如果关卡结束，显示关卡结束特效
        self:levelOver()
    end,

    -- 刷新金币，钻石
    --[[
    refreshResourceNum = function(self)
        if self.crystal_tsf and self.gold_tsf then
            self.helper:makeNumEffect(self.crystal_tsf, local_player:getGem())
            --self.helper:makeNumEffect(self.gold_tsf, local_player:getCoin())
        end
    end,]]

    onClickBack = function(self)
        if self.level_cfg.level_type == 2 then
            -- 剧情关卡，提示关卡不会被保存
            local tb = {
                title = "",
                content = NativeText.GetLangStr(170110),
                buttons =
                {
                    {
                        btn_name = NativeText.GetLangStr(170112),   -- 否
                        callback = function() 
                            frame_manager:hide('common_box')
                        end
                    },
                    {
                        btn_name = NativeText.GetLangStr(170111),   -- 是
                        callback = function()
                            frame_manager:hide('common_box')
                            self.owner:leaveLevel()
                        end
                    },
                },
            }
    
            frame_manager:show('common_box', nil, tb)
        else
            self.owner:leaveLevel()
        end
    end,

    onClickMinimizeChatBox = function (self)

    end, 

    -- 布阵
    onClickEmbattle = function(self)
        frame_manager:show('embattle')
    end,

    -- 背包发生变化
    onBagChanged = function(self, item)
        if not item then return end

        if level_info.map_info then
            self:setLevelRes(level_info.map_info.mapId)
        end
    end,

    onUnload = function(self)
        level_frame = nil
        game_director.events:remove("NOTIFYGETITEM", self.event_ids["NOTIFYGETITEM"])
    end,

    levelOver = function(self, is_sucessed)
        if level_info.level_over then
            local level = game_state_level.level
            if not level then
                log.error('level over, no level!!')
                return
            end

            if is_sucessed then
    
                self:showMissionComplete()
                
                if level.player then
                    local pos = level.player:getPosition()
                    -- 玩家坦克上播放特效
                    local path = "Assets/Arts/fx8/1/prefab_guanqia/qingzhu.prefab"
                    local effect = 
                        level_script:createGameObject(path, pos.x, pos.y, pos.z, 0, 1)
                    battle_helper:destroyObjectAfter(effect, 5)
                end

                local cb = function()
                    game_director:changeState('loading', {next_state = 'home', scene_name = 'home'})
                end
                app:startCoroutine(function()
                    coroutine.yield(WaitForSeconds(3))
                    frame_manager:show('getItems', self, {items = gui_helper.drop_list[common_pb.OVER_COPY], has_Confirm_Btn = true, message = NativeText.GetLangStr(170121), callback = cb})
                end)
            else
                -- 关卡失败
                app:startCoroutine(function()
                    hint:setText(NativeText.GetLangStr(170122))
                    coroutine.yield(WaitForSeconds(2))
                    game_director:changeState('loading', {next_state = 'home', scene_name = 'home'})
                end)
            end

        end
    end,

    -- 设置是否显示领取任务奖励红点
    showMissionRedPoint = function(self, is_show)
        --self.mission_red_point:SetActive(is_show)
    end,

    -- 点了交互按钮
    onClickInteraction = function(self)
        local level = game_state_level.level
        if level.player then
            level.player:interactWithTouchingEntity()
        end
    end,

    -- 点了原地停留
    onClickStay = function(self)
        local level = game_state_level.level
        level:updateTurn()
        
        local button = self.transform:Find("Bottom Right/ButtonStay").gameObject:GetComponent(UnityEngine.UI.Button)
        button.interactable = false
        app:startCoroutine(
            function()
                coroutine.yield(WaitForSeconds(1.1))
                button.interactable = true
            end)
    end,

    -- 刷新交互按钮文字 
    refreshInteractText = function(self, str, high_light)
        if not self.interact_text then
            return
        end

        self.interact_text.text = str
        self.interact_button.interactable = true
        self.interact_button.gameObject:SetActive(high_light)
    end,

    refreshAutoFormationButton = function(self, formation_id, attend_num)
        if not self.transform then
            return
        end
        local img = self.transform:Find("Bottom Right/ButtonFormation/Icon"):GetComponent(UnityEngine.UI.Image)
        local txt = self.transform:Find("Bottom Right/ButtonFormation/Text"):GetComponent(UnityEngine.UI.Text)

        if formation_id <= 3 then
            -- 肉盾
            img:SetSprite("Assets/Arts/ui/atlas/icon/vehicle/type1.png")
        elseif formation_id <= 6 then
            -- 突击
            img:SetSprite("Assets/Arts/ui/atlas/icon/vehicle/type2.png")
        elseif formation_id <= 9 then
            -- 坦克
            img:SetSprite("Assets/Arts/ui/atlas/icon/vehicle/type3.png")
        elseif formation_id <= 12 then
            -- 火炮
            img:SetSprite("Assets/Arts/ui/atlas/icon/vehicle/type4.png")
        else    
            -- 无阵型
            img:SetSprite("Assets/Arts/ui/atlas/icon/vehicle/type0.png")
        end

        txt.text = attend_num.."/8"
    end,

    -- 显示阵型按钮
    showFormationButtons = function(self)
        self.button_formation_heavy:SetActive(true)
        self.button_formation_assult:SetActive(true)
        self.button_formation_artillery:SetActive(true)
        self.button_formation_tank:SetActive(true)
        self.is_formation_show = true
    end,

    -- 隐藏阵型按钮 
    hideFormatoinButtons = function(self)
        self.button_formation_heavy:SetActive(false)
        self.button_formation_assult:SetActive(false)
        self.button_formation_artillery:SetActive(false)
        self.button_formation_tank:SetActive(false)
        self.is_formation_show = false
    end,

    -- 点了阵型
    onClickFormation = function(self)
        if self.is_formation_show then
            self:hideFormatoinButtons()
        else
            self:showFormationButtons()
        end
    end,

    -- 选择肉盾阵型
    onClickFormationHeavy = function(self)
        level_info.is_req_embattle = true
        self:hideFormatoinButtons()
        self:autoFormation(self.level_id, 1)
    end,

    -- 选择突击阵型
    onClickFormationAssult = function(self)
        level_info.is_req_embattle = true
        self:hideFormatoinButtons()
        self:autoFormation(self.level_id, 4)
    end,

    -- 选择火炮阵型 
    onClickFormationArtillery = function(self)
        level_info.is_req_embattle = true
        self:hideFormatoinButtons()
        self:autoFormation(self.level_id, 10)
    end,

    -- 选择坦克阵型 
    onClickFormationTank = function(self)
        level_info.is_req_embattle = true
        self:hideFormatoinButtons()
        self:autoFormation(self.level_id, 7)
    end,

    -- 自动布阵
    autoFormation = function(self, level_id, formation_id)
        --local heros = self:getInitHerosForLevel(level_id)
        local heros = self:getCurrentHeros()
        --[[
        for _,h in ipairs(heros) do
            log.info("### current heros:"..h)
        end]]

        local formation_helper = require("systems.formation_helper")
        local is_story = (self.level_cfg.level_type == 2)
        local hero_list = formation_helper:autoFormation(heros, formation_id, is_story)
        
        log.info("#hero_list:"..#hero_list..", heros:"..#heros)
        for k,v in ipairs(hero_list) do
            log.info("### hero_id:"..v.heroId..", pos:"..v.location)
        end

        network_sender:copyEmbattle(formation_id, hero_list)
    end,

    getCurrentHeros = function(self)
        local src = nil
        if self.level_cfg.level_type == 1 then
            src = game_info.chapter_attend_heros[level_info.cur_chapter]
        else
            src = game_info.level_attend_heros[self.level_id]
        end

        local heros = {}
        for _,hero in ipairs(src.formations) do
            if hero.isDeath ~= 1 then
                table.insert(heros, hero.heroId)
            end
        end

        return heros
    end,

    -- 获取某关卡的初始英雄,返回整数数组
    getInitHerosForLevel = function(self, level_id)
        local heros = {}
        config.monster_stat_heros:foreach(
            function(k,v)
                if v.level == level_id and v.is_init == 1 then
                    table.insert(heros, v.tank_id)
                end
            end
        )
        return heros
    end,

    -- 点击了关卡道具 icon
    onClickItemIcon = function(self, handler, data, index)
        game_state_level.level:useItem(index)
    end,

    -- 刷新道具数量
    refreshItemNum = function(self)
        -- 遍历
        for idx, slot in ipairs(level_info.level_items) do
            if slot then
                local go = self.transform:Find("Bottom Left/ItemBar/Item_"..idx.."/Icon").gameObject
                go:SetActive(true)
                local cfg = item_helper:getItemCfg(slot.id)
                local path = gui_helper:getItemIconPath(cfg)
                local img = go:GetComponent(UnityEngine.UI.Image)
                img.color = UnityEngine.Color(1,1,1,1)
                img:SetSprite(path)

                go = self.transform:Find("Bottom Left/ItemBar/Item_"..idx.."/Num").gameObject
                go:SetActive(true)
                go:GetComponent(UnityEngine.UI.Text).text = tostring(slot.num)
            else
                local go = self.transform:Find("Bottom Left/ItemBar/Item_"..idx.."/Icon").gameObject
                go:SetActive(false)

                go = self.transform:Find("Bottom Left/ItemBar/Item_"..idx.."/Num").gameObject
                go:SetActive(false)
            end
        end
    end,

    -- 刷新健康度和汽油量
    refreshHealthAndGasoline = function(self)
        if not self.transform then
            return
        end

        local gasoline_text = self.transform:Find("Top Right/PlayerInfo/gasoline/Text"):GetComponent(UnityEngine.UI.Text)

        local hp_text = self.transform:Find("Top Right/PlayerInfo/hp/Text"):GetComponent(UnityEngine.UI.Text)

        -- 汽油消耗量
        gasoline_text.text = tostring(math.floor(level_info.gasoline/level_info.max_gasoline*100)).."%"

        -- 血量百分比
        local percent = math.floor(level_info.hero_hp_percent * 100)
        hp_text.text = (percent > 0 and percent or 0).."%"

        if level_info.is_gasoline_leak then
            local icon = self.transform:Find("Top Right/PlayerInfo/gasoline/gasolineBg/brokenIcon").gameObject
            icon:SetActive(true)
        else
            local icon = self.transform:Find("Top Right/PlayerInfo/gasoline/gasolineBg/brokenIcon").gameObject
            icon:SetActive(false)
        end
    end,

    animLeakIcon = function(self)
        local icon = self.transform:Find("Top Right/PlayerInfo/gasoline/gasolineBg/brokenIcon").gameObject
        local lt = LeanTween.scale(icon, Vector3(1.5,1.5,1.5), 0.5)
        lt.loopType = LeanTweenType.pingPong
        lt.loopCount = 2
    end,

    -- 显示任务完成(关卡结束)
    showMissionComplete = function(self)
        self.transform:Find("TextMissionComplete"):SetActive(true)
    end,

    -- 显示任务进度
    showMissionProgress = function(self, text)
        self.mission_progress_image.gameObject:SetActive(true)
        self.mission_progress_image.color = Color.white
        local color = self.mission_progress_text.color
        color.a = 1.0
        self.mission_progress_text.color = color
        self.mission_progress_text.text = text

        -- 设置 image 宽度
        local size = self.mission_progress_image.transform.sizeDelta
        --log.info("##"..tostring(self.mission_progress_text.preferredWidth))
        size.x = self.mission_progress_text.preferredWidth + 20
        self.mission_progress_image.transform.sizeDelta = size

        local lt = LeanTween.color(self.mission_progress_image.transform, Color(1,1,1,0), 1.0)
        lt.delay = 1.0
        lt.loopType = LeanTweenType.once
        lt:setOnComplete(function()
            self.mission_progress_image.gameObject:SetActive(false)
        end)

        color.a = 0.0
        lt = LeanTween.textColor(self.mission_progress_text.transform, color, 1.0)
        lt.delay = 1.0
        lt.loopType = LeanTweenType.once
    end,

    -- 高亮显示道具提示用户使用
    highLightItem = function(self, item_id)
        local idx = level_info:getItemIndex(item_id)
        if not idx then
            return
        end

        local icon_trans = self.transform:Find("Bottom Left/ItemBar/Item_"..idx.."/Icon")

        local lt = LeanTween.scale(icon_trans.gameObject, Vector3(1.2, 1.2,1.2), 0.3)
        lt.loopType = LeanTweenType.pingPong
        lt.loopCount = 4
    end,

    -- 刷新任务显示
    refreshMission = function(self)
        for i=0, self.mission_info_layout.childCount-1 do
            local child = self.mission_info_layout:GetChild(i)
            child:SetActive(false)
        end

        local getChildAt = function(i)
            if i < self.mission_info_layout.childCount then
                local child = self.mission_info_layout:GetChild(i)
                child:SetActive(true)
                return child
            else 
                local ui_info = GameObject.Instantiate(self.mission_info_prefab).transform
                local idx = i + 1
                ui_info.gameObject.name = "mission_"..idx
                ui_info:SetParent(self.mission_info_layout)
                makeRectTransformIdentity(ui_info)

                -- 点击事件注册
                local path = "Top Left/Mission/Panel/openAllMission/Layout/mission_"..idx
                self:clearScript("click", path.."/ButtonLocate")
                self:setScript("click", path.."/ButtonLocate", functor.rmake(self.onClickMissionLocate, idx)) --

                return ui_info
            end
        end

        local idx = 1   -- 界面条目索引
        self.info_on_ui = {}
        for k,quest in ipairs(level_quest_manager.level_quests) do
            if quest.state == 1 then
                -- 显示任务
                local ui_info = getChildAt(idx - 1)
                self:fillMissionInfo(ui_info, quest, idx)
                self.info_on_ui[idx] = quest
                idx = idx + 1
            end
        end
    end,

    -- 填充界面任务元素
    fillMissionInfo = function(self, ui_info, info, idx)
        local title = ui_info:Find("MissionTitle"):GetComponent(UnityEngine.UI.Text)
        local text = frame_helper:getLangCfg(info.cfg.quest_name)
        title.text = text.. " "..info.progress.."/"..info.cfg.quest_total_progress
    end,

    -- 点击任务定位
    onClickMissionLocate = function(self, handler, index)
        log.info("onClickMissionLocate:"..index)
        -- 定位到任务点
        local info = self.info_on_ui[index]
        if not info then
            return
        end

        if info.cfg.quest_type == 1 or info.cfg.quest_type == 2 then
            self:lookQuestLocation(info)
        else
            self:onClickMission()
            self:setDetailInfoExpand(info.ui_detail, true)
        end
    end,

    lookQuestLocation = function(self, quest)
        local tab = quest.quest_location
        local point_manager = game_state_level.path_point_manager
        app:startCoroutine(
            function()
                for _,point_id in ipairs(tab) do
                    local point = point_manager:FindPathPoint(point_id)
                    game_state_level:lookTarget(point.m_Transform)
                    coroutine.yield(WaitForSeconds(1.5))
                end

                game_state_level:lookTank()
            end
        )
    end,

    -- 任务搜索
    onClickMissionShink = function(self, handler)
        local mission_panel = self.transform:Find("Top Left/Mission/Panel")
        if mission_panel.localPosition.x > 0 then
            -- 收缩
            local lt = LeanTween.moveLocalX(mission_panel.gameObject, 0, 0.3)
            lt.loopType = LeanTweenType.once
        else
            -- 展开
            local lt = LeanTween.moveLocalX(mission_panel.gameObject, 400, 0.3)
            lt.loopType = LeanTweenType.once
        end
    end,

    -- 点击任务信息
    onClickMission = function(self, handler)
        self.panel_mission_detail:SetActive(true)
        self:fillAllMissionDetail()
    end,

    -- 填充任务详细界面
    fillAllMissionDetail = function(self)
        -- 获取子结点， 0 下标开始
        local getChild = function(idx)
            if self.mission_detail_layout.childCount > idx then
                local detail_info = self.mission_detail_layout:GetChild(idx)
                self:setDetailInfoExpand(detail_info, false)
                return detail_info
            else
                local detail_info = GameObject.Instantiate(self.mission_detail_prefab).transform
                local slot_idx = idx + 1
                detail_info.gameObject.name = "mission_detail_"..(slot_idx)
                detail_info:SetParent(self.mission_detail_layout)
                makeRectTransformIdentity(detail_info)
                self:setDetailInfoExpand(detail_info, false)

                local path = "MissionDetail/BG/Panel/Mask/Layout/mission_detail_"..(slot_idx)
                self.clearScript("click", path)
                self:setScript("click", path, functor.rmake(self.onClickMissionDetail, detail_info)) --

                return detail_info
            end
        end

        local quests = level_quest_manager.level_quests
        local index = 0
        for idx, quest in ipairs(quests) do
            if quest.state == 1 or quest.state == 2 then
                local ui_detail = getChild(index)
                self:fillOneMissionDetail(ui_detail, quest)
                index = index + 1
            end
        end
    end,

    -- 填充一个任务详细
    fillOneMissionDetail = function(self, ui_detail, quest)
        quest.ui_detail = ui_detail

        -- 任务 icon
        local img_icon = ui_detail:Find("IconBG/Icon"):GetComponent(UnityEngine.UI.Image)
        img_icon:SetSprite(quest.cfg.icon)

        -- 类型
        local text_type = ui_detail:Find("TextType"):GetComponent(UnityEngine.UI.Text)
        local img = ui_detail:GetComponent(UnityEngine.UI.Image)
        if quest.cfg.quest_type == 1 then   -- 主线
            text_type.text = NativeText.GetLangStr(170103)
            img:SetSprite("Assets/Arts/ui/atlas/gamecopy/gamecopy_panel_38_1.png")
        elseif quest.cfg.quest_type == 2 then   -- 支线
            text_type.text = NativeText.GetLangStr(170104)
            img:SetSprite("Assets/Arts/ui/atlas/gamecopy/gamecopy_panel_38_2.png")
        elseif quest.cfg.quest_type == 3 then   -- 探索
            text_type.text = NativeText.GetLangStr(170105)
            img:SetSprite("Assets/Arts/ui/atlas/gamecopy/gamecopy_panel_38_2.png")
        end

        -- 名称
        local text_name = ui_detail:Find("TextName"):GetComponent(UnityEngine.UI.Text)
        text_name.text = frame_helper:getLangCfg(quest.cfg.quest_name)

        -- 进度
        local text_progress = ui_detail:Find("TextProgress"):GetComponent(UnityEngine.UI.Text)
        if quest.progress < quest.cfg.quest_total_progress then
            text_progress.text = quest.progress.."/"..quest.cfg.quest_total_progress
        else
            text_progress.text =  NativeText.GetLangStr(170107)
        end

        text_progress.transform:SetActive(false)

        text_name.text = string.format( "%s  (%s)", text_name.text, text_progress.text )

        local isQuestFirstTime = function(quest_id)
            for _,q_id in ipairs(level_info.finished_quest) do
                if q_id == quest_id then
                    return false
                end
            end
            return true
        end

        -- 奖励
        -- Todo: 判断之前是否完成过
        local tab = nil
        if isQuestFirstTime(quest.id) then
            tab = loadstring("return "..quest.cfg.first_reward)()
        else
            tab = loadstring("return "..quest.cfg.non_first_reward)()
        end
        for item_id,item_num in pairs(tab) do
            local item_cfg = item_helper:getItemCfg(item_id)
            local path = gui_helper:getItemIconPath(item_cfg)
            local reward_icon = ui_detail:Find("Reward"):GetComponent(UnityEngine.UI.Image)
            reward_icon:SetSprite(path)
            local reward_text = ui_detail:Find("Reward/Text"):GetComponent(UnityEngine.UI.Text)
            reward_text.text = tostring(item_num)
            break
        end

        -- 交互按钮
        local action_img = ui_detail:Find("ButtonAction"):GetComponent(UnityEngine.UI.Image)
        local btn_text = ui_detail:Find("ButtonAction/Text"):GetComponent(UnityEngine.UI.Text)
        action_img.gameObject:SetActive(true)
        if quest.state == 1 then
            -- 进行中
            if quest.cfg.quest_type == 1 or quest.cfg.quest_type == 2 then  -- 主线支线，定位到任务点
                action_img:SetSprite("Assets/Arts/ui/atlas/common/Building_button_20_Normal.png")
                btn_text.text = NativeText.GetLangStr(170116)
            else  -- 探索任务，只显示任务描述
                btn_text.text = NativeText.GetLangStr(170117)
                action_img:SetSprite("Assets/Arts/ui/atlas/common/Building_button_20_Normal.png")
                --action_img.gameObject:SetActive(false)
            end
        elseif quest.state == 2 then
            -- 完成，可以领奖
                btn_text.text = NativeText.GetLangStr(170118)
            action_img:SetSprite("Assets/Arts/ui/atlas/common/Building_button_21_Normal.png")
        elseif quest.state == 3 then
            -- 任务结束
            action_img.gameObject:SetActive(false)
        end

        self:clearScript("click", "MissionDetail/BG/Panel/Mask/Layout/"..ui_detail.name.."/ButtonAction")
        self:setScript("click", "MissionDetail/BG/Panel/Mask/Layout/"..ui_detail.name.."/ButtonAction", functor.rmake(self.onClickQuestDetailAction, quest))

        -- 描述
        local text_desc = ui_detail:Find("TextDesc"):GetComponent(UnityEngine.UI.Text)
        text_desc.text = frame_helper:getLangCfg(quest.cfg.quest_des)
        text_desc.gameObject:SetActive(false)

    end,

    -- 展开 / 关闭任务描述
    onClickMissionDetail = function(self, handler, ui_detail_info)
        if ui_detail_info.sizeDelta.y == 178 then
            -- 展开
            self:setDetailInfoExpand(ui_detail_info, true)
        else
            -- 收缩
            self:setDetailInfoExpand(ui_detail_info, false)
        end
    end,

    setDetailInfoExpand = function(self, ui_detail_info, is_expend)
        if is_expend then
            ui_detail_info.sizeDelta = Vector2(1370, 388)
            ui_detail_info:Find("TextDesc"):SetActive(true)
            ui_detail_info:Find("ImageDownArrow"):SetActive(false)
        else
            ui_detail_info.sizeDelta = Vector2(1370, 178)
            ui_detail_info:Find("TextDesc"):SetActive(false)
            ui_detail_info:Find("ImageDownArrow"):SetActive(true)

            -- TODO:如果是最后一个，需要把 scroll rect 移动到底部

        end
    end,

    onClickQuestDetailAction = function(self, handler, quest)
        log.info("onClickQuestDetailAction:"..quest.id)
        if quest.state == 0 or quest.state == 1 then    -- 进行中
            if quest.cfg.quest_type == 1 or quest.cfg.quest_type == 2 then
                -- 定位到任务位置
                self.panel_mission_detail:SetActive(false)
                self:lookQuestLocation(quest)
            else
                -- 显示任务详细
                self:onClickMissionDetail(nil, quest.ui_detail)
            end
        elseif quest.state == 2 then
            -- 领取任务奖励
            --quest.ui_detail.gameObject:SetActive(false)
            network_sender:getCopyTaskReward(game_state_level.level_id, quest.id)
        else

        end
    end,

    onClickMissionDetailBack = function(self)
        self.panel_mission_detail:SetActive(false)
    end,

    onGetItems = function(self, msg)
        if msg.reason == common_pb.COPY_GIFT_BAG then
            frame_manager:show('getItems', self, {items = gui_helper.drop_list[msg.reason], has_Confirm_Btn = true})
        end
    end,

    --Modified by Hong Feng
    showBossDistance = function(self, text, turn)
        self.boss_distance.gameObject:SetActive(true)
        self.boss_distance_num.gameObject:SetActive(true)
        self.boss_distance_bg:SetActive(true)
        self.boss_distance_head:SetActive(true)

        self.boss_distance_num.text = text
        
        if turn <= 6 and turn >= 3 then
            self.boss_distance_head.color = Color.yellow
            self.boss_distance_num.color = Color.yellow
        elseif turn < 3 then
            self.boss_distance_head.color = Color.red
            self.boss_distance_num.color = Color.red
        end
    end,

    blinkBossDistance = function(self)
        --self.boss_distance.gameObject:SetActive(false)
        self.boss_distance_num.gameObject:SetActive(false)
        --self.boss_distance_bg:SetActive(false)
        self.boss_distance_head:SetActive(false)
    end,

    hideBossDistance = function(self)
        self.boss_distance.gameObject:SetActive(false)
        self.boss_distance_num.gameObject:SetActive(false)
        self.boss_distance_bg:SetActive(false)
        self.boss_distance_head:SetActive(false)
    end,

    --藏宝图
    onClickTreasureMap = function(self)
        if self.is_treasure_map_show == true then
            self:hideTreasureMap()
            self.treasure_map_hide:SetActive(false)
        else
            self:showTreasureMap()
            self:hideRedDot()
        end
    end,

    onClickHideTreasureMap = function(self)
        self.treasure_map_hide:SetActive(false)
        self:hideTreasureMap()
    end,

    showTreasureMapButton = function(self)
        self.treasure_map:SetActive(true)
        self.treasure_map_img:SetActive(false)
    end,
    
    hideTreasureMap = function(self)
        self.is_treasure_map_show = false
        self.treasure_map_img:SetActive(false)
        self.treasure_map_1.color = UnityEngine.Color(1, 1, 1, 1)
        self.treasure_map_2.color = UnityEngine.Color(1, 1, 1, 1)
        self.treasure_map_3.color = UnityEngine.Color(1, 1, 1, 1)
        self.treasure_map_4.color = UnityEngine.Color(1, 1, 1, 1)
    end,

    showTreasureMap = function(self)
        self.is_treasure_map_show = true
        self.treasure_map_img:SetActive(true)
        self.treasure_map_hide:SetActive(true)
        
        -- log.error('fade_1 '..tostring(self.need_fade_1))
        -- log.error('fade_2 '..tostring(self.need_fade_2))
        -- log.error('fade_3 '..tostring(self.need_fade_3))
        -- log.error('fade_4 '..tostring(self.need_fade_4))

        if self.need_fade_1 == true then
            self:fadeOutImage(self.treasure_map_1)
        end
        if self.need_fade_2 == true then
            self:fadeOutImage(self.treasure_map_2)
        end
        if self.need_fade_3 == true then
            self:fadeOutImage(self.treasure_map_3)
        end
        if self.need_fade_4 == true then
            self:fadeOutImage(self.treasure_map_4)
        end
    end,

    fadeOutImage = function(self, img)
        -- local r = img.color.r
        -- local g = img.color.g 
        -- local b = img.color.b
        -- local a = img.color.a

        -- app:startCoroutine(
        --     function()
        --         local y = 8
        --         for i = 1, y do
        --             img.color = UnityEngine.Color(r,g,b,(a - i / y * a))
        --             coroutine.yield(WaitForSeconds(1/y))
        --         end
        --     end
        -- )

        local lt = LeanTween.color(img.transform, Color(1,1,1,0), 1.2)
        lt.loopType = LeanTweenType.once
        
    end,

    updateTreasureMapProgress = function(self, progress)
        if not progress then
            log.error('missing treasure map progress data')
        end
        if progress == 0 then
            self.need_fade_1 = false
            self.need_fade_2 = false
            self.need_fade_3 = false
            self.need_fade_4 = false
        elseif progress == 1 then
            self.need_fade_1 = true
            self.need_fade_2 = false
            self.need_fade_3 = false
            self.need_fade_4 = false
        elseif progress == 2 then
            self.need_fade_1 = true
            self.need_fade_2 = true
            self.need_fade_3 = false
            self.need_fade_4 = false
        elseif progress == 3 then
            self.need_fade_1 = true
            self.need_fade_2 = true
            self.need_fade_3 = true
            self.need_fade_4 = false
        elseif progress == 4 then
            self.need_fade_1 = true
            self.need_fade_2 = true
            self.need_fade_3 = true
            self.need_fade_4 = true
        elseif progress > 4 then    --处理一下
            self.need_fade_1 = true
            self.need_fade_2 = true
            self.need_fade_3 = true
            self.need_fade_4 = true
        end
    end,

    showRedDot = function(self)
        self.treasure_map_notice:SetActive(true)
    end,

    hideRedDot = function(self)
        self.treasure_map_notice:SetActive(false)
    end,

    showFullScreenDialog = function(self, callback)       --打开黑屏界面
        self.full_screen_dialog:SetActive(true)

        local img = self.transform:Find("Center/FullScreenDialog/BG").gameObject

        local lt = LeanTween.color(img.transform, Color(0,0,0,1), 1.5)
        lt.loopType = LeanTweenType.once

        --log.error('full fade')
        if callback then
            callback()
        end
    end,

    hideFullScreenDialog = function(self, callback)
        local img = self.transform:Find("Center/FullScreenDialog/BG").gameObject
        local text = self.transform:Find("Center/FullScreenDialog/BG/Text").gameObject
        local lean_time = 1.5

        local lt = LeanTween.color(img.transform, Color(0,0,0,0), lean_time)
        lt.loopType = LeanTweenType.once
        local lt_text = LeanTween.textColor(text.transform, Color(255,255,255,0), lean_time)  --7/26 字渐隐不起效
        lt_text.loopType = LeanTweenType.once

        app:startCoroutine(
            function()
                coroutine.yield(WaitForSeconds(lean_time))
                self.full_screen_dialog:SetActive(false)
                if callback then
                    callback()
                end
            end
        )
    end,

    setFullScreenDialogText = function(self, text, callback)
        -- local center = Vector2(500,-288)
        -- local left_top = Vector2(81, -105)

        -- if pos == 1 then
        --     pos = center 
        -- elseif pos == 2 then
        --     pos = left_top
        -- elseif pos == nil then
        --     pos = Vector2(0,0)
        -- end

        self.full_screen_dialog_text:SetActive(true)
        local line = self.transform:Find("Center/FullScreenDialog/BG/Text"):GetComponent(TypewriterEffect)
        -- local line_pos = self.transform:Find("Center/FullScreenDialog/BG/Text").gameObject

        -- line_pos.transform.position = pos
        --把几个变量赋值成几个固定位置，例如正中，左上等，然后把它当作position传进来确定文字位置
        local cb = function(finished)
            --log.error(tostring(finished))
            if finished == true then
                if callback then
                    callback()
                end
            end
        end
        line:SetText(text, cb)
    end,

    showSpeedTest = function(self)
        self.speed:SetActive(true)
    end,

    hideSpeedTest = function(self)
        self.speed:SetActive(false)
    end,
    returnSpeed = function(self)
        if self.speed_value.text then
            --log.error(self.speed_value.text)
            return self.speed_value.text
        else
            log.error('no speed')
        end
    end,
    --Modify end

}

