local super = require("ui.frame")
local log = logger.get("Game", "Loading Frame")

return class {
    super = super,

    onLoaded = function(self, data)
        log.info('LoadingFrame onLoaded!!')
        super.onLoaded(self)

        -- 如果 loading 过程中界面被关了，隐藏界面
        if not frame_manager.is_loading_show then
            frame_manager:hide('loading')
            return
        end

        -- 游戏 logo，默认隐藏
        --self.logo = self.transform:Find("Logo") 
        -- 进度条，默认显示
        self.img_progress_bar = 
            self.transform:Find("ProgressBG/ProgressBar"):GetComponent(UnityEngine.UI.Image)
        self.progress_bar = 
            self.transform:Find("ProgressBG/ProgressBar"):GetComponent(SmoothFillAmount)
        -- 版本号，默认隐藏
        self.var = self.transform:Find("Ver")

        if data then
            self.args.data = data
        end
        local param = self.args.data
        if param then
            self.is_login = param.is_login          -- 是否是登陆
            self.start_progress = param.start or 0
            self.max_progress = param.max_progress or 0.95
            self.inc_speed = param.inc_speed or 1   -- 增加速度
        else
            self.is_login = false          -- 是否是登陆
            self.max_progress = 0.95
            self.inc_speed = 0.5
            self.start_progress = 0
        end

        self.img_progress_bar.fillAmount = self.start_progress

        if self.is_login then
            --self.logo:SetActive(true)
            self.var:SetActive(true)
        else
            --self.logo:SetActive(false)
            self.var:SetActive(false)
        end

        self.value = 0.0
        self:setProgress(self.max_progress, 1.0 / self.inc_speed)

        self.transform:SetAsLastSibling()
    end,

    -- 设置进度 value [0,1]
    setProgress = function(self, value, time)
        if self.progress_bar then
            self.progress_bar:make(value, time or 0.1)
            self.value = value
        end
    end,

    -- 获取进度
    getProgress = function(self)
        return  self.img_progress_bar.fillAmount
    end,

    onUnload = function(self)

    end,

}