local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.pre_level = self.args.data
       
        clickEvents = 
        {
            "closeBtn",
        }

        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)
        local pre_level = self.pre_level
        local cur_level = local_lord.level
        local talent_points, might, max_level = self:getCfgByLevel(pre_level, cur_level)
        self:findText("content/layout/common_panel_60 (1)/cur").text = "Lv." .. self.pre_level
        self:findText("content/layout/common_panel_60 (1)/next").text = "Lv." .. cur_level
        self:findText("content/text1_Static_5/Image (2)/level").text = cur_level
        self:findText("content/layout/common_panel_60 (2)/next").text = "+" .. talent_points
        self:findText("content/layout/common_panel_60 (3)/next").text = "+" .. might
        self:findText("content/layout/common_panel_60 (4)/next").text = "Lv." .. max_level
    end,

    -- 不包括 start_lv
    getCfgByLevel = function(self, start_lv, end_lv)
        local talent_points = 0
        local might = config.captain_level_ups[end_lv].GetPowerUp - config.captain_level_ups[start_lv].GetPowerUp
        local max_level = 0
        config.captain_level_ups:foreach(function(id, cfg)
            if cfg.Level > start_lv and cfg.Level <= end_lv then
                talent_points = talent_points + cfg.GetCaptainSp
            end
            if cfg.Level == end_lv then
                max_level = cfg.CommandLevelLimit
            end
        end)
        return talent_points, might, max_level
    end,

    click_closeBtn = function(self)
        frame_manager:hide('lord_level_up')
    end,
}
