notice_type = {
    talent_info_buy_physical_strength = 1
}

local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.is_pvp = self.args.data.is_pvp
        self.msg = self.args.data.msg

        clickEvents = {
            "closeBtn",
        }

        frame_helper:regClickEvents("click", self, clickEvents)
        
        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self, content)

        local title = self:findText("content/text1_Static[T2]_29")
        title.text = NativeText.GetLangStr(self.is_pvp and 610034 or 610021)

        local path = "content/Scroll View/Viewport/Content/"
        frame_helper:hideAllChild(self, path)
        local cfg_list = self:getCfgList()
        for __, content in ipairs(cfg_list) do
            local child = frame_helper:getChild(self, __, path)
            child:SetActive(true)
            local title = child:Find("guild_panel_45/text1_Static[T5]_27"):GetComponent(UnityEngine.UI.Text)
            title.text = frame_helper:getLangCfg(content.list[1].show_index_name)
            local item_path = path .. child.name .. "/layout"
            frame_helper:hideAllChild(self, item_path, true)
            for idx, cfg in ipairs(content.list) do
                local item = frame_helper:getChild(self, idx, item_path)
                item:SetActive(true)
                local name = item:GetComponent(UnityEngine.UI.Text)
                local value = item:Find("value"):GetComponent(UnityEngine.UI.Text)
                name.text = frame_helper:getLangCfg(cfg.player_config_name or cfg.data_name)
                value.text = self:getValue(cfg)
            end

            local top_height = 45
            local child_size = #content.list * 40
            local offset = 10
            local rect = child:GetComponent(UnityEngine.RectTransform)
            rect.sizeDelta = Vector2(rect.sizeDelta.x, top_height + child_size + offset)
        end
    end,

    getValue = function(self, cfg)
        if self.is_pvp then
            local is_percentage = cfg.ShowPercent == 1
            for __, data in ipairs(self.msg.dataList) do
                if data.dataType == cfg.data then
                    if is_percentage then
                        return data.value * 0.01 .. "%"
                    else
                        return data.value
                    end
                end
            end
            return is_percentage and "0%" or 0
        else
            local prop_list = loadstring("return " .. cfg.player_config_id)()
            local rst = 0
            local is_percentage = nil
            for __, prop_id in ipairs(prop_list) do
                is_percentage = frame_helper:isPropPercentage(prop_id)
                for __, data in ipairs(self.msg.propList) do
                    if data.PropId == prop_id then
                        if is_percentage then
                            rst = rst + data.PropValue * 0.01
                        else
                            rst = rst + data.PropValue
                        end
                    end
                end
            end
            return is_percentage and (rst .. "%") or rst
        end
    end,

    getCfgList = function(self)
        local rst = {}
        local get = function(show_index)
            for __, content in ipairs(rst) do
                if content.show_index == show_index then
                    return content
                end
            end
            local temp = {
                show_index = show_index,
                list = {},
            }
            table.insert(rst, temp)
            return temp
        end

        local cfg = self.is_pvp and config.captain_pvp_statisticss or config.captain_player_config_shows
        cfg:foreach(function(id, cfg)
            local content = get(cfg.show_index)
            table.insert(content.list, cfg)
        end)
        local sortFunc = function(a, b)
            return a.show_index < b.show_index
        end

        local sortList = function(a, b)
            return a.id < b.id
        end

        for __, value in ipairs(rst) do
            table.sort(value.list, sortList)
        end

        table.sort(rst, sortFunc)
        return rst
    end,

    click_closeBtn = function(self)
        frame_manager:hide('lord_prop')
    end,
}
