notice_type = {
    talent_info_buy_physical_strength = 1
}

local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.talent_cfg = self.args.data.cfg
        self.cur_level = self.args.data.level

        clickEvents = {
            "closeBtn",
        }

        frame_helper:regClickEvents("click", self, clickEvents)
        
        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self, content)
        local path = "content/Scroll View/Viewport/Content"
        frame_helper:hideAllChild(self, path)
        local list_cfg = self:getCfgList()
        for __, cfg in ipairs(list_cfg) do
            local child = frame_helper:getChild(self, __, path)
            child:SetActive(true)
            local level = child:Find("level"):GetComponent(UnityEngine.UI.Text)
            level.text = __
            local prop = child:Find("prop"):GetComponent(UnityEngine.UI.Text)
            local effect_tab = frame_helper:getPropertyDes(cfg.effect)
            prop.text = effect_tab[1].num_str

            local select = child:Find("select"):GetComponent(UnityEngine.UI.Image)
            select.enabled = self.cur_level == cfg.level
        end
        local prop = self:findText("content/prop_name")
        local effect_tab = frame_helper:getPropertyDes(list_cfg[1].effect)
        prop.text = effect_tab[1].name_str
    end,

    getCfgList = function(self)
        local rst = {}
        config.captain_skill_details:foreach(function(id, cfg)
            if cfg.list_id == self.talent_cfg.id then
                table.insert(rst, cfg)
            end
        end)
        local sortFunc = function(a, b)
            return a.id < b.id
        end
        table.sort(rst, sortFunc)
        return rst
    end,

    click_closeBtn = function(self)
        frame_manager:hide('lord_talent_info')
    end,
}
