local super = require("ui.frame")
local log = logger.get("Game", "Officer Level Up Frame")
local gui_helper = require("gui.gui_helper")

return class
{
    super = super,

    onLoaded = function (self)
        super.onLoaded(self)

        self.officer = self.args.data
        self.hero = hero_manager.heros[self.officer:getTankId()]

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "Panel",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.battle_force_text = self:findText('Panel/BGBorder/Fight/FightText')
        self.level_text = self:findText('Panel/BGBorder/LevelText')
        self.prop_panel = self.transform:Find('Panel/BGBorder/Props')
        self.officer_pic = self:findImage('Panel/BGBorder/Icon')

        self.battle_force_text.text = tostring(self.hero.strength)
        self.level_text.text = string.format(NativeText.GetLangStr(110044), self.officer.level)

        self:setProps()
    end,

    setProps = function(self)
        local props = self.officer:getProps(self.officer.level-1, self.officer.quality, self.officer.awake_level, self.officer.star_level)
        local next_props = self.officer:getProps(self.officer.level, self.officer.quality, self.officer.awake_level, self.officer.star_level)
        local props_change = {}
        for k, v in pairs(next_props) do
            props_change[v.PropId] = v.PropValue
        end
        gui_helper:showUpgradeProps(self.prop_panel, props, props_change, false)
    end,

    onUnload = function (self)
    end,

    onRcvMsg = function(self, cmd, msg)
    end,

    update = function(self)
       
    end,
    
    click_Panel = function(self)
        frame_manager:hide('officer_level_up')
    end,

}