local log = logger.get("Game", "Option Frame")
local super = require("ui.frame")

return class{

    super = super,

    onLoaded = function(self)
        super:onLoaded(self)

        self.title = self.args.data.title
        self.options = self.args.data.options
        self.callback = self.args.data.callback

        self.helper = require("gui.tool.frame_helper")

        self.btn_prefab = self.transform:Find("Button").gameObject
        self.layout = self.transform:Find("Layout")

        if self.title then
            self.transform:Find("Title").gameObject:SetActive(true)
            local text_title = self.transform:Find("Title/Text"):GetComponent("UnityEngine.UI.Text")
            text_title.text = self.helper:getLangCfg(self.title)
        else
            self.transform:Find("Title").gameObject:SetActive(false)
        end

        self:init()
    end,

    init = function(self)
        for k, v in ipairs(self.options) do
            local btn = nil
            if k > self.layout.childCount-1 then
                btn = Object.Instantiate(self.btn_prefab).transform
                btn:SetParent(self.layout)
                resetTransformZ(btn)
            else
                btn = self.layout:GetChild(k-1)
            end

            if not btn then
                return
            end

            btn:SetActive(true)

            local text = btn:Find("Text"):GetComponent(UnityEngine.UI.Text)
            text.text = self.helper:getLangCfg(v)

            btn.name = "btn_"..k
            self:setScript("click", "Layout/"..btn.name, functor.rmake(self.onClickBtn, k))
        end
    end,

    onClickBtn = function(self, handler, index)
        if self.callback then
            self.callback(index)
        end
        frame_manager:hide("dialog_option")
    end,
}