local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self)

        self.tankTrans = {}
        self.mainWpTrans = {}
        self.viceWpTrans1 = {}
        self.viceWpTrans2 = {}
        self.viceWpTrans3 = {}
        self.viceWpTrans4 = {}
        self.wheelTrans = {}

        local max = 16

        for k = 1, max do 
            self:setScript("click", "left Scroll View/Viewport/Content/Item (" .. k .. ")", functor.rmake(self.selectTank, k))
        end

        for k = 1, max do 
            self:setScript("click", "mainWeapon Scroll View/Viewport/Content/Item (" .. k .. ")", functor.rmake(self.selectMainWeapon, k))
        end

        for k = 1, max do 
            self:setScript("click", "viceWeapon Scroll View (1)/Viewport/Content/Item (" .. k .. ")", functor.rmake(self.selectViceWeapon1, k))
        end

        for k = 1, max do 
            self:setScript("click", "viceWeapon Scroll View (2)/Viewport/Content/Item (" .. k .. ")", functor.rmake(self.selectViceWeapon2, k))
        end

        for k = 1, max do 
            self:setScript("click", "viceWeapon Scroll View (3)/Viewport/Content/Item (" .. k .. ")", functor.rmake(self.selectViceWeapon3, k))
        end

        for k = 1, max do 
            self:setScript("click", "viceWeapon Scroll View (4)/Viewport/Content/Item (" .. k .. ")", functor.rmake(self.selectViceWeapon4, k))
        end

        for k = 1, max do 
            self:setScript("click", "wheel Scroll View/Viewport/Content/Item (" .. k .. ")", functor.rmake(self.selectWheel, k))
        end

        for k = 1, max do 
           self.tankTrans[k] = self.transform:Find("left Scroll View/Viewport/Content/Item (" .. k .. ")")
           self.tankTrans[k].gameObject:SetActive(false)
        end

        for k = 1, max do 
           self.mainWpTrans[k] = self.transform:Find("mainWeapon Scroll View/Viewport/Content/Item (" .. k .. ")")
           self.mainWpTrans[k].gameObject:SetActive(false)
        end

        for k = 1, max do 
           self.viceWpTrans1[k] = self.transform:Find("viceWeapon Scroll View (1)/Viewport/Content/Item (" .. k .. ")")
           self.viceWpTrans1[k].gameObject:SetActive(false)
        end

        for k = 1, max do 
           self.viceWpTrans2[k] = self.transform:Find("viceWeapon Scroll View (2)/Viewport/Content/Item (" .. k .. ")")
           self.viceWpTrans2[k].gameObject:SetActive(false)
        end

        for k = 1, max do 
           self.viceWpTrans3[k] = self.transform:Find("viceWeapon Scroll View (3)/Viewport/Content/Item (" .. k .. ")")
           self.viceWpTrans3[k].gameObject:SetActive(false)
        end

        for k = 1, max do 
           self.viceWpTrans4[k] = self.transform:Find("viceWeapon Scroll View (4)/Viewport/Content/Item (" .. k .. ")")
           self.viceWpTrans4[k].gameObject:SetActive(false)
        end

        for k = 1, max do 
           self.wheelTrans[k] = self.transform:Find("wheel Scroll View/Viewport/Content/Item (" .. k .. ")")
           self.wheelTrans[k].gameObject:SetActive(false)
        end
       
        local parent = GameObject()
        parent.name = "ModelS"
        parent.transform.localScale = Vector3.one * 1.8

        config.garage_resources:foreach(
            function(k,v)

                local prefabName = v.Vehicle
                local prefabPath = "Assets/Prefab/Vehicle/" .. v.Vehicle .. ".prefab"

                local scaleParent = GameObject()
                scaleParent.transform.parent = parent.transform
                scaleParent.transform.name = "tank_scale_" .. prefabName
                scaleParent.transform.localPosition = Vector3.zero
                scaleParent.transform.localScale = Vector3.one * self:getScale(prefabName)
                scaleParent.transform.localRotation = Quaternion.identity

                app:startCoroutine(function ()
                    coroutine.yield(WaitForInstantiate(prefabPath, scaleParent.transform, function(newObj)
                        self:onComplete(newObj, k)
                        self.tankTrans[k].gameObject:SetActive(true)
                        self.tankTrans[k]:Find("Text"):GetComponent(UnityEngine.UI.Text).text = k
                    end))
                end)

                return
            end
        )

        app:startCoroutine(function ()
            coroutine.yield(WaitForInstantiate("Assets/Arts/fx/cj/cj.prefab", nil, function(newObj)
            end))
        end)

        
    end,

    getScale = function(self, prefabName)
        config.partscale_resources:foreach(function (k, v)
            if v.parts == prefabName then
                return v.scale
            end
        end)
        return 1
    end,

    onComplete = function(self, gameObject, idx)
        -- print("游戏对象创建完成:", gameObject.name, idx, gameObject.transform.localScale)
        -- gameObject.transform.localPosition = Vector3.zero 
        -- gameObject.transform.localScale = Vector3.one
        -- print("游戏对象创建完成:", gameObject.name, idx, gameObject.transform.localScale)
        self.data = self.data or {}
        self.data[idx] = gameObject
    end,

    selectTank = function(self, handle, idx)
        print("select tank idx:", idx)

        for k,v in ipairs(self.data) do
            self.data[k].gameObject:SetActive(k == idx)
        end

        self.curCfg = config.garage_resources[idx]
        self.weapon = self.helper:split(self.curCfg.Weapon, ',')
        self.secWeapon = self.helper:split(self.curCfg.SecWeapon, ',')
        self.luntai = self.helper:split(self.curCfg.wheel, ',')

        local weapon = self.weapon
        local secWeapon = self.secWeapon
        local luntai = self.luntai

        for k,v in ipairs(self.mainWpTrans) do
            v.gameObject:SetActive(false)
        end

        for k,v in ipairs(self.viceWpTrans1) do
            v.gameObject:SetActive(false)
        end

        for k,v in ipairs(self.viceWpTrans2) do
            v.gameObject:SetActive(false)
        end

        for k,v in ipairs(self.viceWpTrans3) do
            v.gameObject:SetActive(false)
        end

        for k,v in ipairs(self.viceWpTrans4) do
            v.gameObject:SetActive(false)
        end

        for k,v in ipairs(self.wheelTrans) do
            v.gameObject:SetActive(false)
        end
        
        for k,v in ipairs(weapon) do
            -- print("weapon:", #secWeapon)
            self.mainWpTrans[k].gameObject:SetActive(true)
            self.mainWpTrans[k]:Find("Text"):GetComponent(UnityEngine.UI.Text).text = k
        end

        self.z_wq = self.data[idx].transform:FindTransform("z_wq")
        
        self.f_wq_1 = self.data[idx].transform:FindTransform("f_wq_1")
        if self.f_wq_1 then
            for k,v in ipairs(secWeapon) do
                -- print("secWeapon:", v)
                self.viceWpTrans1[k].gameObject:SetActive(true)
                self.viceWpTrans1[k]:Find("Text"):GetComponent(UnityEngine.UI.Text).text = k
            end
        else
            print("找不到！！！！！！", self.data[idx].name)
        end

        self.f_wq_2 = self.data[idx].transform:FindTransform("f_wq_2")
        if self.f_wq_2 then
            for k,v in ipairs(secWeapon) do
                -- print("secWeapon:", v)
                self.viceWpTrans2[k].gameObject:SetActive(true)
                self.viceWpTrans2[k]:Find("Text"):GetComponent(UnityEngine.UI.Text).text = k
            end
        else
            print("找不到！！！！！！", self.data[idx].name)
        end

        self.f_wq_3 = self.data[idx].transform:FindTransform("f_wq_3")
        if self.f_wq_3 then
            for k,v in ipairs(secWeapon) do
                -- print("secWeapon:", v)
                self.viceWpTrans3[k].gameObject:SetActive(true)
                self.viceWpTrans3[k]:Find("Text"):GetComponent(UnityEngine.UI.Text).text = k
            end
        else
            print("找不到！！！！！！", self.data[idx].name)
        end

        self.f_wq_4 = self.data[idx].transform:FindTransform("f_wq_4")
        if self.f_wq_4 then
            for k,v in ipairs(secWeapon) do
                -- print("secWeapon:", v)
                self.viceWpTrans4[k].gameObject:SetActive(true)
                self.viceWpTrans4[k]:Find("Text"):GetComponent(UnityEngine.UI.Text).text = k
            end
        else
            print("找不到！！！！！！", self.data[idx].name)
        end

        self.lt_1 = self.data[idx].transform:FindTransform("lt_1")
        if self.lt_1 then
            for k,v in ipairs(luntai) do
                self.wheelTrans[k].gameObject:SetActive(true)
                self.wheelTrans[k]:Find("Text"):GetComponent(UnityEngine.UI.Text).text = "轮胎" .. k
            end
        else
            print("找不到！！！！！！轮胎")
        end
    end,

    selectMainWeapon = function(self, handle, idx)
        print("选择武器:", idx)

        if self:isOwn(self.z_wq, self.weapon[idx]) then
            return
        end

        if self.z_wq and self.weapon[idx] then
            local resPath = 'Assets/Prefab/Weapon/' .. self.weapon[idx] .. '.prefab'
            self:equipWeapon(self.z_wq, resPath, self.weapon[idx])
        end
    end,

    isOwn = function(self, node, name)
        local rst = false
        for i = 0, node.childCount -1 do
            node:GetChild(i).gameObject:SetActive(node:GetChild(i).name == name)
            if node:GetChild(i).name == name then
                rst = true
            end
        end
        return rst
    end,

    selectViceWeapon1 = function(self, handle, idx)
        print("选择副武器1:", idx)

        if self:isOwn(self.f_wq_1, self.secWeapon[idx]) then
            return
        end

        if self.f_wq_1 and self.secWeapon[idx] then
            local resPath = 'Assets/Prefab/SecWeapon/' .. self.secWeapon[idx] .. '.prefab'
            self:equipWeapon(self.f_wq_1, resPath, self.secWeapon[idx])
        end
    end,

    selectViceWeapon2 = function(self, handle, idx)
        print("选择副武器2:", idx)

        if self:isOwn(self.f_wq_2, self.secWeapon[idx]) then
            return
        end

         if self.f_wq_2 and self.secWeapon[idx] then
            local resPath = 'Assets/Prefab/SecWeapon/' .. self.secWeapon[idx] .. '.prefab'
            self:equipWeapon(self.f_wq_2, resPath, self.secWeapon[idx])
        end
    end,

    selectViceWeapon3 = function(self, handle, idx)
        print("选择副武器3:", idx)

        if self:isOwn(self.f_wq_3, self.secWeapon[idx]) then
            return
        end

        if self.f_wq_3 and self.secWeapon[idx] then
            local resPath = 'Assets/Prefab/SecWeapon/' .. self.secWeapon[idx] .. '.prefab'
            self:equipWeapon(self.f_wq_3, resPath, self.secWeapon[idx])
        end
    end,

    selectViceWeapon4 = function(self, handle, idx)
        print("选择副武器4:", idx)

         if self:isOwn(self.f_wq_4, self.secWeapon[idx]) then
            return
        end

        if self.f_wq_4 and self.secWeapon[idx] then
            local resPath = 'Assets/Prefab/SecWeapon/' .. self.secWeapon[idx] .. '.prefab'
            self:equipWeapon(self.f_wq_4, resPath, self.secWeapon[idx])
        end
    end,

    selectWheel = function(self, handle, idx)
        print("选择轮胎:", idx)

        if self:isOwn(self.lt_1, self.luntai[idx]) then
            return
        end

        if self.lt_1 and self.luntai[idx] then
            local resPath = 'Assets/Prefab/Wheel/' .. self.luntai[idx] .. '.prefab'
            self:equipWeapon(self.lt_1, resPath, self.luntai[idx])
        end
    end,

    equipWeapon = function(self, nodeTs, resPath, prefabName)
        -- for i = 0, nodeTs.childCount - 1 do
        --     nodeTs:GetChild(i):SetActive(false)
        -- end

        print("resPath:", resPath, prefabName, nodeTs.name)

        local scaleParent = GameObject()
        scaleParent.transform.parent = nodeTs
        scaleParent.transform.name = "part_scale_" .. prefabName
        scaleParent.transform.localPosition = Vector3.zero
        scaleParent.transform.localScale = Vector3.one * self:getScale(prefabName)
        scaleParent.transform.localRotation = Quaternion.identity

        print("###################:", scaleParent.transform.localRotation)

        app:startCoroutine(function ()
            coroutine.yield(WaitForInstantiate(resPath, scaleParent.transform, function(newObj)

                print("###################:", scaleParent.transform.localRotation)

                print("scale:", newObj.transform.localScale)
            end))
        end)
    end,
}
