local log = logger.get("Game", "commander promote result panel")

return class{
    ctor = function(self, info_panel)
        self.panel = info_panel
        self.helper = require("gui.tool.frame_helper")

        self.cur_icon = self.panel:Find('Info/Icons/Icon1')
        self.next_icon = self.panel:Find('Info/Icons/Icon2')
        self.fight_text = self.panel:Find('Info/Fight/FightText'):GetComponent(UnityEngine.UI.Text)
        self.title = self.panel:Find('Info/Text'):GetComponent(UnityEngine.UI.Text)

        self:hide()
    end,

    showPromoteResult = function(self, officer_inst, isAwake)
        self.helper.showTrans(self.panel)

        if isAwake then
            self.title.text = NativeText.GetLangStr("110031")
        else
            self.title.text = NativeText.GetLangStr("110006")
        end
        
        local hero_id = officer_inst:getTankId()
        self:setFight(hero_manager.heros[hero_id].strength)
        self:setIcon(officer_inst)

        --gui_helper:showUpgradeProps(self.panel:Find("Info/Params"), props, changes)
    end,

    setFight = function(self, value)
        self.fight_text.text = value
    end,

    setIcon = function(self, commander)
        --gui_helper:setCommanderIcon(commander.star_level, commander.quality, self.cur_icon)
        --gui_helper:setCommanderIcon(commander.star_level, commander.quality + 1, self.next_icon)
    end,

    hide = function(self)
        self.helper.hideTrans(self.panel)
    end,


}