local log = logger.get("Game", "Battle Settlement")
local super = require("ui.frame")

return class{
    super = super,

    onLoaded = function (self)
        super.onLoaded(self)

        self.is_win = self.args.data.is_win
        self.callback = self.args.data.callback
        
        clickEvents = {
            "closeBtn",
        }

        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)
        
        self:init()
    end,

    onUnload = function(self)
    end,

    init = function(self)
        self.win = self.transform:Find("win")
        self.lose = self.transform:Find("lose")
        self.helper.hideTrans(self.win)
        self.helper.hideTrans(self.lose)

        if self.is_win then
            self.helper.showTrans(self.win)
        else
            self.helper.showTrans(self.lose)
        end
    end,

    click_closeBtn = function(self)
        if self.callback then
            self.callback()
        end
        frame_manager:hide('recruit_settle')
    end,
}