local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        -- 路径: root/login
        -- 事件: click_login 
        clickEvents = {
            "bg/closeBtn",
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.owner = self.args.owner
        local rwd_json = self.args.data

        if type(rwd_json) == "string" then
            self:init(rwd_json)
        end

        self.rmbTime = UnityEngine.Time.realtimeSinceStartup
    end,

    onUnload = function (self)
    end,

    init = function(self, rwd_json)
        self.childs_tsf = {}

        for i = 1, 18 do
            self.childs_tsf[i] = self.transform:Find("bg/Background/Content/item (" .. i .. ")")
        end

        for __, item in ipairs(self.childs_tsf) do
            item.gameObject:SetActive(false)
        end

        local tb = self.helper:getJsonTab(rwd_json)
        local idx = 1
        for itemId, num in pairs(tb) do
            local item = self.childs_tsf[idx]
            item.gameObject:SetActive(true)
            local img = item:Find("Image"):GetComponent(UnityEngine.UI.Image)
            img:SetSprite(self.helper:getItemIcon(itemId))
            local text = item:Find("Image/valueText"):GetComponent(UnityEngine.UI.Text)
            text.text = num
            idx = idx + 1
        end
    end,

    click_closeBtn = function(self)
        if UnityEngine.Time.realtimeSinceStartup - self.rmbTime > 2 then
            frame_manager:hide('reward')
        end
    end,
}
