local log = logger.get("Game", "Drop Bag Helper")

local dropbag_helper_cls = class{
    ctor = function(self)
        self.over_view = {}
        self.drop_bag = {}
        self.no_random = {}
        self:initOverView()
        self:initDropBag()
        self:initNoRandom()
    end,

    initOverView = function(self)
        config.dropbag_overviews:foreach(
            function (k, v)
                self.over_view[v.id] = {}
            end
        )

        config.dropbag_overviews:foreach(
            function (k, v)
                self.over_view[v.id][v.dropbag_id] = v
            end
        )
    end,

    initDropBag = function(self)
        config.dropbag_dropbags:foreach(
            function (k, v)
                self.drop_bag[v.dropbag_id] = {}
            end
        )

        config.dropbag_dropbags:foreach(
            function (k, v)
                self.drop_bag[v.dropbag_id][v.drop_item] = v
            end
        )
    end,

    initNoRandom = function(self)
        config.dropbag_norandoms:foreach(
            function (k, v)
                self.no_random[v.item_id] = {}
            end
        )

        config.dropbag_norandoms:foreach(
            function (k, v)
                self.no_random[v.item_id][v.drop_item] = v
            end
        )
    end,
}

dropbag_helper = dropbag_helper or dropbag_helper_cls()

return dropbag_helper