return class {
    -- frame (must extend monobehavior)
    -- transform (need component RawImage)
    -- resPath (the prefab path)
    -- Camera.clearFlags 1:ClearFlags 2:Solid Color
    -- rt_size 是RenderTexture的大小，越小占的内存越小
    add = function(self, frame, transform, resPath, rt_size_scale, callback, aspect)

        local rawImage = transform:GetComponent(UnityEngine.UI.RawImage)
        if rawImage == nil or type(callback) ~= "function" then
            return
        end

        camera_idx = camera_idx or 0
        camera_idx = camera_idx + 1
        self.helper = self.helper or require("gui.tool.frame_helper")
        
        local camera_obj = GameObject()
        camera_obj.name = "RtCamera" .. camera_idx
        camera_obj.transform.localPosition = Vector3(camera_idx * 1000, 0 ,0)
        camera_obj:AddComponent(UnityEngine.Camera)
        local cam = camera_obj:GetComponent(UnityEngine.Camera)
        cam.clearFlags = 2
        cam.cullingMask = 2 ^ UnityEngine.LayerMask.NameToLayer("Model")
        cam.orthographic = true

        -- if aspect then
        --     aspect = UnityEngine.Screen.height / UnityEngine.Screen.width
        -- else
        --     aspect = 1
        -- end

        -- local roleRenderTexture = UnityEngine.RenderTexture(512, aspect * 512,1);
        local roleRenderTexture = UnityEngine.RenderTexture(rt_size_scale, rt_size_scale, 1);
        cam.targetTexture = roleRenderTexture;
        cam.orthographicSize = 7
        rawImage.texture = roleRenderTexture
        -- rawImage.transform.localScale = Vector3(1,aspect,1)

        app:startCoroutine(function ()
            coroutine.yield(WaitForInstantiate(resPath, camera_obj.transform, function(newObj)
                newObj.transform.localPosition = Vector3(0, 0, 1)
                newObj.transform.localScale = Vector3(1,1,1)
                self.helper:setChildLayer(newObj.transform, "Model")
                callback(newObj)
            end))
        end)

        self.camera_list =  self.camera_list or {}
        self.camera_list[camera_idx] = { camera_idx = camera_idx, camera_obj = camera_obj }
        return camera_idx, cam
    end, 

    remove = function(self, camera_idx)
        if self.camera_list[camera_idx] then
            UnityEngine.Object.Destroy(self.camera_list[camera_idx].camera_obj)
            self.camera_list[camera_idx] = nil
        end
    end,

    clear = function(self)
        if not self.camera_list then return end
        for __, tb in pairs(self.camera_list) do
            if tb then
                UnityEngine.Object.Destroy(tb.camera_obj)
            end
        end
        self.camera_list = nil
    end,
}
