local log = logger.get("Game", "Passive Skill Helper")

local cls = class{
    ctor = function(self)
        self.skills = {}
        self.skill_lvs = {}
        self.skill_mod = {}
        self:init()
    end,

    init = function(self)
        config.passive_skill_skills:foreach(
            function (k, v)
                self.skill_lvs[v.skill_id] = {}
            end
        )

        config.passive_skill_skills:foreach(
            function (k, v)
                local id = v.skill_id * 1000 + v.skill_level
                self.skills[id] = v

                self.skill_lvs[v.skill_id][v.skill_level] = v
            end
        )

        --[[ config.commander_skillmodes:foreach(
            function (k, v)
                self.skill_mod[v.skill_mode_id] = {}
            end
        )

        config.commander_skillmodes:foreach(
            function (k, v)
                self.skill_mod[v.skill_mode_id][v.starlevel] = v
            end
        ) ]]
    end,

    getSkill = function(self, id, level)
        local idx = id * 1000 + (level > 0 and level or 1)
        return self.skills[idx]
    end,

    getSkillMods = function(self, mod)
        return self.skill_mod[mod]
    end,

    getSkillMod = function(self, mod, star_lv)
        local list = self.skill_mod[mod]

        if list then
            return list[star_lv]
        else
            log.error("########################################### skill mod cfg error ! mod id", id)
        end

        return nil
    end,
}

passive_skill_helper = passive_skill_helper or cls()

return passive_skill_helper