local log = logger.get("Game", "Player Cfg Helper")



player_cfg_helper = {

    -- 守城武器攻击百分比加成
    getDefenseATKPercent = function(self, heros, is_global)
        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_WEAPON_ATK_ADD_PERCENT)) or 0           -- 守城武器全局百分比加成

        local hero_value_1 = 0          -- 英雄守城武器百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_DEFENSE_WEAPON_ATK_ADD_PERCENT) or 0
        end

        local total = value_1 + hero_value_1

        return total
    end,
    
    -- 守城武器防御百分比加成
    getDefenseDEFPercent = function(self, heros, is_global)
        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_WEAPON_DEF_ADD_PERCENT)) or 0           -- 守城武器全局百分比加成

        local hero_value_1 = 0          -- 英雄守城武器百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_DEFENSE_WEAPON_DEF_ADD_PERCENT) or 0
        end

        local total = value_1 + hero_value_1

        return total
    end,

    -- 获取兵种攻击力百分比加成
    getCorpATKPercent = function(self, soldier_type, heros, is_mass, is_wall, is_global)
        local percent = 0

        if soldier_type == 1 then
            percent = self:getCorp1ATKPercent(heros, is_mass, is_wall, is_global)
        elseif soldier_type == 2 then
            percent = self:getCorp2ATKPercent(heros, is_mass, is_wall, is_global)
        elseif soldier_type == 3 then
            percent = self:getCorp3ATKPercent(heros, is_mass, is_wall, is_global)
        elseif soldier_type == 4 then
            percent = self:getCorp4ATKPercent(heros, is_mass, is_wall, is_global)
        else
            log.error("##################################### cant find soldier type: ", soldier_type)
        end

        return percent * 0.01
    end,

    -- 获取兵种防御力百分比加成
    getCorpDEFPercent = function(self, soldier_type, heros, is_mass, is_wall, is_global)
        local percent = 0

        if soldier_type == 1 then
            percent = self:getCorp1DEFPercent(heros, is_mass, is_wall, is_global)
        elseif soldier_type == 2 then
            percent = self:getCorp2DEFPercent(heros, is_mass, is_wall, is_global)
        elseif soldier_type == 3 then
            percent = self:getCorp3DEFPercent(heros, is_mass, is_wall, is_global)
        elseif soldier_type == 4 then
            percent = self:getCorp4DEFPercent(heros, is_mass, is_wall, is_global)
        else
            log.error("##################################### cant find soldier type: ", soldier_type)
        end

        return percent * 0.01
    end,
    
    -- 火箭兵攻击百分比加成
    getCorp1ATKPercent = function(self, heros, is_mass, is_wall, is_global)

        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP1_ATK_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP1_ATK_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP1_ATK_ADD_PERCENT)) or 0     -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP1_ATK_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP1_ATK_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT) or 0
            hero_value_5 = hero_value_5 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP1_ATK_ADD_PERCENT) or 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,

    -- 突击兵攻击百分比加成
    getCorp2ATKPercent = function(self, heros, is_mass, is_wall, is_global)
        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP2_ATK_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP2_ATK_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP2_ATK_ADD_PERCENT)) or 0     -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP2_ATK_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP2_ATK_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT) or 0
            hero_value_5 = hero_value_5 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP2_ATK_ADD_PERCENT) or 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,

    -- 狙击兵攻击百分比加成
    getCorp3ATKPercent = function(self, heros, is_mass, is_wall, is_global)
        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP3_ATK_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP3_ATK_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP3_ATK_ADD_PERCENT)) or 0     -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP3_ATK_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP3_ATK_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT) or 0
            hero_value_5 = hero_value_5 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP3_ATK_ADD_PERCENT) or 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,

    -- 蛮兵攻击百分比加成
    getCorp4ATKPercent = function(self, heros, is_mass, is_wall, is_global)
        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP4_ATK_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP4_ATK_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = 0                                                                                                       -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP3_ATK_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_ATK_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP3_ATK_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_ATK_PERCENT) or 0
            hero_value_5 = 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_ATK_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,
    
    -- 火箭兵防御百分比加成
    getCorp1DEFPercent = function(self, heros, is_mass, is_wall, is_global)

        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP1_DEF_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP1_DEF_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP1_DEF_ADD_PERCENT)) or 0     -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP1_DEF_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP1_DEF_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT) or 0
            hero_value_5 = hero_value_5 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP1_DEF_ADD_PERCENT) or 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,
    
    -- 突击兵防御百分比加成
    getCorp2DEFPercent = function(self, heros, is_mass, is_wall, is_global)

        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP2_DEF_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP2_DEF_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP2_DEF_ADD_PERCENT)) or 0     -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP2_DEF_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP2_DEF_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT) or 0
            hero_value_5 = hero_value_5 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP2_DEF_ADD_PERCENT) or 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,
    
    -- 狙击兵防御百分比加成
    getCorp3DEFPercent = function(self, heros, is_mass, is_wall, is_global)

        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP3_DEF_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP3_DEF_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP3_DEF_ADD_PERCENT)) or 0     -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP3_DEF_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP3_DEF_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT) or 0
            hero_value_5 = hero_value_5 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP3_DEF_ADD_PERCENT) or 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,
    
    -- 蛮兵防御百分比加成
    getCorp4DEFPercent = function(self, heros, is_mass, is_wall, is_global)

        local value_1 = (is_global and local_player:getGlobalProp(common_pb.SYS_CORP4_DEF_PERCENT)) or 0                        -- 玩家全局单兵种百分比加成
        local value_2 = (is_global and local_player:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT)) or 0                     -- 玩家全局全兵种百分比加成
        local value_3 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_CORP4_DEF_PERCENT)) or 0                  -- 玩家全局集结单兵种百分比加成
        local value_4 = (is_global and local_player:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT)) or 0                -- 玩家全局集结全兵种百分比加成
        local value_5 = 0                                                                                       -- 玩家全局守城单兵种百分比加成
        local value_6 = (is_global and local_player:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT)) or 0     -- 玩家全局守城全兵种百分比加成

        local hero_value_1 = 0          -- 英雄单兵种百分比加成
        local hero_value_2 = 0          -- 英雄全兵种百分比加成
        local hero_value_3 = 0          -- 英雄集结单兵种百分比加成
        local hero_value_4 = 0          -- 英雄集结全兵种百分比加成
        local hero_value_5 = 0          -- 英雄守城单兵种百分比加成
        local hero_value_6 = 0          -- 英雄守城全兵种百分比加成

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_CORP3_DEF_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ALL_CORP_DEF_PERCENT) or 0
            hero_value_3 = hero_value_3 + hero:getGlobalProp(common_pb.SYS_GROUP_CORP3_DEF_PERCENT) or 0
            hero_value_4 = hero_value_4 + hero:getGlobalProp(common_pb.SYS_GROUP_ALLCORP_DEF_PERCENT) or 0
            hero_value_5 = 0
            hero_value_6 = hero_value_6 + hero:getGlobalProp(common_pb.SYS_DEFENSE_BATTLE_CORP0_DEF_ADD_PERCENT) or 0
        end

        local total = value_1 + value_2 + hero_value_1 + hero_value_2

        if is_mass then
            total = total + value_3 + value_4 + hero_value_3 + hero_value_4
        elseif is_wall then
            total = total + value_5 + value_6 + hero_value_5 + hero_value_6
        end

        return total
    end,

    getResGatherSpeedPercent = function(self, type, heros)
        local num = 0

        if type == 1 then
            num = self:getIronGatherSpeedPercent(heros)
        elseif type == 2 then
            num = self:getGearGatherSpeedPercent(heros)
        elseif type == 3 then
            num = self:getECTGatherSpeedPercent(heros)
        elseif type == 4 then
            num = self:getFoodGatherSpeedPercent(heros)
        elseif type == 5 then
            num = self:getTITANGatherSpeedPercent(heros)
        end

        return num
    end,

    -- 食物采集速度加成
    getFoodGatherSpeedPercent = function(self, heros)
        local value_1 = local_player:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
        local value_2 = local_player:getGlobalProp(common_pb.SYS_FOOD_COLLECT_SPEED_PERCENT) or 0
        local hero_value_1 = 0
        local hero_value_2 = 0

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_FOOD_COLLECT_SPEED_PERCENT) or 0
        end

        return value_1 + value_2 + hero_value_1 + hero_value_2
    end,

    -- 钢材采集速度加成
    getIronGatherSpeedPercent = function(self, heros)
        local value_1 = local_player:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
        local value_2 = local_player:getGlobalProp(common_pb.SYS_IRON_COLLECT_SPEED_PERCENT) or 0
        local hero_value_1 = 0
        local hero_value_2 = 0

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_IRON_COLLECT_SPEED_PERCENT) or 0
        end

        return value_1 + value_2 + hero_value_1 + hero_value_2
    end,

    -- 电力采集速度加成
    getECTGatherSpeedPercent = function(self, heros)
        local value_1 = local_player:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
        local value_2 = local_player:getGlobalProp(common_pb.SYS_ELECTRIC_COLLECT_SPEED_PERCENT) or 0
        local hero_value_1 = 0
        local hero_value_2 = 0

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_ELECTRIC_COLLECT_SPEED_PERCENT) or 0
        end

        return value_1 + value_2 + hero_value_1 + hero_value_2
    end,

    -- 钛矿采集速度加成
    getTITANGatherSpeedPercent = function(self, heros)
        local value_1 = local_player:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
        local value_2 = local_player:getGlobalProp(common_pb.SYS_TITANIUM_COLLECT_SPEED_PERCENT) or 0
        local hero_value_1 = 0
        local hero_value_2 = 0

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_TITANIUM_COLLECT_SPEED_PERCENT) or 0
        end

        return value_1 + value_2 + hero_value_1 + hero_value_2
    end,

    -- 齿轮采集速度加成
    getGearGatherSpeedPercent = function(self, heros)
        local value_1 = local_player:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
        local value_2 = local_player:getGlobalProp(common_pb.SYS_GEAR_COLLECT_SPEED_PERCENT) or 0
        local hero_value_1 = 0
        local hero_value_2 = 0

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_RESOURCE_COLLECT_SPEED_PERCENT) or 0
            hero_value_2 = hero_value_2 + hero:getGlobalProp(common_pb.SYS_GEAR_COLLECT_SPEED_PERCENT) or 0
        end

        return value_1 + value_2 + hero_value_1 + hero_value_2
    end,

    -- 钻石采集速度加成
    getDiamondGatherSpeedPercent = function(self, heros)
        local value_1 = local_player:getGlobalProp(common_pb.SYS_DIAMOND_COLLECT_SPEED_PERCENT) or 0
        local hero_value_1 = 0

        for k, v in pairs(heros) do
            local hero = hero_manager:getHero(v)
            hero_value_1 = hero_value_1 + hero:getGlobalProp(common_pb.SYS_DIAMOND_COLLECT_SPEED_PERCENT) or 0
        end

        return value_1 + hero_value_1
    end,

    teamCargo = function(self, heros, team)
        local cargo = local_player:getGlobalProp(common_pb.SYS_SOLDIER_CAPACITY)
        local percent = local_player:getGlobalProp(common_pb.SYS_VEHICLE_CAPACITY_PERCENT)

        for k, v in pairs(team) do
            local cfg = config.soldier_soldiers[v.cfg_id]

            if cfg then
                cargo = cargo + cfg.Capacity*v.count
            end
        end

        return math.floor(cargo * (1+percent*0.0001))
    end,
}