notice_type = {
    talent_info_buy_physical_strength = 1
}

local super = require("ui.frame")

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        self.item_id = self.args.data.item_id
        self.callback = self.args.data.callback

        clickEvents = {
            "content/bg/useBtn",
            "content/bg/buyUseBtn",
            "closeBtn",
        }

        frame_helper:regClickEvents("click", self, clickEvents)

        self:init()
    end,

    onUnload = function (self)
    end,

    init = function(self, content)
        local num = self:findText("content/bg/useBtn/own_num")
        local name = self:findText("content/bg/name")
        local des = self:findText("content/bg/des")
        local icon = self:findImage("content/bg/icon")
        local quality = self:findImage("content/bg/quality")
        local own_num = bag_manager:getItemNum(self.item_id)
        num.text = string.format(NativeText.GetLangStr(610016), own_num)  
        icon:SetSprite(frame_helper:getItemIcon(self.item_id))
        icon:SetSprite(frame_helper:getItemQualityIcon(self.item_id))
        name.text = frame_helper:getItemName(self.item_id)
        des.text = frame_helper:getItemDes(self.item_id)

        local have_trans = self.transform:Find("content/bg/useBtn")
        local none_trans = self.transform:Find("content/bg/buyUseBtn")

        frame_helper:setActive(have_trans, own_num > 0)
        frame_helper:setActive(none_trans, own_num <= 0)

        if own_num <= 0 then
            local cfg = item_helper:getItemCfg(self.item_id)
            local buy_cost = frame_helper:getDiamondPriceFromStr(cfg.allprice)
            local DIAMOND    = 30001 -- 钻石
            local image_text = self.transform:Find('content/bg/buyUseBtn/image_text'):GetComponent(UnityEngine.UI.Text)
            local item_name = gui_helper:getImageTextItemStr(DIAMOND)
            image_text:SetImageText(string.format("%s %s", item_name, buy_cost))
        end
    end,

    click_useBtn = function(self)
        if self.callback then
            self.callback(true)
        end
        frame_manager:hide('use_item')
    end,

    click_buyUseBtn = function(self)
        if self.callback then
            self.callback(false)
        end
        frame_manager:hide('use_item')
    end,

    click_closeBtn = function(self)
        frame_manager:hide('use_item')
    end,
}
