local super = require("ui.frame")
local log = logger.get("Game", "Guild Logo")
local max_num = 100
local per_times = 1

return class {
    super = super, 

    onLoaded = function (self)
        super.onLoaded(self)

        -- self.game_state_island = self.args.owner
        -- self.msg = self.args.data.msg
        -- self.familyId = self.msg.familyInfo.familyId

        self.item_id  = self.args.data.item_id
        self.select_num = self.args.data.select_num
        max_num = self.args.data.max_num
        self.callback = self.args.data.callback

        -- print('item_id:', self.item_id, self.item_num)

        clickEvents = 
        {
            'close',
            'content/bg/confirmBtn',
            'content/bg/cancelBtn',
            'content/bg/frameBg/addBtn',
            'content/bg/frameBg/delBtn',
        }

        -- 注册点击事件
        self.helper = require("gui.tool.frame_helper")
        self.helper:regClickEvents("click", self, clickEvents)

        self.name_text = self:findText('content/bg/name_text')
        self.des_text = self:findText('content/bg/des_text')
        self.icon = self:findImage('content/bg/icon')
        self.select_num_text = self:findText('content/bg/frameBg/select_num_text')
        self.get_num_text = self:findText('content/bg/frameBg/get_num_text')
        self.slider = self.transform:Find('content/bg/frameBg/slider'):GetComponent(UnityEngine.UI.Slider)
        if not self.select_num then
            self.select_num = 1
        end
        self.slider.value = self.select_num / max_num
        
        self:init()
    end,

    onUnload = function (self)
    end,

    click_close = function(self)
    end,

    click_confirmBtn = function(self)
        if self.callback then
            self.callback(self.item_id, self.select_num)
            frame_manager:hide('use_slider')
        else
            network_sender:useItem(self.item_id, self.select_num)
            frame_manager:hide('use_slider')
        end
    end,

    click_cancelBtn = function(self)
        frame_manager:hide('use_slider')
    end,

    click_addBtn = function(self)
        self:removeListener()
        self.select_num = self.select_num + per_times
        self.select_num = self.select_num > max_num and max_num or self.select_num
        self.slider.value = self.select_num / max_num
        self.select_num_text.text = string.format(NativeText.GetLangStr(260007), self.select_num, max_num)
        self:addListener()
    end,

    click_delBtn = function(self)
        self:removeListener()
        self.select_num = self.select_num - per_times
        self.select_num = self.select_num < 1 and 1 or self.select_num
        self.slider.value = self.select_num / max_num
        self.select_num_text.text = string.format(NativeText.GetLangStr(260007), self.select_num, max_num)
        self:addListener()
    end,

    init = function(self)
        local cfg = self.helper:getItemCfg(self.item_id)
        self.name_text.text = self.helper:getLangCfg(cfg.name_id)
        self.des_text.text = self.helper:getLangCfg(cfg.des_id)
        self.icon:SetSprite(self.helper:getItemIcon(self.item_id))
        max_num = self.helper:getItemNum(self.item_id)

        self.select_num = self.select_num > max_num and max_num or self.select_num
        self.slider.value = self.select_num / max_num
        self.select_num_text.text = string.format(NativeText.GetLangStr(260007), self.select_num, max_num)

        self:addListener()
    end,

    addListener = function(self)
        self.slider.onValueChanged:AddListener(
            function()
                self:refreshSlider()
            end)
    end,

    removeListener = function(self)
        self.slider.onValueChanged:RemoveAllListeners()
    end,

    refreshSlider = function(self)
        local own_num = self.helper:getItemNum(self.item_id)
        self.select_num = math.ceil(self.slider.value * own_num)
        self.select_num = self.select_num < 1 and 1 or self.select_num
        self.select_num_text.text = string.format(NativeText.GetLangStr(260007), self.select_num, own_num)
    end,
}

