local log = logger.get("Game", "Weapon Upgrade result Panel")
local item_helper = require('RTS.prop_sys.prop_enum')

-- 武器升级结构 panel
return class{
    ctor = function(self, info_panel)
        self.panel = info_panel
        self.helper = require("gui.tool.frame_helper")

        self.icon = info_panel:Find('Frame/Top/Grade/Icon'):GetComponent(UnityEngine.UI.Image)
        self.grade = info_panel:Find('Frame/Top/Grade'):GetComponent(UnityEngine.UI.Image)
        self.level = info_panel:Find('Frame/Top/Grade/Level'):GetComponent(UnityEngine.UI.Text)
        self.name = info_panel:Find('Frame/Top/Name'):GetComponent(UnityEngine.UI.Text)
        self.type = info_panel:Find('Frame/Top/Type'):GetComponent(UnityEngine.UI.Text)

        self.level_from = self.panel:Find("Frame/Center/TextLevelFrom"):GetComponent(UnityEngine.UI.Text)
        self.level_to = self.panel:Find("Frame/Center/TextLevelTo"):GetComponent(UnityEngine.UI.Text)

        self:hide()
    end,

    showItem = function(self, item, src_level, src_props, dest_level, dest_props)
        self.helper.showTrans(self.panel)

        local icon_path = gui_helper:getItemIconPath(item.cfg)
        self.icon:SetSprite(icon_path)
        self.level_from.text = tostring(src_level)
        self.level_to.text = tostring(dest_level)

        self.name.text = self.helper:getLangCfg(item.cfg.name_id)
        self.type.text = gui_helper:getWeaponType(item.cfg)
        self.grade:SetSprite(gui_helper:getQualityIconPath(item.cfg.color))
        self.level.text = "Lv."..item.level

        local add_props = loadstring("return "..item.cfg.attr_grow)()
        local change_props = {}
        local props = {}

        if type(add_props) == "table" then
            for k, v in pairs(add_props) do
                local value = item:getProp(k)
                change_props[k] = value
                table.insert( props, {PropId = k, PropValue = value - v*(dest_level-src_level)} )
            end
        end

        --[[local changes ={}
        for k,v in ipairs(dest_props) do
            if v.PropValue ~= 0 then
                local prop_cfg = config.attribute_config_attrs[v.PropId]
                changes[v.PropId] = v.PropValue
            end
        end]]

        -- 显示 props 中的属性 (升级属性)
        gui_helper:showUpgradeProps(self.panel:Find("Frame/Center"), props, change_props)

    end,

    hide = function(self)
        self.helper.hideTrans(self.panel)
    end,


}