require('guide/guide_helper')
local log = logger.get("Game", "guide 10001")

-- 10001 号引导 建造研发中心
return 
{
    condition = function()
        -- 研发中心等级为 0
        --return home_info:getResearchEntityLv() == 0
        if guide_helper:getHomeEntityLevel(3) then
            return false 
        else
            return true
        end
    end,

    -- 执行过程，在协程中执行
    proc = function(id)
        log.info('guide 10001')
        local id = guide_manager.running_guide_id
        --app:logEvent("client_login", tostring(game_info.account))
        -- 等待对话完成
        guide_helper:waitDialogFinished(10001)
        app:logEvent("guide_10001_1", "10001 dialog")
        guide_helper:enableScreenMask()

        -- 摄像机定位到 grid gameobject
        local entity_obj = guide_helper:cameraFocusToHomeEntity(18)

        coroutine.yield(WaitForSeconds(1.0))
        -- 等待小精灵加载
        guide_helper:waitGuideSpriteShow(Vector3(-500, 100, 0))

        -- 小精灵说句话
        --NativeText.GetLangStr(610035)

        --frame_helper:getLangCfg()
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_1'))

        -- 等待 touch
        guide_helper:waitAnyTouch()

        -- 再说句话
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_2'))
        guide_helper:waitAnyTouch()
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_3'))
        -- 小精灵播放动画
        guide_helper:guideSpritePlayAnim("idle")

        -- 等待 touch
        --guide_helper:waitAnyTouch()

        -- 关闭对话
        

        -- 等待点击建筑
        guide_helper:waitForceHomeEntityGuide(entity_obj)
        guide_helper:guideSpriteDialog(nil)
        -- 等待建筑创建界面开启
        guide_helper:waitForFrame('home_entity_create')
       
        guide_helper:guideSpriteMoveToUI(
            'home_entity_create', 'content/Scroll View/Viewport/Content/1', Vector3(542, 0, 0), 2.0)

        coroutine.yield(WaitForSeconds(2.0))

        -- 面朝左边
        guide_helper:guideSpriteFacing(1)

        coroutine.yield(WaitForSeconds(0.1))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_4'),'bottom_left')
        coroutine.yield(WaitForSeconds(0.1))
        
        -- 等待点击
        guide_helper:waitForceButtonGuide(
            'home_entity_create', 'content/Scroll View/Viewport/Content/1')
        app:logEvent("guide_10001_2", "finished building")
        -- 引导完成
        --guide_manager:onGuideComplete(id)
        guide_manager:onGuideComplete(id)
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_5'))

        guide_helper:guideSpriteDialog(nil)
        coroutine.yield(WaitForSeconds(1.0))

        guide_helper:guideSpriteMoveToUI(
            'home', 'new/leftCenter/ButtonChapterAchievementGo', Vector3(730, 50, 0), 1.5)

        coroutine.yield(WaitForSeconds(2))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_6'),'top_left')
        
        guide_helper:waitForceButtonGuide('home', 'new/leftCenter/ButtonChapterAchievementGo')
        guide_helper:waitGuideSpriteHide()

        guide_helper:waitForFrame('getItems')
        

        local frame = frame_manager:getFrame("getItems")
        local area = frame.transform:Find("Frame")
        local canvas, raycaster = guide_helper:beginHighlightUIControl(area, "Temp", false)
        guide_helper:waitAnyTouch()
        guide_helper:endHighlightUIControl(canvas, raycaster)
        

        --guide_helper:waitForceButtonGuide('getItems', 'Frame/HasButton/BG/Confirm')
        app:logEvent("guide_10001_3", "reward collected")
        guide_helper:waitGuideSpriteShow(Vector3(-196, -237, 0))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_24'),'top_left')
        guide_helper:waitForceButtonGuide('home', 'new/leftCenter/ButtonChapterAchievementGo')
        guide_helper:waitGuideSpriteHide()
        -- 关闭屏幕遮罩
        --guide_helper:disableScreenMask()
        --guide_helper:guideFinished()
        
    end,

    -- 引导被打断
    onBreak = function(id)
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
