require('guide/guide_helper')
local log = logger.get("Game", "guide 10002")

-- 10002 号引导 升级舰桥 到 2 级
return 
{
    -- 条件，研发中心大于 0 级
    condition = function()
        --return guide_helper:getHomeEntityLevel(1) == 1
        return true
    end,

    -- 执行过程，在协程中执行
    proc = function(id)
        log.info('guide 10002')
        local id = guide_manager.running_guide_id

        guide_helper:enableScreenMask()
        guide_helper:waitGuideSpriteShow(Vector3(-500, 100, 0))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_7'))
        guide_helper:waitAnyTouch()
        -- 摄像机定位到 grid gameobject
        guide_helper:waitGuideSpriteHide()
        local entity_obj = guide_helper:cameraFocusToHomeEntity(4)

        -- 等待点击
        guide_helper:waitForceHomeEntityGuide(entity_obj)

        -- 等待用戶點擊升級按鈕
        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")

        -- 等待建筑升级界面开启
        guide_helper:waitForFrame('home_entity_upgrade')

        guide_helper:waitGuideSpriteShow(Vector3(-550, 224, 0))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_8'))

        -- 高亮区域 升级预览
        local frame = frame_manager:getFrame("home_entity_upgrade")
        local area = frame.transform:Find("content/Left Scroll View")
        local canvas, raycaster = guide_helper:beginHighlightUIControl(area, "Temp", false)
        guide_helper:waitAnyTouch()
        guide_helper:guideSpriteDialog(nil)
        guide_helper:endHighlightUIControl(canvas, raycaster)

        -- 高亮区域，解锁预览
        guide_helper:guideSpriteMove(Vector3.New(-622,-85,0),1)
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_9'))
        area = frame.transform:Find("content/unlock")
        canvas, raycaster = guide_helper:beginHighlightUIControl(area, "Temp", false)
        guide_helper:waitAnyTouch()
        guide_helper:guideSpriteDialog(nil)
        guide_helper:endHighlightUIControl(canvas, raycaster)
        
        guide_helper:guideSpriteMove(Vector3.New(368,-197,0),1.5)
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_10'))

        -- 等待点升级
        guide_helper:waitForceButtonGuide("home_entity_upgrade", "content/un_upgrading/upgradeBtn")

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)
        guide_helper:guideFinished()
    end,

    -- 引导被打断
    onBreak = function(id)
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
