require('guide/guide_helper')
local log = logger.get("Game", "guide 10005")

-- 10005 训练士兵
return 
{
    -- 条件
    condition = function()
        if guide_helper:getItemNum(32004) >= 5000 and guide_helper:getItemNum(32002) >= 5000 and guide_helper:getItemNum(32003) >= 5000 then
            return true
        else
            return false
        end
    end,

    -- 执行过程，在协程中执行
    proc = function(id)
        log.info('guide 10005')
        local id = guide_manager.running_guide_id

        guide_helper:enableScreenMask()
        local entity_obj = guide_helper:cameraFocusToHomeEntity(18)
        game_state_home.home_map:onClickEntity(18)
        --coroutine.yield(WaitForSeconds(0.1))
        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_20")
        guide_helper:waitForFrame('home_barrack')
        guide_helper:waitGuideSpriteShow(Vector3(263, -28, 0))
        guide_helper:guideSpriteFacing(0)
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_11'))

        -- 高亮区域 相克信息
        local frame = frame_manager:getFrame("home_barrack")
        local area = frame.transform:Find("content/right_bar")
        local canvas, raycaster = guide_helper:beginHighlightUIControl(area, "Temp", false)
        guide_helper:waitAnyTouch()
        guide_helper:guideSpriteDialog(nil)
        guide_helper:endHighlightUIControl(canvas, raycaster)

        
        -- 高亮区域，士兵属性
        guide_helper:guideSpriteMove(Vector3.New(-313,-159,0),1.5)
        coroutine.yield(WaitForSeconds(1.5))
        guide_helper:guideSpriteFacing(0)
        coroutine.yield(WaitForSeconds(0.5))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_12'))
        area = frame.transform:Find("content/UIPolygon")
        canvas, raycaster = guide_helper:beginHighlightUIControl(area, "Temp", false)
        guide_helper:waitAnyTouch()
        guide_helper:guideSpriteDialog(nil)
        guide_helper:endHighlightUIControl(canvas, raycaster)

        -- 用户点击训练按钮
        guide_helper:guideSpriteMove(Vector3.New(308,-161,0),1.5)
        coroutine.yield(WaitForSeconds(2))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_13'))
        guide_helper:waitForceButtonGuide("home_barrack", "content/un_upgrade/trainBtn")
        guide_manager:onGuideComplete(id)
        guide_helper:guideSpriteDialog(nil)
        guide_helper:waitGuideSpriteHide()

        
        --训练完成，领取奖励
        guide_helper:waitGuideSpriteShow(Vector3(-196, -237, 0))
        guide_helper:guideSpriteFacing(1)
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_6'),'top_left')
        guide_helper:waitForceButtonGuide('home', 'new/leftCenter/ButtonChapterAchievementGo')
        guide_helper:waitGuideSpriteHide()
        guide_helper:waitForFrame('getItems')

        local frame = frame_manager:getFrame("getItems")
        local area = frame.transform:Find("Frame")
        local canvas, raycaster = guide_helper:beginHighlightUIControl(area, "Temp", false)
        guide_helper:waitAnyTouch()
        guide_helper:endHighlightUIControl(canvas, raycaster)
        
        --guide_helper:waitForceButtonGuide('getItems', 'Frame/HasButton/BG/Confirm')

        --奖励领取完成，继续引导至下一个任务
        guide_helper:waitDialogFinished(10002)
        guide_helper:waitGuideSpriteShow(Vector3(-196, -237, 0))
        guide_helper:guideSpriteFacing(1)
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_24'),'top_left')
        guide_helper:waitForceButtonGuide('home', 'new/leftCenter/ButtonChapterAchievementGo')
        

        -- 关闭屏幕遮罩
        --guide_helper:disableScreenMask()
        --coroutine.yield(WaitForSeconds(0.1))
        -- 引导完成
        
        guide_helper:guideFinished()
    end,

    -- 引导被打断
    onBreak = function(id)
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
