require('guide/guide_helper')
local log = logger.get("Game", "guide 10007")

-- 10007 攻打资源船
return 
{
    -- 条件
    condition = function()
        local info = chapter_manager:getChapterInfo(1)
        if info.state == common_pb.ECHAPTER_TRIGGER then
            return true
        else
            return false
        end
    end,

    -- 执行过程，在协程中执行
    proc = function(id)
        log.info('guide 10007')
        local id = guide_manager.running_guide_id

        guide_helper:enableScreenMask()

        -- 弹出对话框：这里是建筑升级效果的预览
        guide_helper:waitGuideSpriteShow(Vector3(371, -167, 0))
        guide_helper:guideSpriteFacing(0)
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_20'))

        local entity_obj = guide_helper:cameraFocusToHomeEntity(31)

        coroutine.yield(WaitForSeconds(1.0))

       -- 点击建筑
        guide_helper:waitForceHomeEntityGuide(entity_obj)
        guide_helper:guideSpriteDialog(nil)


        -- 點擊侦察按鈕
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_21'))
        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_30")
        guide_helper:guideSpriteDialog(nil)
        -- 等待侦察战报

        -- 点邮件
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_22'))
        guide_helper:waitForceButtonGuide("home", "new/buttomLeft/bg/layout/emailBtn")
        guide_helper:guideSpriteDialog(nil)
        guide_helper:waitGuideSpriteHide()
        -- 等待邮箱界面开启
        guide_helper:waitForFrame('mail')

        -- 点战报
        guide_helper:waitForceButtonGuide("mail", "BG/Center/Buttons/BattleBtn")

        guide_helper:waitGuideSpriteShow(Vector3(-602, -167, 0))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_23'))
        -- 高亮区域
        local frame = frame_manager:getFrame("mail")
        local area = frame.transform:Find("BG/Center/Right")
        local canvas, raycaster = guide_helper:beginHighlightUIControl(area, "Temp", false)
        guide_helper:waitAnyTouch()
        guide_helper:endHighlightUIControl(canvas, raycaster)
        guide_helper:guideSpriteDialog(nil)
        guide_helper:waitGuideSpriteHide()
        -- 点返回
        guide_helper:waitForceButtonGuide("mail", "BG/Top/BackBtn")

        -- 点建筑
        entity_obj = guide_helper:cameraFocusToHomeEntity(31)
        coroutine.yield(WaitForSeconds(1.0))
        guide_helper:waitForceHomeEntityGuide(entity_obj)

        -- 点进攻
        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_31")

        -- 等待出征界面
        guide_helper:waitForFrame('launch_rally')

        -- 点自动选择
        guide_helper:waitForceButtonGuide("launch_rally", "BG/Content/Buttons/Auto")

        -- 点出发
        guide_helper:waitForceButtonGuide("launch_rally", "BG/Content/Buttons/Send")

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)
        guide_helper:guideFinished()
    end,

    -- 引导被打断
    onBreak = function(id)
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
