require('guide/guide_helper')
local log = logger.get("Game", "guide 10002")

-- 引导玩家制造武器
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        if guide_helper:getHomeEntityLevel(11) <= 0 then    --兵工厂等级小于等于0
            log.error('false')
            return false
        else
            return true
        end
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()

        -- 攝像機移到目標上
        local entity_obj = guide_helper:cameraFocusToHomeEntity(15)
        
        -- 等待用戶點擊 home entity
        coroutine.yield(guide_helper:waitForceHomeEntityGuide(entity_obj))

        -- 等待用戶點擊生产按钮
        coroutine.yield(guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_12"))

        -- 等待开启兵工厂
        coroutine.yield(guide_helper:waitForFrame('home_arsenal_main'))

        --点击制造
        coroutine.yield(guide_helper:waitForceButtonOnClickGuide('home_arsenal_main', 'content/bg/layout/1/makeBtn'))

        coroutine.yield(guide_helper:waitForceButtonOnClickGuide('home_arsenal_main', 'content/bg/making/time/speedUpBtn'))

        coroutine.yield(guide_helper:waitForFrame('home_speed_up'))

        coroutine.yield(guide_helper:waitForceButtonOnClickGuide('home_speed_up', 'content/Scroll View/Viewport/Content/tplt/useTrans/useBtn'))

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)
        guide_helper:guideFinished()
    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
