require('guide/guide_helper')
local log = logger.get("Game", "guide 10008")

-- 10008 通过资源船进关卡
return 
{
    -- 条件 
    condition = function()
        local info = chapter_manager:getChapterInfo(1)
        if info.state == common_pb.ECHAPTER_OCCUPY then
            return true
        else
            return false
        end
    end,

    -- 执行过程，在协程中执行
    proc = function(id)
        log.info('guide 10008')
        local id = guide_manager.running_guide_id

        guide_helper:enableScreenMask()

        -- 弹出对话框：这里是建筑升级效果的预览
        hint:setText("Let's unlock this resource ship")    -- 这里后边换成小秘书

        coroutine.yield(WaitForSeconds(0.5))
        local ship_obj = guide_helper:cameraFocusToHomeResShip(1)
        coroutine.yield(WaitForSeconds(1.0))

        guide_helper:waitForceHomeResShipGuide(ship_obj)

        frame_manager:show('level_select', nil, {chapter_id = 1})

        guide_helper:waitForFrame("level_select")
        
        guide_helper:waitForceButtonGuide("level_select", "Root/LevelPanel1")


        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)
        guide_helper:guideFinished()
    end,

    -- 引导被打断
    onBreak = function(id)
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}