require('guide/guide_helper')
local log = logger.get("Game", "guide 10012")

-- 100013 治疗伤兵
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        --log.error(tostring(guide_helper:isGuideComplete(10012)))
        if guide_helper:getItemNum(32004) >= 10000 and guide_helper:getItemNum(32001) >= 10000 and guide_helper:getItemNum(32003) >= 10000 then
            if not guide_helper:getHomeEntityLevel(7) then
                return true
            end
        end
        return false
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()
        local entity_obj = guide_helper:cameraFocusToHomeEntity(13)     --focus to grid 13
        coroutine.yield(WaitForSeconds(0.5))
        guide_helper:waitForceHomeEntityGuide(entity_obj)
        guide_helper:waitForFrame('home_entity_create')
        guide_helper:waitForceButtonGuide('home_entity_create', 'content/Scroll View/Viewport/Content/1')
        guide_manager:onGuideComplete(id)
        coroutine.yield(WaitForSeconds(1))

        guide_helper:waitDialogFinished(10004)

        guide_helper:waitGuideSpriteShow(Vector3(-487, 128, 0))
        guide_helper:guideSpriteDialog(frame_helper:getLangCfg('guide_34'))
        guide_helper:waitAnyTouch()
        guide_helper:guideSpriteDialog(nil)
        guide_helper:waitGuideSpriteHide()
        entity_obj = guide_helper:cameraFocusToHomeEntity(13) 
        game_state_home.home_map:onClickEntity(13)
        
        --coroutine.yield(WaitForSeconds(0.1))
        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_23")
        guide_helper:waitForFrame('home_hospital')
        coroutine.yield(WaitForSeconds(1.0))
        guide_helper:waitForceButtonGuide('home_hospital', 'content/sss/cureBtn')
        coroutine.yield(WaitForSeconds(1))
        guide_helper:waitDialogFinished(10006)
        --guide_helper:waitForceHomeEntityBubbleGuide(entity_obj)
        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
