require('guide/guide_helper')
local log = logger.get("Game", "guide 10002")

-- 100002 号引导    引导玩家晋升觉醒一个英雄
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        
        local level = guide_helper:getHeroQuality(41)
        local item1 = guide_helper:getItemNum(33018)
        --local item2 = guide_helper:getItemNum(33026)

        log.info('promotion level = '..level)
        if level == 1 and item1 >= 10 then
            return true
        else
            frame_manager:show('hero_list') --不加这个材料不足点了没反应
            return false
        end
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()
        guide_helper:waitDialogFinished(359)
        -- 点车队
        coroutine.yield(guide_helper:waitForceButtonGuide('home', 'new/buttomLeft/bg/layout/carBtn'))
    
        -- 等待界面开启
        coroutine.yield(guide_helper:waitForFrame('hero_list'))    
        --log.error('111')
        -- 定位到摩西
        local hero_elem = guide_helper:heroListFocusTo(41)
        if not hero_elem then
            -- 没有找到这个英雄
            guide_manager:onGuideBreak()
            return
        end

        -- 等待用户点击英雄图标
        coroutine.yield(guide_helper:waitForceHeroGuide(hero_elem))

        -- 等待开启 officer 界面
        coroutine.yield(guide_helper:waitForFrame('officer'))  
        
        --点击切换到英雄
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Left/Switch'))

        --点击晋升
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Right/OfficerNode/PromotePanel/PromoteBtn'))

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
