require('guide/guide_helper')
local log = logger.get("Game", "guide 10002")

-- 100003 号引导    引导玩家觉醒并升星一个英雄
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        
        local a,b = guide_helper:getHeroAwakeLevel(17)
            if a == 0 and b == 0 then   --17号英雄星级为0，觉醒等级为0
                if guide_helper:getItemNum(120044) >= 20 then
                    return true
                else
                    return false
                end
            end
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()

        -- 点车队
        coroutine.yield(guide_helper:waitForceButtonGuide('home', 'new/buttomLeft/bg/layout/carBtn'))
    
        -- 等待界面开启
        coroutine.yield(guide_helper:waitForFrame('hero_list'))    
        --log.error('111')
        -- 定位到摩西
        local hero_elem = guide_helper:heroListFocusTo(17)
        if not hero_elem then
            -- 没有找到这个英雄
            guide_manager:onGuideBreak()
            return
        end

        -- 等待用户点击英雄图标
        coroutine.yield(guide_helper:waitForceHeroGuide(hero_elem))

        -- 等待开启 officer 界面
        coroutine.yield(guide_helper:waitForFrame('officer'))  
        
        --点击切换到英雄
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Left/Switch'))

        --点击觉醒页签
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Right/OfficerNode/ButtonAwake'))

        --以后这段绝壁要改
        for i = 1, 4 do
            coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Right/OfficerNode/AwakePanel/AwakeBtn'))
            coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/AwakeResult/Frame/AwakeConfirm'))
        end

        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Right/OfficerNode/ButtonTalent'))

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
