require('guide/guide_helper')
local log = logger.get("Game", "guide 10002")

-- 100004 号引导，引导玩家研究科技
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        if guide_helper:getHomeEntityLevel(2) >= 1 then
            return true
        else
            return false
        end
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()

        -- 攝像機移到目標上
        local entity_obj = guide_helper:cameraFocusToHomeEntity(2)
        
        -- 等待用戶點擊 home entity
        coroutine.yield(guide_helper:waitForceHomeEntityGuide(entity_obj))

        -- 等待用戶點擊升級按鈕
        coroutine.yield(guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/Button (3)"))

        -- 等待开启科技界面
        coroutine.yield(guide_helper:waitForFrame('home_entity_research'))

        --点击战斗类别
        coroutine.yield(guide_helper:waitForceButtonOnClickGuide('home_entity_research', 'content/base_trans/layout/tplt (2)'))
        
        --点击全体攻击
        coroutine.yield(guide_helper:waitForceButtonOnClickGuide('home_entity_research', 'content/detail_trans/Scroll View/Viewport/Content/icons/1/icon'))
        
        coroutine.yield(guide_helper:waitForTransformShow('home_entity_research', 'upgrade_trans'))
        
        coroutine.yield(nil)
        coroutine.yield(guide_helper:waitForceButtonOnClickGuide('home_entity_research', 'upgrade_trans/content/confirmBtn'))

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
