require('guide/guide_helper')
local log = logger.get("Game", "guide 10005")

-- 10005 引导公会内容
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        return true
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()

        if not guide_helper:isInGuild() then    --没公会
            log.info('player not in guild')
            guide_helper:waitDialogFinished(378)
            coroutine.yield(guide_helper:waitForceButtonGuide('guild_apply', 'content/right_bar/Right (1)'))
            guide_helper:waitDialogFinished(377)
            guide_helper:disableScreenMask()
        else    --有公会
            log.info('player in guild')
            coroutine.yield(guide_helper:waitForFrame('guild_info'))    -- 等待有公会的界面打开

            local frame = frame_manager:getFrame('guild_info')      --不知道这时候他是不是已经搬迁过了，那么用有没有搬迁按钮来判断一下
            local button = frame.transform:Find('content/info/layout/move')

            if button.gameObject.activeInHierarchy then
                log.info('player have not moved base yet')
                coroutine.yield(guide_helper:waitForceButtonGuide('guild_info', 'content/info/layout/move'))    --点击搬迁
                coroutine.yield(guide_helper:waitForFrame('guild_move_base'))   --等待搬迁界面打开， WTF 这个东西有个单独的frame
                coroutine.yield(guide_helper:waitForceButtonGuide('guild_move_base', 'BG/OK'))  --点击确定搬迁
            else
                log.info('player already moved base')
            end
            -- 关闭屏幕遮罩
            guide_helper:disableScreenMask()
            -- 引导完成
            guide_manager:onGuideComplete(id)
        end


    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
