require('guide/guide_helper')
local log = logger.get("Game", "guide 10015")

-- 100015   消灭普通怪物引导
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        return true    
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()
        --一堆话
        guide_helper:waitDialogFinished(350)
        --点击打开世界地图 
        coroutine.yield(guide_helper:waitForceButtonGuide('home', 'new/buttomLeft/bg/homeBtn'))
        
        --等待世界地图界面打开
        coroutine.yield(guide_helper:waitForFrame('worldMap'))

        --等待世界地图基地加载完成
        --coroutine.yield(guide_helper:waitForPlayerHold())

        --点击搜索按钮
        coroutine.yield(guide_helper:waitForceButtonGuide('worldMap', 'new/buttomRight/SearchBtn'))

        --等待搜索界面打开
        coroutine.yield(guide_helper:waitForFrame('world_map_search'))
        --log.error('wait for search panel')

        --log.error(tostring(search_info:isSearched()))
        -- while not search_info:isSearched() do     --等待搜索界面数据填充
        --     log.error('wait for search data')
        --     coroutine.yield(nil)
        -- end

        --log.error('data loaded')
        --等待用户点击搜索按钮 ！！！！！！注意这个地方如果周围的怪不是1级的那么就雪崩了，但是请不要找我修复这个bug，找配置地图的策划去
        coroutine.yield(guide_helper:waitForceButtonGuide('world_map_search', 'BG/Bottom/Search'))

        guide_helper:waitDialogFinished(351)

        --等待点击怪物
        guide_helper:waitForceMonsterGuide()

        --等待怪物界面开启
        coroutine.yield(guide_helper:waitForFrame('world_monster_info'))

        --click battle
        coroutine.yield(guide_helper:waitForceButtonGuide('world_monster_info', 'BG/Buttons/FightBtn'))

        --wait for choosing destination frame
        coroutine.yield(guide_helper:waitForFrame('select_hold'))
        
        coroutine.yield(own_hold_info:waitFrameOpened())

        --chose first starting point
        coroutine.yield(guide_helper:waitForceButtonGuide('select_hold', 'BG/Scroll View/Viewport/Content/1/Image/Panel/hold_1/Button'))

        --wait for formation frame
        coroutine.yield(guide_helper:waitForFrame('formation_attack_mst'))

        --click new troop button
        coroutine.yield(guide_helper:waitForceButtonGuide('formation_attack_mst', 'BG/Content/Scroll View/Viewport/Content/Add/AddPanel'))
        
        --wait for detailed formation frame
        coroutine.yield(guide_helper:waitForFrame('world_formation_adjust'))

         --click choose formation
         coroutine.yield(guide_helper:waitForceButtonGuide('world_formation_adjust', 'BG/FormationBtn'))

         --wait for formation type select
        coroutine.yield(guide_helper:waitForFrame('formation_select'))

        guide_helper:waitDialogFinished(379)    --need to change
        
        frame_manager:hide('formation_select')

        --quick formation
        coroutine.yield(guide_helper:waitForceButtonGuide('world_formation_adjust', 'BG/Quick'))

        --coroutine.yield(WaitForSeconds(1.0))

        -- fight
        coroutine.yield(guide_helper:waitForceButtonGuide('world_formation_adjust', 'BG/Confirm'))
        coroutine.yield(guide_helper:waitForceButtonGuide('formation_attack_mst', 'BG/Depart'))

        guide_helper:waitDialogFinished(380)    --need to change
        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()
        -- 引导完成
        guide_manager:onGuideComplete(id)

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
