require('guide/guide_helper')
local log = logger.get("Game", "guide 10019")

-- 10019 号引导 引导玩家强化武器
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        return true
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()
        guide_helper:waitDialogFinished(358)    --介绍武器强化
        -- 点车队
        coroutine.yield(guide_helper:waitForceButtonGuide('home', 'new/buttomLeft/bg/layout/carBtn'))
    
        -- 等待界面开启
        coroutine.yield(guide_helper:waitForFrame('hero_list'))    
        --log.error('111')
        -- 定位到41好英雄
        local hero_elem = guide_helper:heroListFocusTo(41)
        if not hero_elem then
            -- 没有找到这个英雄

            guide_manager:onGuideBreak()
            return
        end
        
        -- 等待用户点击英雄图标
        coroutine.yield(guide_helper:waitForceHeroGuide(hero_elem))

        -- 等待开启 officer 界面
        
        coroutine.yield(guide_helper:waitForFrame('officer'))  
        
        -- 点右侧的武器
        --log.error('1')
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Right/TankInfo/Info/Weapons/Weapon (0)/Grade'))
        --log.error('2')
        -- 点强化
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/EquipInfo/WeaponInfo/Buttons/ButtonUpgrade'))

        -- 等待界面开启
        coroutine.yield(guide_helper:waitForFrame('weapon_upgrade'))  

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
