require('guide/guide_helper')
local log = logger.get("Game", "guide 10020")

-- 10020 号引导 造个工厂
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        return true
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id

        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()
        guide_helper:waitDialogFinished(360)    --介绍为何要早工厂
        
        --点击打开世界地图
        coroutine.yield(guide_helper:waitForceButtonGuide('home', 'new/buttomLeft/bg/homeBtn'))

        --等待世界地图界面打开
        coroutine.yield(guide_helper:waitForFrame('worldMap'))

        --点击搜索按钮
        coroutine.yield(guide_helper:waitForceButtonGuide('worldMap', 'new/buttomRight/SearchBtn'))

        --等待搜索界面打开
        coroutine.yield(guide_helper:waitForFrame('world_map_search'))

        --点击资源页签
        coroutine.yield(guide_helper:waitForceButtonGuide('world_map_search', 'BG/Pages/Page3'))

        --点击搜索
        coroutine.yield(guide_helper:waitForceButtonGuide('world_map_search', 'BG/Bottom/Search'))

        --自己造吧
        guide_helper:waitDialogFinished(361)

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
