require('guide/guide_helper')
local log = logger.get("Game", "guide 21")

-- 2 号引导
return 
{
    -- 进行的额外条件，比如资源是否够
    condition = function()
        return false
    end,

    -- 执行过程，在协程中执行
    proc = function()
        local id = guide_manager.running_guide_id
        log.error('guide 21')
        -- 开启屏幕遮罩
        guide_helper:enableScreenMask()

        -- 点车队
        coroutine.yield(guide_helper:waitForceButtonGuide('home', 'new/buttomLeft/bg/layout/carBtn'))
    
        -- 等待界面开启
        coroutine.yield(guide_helper:waitForFrame('hero_list'))    
        --log.error('111')
        -- 定位到摩西
        local hero_elem = guide_helper:heroListFocusTo(17)
        if not hero_elem then
            -- 没有找到这个英雄

            guide_manager:onGuideBreak()
            return
        end

        -- 等待用户点击英雄图标
        coroutine.yield(guide_helper:waitForceHeroGuide(hero_elem))

        -- 等待开启 officer 界面
        coroutine.yield(guide_helper:waitForFrame('officer'))  
        
        -- 点右侧的武器
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/Right/TankInfo/Info/Weapons/Weapon (0)/Grade'))

        -- 点更换
        coroutine.yield(guide_helper:waitForceButtonGuide('officer', 'BG/EquipInfo/WeaponInfo/Buttons/ButtonChange'))

        -- 等待界面开启
        coroutine.yield(guide_helper:waitForFrame('changeEquipment'))  

        -- 更换装备界面，点击武器
        coroutine.yield(guide_helper:waitForceChangeEquipClickGuide(233))

        coroutine.yield(guide_helper:waitForceButtonGuide('changeEquipment', 'DetailInfo/Bottom/ChangeBtn'))

        coroutine.yield(guide_helper:waitForceButtonGuide('changeEquipment', 'BG/Top/HomeBtn'))

        -- 关闭屏幕遮罩
        guide_helper:disableScreenMask()

        -- 引导完成
        guide_manager:onGuideComplete(id)

    end,

    -- 引导被打断
    onBreak = function(id)
        guide_helper:disableScreenMask()
    end,

    -- 引导完成回调
    onComplete = function(id)
    end,
}
