
-- 辅助操作 avatar 的函数集
local uobject = class {
    ctor = function (self, base)
        self.__base = base
    end, 

    get_bone_pos = function (self, bone)
        return self:GetBonePosition(string.cache(bone))
    end, 

    bind = function (self, bone, obj, rot, once)
        -- 利用索引规避字符串传递
        if type(rot) == "table" then 
            return self:Bind(string.cache(bone), obj, true, rot[1], rot[2], rot[3], once or false)
        end
        return self:Bind(string.cache(bone), obj, rot or false, 0, 0, 0, once or false)
    end, 
}

return {
    new = function (gameObject, mainAssetPath, partAssetPaths)
        local model = uobject.new(Fenix.Game.Unity.AvatarActor.Create(gameObject, mainAssetPath))
        for _, partAssetPath in ipairs(partAssetPaths) do 
            model:Combine(partAssetPath)
        end
        return model
    end
}