ZZXY_RebuildConfig = function (configTypeMap, tm)
    for configName, configType in pairs(configTypeMap) do
        -- print("import", configName)
        if configType == 0 then
            local map = {}
            local data = gConfig[configName]
            local wrap = {}
            for index, name in ipairs(tm[configName]) do 
                map[name] = index
            end
            setmetatable(wrap, {
                __index = function (self, key_i)
                    return data[map[key_i]]
                end, 
            })
            config[configName] = wrap
        elseif configType == 2 or configType == 1 then
            -- key/value or index 形式索引
            local map = {}
            local data = gConfig[configName]
            local wrap = {
                foreach = function (self, callback)
                    if configType == 2 then 
                        for _k, _v in pairs(data) do 
                            callback(_k, self[_k])
                        end
                    else
                        for _k, _v in ipairs(data) do 
                            callback(_k, self[_k])
                        end
                    end
                end, 

                -- 是否包含字段
                containsField = function(self, field_name)
                    return map[field_name]
                end,
            }
            for index, name in ipairs(tm[configName]) do 
                map[name] = index
            end
            local containsField = function(field_name)
                return map[field_name]
            end
            local record_meta = {
                __index = function (self_t, key_t)
                    if key_t == 'containsField' then
                        return containsField
                    end
                    
                    local key_index = map[key_t]
                    if key_index == nil then 
                        logger.warn(string.format("no such field: %s in config: %s\n%s", tostring(key_t), configName, debug.traceback()))
                        return nil
                    end

                    return rawget(self_t, key_index)
                end, 
            }
            setmetatable(wrap, {
                __index = function (self, key_i)
                    local record = data[key_i]
                    if record == nil then 
                        --logger.warn(string.format("no such id: %s in config: %s\n%s", tostring(key_i), configName, debug.traceback()))
                        return nil
                    end
                    if getmetatable(record) == nil then
                        setmetatable(record, record_meta)
                    end
                    return record
                end, 
            })
            config[configName] = wrap
        end
    end
end
