
local log = logger.get("Game", "Res Checker")

require('config.whitelist')
require('config.asset_filter')

-- 检查使用的资源
checkUsingResources = function(self)
    log.info("#### checkUsingResources!!")


    -- 将一张表的某个字段资源设置为已使用
    function setUsedRes(cfg_tab, path_field, name_field, type)
        cfg_tab:foreach(
            function(k, line)
                local path = line[path_field] 
                if not path then
                    log.error("failed to find path field:"..path_field)
                    path = ""
                end

                if name_field ~= "" then
                    local name = line[name_field]
                    if not name then
                        log.error("failed to find name field:"..name_field)
                    else
                        path = path .. name
                    end
                end

                UsingResourceChecker.setResUsed(path, type)
            end
        )
    end

    -- 已使用资源配置表，搜集所有已使用的资源
    config.asset_filter_attrs:foreach(
        function(k, line)
            log.info("check #"..k.." path_field:"..line.asset_path.." name_field:"..line.asset_path_name)
            setUsedRes(line.sheet_name, line.asset_path, line.asset_path_name, line.type)
        end
    )

    -- 界面 prefab
    local frame_manager = require('gui.frame_manager')
    for k,v in pairs(frame_manager.data) do
        UsingResourceChecker.setResUsed(v.v.path, 9)
    end

    -- 程序用资源
    local res_tab = require('gui.tool.res_path')
    for k,v in pairs(res_tab) do
        UsingResourceChecker.setResUsed(v, 9)
    end

    UsingResourceChecker.DoCheck()
end

checkUsingResources()

