local log = logger.get("Game", "LevelActor")

-- 关卡角色
return class {
    ctor = function(self, cfg_id, team, id, pos, rot, obstacle_size, events, root, entity_type)

        self.anim_names =       -- 动画名称配置 
        {
            idle = 'idle',
            move = 'run',
            stop = 'stop',
            attack = 'attack',
            die = 'die',
        }   

        self.team = team
        self.id = id
        --[[地图实体类型
        enum MAP_ENTITY_TYPE
        {
            MET_PLAYER = 1;
            MET_NPC = 2;
            MET_MONSTER = 3;
            MET_MINE = 4;	
            MET_EVENT = 5;
        }]]
        self.entity_type = entity_type   
        self.cfg_id = cfg_id
        self.obstacle_size = obstacle_size
        self.events = events
        self.is_initialized = false
        self.is_paused = true
        self.is_destroyed = false
        self.gameObject = nil

        self:initCfg()
        self:init(pos, rot, root)
    end,

    -- 子类分别初始化配置及相关参数
    initCfg = function(self)
    end,

    -- 初始化,加载资源，创建 cs 实例
    init = function(self, pos, rot, root)
    end, 

    -- 资源加载完成回调
    onResLoaded = function(self)
    end,

    setPaused = function(self, paused)
        self.is_paused = paused
    end,

    disappear = function(self, callback)
        if callback then
            callback()
        end
    end,

    -- 销毁该对象
    destroy = function (self)
        self.is_destroyed = true
        if self.is_initialized then 
            self.is_initialized = false
            self.events:dispatch("actor_unloaded", self)
        end

        if self.gameObject then
            self.gameObject:destroy()
        end
    end, 

    getPosition = function(self)
        return self.transform.position
    end,
    
    -- 与玩家发生交互
    interactWithPlayer = function(self, player)
        
    end,

    -- 玩家向我移动了
    onPlayerMoveToMe = function(self)
    end,
}