local super = require('level.level_tank')
local log = logger.get("Game", "LevelAward")

return class{
    super = super,
    
    initCfg = function (self)
        self.cfg = config.game_copy_random_events[self.cfg_id]
        if self.cfg == nil then
            -- 找不到配置
            log.error('config.game_copy_random_events 中找不到配置:'..tostring(self.cfg_id))
            return
        end
        self.prefab_path = self.cfg.Para3
        --log.error("wtf???", self.prefab_path, self.entity_type)
    end, 

    onResLoaded = function(self, pos, rot)
        local go = self.gameObject
        go.name = "award_" .. self.id
        go.layer = core.layers["Tank"]
        log("创建了随机事件奖励对象", self.id, self.cfg_id)
        self.cs_inst = self.gameObject:GetComponentInChildren(UnityEngine.Collider, true).gameObject:AddComponent(LevelMonster)
        self.transform = self.cs_inst.transform
        self.transform.position = pos
        self.transform.rotation = rot
        
        self.__base = self.cs_inst
        self.cs_inst:Init(common_pb.MET_MINE, self.team, self.id, self.obstacle_size,
            function () 
                self.touch_player = true
                self.events:dispatch("entity_touch_player_evt", self)
            end, 
            function ()
                self.touch_player = false
            end)
    end,

    -- 与玩家发生交互
    interactWithPlayer = function(self, player)
        network_sender:levelInteraction(level_info.map_id, self.id)
    end,

}