local log = logger.get("Game", "LevelOperationTrigger")

return class {
    ctor = function(self, id, operation_type, point_id, op_callback)
        self.id = id
        self.operation_type = operation_type
        self.point_id = point_id
        self.op_callback = op_callback  -- 用户在 trigger 范围内操作的回调
        self.is_interacted = false         -- 是否和用户交互过了
        self:reload()
    end,

    reload = function(self)

    end,

    -- 玩家在区域内按了交互按钮
    interactWithPlayer = function(self, player)
        if self.op_callback then
            self.op_callback(self)
        end

        if not self.is_interacted then
            self.is_interacted = true
        end
    end,

    destroy = function(self)
        if level.player.operation_trigger == self then
            level.player:setTouchingOpTrigger(nil)
        end

        if self.go then
            self.go:destroy()   
        end
    end,

}