local log = logger.get("Game", "LevelScript 1006")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")
local rts_soldier = require('RTS.rts_soldier')

local gate = nil
local gate_1 = nil
local is_gate_destroyed = false
local is_gate_1_destroyed = false
local is_chest_1_collected = false
local is_chest_2_collected = false
local chest_1 = nil
local chest_2 = nil
local op_10 = false
local op_12 = false
local camp1, camp2 = nil

local battle_count = 0
-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用

local phase_100 = class{
    super = phase_base,

    onEnter = function(self)
        -- --log.error('111')
        -- local soldier = self.level_script:createGameObject(self.level_script.prefabs.soldier, 432.9, 1, -106, 0 , 1)
        -- local go = soldier.transform.gameObject

        -- self.cs_inst = go:GetComponentInChildren("Soldier")
        -- if self.cs_inst then
        --     log.error('YES!!')
        -- else
        --     log.error('self.cs_inst not exist')
        -- end
        -- --self.cs_inst:PlayAnimation(rts_soldier.getAnimPostfix(self).."run")

        local camp1 = self.level_script:createGameObject(self.level_script.prefabs.churchill, 332.2, 4.06, -157.4, 0, 1, function(go)
            go:setHeadIcon("Assets/Prefab/Level/Texture/exclamation.png")
        end)
    end,
}

local phase_0 = class{
    super = phase_base,

    onEnter = function(self)

        local dialog_finished = function()
            local hide_cb = function()
                level_script:changePhase('phase_1')
            end

            game_state_level.gui:hideFullScreenDialog(hide_cb)
        end

        local type_cb = function()
            local text = 'Everything that lives is designed to end.\n\n We are perpetually trapped in a never-ending spiral of life and death.\n\n Is this a curse?\n\n Or some kind of punishment?'
            game_state_level.gui:setFullScreenDialogText(text, dialog_finished)
        end

        game_state_level.gui:showFullScreenDialog(type_cb)
    end,
}
--第一个阶段，从进入关卡到与NPC对话完成
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)

        local dialog100101 = function()
            if not guide_manager:isGuideComplete(10013) then
                guide_manager:_doGuide(10013)
            end
        end
        self.level_script:playDialog(100101,dialog100101)
        
    --   
    --    --emp_manager:showAimFrame()
    --    local cam = self.level_script:findGameObject('MainCamera')
    --    local cannon_left = self.level_script:createGameObjectAttach(self.level_script.prefabs.cannon, cam, 'left', 0.8)
    --    local cannon_right = self.level_script:createGameObjectAttach(self.level_script.prefabs.cannon, cam, 'right', 0.8)

    --    app:startCoroutine(
    --        function()
    --             for i = 1, 10 do
    --                 self.level_script:shootBullet(10010, cannon_left:findChild('shoot'), self.level_script:getPlayerPos(), 100)
    --                 self.level_script:wait(0.3)
    --                 self.level_script:shootBullet(10010, cannon_right:findChild('shoot'), self.level_script:getPlayerPos(), 100)
    --                 self.level_script:wait(0.3)
    --             end
    --        end
    --    )
    --SoundEngine.PostEvent("Play_BGM_courage", self.gameObject)
    end,

    onEnterPoint = function(self, point_id)

        if point_id == 5 and is_gate_1_destroyed == false then

            local destory_gate = function(var)
                app:startCoroutine(
                    function()
                        self.level_script:setPathPointType(5,0)
                        if var == 1 then    --boom gate
                            for i = 1, 3 do
                                self.level_script:playerShootBullet(10010, gate_1.transform.position, 120)
                                SoundEngine.PostEvent("Play_missile_launch", self.gameObject)
                                self.level_script:wait(0.2)
                                if i == 3 then
                                    self.level_script:wait(0.5)
                                    gate_1:playAnimation('boom')
                                    SoundEngine.PostEvent("Play_destroy_concrete", self.gameObject)
                                    self.level_script:incQuestProgress(16,1)
                                    self.level_script:removeGameObject(gate_1)
                                    self.level_script:entityMoveTo(81, Vector3.New(43,0,-269) ,300)
                                    self.level_script:wait(1)
                                    self.level_script:battleWithMonster(81)
                                    level_script:changePhase('phase_2')
                                end
                            end
                        elseif var == 2 then    --dismantle gate
                            hint:setText(frame_helper:getLangCfg('guide_36'))
                            gate_1:playAnimation('boom')
                            SoundEngine.PostEvent("Play_destroy_concrete", self.gameObject)
                            self.level_script:incQuestProgress(16,1)
                            level_script:changePhase('phase_2')
                            self.level_script:wait(3)
                            self.level_script:removeGameObject(gate_1)
                        end
                        is_gate_1_destroyed = true
                    end
                )
            end

            self.level_script:showDialogOption('level_script_130', {'level_script_131', 'level_script_132'}, destory_gate)

        elseif point_id == 1 then
            --guide_manager:_doGuide(10011)
        end
    end,
}

local phase_2 = class{
    super = phase_base,

    onEnter = function(self)
        log.info('enter p2')

        local Op10 = function()
            op_10 = true
            self.level_script:incQuestProgress(17,1)
            --TODO dialog
            self.level_script:removeOpTrigger(1)
            camp1:setHeadIcon(nil)            
            self.level_script:playDialog(100102)
            if op_10 == true and op_12 == true then
                self.level_script:setPathPointType(13,0)
                level_script:changePhase('phase_3')
            end
        end

        local Op12 = function()
            op_12 = true
            --TODO dialog
            self.level_script:incQuestProgress(17,1)
            self.level_script:removeOpTrigger(2)
            camp2:setHeadIcon(nil)
            self.level_script:playDialog(100103)
            if op_10 == true and op_12 == true then
                self.level_script:setPathPointType(13,0)
                level_script:changePhase('phase_3')
            end
        end
        camp1 = self.level_script:createGameObject(self.level_script.prefabs.dummy, 236.74, 4.06, -55.06, 0, 1, function(go)
            go:setHeadIcon("Assets/Prefab/Level/Texture/exclamation.png")
        end)
        camp2 = self.level_script:createGameObject(self.level_script.prefabs.dummy, 69.27, 4.06, 23.82, 0, 1, function(go)
            go:setHeadIcon("Assets/Prefab/Level/Texture/exclamation.png")
        end)

        self.level_script:createOpTrigger(1, 7, 10, Op10)
        self.level_script:createOpTrigger(2, 7, 12, Op12)
    end,

    onEnterPoint = function(self, point_id)
        app:startCoroutine(
            function()
                if point_id == 10 or point_id == 12 then
                    guide_manager:_doGuide(10014)
                elseif point_id == 13 then
                    self.level_script:playDialog(100104)
                end
            end
        )
    end,
}

local phase_3 = class{
    super = phase_base,

    onEnter = function(self)
        log.info('enter p3')
        self.level_script:showEntity(84)
    end,

    onEnterPoint = function(self, point_id)
        if point_id == 19 then
            self.level_script:incQuestProgress(18,1)
            app:startCoroutine(
                function()
                    self.level_script:wait(1)
                    local dialog374 = function()
                        --SoundEngine.PostEvent("Play_BGM_Fallout4", self.gameObject)
                        self.level_script:finishLevel(true)
                    end
                    self.level_script:playDialog(100105, dialog374)
                end
            )
        elseif point_id == 15 then
            --guide_manager:_doGuide(10013)
        end
    end,
}

local phase_99 = class{
    super = phase_base,

    onEnter = function(self)
        log.error('enter')
        local X = 9999  --total queue time
        local Y = 300   --waste no more than Y seconds of time

        local S1 = 60   --1 min speed up
        local S2 = 180  --3 mins
        local S3 = 600  --10m
        local S4 = 1800 --30m
        local S5 = 3600 --60m

        local A1 = 5
        local A2 = 10
        local A3 = 3
        local A4 = 2
        local A5 = 1

        local S = {S1, S2, S3, S4, S5}
        local A = {A1, A2, A3, A4, A5}

        log.error('rec define')
        local rec = function(X, N)
            if S[N] > X + Y then
                rec(X, N-1)
            else
                local Z = X / S[N]
                Z = Z - Z%1 --int
                if Z >= A[N] then
                    log.error('Use '..S[N]..' sec speed up * '..A[N])
                    X = X - A[N] * S[N]
                    if X <= 0 then
                        return
                    end
                    rec(X, N-1)
                else
                    log.error('Use '..S[N]..' sec speed up * '..Z)
                    X = X - Z * S[N]
                    if X <= 0 then
                        return
                    end
                    rec(X, N-1)
                end
            end
        end

        log.error('run func')
        rec(X, 5)
    end,
}
-- 关卡 1006 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)
        self:myInit()
        self:addPhases("phase_100", phase_100(self))
        self:addPhases("phase_0", phase_0(self))
        self:addPhases("phase_1", phase_1(self))
        self:addPhases("phase_2", phase_2(self))
        self:addPhases("phase_3", phase_3(self))
        self:addPhases("phase_99", phase_99(self))
        self:changePhase("phase_1")
        --log.error('11111')
    end,

    myInit = function(self)

        self.prefabs = {
            churchill = 'Assets/Prefab/Level/level_prefab_kv2.prefab',     --丘吉尔坦克，解救英雄时用到
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            repair_kit = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Battery.prefab',   --修复桥梁的物品
            boom = 'Assets/Prefab/Level/level_boom.prefab',
            gate = 'Assets/Prefab/Level/level_prefab_door.prefab',
            chest = 'Assets/Prefab/Level/level_chest.prefab',
            cannon = 'Assets/Prefab/Level/level_cannon.prefab',
            soldier = 'Assets/Prefab/Level/level_soldier.prefab',
            dummy = 'Assets/Prefab/Level/level_camp_dummy.prefab',
        }

        -- 预加载
        app:startCoroutine( 
            function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)

        --gate at the enterance
        --gate = self:createGameObject(self.prefabs.gate, 286.4594, 0, -188.7262, -10.453, 0.4858581)
        gate_1 = self:createGameObject(self.prefabs.gate, 26.16, -0.2, -258.59, 34.436, 0.5077926)

        --chest 1
        chest_1 = self:createGameObject(self.prefabs.chest, 75.9, -2, -219.4, -58.042, 1)
        chest_2 = self:createGameObject(self.prefabs.chest, 286.3, -2, 273.5, -58.042, 1)
        --patrol
        --self:beginOrderPatrol(81,{6,5},400)
        self:beginOrderPatrol(82,{8,9,10,9},400)
        self:beginOrderPatrol(83,{11,12,13,12},400)

        self:hideEntity(84)     --hide boss
    end,

    onEnterPoint = function(self, point_id)
        super.onEnterPoint(self, point_id)
        app:logEvent("level_enter_point_1001_"..tostring(point_id), tostring(point_id))
        if point_id == 17 and is_chest_1_collected == false then
            --hint:setText('地上似乎有东西闪闪发光')
            --guide_manager:_doGuide(10008)
        elseif point_id == 16 and is_chest_2_collected == false then
            --hint:setText('这里的地上似乎也有什么东西')
            --guide_manager:_doGuide(10009)
        end
    end,

    onUseShovel = function(self, point_id)
        app:startCoroutine(
            function()
                if point_id == 17 and is_chest_1_collected == false then
                    is_chest_1_collected = true
                    SoundEngine.PostEvent("Play_ui_click", self.gameObject)
                    self:getGiftBagReward(13)
                    self:removeGameObject(chest_1)
                    --TODO use server reward
                elseif point_id == 16 and is_chest_2_collected == false then
                    is_chest_2_collected = true
                    SoundEngine.PostEvent("Play_ui_click", self.gameObject)
                    self:getGiftBagReward(14)
                    self:removeGameObject(chest_2)
                else
                    self:wait(1)
                    hint:setText(frame_helper:getLangCfg('level_script_159'))
                end
            end
        )
    end,

    onBattleWin = function(self, battle_id)
        super.onBattleWin(self, battle_id)
        --log.error('battle count = '..battle_count)
        battle_count = battle_count + 1

        if battle_count == 2 then
            --guide_manager:_doGuide(10010)
        elseif battle_count == 4 then
            
        end
    end,

    onEnterTrigger = function(self, trigger_name)
        super.onEnterTrigger(self, trigger_name)
        --log.error('enter')
        if trigger_name == 'Trigger01' then
            local gate = self:findGameObject('zha@work (1)')
            -- local light = self:findGameObject('light')
            -- light:SetActive(true)
            self:sceneGameObjectPlayAnimation(gate, 'work')
        end
    end,

    onExitTrigger = function(self, trigger_name)
        super.onExitTrigger(self, trigger_name)
        --log.error('exit')
        if trigger_name == 'Trigger01' then
            local gate = self:findGameObject('zha@work (1)')
            -- local light = self:findGameObject('light')
            -- light:SetActive(false)
            self:sceneGameObjectPlayAnimation(gate, 'close')
        end
    end,
}