local log = logger.get("Game", "LevelScript 1002")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")


-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用

local treasure_map_progress = 0
local update_count = 0
local chest_1 = nil
local energy = nil


-- *************NOTICE*****************
--
-- this phase is used for testing only!!
--
-- *************NOTICE*****************

local phase_0 = class{
    super = phase_base,

    onEnter = function(self)
        
        app:startCoroutine(
            function()
                log.error('天哪！有个傻逼用了不该用的phase')
                self.level_script:wait(1)
                self.level_script:playerMoveTo(Vector3.New(-349,3.1,228.2), 600)
                self.level_script:wait(2)
                log.error('start find')
                self.level_script:playerFindNearestPathPoint()
                log.error('found')
                level_script:changePhase('phase_3')
            end
        )
        
    end,
}
--第一个阶段，进入关卡，发现利维坦，赋予玩家寻找动力系统位置的使命
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)
        --self.level_script:finishLevel(true)
        SoundEngine.PostEvent("Play_BGM_courage", self.gameObject)

        local dialog324 = function()
            app:startCoroutine(
                function()
                    game_state_level.gui:showTreasureMapButton()
                    self.level_script:wait(0.1)
                    treasure_map_progress = treasure_map_progress + 1
                    game_state_level.gui:updateTreasureMapProgress(treasure_map_progress)
                    guide_manager:_doGuide(10018)
                    level_script:changePhase('phase_2')
                end
            )
        end

        local chooseCB = function()
            app:startCoroutine(
                function()
                    --hint:setText('开始搜索')
                    SoundEngine.PostEvent("Play_ui_switch", self.gameObject)
                    local cam = game_state_level.level_manager.levelCamera
                    local look_target = cam.transform.position - cam.m_Offset 
                    local new_offset = cam.m_Offset * 2
                    new_offset.z = new_offset.z * 0.2
                    cam:LookPosWithOffset(look_target, new_offset)
        
                    self.level_script:changeCameraFov(45)   --初始为31
                    game_state_level.level_manager.fogOfWar.gameObject:SetActive(false)

                    --hide level frame
                    local level_frame = frame_manager:getFrame('level')
                    if level_frame then
                        --level_frame.transform:SetActive(false)
                        frame_helper.hideTrans(level_frame.transform)
                    end

                    frame_manager:show('emp_aim')
                    local vsb1, frame = frame_manager:isDisplay('emp_aim')
                    if vsb1 then
                        frame:addCommandBuff(function()
                            frame:showSearchFrame()
                        end)
                    end
                    self.level_script:wait(3)

                    cam:LookPosWithOffset(Vector3.New(-161, 0, 65), new_offset)
                    SoundEngine.PostEvent("Play_ui_confirm", self.gameObject)
                    self.level_script:wait(1.1)
                    cam:LookPosWithOffset(Vector3.New(-90, 0, -125), new_offset)
                    SoundEngine.PostEvent("Play_ui_confirm", self.gameObject)
                    self.level_script:wait(1.1)
                    cam:LookPosWithOffset(Vector3.New(-301, 0, -198), new_offset)
                    SoundEngine.PostEvent("Play_ui_confirm", self.gameObject)
                    self.level_script:wait(1.1)
                    cam:LookPosWithOffset(Vector3.New(-314, 0, 103), new_offset)
                    SoundEngine.PostEvent("Play_ui_confirm", self.gameObject)
                    self.level_script:wait(1.1)
                    cam:LookPosWithOffset(Vector3.New(-381, 0, 281), new_offset)
                    SoundEngine.PostEvent("Play_ui_confirm", self.gameObject)
                    self.level_script:wait(1.1)
                    cam:LookPosWithOffset(Vector3.New(-516, 0, 350), new_offset)
                    SoundEngine.PostEvent("Play_ui_award", self.gameObject)

                    local vsb, frame = frame_manager:isDisplay('emp_aim')
                    if vsb then
                        frame:searchCarrier()
                    end
                    self.level_script:wait(7)

                    
                    --log.info('search finish')

                    --恢复摄像机
                    look_target = cam.transform.position - cam.m_Offset 
                    cam:LookPosWithOffset(look_target, cam.m_InitOffset)
                    self.level_script:changeCameraFov(31)
                    self.level_script:cameraFocusToPlayer()
                    frame:hideSearchFrame()
                    frame_helper.showTrans(level_frame.transform)
                    game_state_level.level_manager.fogOfWar.gameObject:SetActive(true)

                    self.level_script:wait(1)
                    self.level_script:playDialog(100201, dialog324)
                end
            )
        end

        local dialog319 = function()
            self.level_script:showDialogOption('level_script_116', {'level_script_117'}, chooseCB)
        end
        self.level_script:playDialog(100202, dialog319)
    end,

    onEnterPoint = function(self, point_id)
    end,

    -- onUpdate = function(self, dt)
    --     update_count = update_count + dt
    --     if update_count >= 1 then
    --         update_count = 0
    --         log.error('treasure_map_progress '..treasure_map_progress)
    --     end
    -- end,
}

local phase_2 = class{
    super = phase_base,

    onEnter = function(self)
        --log.error('enter p2')
        game_state_level.gui:showTreasureMapButton()
        chest_1 = self.level_script:createGameObject(self.level_script.prefabs.chest, -23.9, 0, 5.5, 0, 1)
    end,

    onUseShovel = function(self, point_id)
        app:startCoroutine(
            function()
                --log.info('111')
                if point_id == 20 and not self.level_script.find_power then
                    --log.info('222')
                    self.level_script.find_power = true
                    self.level_script:incQuestProgress(19,1)
                    local dialog329 = function()
                        level_script:changePhase('phase_3')
                    end

                    local dialog333 = function()
                        level_script:changePhase('phase_3')
                    end

                    if treasure_map_progress ~= 4 then
                        self.level_script:playDialog(100203, dialog329)
                    else
                        self.level_script:playDialog(100204, dialog333)
                    end
                elseif point_id == 5 and chest_1 then
                    self.level_script:removeGameObject(chest_1)
                    chest_1 = nil
                    self.level_script:getGiftBagReward(20)
                else
                    self.level_script:wait(1)
                    hint:setText(frame_helper:getLangCfg('level_script_159'))
                end
            end
        )
    end,

    onExit = function(self)
        if chest_1 then
            self.level_script:removeGameObject(chest_1)
            chest_1 = nil
        end
    end,

    onBattleWin = function(self, id)
        if id == 85 then
            self.level_script:getGiftBagReward(22)
        end
    end,

    onBattleLose = function(self, id)
        if id == 85 then
            hint:setText(frame_helper:getLangCfg('level_script_155'))
        end
    end,

    onUpdate = function(self, dt)
        update_count = update_count + dt
        if update_count >= 1 then
            update_count = 0
            if treasure_map_progress >= 4 and not energy then
                energy = self.level_script:createGameObject(self.level_script.prefabs.dummy, -226.5, -9, 35.9, 0, 1, function(go)
                    go:setHeadIcon("Assets/Prefab/Level/Texture/exclamation.png")
                end)
            end
        end
    end,

    onEnterPoint = function(self, point_id)
        if point_id == 1 and not self.point_1_done then

            self.point_1_done = true

            local point_1_choice = function(var)    --是否搜索商店
                app:startCoroutine(
                    function()
                        local choice = var

                        if choice == 1 then         --搜索
                            level_info:consumeItem(31005)
                            game_state_level.gui:refreshItemNum()

                            self.level_script:wait(1)
                            hint:setText(frame_helper:getLangCfg('level_script_154'))
                            self.level_script:wait(2)
                            self.level_script:addSupplyItem(31007, 1, '+1')     --一个饼干
                            
                        elseif choice == 2 then     --不搜索
                            
                        end
                    end
                )
            end

            self.level_script:showDialogOption('level_script_121', {'level_script_122', 'level_script_123'}, point_1_choice)

        elseif point_id == 2 and not self.point_2_done then     --npc喊喊话
            self.point_2_done = true
            self.level_script:entityChat(80, 'level_script_124', 5)

        elseif point_id == 20 and treasure_map_progress >= 4 then
            local dialog100208 = function()
                guide_helper:enableScreenMask()
                guide_helper:waitForceButtonGuide('level', 'Bottom Left/ItemBar/Item_3/Icon')
                guide_helper:disableScreenMask()
                guide_helper:guideFinished()
            end
            energy:setHeadIcon(nil) 
            self.level_script:playDialog(100208, dialog100208)
        elseif point_id == 10 and not self.point_10_done then
            --log.error('1002 关卡有人走到了桥上')
            self.point_10_done = true
            self.level_script:playDialog(100205)
        elseif point_id == 13 and not self.point_13_done then
            --log.error('1002 关卡有人走到了集装箱')
            self.point_13_done = true
            local point_13_choice = function(var)
                app:startCoroutine(
                    function()
                        local choice = var
                        math.randomseed(Time.time * 10000)      --在脚本里肆意播放种子
                        if choice == 1 then
                            local dice = nil

                            for i = 1, 10 do
                                dice = math.random(0,100) / 100
                                --log.error(dice)
                            end

                            if dice >= 0.7 then
                                hint:setText(frame_helper:getLangCfg('level_script_156'))
                                --hint:setText('集装箱中突然响起了引擎的轰鸣，随后一阵炫目的光直射在你的脸上')
                                self.level_script:wait(2)
                                hint:setText(frame_helper:getLangCfg('level_script_157'))
                                --hint:setText('远光狗，你大声叫道，全体准备战斗')
                                self.level_script:wait(2)
                                self.level_script:battleWithMonster(85)
                            else
                                self.level_script:wait(1)
                                hint:setText(frame_helper:getLangCfg('level_script_158'))
                                --hint:setText('原来这个集装箱是当地的流氓藏匿宝藏的地点，趁着他们还没回来，你葱葱拿走了几件物品')
                                self.level_script:wait(2)
                                self.level_script:getGiftBagReward(21)
                            end

                        elseif choice == 2 then
                            --溜了溜了
                        end
                    end
                )
            end
            self.level_script:showDialogOption('level_script_125', {'level_script_126', 'level_script_127'}, point_13_choice)
        end
    end,
}

local phase_3 = class{
    super = phase_base,

    onEnter = function(self)
        log.info('enter p3')
        --SoundEngine.PostEvent("Play_BGM_heroic", self.gameObject)
        app:startCoroutine(
            function()
                -- hint:setText('观众老爷这里后面的还没有制作完成，先用文字脑补一下吧')
                -- self.level_script:wait(2)
                -- hint:setText('这里会播放车子开到利维坦上面，随后利维坦启动的内容')
                -- self.level_script:wait(3)
                -- hint:setText('随后出现大量敌人，罗宾教主角使用利维坦主炮将他们大部分消灭')
                -- self.level_script:wait(3)
                -- hint:setText('随后主角与剩下的敌人首领进行一场战斗后关卡结束')
                -- self.level_script:wait(3)
                -- SoundEngine.PostEvent("Play_BGM_Fallout4", self.gameObject)
                -- self.level_script:finishLevel(true)

                self.level_script:wait(1)
                hint:setText('Leviathan is activated!')
                self.level_script:wait(2)

            end
        )
    end,

    -- onUpdate = function(self, dt)
    --     update_count = update_count + dt
    --     if update_count >= 1 then
    --         update_count = 0
    --         log.error('treasure_map_progress '..treasure_map_progress)
    --     end
    -- end,

    onEnterPoint = function(self, point_id)
        if point_id == 27 and not self.point_27_done then
            self.level_script:incQuestProgress(20,1)
            local enemy_1, enemy_2, enemy_3, enemy_4, enemy_boss = nil

            local enemyCreated = function()
                app:startCoroutine(
                    function()
                        self.level_script:cameraFocusToTransform(enemy_boss.transform, true)
                        enemy_1:playAnimation('run')
                        enemy_2:playAnimation('run')
                        enemy_3:playAnimation('run')
                        enemy_4:playAnimation('run')
                        enemy_boss:playAnimation('run')

                        enemy_1:moveTo(Vector3.New(-314.9,0,-135.6), 69/2)
                        enemy_2:moveTo(Vector3.New(-379.5,0,-147), 69/2)
                        enemy_3:moveTo(Vector3.New(-386.1,0,-114.5), 69/2)
                        enemy_4:moveTo(Vector3.New(-320.7,0,-104.1), 69/2)
                        enemy_boss:moveTo(Vector3.New(-348.5,0,-123), 69/2)

                        self.level_script:wait(1.5)

                        local point_27_choice = function(var)
                            app:startCoroutine(
                                function()
                                    if var == 1 then

                                        emp_manager:showAimFrame()
                                        local vsb1, frame = frame_manager:isDisplay('emp_aim')
    
                                        if vsb1 then
                                            while not frame:isLoaded() do
                                                coroutine.yield(nil)
                                                --log.error('waiting')
                                            end
                                            coroutine.yield(nil)
                                            frame:showFireButton()
                                        else
                                            log.error('missing frame emp_aim')
                                        end

                                        while frame_manager:isDisplay('emp_aim') do
                                            coroutine.yield(nil)
                                            --log.error('emp aim displaying')
                                        end

                                        local dialog345 = function()
                                            app:startCoroutine(
                                                function()
                                                    self.level_script:wait(1)
                                                    --SoundEngine.PostEvent("Play_BGM_Fallout4", self.gameObject)
                                                    self.level_script:finishLevel(true)
                                                end
                                            )
                                        end
                                        self.level_script:playDialog(100206, dialog345)
                                    end
                                end
                            )
                        end

                        local dialog342 = function()
                            self.level_script:showDialogOption('level_script_128', {'level_script_129'}, point_27_choice)
                        end

                        self.level_script:playDialog(100207, dialog342)
                    end
                )
            end

            enemy_1 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -182.6883, 0, -116.1371, -98.395, 1.5)
            enemy_2 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -247.311, 0, -127.5005, -98.395, 1.5)
            enemy_3 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -253.862, 0, -94.96851, -98.395, 1.5)
            enemy_4 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -188.5055, 0, -84.57082, -98.395, 1.5)
            enemy_boss = self.level_script:createGameObject(self.level_script.prefabs.twin, -216.2828, 0, -103.53, -99.464, 1.5, enemyCreated)
        end
    end,
}

local phase_4 = class{
    super = phase_base,

    onEnter = function(self)
        log.info('enter p4')
    end,
}
-- 关卡 1006 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)
        self:myInit()
        self:addPhases("phase_0", phase_0(self))
        self:addPhases("phase_1", phase_1(self))
        self:addPhases("phase_2", phase_2(self))
        self:addPhases("phase_3", phase_3(self))
        self:addPhases("phase_4", phase_4(self))
        self:changePhase("phase_1")
    end,

    myInit = function(self)

        self.prefabs = {
            churchill = 'Assets/Prefab/Level/level_prefab_kv2.prefab',
            twin = 'Assets/Prefab/Level/level_prefab_twin.prefab',
            dummy = 'Assets/Prefab/Level/Level_dummy.prefab',
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            repair_kit = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Battery.prefab',   --修复桥梁的物品
            boom = 'Assets/Prefab/Level/level_boom.prefab',
            gate = 'Assets/Prefab/Level/level_prefab_door.prefab',
            chest = 'Assets/Prefab/Level/level_chest.prefab',
            cannon = 'Assets/Prefab/Level/level_cannon.prefab',
            aim = 'Assets/Prefab/Level/level_emp_aim.prefab',
            boom = 'Assets/Prefab/Level/level_boom.prefab',
            dummy = 'Assets/Prefab/Level/level_camp_dummy.prefab',
        }

        -- 预加载
        app:startCoroutine( 
            function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)
        --game_state_level.gui:showTreasureMapButton()

        self:beginOrderPatrol(81,{8,9},400)
        self:beginOrderPatrol(82,{14,16,17,16},400)
        self:beginOrderPatrol(83,{21,22,23,22},400)
        self:beginOrderPatrol(84,{26,27},400)

        --self:hideEntity(84)
        self:hideEntity(85)
        self:hideEntity(86)
    end,

    onEnterPoint = function(self, point_id)
        super.onEnterPoint(self, point_id)
    end,

    onUseShovel = function(self, point_id)
        --使用道具时，务必要加上这个
        if self.curr_phase.onUseShovel then
            self.curr_phase:onUseShovel(point_id)
            --log.error('1002使用铲子，使用点：'..point_id)
            app:logEvent("level_use_shovel_"..tostring(point_id), tostring(point_id))
        end
    end,

    --战斗机结束后level frame会重置，按钮会消失
    onBattleWin = function(self, battle_id)
        super.onBattleWin(self, battle_id)
        game_state_level.gui:showTreasureMapButton()

        if battle_id == 81 or battle_id == 82 or battle_id == 83 then
            treasure_map_progress = treasure_map_progress + 1
            game_state_level.gui:updateTreasureMapProgress(treasure_map_progress)
            game_state_level.gui:showRedDot()
            hint:setText('New data acquired, check your intel panel')
        else
            game_state_level.gui:updateTreasureMapProgress(treasure_map_progress)
        end
    end,

    onBattleLose = function(self, battle_id)
        super.onBattleLose(self, battle_id)
        game_state_level.gui:showTreasureMapButton()
    end,

    --auto gate !
    onEnterTrigger = function(self, trigger_name)
        super.onEnterTrigger(self, trigger_name)

        if trigger_name == 'Trigger01' then
            local gate = self:findGameObject('zha@work (1)')
            self:sceneGameObjectPlayAnimation(gate, 'work')
        end
    end,

    onExitTrigger = function(self, trigger_name)
        super.onExitTrigger(self, trigger_name)

        if trigger_name == 'Trigger01' then
            local gate = self:findGameObject('zha@work (1)')
            self:sceneGameObjectPlayAnimation(gate, 'close')
        end
    end,

    onEnterPoint = function(self, point_id)
        super.onEnterPoint(self, point_id)
        app:logEvent("level_enter_point_1002_"..tostring(point_id), tostring(point_id))
    end,
}