local log = logger.get("Game", "LevelScript 1006")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")

--5个修桥的材料
local repair_kit_1 = nil    --村庄中的
local repair_kit_2 = nil    --野怪81守护的
local repair_kit_3 = nil    --野怪81守护的
local repair_kit_4 = nil    --野怪80守护的
local repair_kit_5 = nil    --野怪80守护的
--local dummy = nil        --用于NPC头顶气泡
local dummy = nil

local kit_pos_1 = Vector3.New(-244.1,0,-204.6)      --修桥材料的点，在这统一改，方便儿～～
local kit_pos_2 = Vector3.New(-38.8,0,-211.8)
local kit_pos_3 = Vector3.New(-6.3,0,-211.8)
local kit_pos_4 = Vector3.New(29.2,0,-126.6)
local kit_pos_5 = Vector3.New(40.5,0,-99.4)

local kit_collect_count = 0

local progress_count = 0

-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用


--第一个阶段，从进入关卡到与NPC对话完成
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)

        --self.level_script:playDialog(181)
        --hint:setText('前往绿洲，寻找芯片')
        self.level_script:createOpTrigger(1,1,self.level_script.prefabs.camp_trigger,Vector3.New(-268.1,0.7,-171.3),60,1,60,self.npcQuestGet)      --对话NPC
        self.level_script:entityChat(79,'level_script_78',60)
    end,

    onBattleWin = function(self,index)
        if index == 79 then
            app:startCoroutine(
                function()
                    --dummy = self.level_script:createGameObject(self.level_script.prefabs.dummy,-259,0,-161.8,0,1)
                    self.level_script:wait(1)
                    self.level_script:playDialog(186)
                    --self.level_script:gameObjectChat(dummy,'level_script_81',100)
                end
        )
        end
    end,

    onExit = function(self)
        log.info("exit phase1")
        progress_count = 0
    end,

    -------------自定义函数区域---------------

    npcQuestGet = function()
        --level_script:removeGameObject(dummy)
        level_script:playDialog(190)
        --hint:setText('接受任务：修理桥梁，收集5个金属零件来修复桥梁前往绿洲')
        level_script:removeOpTrigger(1)
        level_script:changePhase('phase_2')
    end,
}

--第二个阶段，收集材料，开始修复桥梁
local phase_2 = class{
    super = phase_base,

    onEnter = function(self)
        --创建GameObject
        repair_kit_1 = self.level_script:createGameObject(self.level_script.prefabs.repair_kit,kit_pos_1.x,kit_pos_1.y,kit_pos_1.z,0,2)   
        repair_kit_2 = self.level_script:createGameObject(self.level_script.prefabs.repair_kit,kit_pos_2.x,kit_pos_2.y,kit_pos_2.z,0,2)
        repair_kit_3 = self.level_script:createGameObject(self.level_script.prefabs.repair_kit,kit_pos_3.x,kit_pos_3.y,kit_pos_3.z,0,2)
        repair_kit_4 = self.level_script:createGameObject(self.level_script.prefabs.repair_kit,kit_pos_4.x,kit_pos_4.y,kit_pos_4.z,0,2)
        repair_kit_5 = self.level_script:createGameObject(self.level_script.prefabs.repair_kit,kit_pos_5.x,kit_pos_5.y,kit_pos_5.z,0,2)

        self.level_script:entityChat(80,'level_script_79',60)
        self.level_script:entityChat(81,'level_script_80',60)

        --Trigger call back
        local kit_cb_1 = function()
            kit_collect_count = kit_collect_count + 1   --增加计数
            self.level_script:removeOpTrigger(2)        --移除trigger
            self.level_script:createGameObject(self.level_script.prefabs.op_effect,kit_pos_1.x,kit_pos_1.y,kit_pos_1.z,0,2)     --采矿特效
            self.level_script:removeGameObject(repair_kit_1)    --移除矿
            hint:setText('收集进度：金属零件'..kit_collect_count..'/5')  --显示进度
            if kit_collect_count == 5 then
                hint:setText('零件收集完成！可以开始修复桥梁了')
                level_script:changePhase('phase_3')
            end
        end

        local kit_cb_2 = function()
            kit_collect_count = kit_collect_count + 1
            self.level_script:removeOpTrigger(3)
            self.level_script:createGameObject(self.level_script.prefabs.op_effect,kit_pos_2.x,kit_pos_2.y,kit_pos_2.z,0,2)
            self.level_script:removeGameObject(repair_kit_2)
            hint:setText('收集进度：金属零件'..kit_collect_count..'/5')
            self.level_script:monsterBeginTracePlayer(81,2)
            if kit_collect_count == 5 then
                hint:setText('零件收集完成！可以开始修复桥梁了')
                level_script:changePhase('phase_3')
            end
        end

        local kit_cb_3 = function()
            kit_collect_count = kit_collect_count + 1
            self.level_script:removeOpTrigger(4)
            self.level_script:createGameObject(self.level_script.prefabs.op_effect,kit_pos_3.x,kit_pos_3.y,kit_pos_3.z,0,2)
            self.level_script:removeGameObject(repair_kit_3)
            hint:setText('收集进度：金属零件'..kit_collect_count..'/5')
            self.level_script:monsterBeginTracePlayer(81,2)
            if kit_collect_count == 5 then
                hint:setText('零件收集完成！可以开始修复桥梁了')
                level_script:changePhase('phase_3')
            end
        end

        local kit_cb_4 = function()
            kit_collect_count = kit_collect_count + 1
            self.level_script:removeOpTrigger(5)
            self.level_script:createGameObject(self.level_script.prefabs.op_effect,kit_pos_4.x,kit_pos_4.y,kit_pos_4.z,0,2)
            self.level_script:removeGameObject(repair_kit_4)
            hint:setText('收集进度：金属零件'..kit_collect_count..'/5')
            self.level_script:monsterBeginTracePlayer(80,2)
            if kit_collect_count == 5 then
                hint:setText('零件收集完成！可以开始修复桥梁了')
                level_script:changePhase('phase_3')
            end
        end

        local kit_cb_5 = function()
            kit_collect_count = kit_collect_count + 1
            self.level_script:removeOpTrigger(6)
            self.level_script:createGameObject(self.level_script.prefabs.op_effect,kit_pos_5.x,kit_pos_5.y,kit_pos_5.z,0,2)
            self.level_script:removeGameObject(repair_kit_5)
            hint:setText('收集进度：金属零件'..kit_collect_count..'/5')
            self.level_script:monsterBeginTracePlayer(80,2)
            if kit_collect_count == 5 then
                hint:setText('零件收集完成！可以开始修复桥梁了')
                self.level_script:playerChat('level_script_68',3)
                level_script:changePhase('phase_3')
            end
        end

        --Create trigger
        self.level_script:createOpTrigger(2,1,self.level_script.prefabs.camp_trigger,kit_pos_1,60,1,60,kit_cb_1)
        self.level_script:createOpTrigger(3,1,self.level_script.prefabs.camp_trigger,kit_pos_2,60,1,60,kit_cb_2)
        self.level_script:createOpTrigger(4,1,self.level_script.prefabs.camp_trigger,kit_pos_3,60,1,60,kit_cb_3)
        self.level_script:createOpTrigger(5,1,self.level_script.prefabs.camp_trigger,kit_pos_4,60,1,60,kit_cb_4)
        self.level_script:createOpTrigger(6,1,self.level_script.prefabs.camp_trigger,kit_pos_5,60,1,60,kit_cb_5)
    end,

}

--第三个阶段，修复桥梁修复完成
local phase_3 = class{
    super = phase_base,

    onEnter = function(self)
        local text_progress = self.level_script:createGameObject(self.level_script.prefabs.progess_text,-369.4,31.3,-144.8,0,5)    --桥梁进度文字

        local repairCallBack = function()
            app:startCoroutine(
                function()
                    self.level_script:createGameObject(self.level_script.prefabs.op_effect,-358,0,-142.2,0,3)       --修桥烟雾
                    self.level_script:createGameObject(self.level_script.prefabs.op_effect,-373.6,0,-130.4,0,3)
                    self.level_script:createGameObject(self.level_script.prefabs.op_effect,-360.8,0,-152.3,0,3)
                    log.error('p3 1 ')
                    local tt = text_progress:GetComponentInChildren(UnityEngine.TextMesh,true)
                    log.error('p3 2 ')
                    math.randomseed(Time.time)
                    progress_count = progress_count + math.random(10,30)
                    
                    if progress_count >= 100 then
                        progress_count = 100
                        tt.text = progress_count..' %'
                        self.level_script:removeGameObject(text_progress)   --删除桥
                        self.level_script:removeOpTrigger(7)    --delete op
                        --log.error('enter p4 from p3')
                        self.level_script:playerChat('level_script_69',3)
                        self.level_script:wait(2)
                        level_script:changePhase('phase_4')
                    else 
                        tt.text = progress_count..' %'
                    end
                end
            )
        end

        self.level_script:createOpTrigger(7,1,self.level_script.prefabs.camp_trigger,Vector3.New(-352.1,0,-162.6),60,1,60,repairCallBack)   --桥梁触发区域

    end,

    onExit = function(self)
        log.info('exit phase_3')
    end,
}

--第四阶段，boss出现
local phase_4 = class{
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                --self.level_script:wait(3)
                local boss_1 = self.level_script:createGameObject(self.level_script.prefabs.boss_spider,-290,0,-322.7,0,1)
                self.level_script:playLevelCameraAnim('scenario-1-2_2')
                --self.level_script:playLevelCameraAnim('scenario-1-2_1')
                self.level_script:wait(3)
                self.level_script:playAnimation(boss_1,'born')
                self.level_script:wait(6.667)
                self.level_script:playAnimation(boss_1,'idle')
                self.level_script:wait(4.5)
                self.level_script:removeGameObject(boss_1)

                local boss_2 = self.level_script:createGameObject(self.level_script.prefabs.boss_spider,-101.7,0,32.9,-128.948,1)
                --log.error('enter p4')
                local bossfire = function()
                    app:startCoroutine(
                        function()
                            
                            math.randomseed(Time.time)
                            self.level_script:playAnimation(boss_2,'attack')
                            for i = 1, 20 do
                                local fire_pos = Vector3.New(-269.2 + math.random(-90,90),0,-201.7 + math.random(-40,40))
                                self.level_script:shootBullet(10010, self.level_script:findChild(boss_2.transform,"shoot"),fire_pos,150)
                                self.level_script:wait(0.2)
                                self.level_script:playCameraAnim('shake11')
                            end
                            --level_script:changePhase('phase_5')
                        end
                    )
                end
                self.level_script:wait(0.1)
                self.level_script:playAnimation(boss_2,'walk')
                --log.error('walk')
                self.level_script:playerChat('level_script_70',3)
                self.level_script:gameObjectMoveTo(boss_2,Vector3.New(-260.1,0,-95.1),10,bossfire)
                
                --for i = 1, 10 do
                 --   self.level_script:playCameraAnim('shake11')
                   -- self.level_script:wait(0.5)
                --end
            end
        ) 
    end,

    onExit = function(self)
    end,

}

--第五阶段，展现boss动画
local phase_5 = class{
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                local boss = self.level_script:createGameObject(self.level_script.prefabs.boss_spider,-536.3758,0,-271.9083,-216.993,1)
                local text_progress = self.level_script:createGameObject(self.level_script.prefabs.progess_text,-427.1,23,-313.9,0,5)

                local tt = text_progress:GetComponentInChildren(UnityEngine.TextMesh,true)

                local animation = {'attack','attack_1','attack_2','born','broken','idle','idle_1','run','walk'}
                local size = 9
                local index = 1
                local bossShow = function()
                    self.level_script:playAnimation(boss,animation[index])

                    if not tt then
                        tt = text_progress:GetComponentInChildren(UnityEngine.TextMesh,true)
                    end

                    tt.text = animation[index]
                    index = index + 1
                    if index > 9 then
                        index = 1
                    end
                end
                
                self.level_script:createOpTrigger(8,1,self.level_script.prefabs.camp_trigger,Vector3.New(-499.3,0,-302.2),180,1,180,bossShow)
            end
        ) 
    end,

    onExit = function(self)
    end,

}

--第六阶段，测试新脚本接口
local phase_6 = class{
    super = phase_base,

    onEnter = function(self)
        local count = 0
        app:startCoroutine(
            function()
                
                local scriptTest = function()
                    
                    if count == 0 then
                        log.error('count = '..count)
                        self.level_script:addStoryLevelHero(62)
                    elseif count == 1 then
                        log.error('count = '..count)
                        self.level_script:removeStoryLevelHero(62)
                    end
                    count = count + 1
                    if count > 1 then
                        count = 0 
                    end
                end
                
                self.level_script:createOpTrigger(9,1,self.level_script.prefabs.camp_trigger,Vector3.New(-483,0,-323),180,1,180,scriptTest)
            end
        ) 
    end,

    onExit = function(self)
    end,

}

-- 关卡 1006 对应的脚本
----------------------
return class{
    super = super,

    -- 初始化
    init = function(self)
        self:myInit()
        self:addPhases("phase_1", phase_1(self))
        self:addPhases("phase_2", phase_2(self))
        self:addPhases("phase_3", phase_3(self))
        self:addPhases("phase_4", phase_4(self))
        self:addPhases("phase_5", phase_5(self))
        self:addPhases("phase_6", phase_6(self))
        self:changePhase("phase_1")
    end,

    --reload = function(self)
     --   super.reload(self)
     --   self:myInit()
    --end,

    myInit = function(self)
        self.prefabs = {
            churchill = 'Assets/Prefab/Level/Prefab_Vehicle_Tank_KV2.prefab',     --丘吉尔坦克，解救英雄时用到
            boom = 'Assets/Arts/fx/prefab/skill10010_hit.prefab',       --爆炸特效
            camp_trigger = 'Assets/Prefab/Level/OperationTrigger.prefab',    --帐篷触发
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            boss_spider = 'Assets/Prefab/Vehicle/Prefab_Boss_Spider.prefab',    --蜘蛛boss
            tnt = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Electronic 1.prefab',   --炸弹
            repair_kit = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Battery.prefab',   --修复桥梁的物品
            progess_text = 'Assets/Prefab/Level/Level_progress_text.prefab',    --进度条文字
            dummy = 'Assets/Prefab/Level/Level_dummy.prefab',
        }

        -- 预加载
        app:startCoroutine( function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)

        --桥边的怪
        self:beginPatrol(79,{   
            Vector3.New(-409.8, 0, -210.7),
            Vector3.New(-268.9, 0,-129.4),
        },30)

        --上方废墟的怪
        self:beginPatrol(80,{   
            Vector3.New(-12.3, 0, -57.7),
            Vector3.New(-12.3, 0, -161.2),
        },30)

        --下方营地的怪
        self:beginPatrol(81,{   
            Vector3.New(-101.8, 0, -260.4),
            Vector3.New(-23.9, 0, -200.1),
        },30)
    end,
}