local log = logger.get("Game", "LevelScript 1006")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")


-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用


--第一个阶段，从进入关卡到与NPC对话完成
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)
       
    end,
}


-- 关卡 1006 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)

        self.prefabs = {
            churchill = 'Assets/Prefab/Level/level_prefab_kv2.prefab',     --丘吉尔坦克，解救英雄时用到
            boom = 'Assets/Arts/fx/prefab/skill10010_hit.prefab',       --爆炸特效
            camp_trigger = 'Assets/Prefab/Level/OperationTrigger.prefab',    --帐篷触发
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            repair_kit = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Battery.prefab',   --修复桥梁的物品
            progess_text = 'Assets/Prefab/Level/Level_progress_text.prefab',    --进度条文字
            boss_spider = 'Assets/Prefab/Vehicle/Prefab_Boss_Spider.prefab',    --蜘蛛boss

        }

        -- 预加载
        app:startCoroutine( function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)


        self:addPhases("phase_1", phase_1(self))

        self:changePhase("phase_1")
    end,
}