local log = logger.get("Game", "LevelScript 1006")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")

--define truck search stat
local truck_13 = 0
local truck_26 = 0

--define quest npc game object
local npc_go = nil

--define chests
local chest_go_15 = nil
local chest_15 = 0

local chest_go_18 = nil
local chest_18 = 0

local chest_go_37 = nil
local chest_37 = 0

--define dialog points
local dialog_25 = 0

--define prisoner 
local hostage = nil

--define bomb related variables
local has_bomb = false
local bomb_placed = false
local bomb_11 = nil     --bombs placed at prison gate, boom shaka laka
local bomb_22 = nil

--define prison gate
local prison_gate = nil

--mission
local mission = false

-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用


--第一个阶段，first camp
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                --level_script:finishLevel(true)
            end
        )
    end,

    onEnterPoint = function(self, point_id)
        if point_id == 2 and mission == false then
            mission = true
            npc_go:setHeadIcon(nil)

            local npcQuest_2 = function()
                self.level_script:incQuestProgress(8,1)
            end

            local npcQuest_1 = function()
                app:startCoroutine(
                    function()
                        self.level_script:cameraFocusToEntity(82,true)
                        self.level_script:gameObjectChat(hostage,'level_script_102',3)
                        self.level_script:wait(2)
                        self.level_script:cameraFocusToPlayer()
                        self.level_script:wait(0.5)
                        self.level_script:playDialog(200201,npcQuest_2)
                    end
                )
            end

            self.level_script:playDialog(200202,npcQuest_1)
        end
    end,

    onBattleWin = function(self, index)     --index为entity的索引编号

        --log.error('enter OnBattle Win function')
        if index == 79 then
            local tnt = self.level_script:createGameObject(self.level_script.prefabs.tnt,755,0,2453.7,0,2)

            local bomb_1 = function()
                self.level_script:incQuestProgress(9,1)
                level_script:changePhase('phase_4')
            end

            local collectTNT = function()
                app:startCoroutine(
                    function()
                        --self.level_script:wait(2)
                        self.level_script:playDialog(200203,bomb_1)
                        self.level_script:removeGameObject(tnt)
                        self.level_script:removeOpTrigger(1)
                        
                    end
                )
            end
            self.level_script:createOpTrigger(1,2,5,collectTNT)   --桥梁触发区域
        end
    end,

    onExit = function(self)
        --log.error('exit p1')
    end,
}

--第四阶段，击败第二个营地，获得炸弹遥控装置，炸弹完成
local phase_4 = class{
    super = phase_base,

    onBattleWin = function(self, index)     --index为entity的索引编号
        
                --log.error('enter OnBattle Win function')
                if index == 80 then
                    local tnt = self.level_script:createGameObject(self.level_script.prefabs.tnt,524.8,0,2709,0,2)     --引线，应该由dropbag掉落
                    
                    local dialog_cb = function()
                        self.level_script:incQuestProgress(9,1)
                        has_bomb = true
                        self.level_script:changePhase('phase_7')
                    end

                    local collectWire = function()
                        app:startCoroutine(
                            function()
                                self.level_script:removeGameObject(tnt)
                                self.level_script:removeOpTrigger(13)
                                self.level_script:playDialog(200204,dialog_cb)     --获得了引线
                            end
                        )
                        --log.error('call back finish')
                    end
        
                    --log.error(index..'battle id')
                    self.level_script:createOpTrigger(13,2,18,collectWire)   
                end
            end,
}
--前往牢房安装炸弹
local phase_7 = class{
    super = phase_base,
    
    onEnterPoint = function(self,point_id)
    end,

    onEnter = function(self)
        local wallDown = function()
            self.level_script:resumePlayerInput()
            self.level_script:setPathPointType(28,0)
            self.level_script:changePhase('phase_8')
        end

        local moveCB = function()
            app:startCoroutine(
                function()
                    self.level_script:playerFindNearestPathPoint()
                    self.level_script:wait(0.5)
                    hint:setText('3')
                    self.level_script:wait(1)
                    hint:setText('2')
                    self.level_script:wait(1)
                    hint:setText('1')
                    self.level_script:wait(1)
                    --delete bombs at prison gate
                    self.level_script:removeGameObject(bomb_11)
                    self.level_script:removeGameObject(bomb_22)
                    --bomb fx and gate down
                    local boom_11 = self.level_script:createGameObject(self.level_script.prefabs.boom,276.7,0,2862,0,1)
                    local boom_22 = self.level_script:createGameObject(self.level_script.prefabs.boom,300.3,0,2811.3,0,1)
                    self.level_script:wait(1)
                    self.level_script:removeGameObject(boom_11)
                    self.level_script:removeGameObject(boom_22)
                    self.level_script:playAnimation(prison_gate,'boom')
                    self.level_script:wait(1.5)
                    wallDown()
                    self.level_script:wait(1.5)
                    self.level_script:removeGameObject(prison_gate)
                    --self.level_script:gameObjectMoveTo(prison_gate,Vector3.New(47.3,-5,356.44),7,wallDown)
                end
            )
        end

        local bombCB = function()
            self.level_script:breakPlayerInput()
            self.level_script:playerMoveTo(Vector3.New(291.8,0,2702.8), 60, moveCB)
        end

        local placeBomb = function()
            app:startCoroutine(
                function()
                    bomb_placed = true
                    self.level_script:removeOpTrigger(20)
                    bomb_11 = self.level_script:createGameObject(self.level_script.prefabs.tnt,276.7,0,2862,0,1)
                    bomb_22 = self.level_script:createGameObject(self.level_script.prefabs.tnt,300.3,0,2811.3,0,1)

                    self.level_script:wait(1)
                    --log.error('place dialog 228')
                    self.level_script:playDialog(200204,bombCB)
                end
            )
        end

        self.level_script:createOpTrigger(20,4,28,placeBomb)
    end
}

--消灭敌人，解救人质
local phase_8 = class{
    super = phase_base,

    onEnter = function(self)
        hostage:setHeadIcon("Assets/Prefab/Level/Texture/exclamation.png")
    end,

    onEnterPoint = function(self, point_id)
        if point_id == 34 then
            local hostage_dialog = function()
                app:startCoroutine(
                    function()
                        --self.level_script:wait(1.5)
                        self.level_script:finishLevel(true)
                    end
                )
            end
 
            hostage:setHeadIcon(nil)
            self.level_script:removeOpTrigger(34)
            self.level_script:playDialog(200206,hostage_dialog)
        end
    end,
}

-- 关卡 1007 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)
        self:myInit()
        self:addPhases("phase_1", phase_1(self))
        self:addPhases("phase_4", phase_4(self))
        self:addPhases("phase_7", phase_7(self))
        self:addPhases("phase_8", phase_8(self))
        self:changePhase("phase_1")
    end,

    myInit = function(self)
        self.prefabs = {
            churchill = 'Assets/Prefab/Level/level_prefab_kv2.prefab',     --丘吉尔坦克，解救英雄时用到
            boom = 'Assets/Arts/fx/prefab/die.prefab',       --爆炸特效
            camp_trigger = 'Assets/Prefab/Level/OperationTrigger.prefab',    --帐篷触发
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            tnt = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Battery.prefab',   --炸弹
            chest = 'Assets/Prefab/Level/level_chest.prefab',   --宝箱
            gate = 'Assets/Prefab/Level/level_prefab_door.prefab',   --宝箱
        }

        -- 预加载
        app:startCoroutine( function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)

        self:beginOrderPatrol(85,{6,7,10,7},400)     --第一个营地上方的怪
        --self:beginOrderPatrol(79,{5},400)             --第一个营地的怪
        --self:hideEntity(86) --隐藏用来战斗的boss

        --init NPC
        npc_go = self:createGameObject(self.prefabs.churchill,530.9,0,2340.3,165.084,1.5,
        function(go)
            go:setHeadIcon("Assets/Prefab/Level/Texture/exclamation.png")
        end)

        --init chests
        -- chest_go_15 = self:createGameObject(self.prefabs.chest,156,0,333.5,0,1)
        -- chest_go_18 = self:createGameObject(self.prefabs.chest,44.3,0,241.2,0,1)
        chest_go_37 = self:createGameObject(self.prefabs.chest,441.9,0,2413.4,0,1)

        --init hostage
        hostage = self:createGameObject(self.prefabs.churchill,315,0,3167.3,167,1.5)

        --init gate
        prison_gate = self:createGameObject(self.prefabs.gate,293.6,0,2837.6,-23.921,0.35)
    end,

     --global enter point call back
     onEnterPoint = function(self, point_id)
        ------------NEVER EVER FORGET THIS LINE--------------------
        super.onEnterPoint(self, point_id)
        app:logEvent("level_enter_point_2002_"..tostring(point_id), tostring(point_id))
        app:startCoroutine(
            function()     
                if point_id == 13 and truck_13 == 0 then
                --     truck_13 = 1
                --     hint:setText('你仔细搜索了这辆废弃的卡车')
                --     self:wait(1)
                --     self:getGiftBagReward(10)
                -- elseif point_id == 26 and truck_26 == 0 then
                --     truck_26 = 1
                --     hint:setText('你仔细搜索了这辆废弃的卡车')
                --     self:wait(1)
                --     self:getGiftBagReward(11)
                -- elseif point_id == 15 and chest_15 == 0 then
                --     chest_15 = 1
                --     self:removeGameObject(chest_go_15)
                --     self:getGiftBagReward(4)
                --     --self:showGetItemUI({[15] = 2,[33001] = 35,[30002] = 2981,})
                -- elseif point_id == 18 and chest_18 == 0 then
                --     chest_18 = 1
                --     self:removeGameObject(chest_go_18)
                --     self:getGiftBagReward(5)
                --     --self:showGetItemUI({[15] = 2,[33001] = 35,[30002] = 2981,})
                elseif point_id == 37 and chest_37 == 0 then
                    chest_37 = 1
                    self:removeGameObject(chest_go_37)
                    self:getGiftBagReward(6)
                    --self:showGetItemUI({[15] = 2,[33001] = 35,[30002] = 2981,})
                -- elseif point_id == 25 and dialog_25 == 0 then
                --     dialog_25 = 1
                --     self:playDialog(226)
                elseif point_id == 28 and has_bomb == false then
                    --log.error('place dialog 227')
                    self:playDialog(200208)
                end
            end
        )
    end,
}