local log = logger.get("Game", "LevelScript 1006")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")

--init boss
local boss = nil            --boss level object

--friendly mobs to buy time
local friend_mob_1 = nil
local friend_mob_2 = nil
local friend_mob_count = 1     --waves of friendly mobs

--chests
local chest_11_go = nil
local chest_11 = false
local chest_27_go = nil
local chest_27 = false
local chest_30_go = nil
local chest_30 = false

local des_1, des_2 = nil
local run = true
local is_fps = false
local soldier_test_count = 0
local sniper = nil
local fps_cam = nil
local fps_fps_cam_root = nil

local p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11 = nil
local fps_path_init = {p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11}
local fps_path_name = {'p1','p2','p3','p4','p5','p6','p7','p8','p9','p10','p11'}
local fps_path_list = {}
--local fps_path_list = {p1,p2,p4,p6,p8,p10}


local path_count = 1

local is_broken = false
local mob_1, mob_2, mob_3, mob_4, mob_5, mob_6 = 0
local mob_1_hp = 2
local mob_2_hp = 2
local mob_3_hp = 2
local mob_4_hp = 2
local mob_5_hp = 2
local mob_6_hp = 2
local player_force_stop = false
local boss_hp = 5
local bait = nil
local bait_bullet = nil
local island_cannon = nil

local bone = {}
local bone_fire  = {}
local bullet_enhanced = false
local weak_bullet_hit_count = 0     --hit by unenhanced bullet
local strong_bullet_hit_count = 0

-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用

local phase_fps_test = class{
    super = phase_base,

    onEnter = function(self)

        p1 = self.level_script:findGameObject('p1').transform.position
        p2 = self.level_script:findGameObject('p2').transform.position
        p3 = self.level_script:findGameObject('p3').transform.position
        p4 = self.level_script:findGameObject('p4').transform.position
        p5 = self.level_script:findGameObject('p5').transform.position
        p6 = self.level_script:findGameObject('p6').transform.position
        p7 = self.level_script:findGameObject('p7').transform.position
        p8 = self.level_script:findGameObject('p8').transform.position
        p9 = self.level_script:findGameObject('p9').transform.position
        p10 = self.level_script:findGameObject('p10').transform.position
        p11 = self.level_script:findGameObject('p11').transform.position
        fps_path_list = {p1,p2,p3,p4,p5,p6,p7,p8,p9,p10}

        self.hit_count = 0
        self.mob_hit_count = 0
        boss:initBossStates()
        boss:moveInPath(fps_path_list, 30)
        
        self:player_endless_move()
        fps_cam_root = self.level_script:createGameObject(self.level_script.prefabs.dummy, 0,0,0,0,1)
        --这里非常重要啊，boss是一个levelgameobject，先取他的gameobject，再取这个gameobject中boscollider组件，
        --然后将这个collider的gameobject的name赋值，然后在raycasthit里面去判断
        boss.go:GetComponentInChildren(UnityEngine.BoxCollider).gameObject.name = 'boss'

        if not is_fps then
            is_fps = true
            local pos = fps_cam_root.go.transform.position
            pos.y = 13.29
            local rot = Quaternion.LookRotation(boss.transform.position - self.level_script.level.player.transform.position, Vector3.up)
            self.level_script:breakPlayerInput()
            -- self:playerKeepMoving()
            game_state_level:setFPSMode(is_fps, pos, rot, true, fps_cam_root.transform, 10010, function(hit_rst)
                if hit_rst then
                    --log.info('call hit enemy')
                    --self.level_script.level.player.cs_inst.transform
                    self:hitEnemy(hit_rst)
                else
                    --log.info('not enter')
                end
            end)

            fps_cam = game_state_level.level_manager.FPSCamera
        end

    end,

    hitEnemy = function(self, hit_rst)
        if not hit_rst.collider then
            return
        end

        local go = hit_rst.collider.gameObject
        --log.error('HHHH tag name is '..go.tag)
        if go.name == 'boss' then
            --hint:setText('Hit')
            if bullet_enhanced == false then
                weak_bullet_hit_count = weak_bullet_hit_count + 1
                if weak_bullet_hit_count >= 5 then
                    local boss_mock = math.random(0,1)
                    if boss_mock <= 0.33 then
                        hint:setText('Boss: Your attack is useless against me')
                    elseif boss_mock <= 0.67 and boss_mock >= 0.34 then
                        hint:setText('Boss: Insects! I will crush you!')
                    else
                        hint:setText('Boss: Your death is near!')
                    end
                    weak_bullet_hit_count = 0
                end
            else
                boss:hit()
                strong_bullet_hit_count = strong_bullet_hit_count + 1
                if strong_bullet_hit_count >= 10 then
                    level_script:changePhase('phase_chase_3')
                end
            end
            
        elseif go.name == 'mob_1' and mob_1 then
            --log.error('mob 1')
            mob_1_hp = mob_1_hp - 1
            if mob_1_hp <= 0 then
                self.mob_1_dead = true
                local fx = self.level_script:createGameObject(self.level_script.prefabs.boom, mob_1.go.transform.position.x, 0, mob_1.go.transform.position.z, 0, 1)
                app:startCoroutine(
                    function()
                        self.level_script:removeGameObject(mob_1)
                        self.level_script:wait(2)
                        self.level_script:removeGameObject(fx)
                    end
                )
            end
        elseif go.name == 'mob_2' and mob_2 then
            mob_2_hp = mob_2_hp - 1
            if mob_2_hp <= 0 then
                self.mob_2_dead = true
                local fx = self.level_script:createGameObject(self.level_script.prefabs.boom, mob_2.go.transform.position.x, 0, mob_2.go.transform.position.z, 0, 1)
                app:startCoroutine(
                    function()
                        self.level_script:removeGameObject(mob_2)
                        self.level_script:wait(2)
                        self.level_script:removeGameObject(fx)
                    end
                )
            end
        elseif go.name == 'mob_3' and mob_3 then
            mob_3_hp = mob_3_hp - 1
            if mob_3_hp <= 0 then
                self.mob_3_dead = true
                local fx = self.level_script:createGameObject(self.level_script.prefabs.boom, mob_3.go.transform.position.x, 0, mob_3.go.transform.position.z, 0, 1)
                app:startCoroutine(
                    function()
                        self.level_script:removeGameObject(mob_3)
                        self.level_script:wait(2)
                        self.level_script:removeGameObject(fx)
                    end
                )
            end
            
        end
    end,

    player_endless_move = function(self)
        if player_force_stop == true then
            return
        end
        self.level_script:breakPlayerInput()
        
        local random_pos = fps_path_list[path_count]
        if not random_pos then
            -- 结束了
            --log.error('return')
            return
        end
        
        --log.error('move call back, count =  '..path_count)    
        path_count = path_count + 1        
        
        self.level_script:playerMoveTo(random_pos, 40, 
        function()
            log.info("### on callback called!")
            self:player_endless_move()
        end)
    end,

    onUpdate = function(self, dt)
        boss:rotateTo(self.level_script.level.player.transform, 720)
        local player_pos = self.level_script:getPlayerPos()
        if fps_cam_root then
            fps_cam_root.transform.position = player_pos
        end

        if self.mob_1_dead and self.mob_2_dead and self.mob_3_dead then
            --log.error('player resume moving')
            player_force_stop = false
            self:player_endless_move()
            self.mob_1_dead = false
            hint:setText('Your cannon is greatly enhanced')
            bullet_enhanced = true
            game_state_level:updateShootEffect(10033)
        end
    end,

    onEnterTrigger = function(self, trigger_name)
        if trigger_name == 'Trigger01' then
            --log.error('enter trigger01')
            local fps_mob_created = function()
                mob_1.go:GetComponentInChildren(UnityEngine.CapsuleCollider).gameObject.name = 'mob_1'
                mob_2.go:GetComponentInChildren(UnityEngine.CapsuleCollider).gameObject.name = 'mob_2'
                mob_3.go:GetComponentInChildren(UnityEngine.CapsuleCollider).gameObject.name = 'mob_3'

                
                app:startCoroutine(
                    function()
                        for i = 1, 100 do
                            if mob_1 then
                                self.level_script:playAnimation(mob_1, 'attack')
                                self.level_script:shootBullet(10010, self.level_script:findChild(mob_1.transform,"shoot"),self.level_script:getPlayerPos(),600)
                                self.level_script:wait(math.random(0,0.4))
                            end

                            if mob_2 then
                                self.level_script:playAnimation(mob_2, 'attack')
                                self.level_script:shootBullet(10010, self.level_script:findChild(mob_2.transform,"shoot"),self.level_script:getPlayerPos(),600)
                                self.level_script:wait(math.random(0,0.5))
                            end

                            if mob_3 then
                                self.level_script:playAnimation(mob_3, 'attack')
                                self.level_script:shootBullet(10010, self.level_script:findChild(mob_3.transform,"shoot"),self.level_script:getPlayerPos(),600)
                                self.level_script:wait(math.random(0,0.2))
                            end
                        end
                    end
                )
            end

            mob_1 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -1350.3, 0, -276.7, 81.79601, 2)
            mob_2 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -1365.6, 0, -326.6, 60.347, 2)
            mob_3 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -1316.4, 0, -339.6, 53.269, 2,fps_mob_created)
            --self.level_script:playerStopMove()
        elseif trigger_name == 'Trigger02' then
            --log.error('trigger02')
            hint:setText('You way is blocked by these tanks! Destroy them!')
            game_state_level.level_manager.FPSCamera.transform.rotation = Quaternion.LookRotation(mob_2.transform.position - self.level_script.level.player.transform.position, Vector3.up)
            --上面这里镜头旋转硬切太厉害，要优化
            player_force_stop = true
            mob_1:rotateTo(self.level_script.level.player.transform,180)
            mob_2:rotateTo(self.level_script.level.player.transform,180)
            mob_3:rotateTo(self.level_script.level.player.transform,180)
            self.level_script:playerStopMove()
        end
    end,
}

local phase_start = class{
    super = phase_base,

    onEnter = function(self)
        self.level_script:playerStopMove()
        hint:setText('We need to find the boss and kill him')
    end,

    onEnterPoint = function(self, id)
        if id == 2 then
            local chooseCB = function(var)
                if var == 1 then    --逃亡玩法
                    level_script:changePhase('phase_cannon_1')
                elseif var == 2 then    --开炮玩法
                    level_script:changePhase('phase_cannon_1')
                end
            end

            self.level_script:showDialogOption('level_script_148', {'level_script_149', 'level_script_150'}, chooseCB)
        end
    end,
}

local phase_chase_1 = class{
    super = phase_base,

    onEnter = function(self)
        local destory_oil = function()
            app:startCoroutine(
                function()
                    self.lure_boss = true
                    self.level_script:removeOpTrigger(10)
        
                    for i = 1, 5 do
                        local boom_pos = Vector3.New(math.random(-100, -34), math.random(0, 40), math.random(50,110))
                        self.level_script:createGameObject(self.level_script.prefabs.boom, boom_pos.x, boom_pos.y, boom_pos.z, 0, 1)
                        self.level_script:wait(0.1)
                    end

                    level_script:changePhase('phase_chase_2')
                end
            )
        end
        hint:setText('We need to lure the boss out')
        self.level_script:createOpTrigger(10, 1, 7, destory_oil)
    end,

    onEnterPoint = function(self, id)
        if id == 7 and not self.lure_boss then
            hint:setText('May be this will work')
        end
    end,
}

local phase_chase_2 = class{
    super = phase_base,

    onEnter = function(self)
        local boss_created = function()
            app:startCoroutine(
                function()
                    self.level_script:cameraFocusToTransform(boss.go.transform)
                    self.level_script:playAnimation(boss, 'born')
                    self.level_script:wait(6.6)
                    self.level_script:cameraFocusToPlayer()
                    hint:setText('Prepare yourself for battle')
                    self.level_script:wait(1)
                    level_script:changePhase('phase_fps_test')
                end
            )
        end

        boss = self.level_script:createGameObject(self.level_script.prefabs.boss_spider, 849, 0, -123, -88.799, 1.5, boss_created)
    end,
}

local phase_chase_3 = class{
    super = phase_base,

    onEnter = function(self)
        game_state_level:setFPSMode(false)
        self.level_script:playerFindNearestPathPoint()
        hint:setText('Boss is injured, finish him now!')
    end,

    onUpdate = function(self, dt)
        if Vector3.Distance(boss.go.transform.position, self.level_script:getPlayerPos()) <= 95 then
            self.level_script:battleWithMonster(99)
        end
    end,

    onBattleWin = function(self, id)
        if id == 99 then
            self.level_script:finishLevel(true)
        end
    end,
}
--释放信号弹
local phase_cannon_1 = class{
    super = phase_base,

    onEnter = function(self)
        hint:setText('We should lure the boss out and use the gaint cannon to kill him')
        island_cannon = self.level_script:findGameObject('Prefab_Weapon_Artillery_Canmou')
        fps_cam_root = self.level_script:createGameObject(self.level_script.prefabs.dummy, 0,0,0,0,1)
        local baitBulletCB = function()
            app:startCoroutine(
                function()
                    local simple_bullet = SimpleBullet.Create(bait_bullet.go, Vector3.New(37.04, 52.7, -456.25), Vector3.New(-613, 0, 72), 100, 300)
                    local total_time = simple_bullet.m_fTotalTime
                    self.level_script:cameraFocusToTransform(bait_bullet.go.transform)
                    self.level_script:wait(total_time)
                    --hint:setText('hit')
                    self.level_script:removeGameObject(bait_bullet)
                    bait = self.level_script:createGameObject(self.level_script.prefabs.bait, -613, 0, 72, 0, 1)
                    self.level_script:wait(1)
                    self.level_script:cameraFocusToPlayer()
                    level_script:changePhase('phase_cannon_2')
                end
            )
        end

        local send_bait = function()
            self.level_script:incQuestProgress(21,1)
            self.bait_sent = true
            self.level_script:removeOpTrigger(1)
            --self.level_script:shootBullet(10010,bait_dummy:findChild('shoot'), Vector3.New(-610, 0, 72), 100)
            bait_bullet = self.level_script:createGameObject(self.level_script.prefabs.bait_bullet, 37.04, 52.7, -456.25, 0, 0.3, baitBulletCB)
        end

        self.level_script:createOpTrigger(1,8,37,send_bait)
    end,

    onEnterPoint = function(self, id)
        if id == 1 and not self.bait_sent then
            hint:setText('May be this can lure him out')
        end
    end,
}

--boss出现并走到诱饵位置
local phase_cannon_2 = class{
    super = phase_base,

    onEnter = function(self)
        local bossArriveBait = function()
            app:startCoroutine(
                function()
                    self.level_script:playAnimation(boss, 'attack_1')
                    self.level_script:wait(3.66)
                    self.level_script:playAnimation(boss, 'idle_1')
                    self.level_script:wait(1)
                    self.level_script:removeGameObject(bait)
                    self.level_script:cameraFocusToPlayer()
                    level_script:changePhase('phase_cannon_3')
                end
            )
        end

        local bossCreated = function()
            app:startCoroutine(
                function()
                    --boss:initBossStates()
                    boss.go:GetComponentInChildren(UnityEngine.BoxCollider).gameObject.name = 'Prefab_Boss_Spider'
                    self.level_script:cameraFocusToTransform(boss.go.transform)
                    self.level_script:changeCameraFov(50)
                    self.level_script:playAnimation(boss, 'born')
                    self.level_script:wait(6.67)
                    self.level_script:playAnimation(boss, 'run')
                    boss:rotateTo(bait.go.transform, 360)
                    boss:moveTo(Vector3.New(-422.4, 0, 103.1), 32, bossArriveBait)
                end
            )
        end

        boss = self.level_script:createGameObject(self.level_script.prefabs.boss_spider, -328, 0, 127.2, -104.302, 1.5, bossCreated)
        
    end,

    onEnterPoint = function(self, id)
        if id == 43 and not self.cannon then
            hint:setText("Let's blast the hell out of him")
        end
    end,
}

--开炮攻击boss
local phase_cannon_3 = class{
    super = phase_base,

    onEnter = function(self)
        self.level_script:setPathPointType(3,0)
        local useCannon = function()
            self.level_script:incQuestProgress(22,1)
            self.level_script:removeOpTrigger(2)
            island_cannon = self.level_script:findGameObject('Prefab_Weapon_Artillery_Canmou')
            island_cannon:SetActive(false)
            if not is_fps then
                is_fps = true
                local pos = self.level_script.level.player:getPosition()
                pos.y = 26.39
                
                local rot = Quaternion.LookRotation(boss.transform.position - self.level_script.level.player.transform.position, Vector3.up)
                self.level_script:breakPlayerInput()
                -- self:playerKeepMoving()
                game_state_level:setFPSMode(is_fps, pos, rot, true, fps_cam_root.transform, 10010, function(hit_rst)
                game_state_level:updateShootEffect(10042)
                    if hit_rst then
                        --log.info('call hit enemy')
                        --self.level_script.level.player.cs_inst.transform
                        self:hitEnemy(hit_rst)
                    else
                        --log.info('not enter')
                    end
                end)
                boss:initBossStates()
                fps_cam = game_state_level.level_manager.FPSCamera
            end
        end

        self.level_script:createOpTrigger(2,8,43,useCannon)
    end,

    hitEnemy = function(self, hit_rst)
        if not hit_rst.collider then
            return
        end

        local go = hit_rst.collider.gameObject
        --log.error('HHHH tag name is '..go.tag)
        if go.name == 'Prefab_Boss_Spider' then
            boss_hp = boss_hp - 1
            --log.error('hit')
            boss:hit()
            if boss_hp == 0 then
                app:startCoroutine(
                    function()
                        --log.error('dead')
                        game_state_level:setFPSMode(false)
                        self.level_script.level_manager.levelCamera:SetActive(false)
                        bait_bullet_1 = self.level_script:createGameObject(self.level_script.prefabs.bait_bullet_1, -520, 37.7, -549.4, 0, 1)
                        local hit_point = self.level_script:findChild(boss.transform, 'Bone007')
                        local simple_bullet = SimpleBullet.Create(bait_bullet_1.go, Vector3.New(-520, 37.7, -549.4), hit_point.transform.position, 150, 10)
                        local total_time = simple_bullet.m_fTotalTime
                        self.level_script:cameraFocusToTransform(bait_bullet_1.go.transform)
                        self.level_script:wait(total_time - 0.2)
                        self.level_script.level_manager.levelCamera:SetActive(true)
                        self.level_script:removeGameObject(bait_bullet_1)

                        for i = 1, 30 do
                            if i <= 9 then
                                bone[i] = 'Bone00'..i
                            elseif i >= 10 and i <= 59 then
                                bone[i] = 'Bone0'..i
                            end
                            --log.error(bone[i])
                        end
            
                        for i = 1, 10 do
                            local x, y, z   
                            x = self.level_script:findChild(boss.transform, tostring(bone[i])).position.x
                            y = self.level_script:findChild(boss.transform, tostring(bone[i])).position.y
                            z = self.level_script:findChild(boss.transform, tostring(bone[i])).position.z
            
                            bone_fire[i] = self.level_script:createGameObject(self.level_script.prefabs.boom, x, y, z, 0, 1)
                            self.level_script:playCameraAnim('shake11')
                            self.level_script:wait(math.random(0.01,0.03))
                        end
                        self.level_script:playAnimation(boss, 'broken')
                        self.level_script:wait(3)
                        
                        self.level_script:cameraFocusToPlayer()
                        island_cannon = self.level_script:findGameObject('Prefab_Weapon_Artillery_Canmou')
                        island_cannon:SetActive(true)
                        self.level_script:resumePlayerInput()
                        level_script:changePhase('phase_cannon_4')
                        --self:wait(1)
            
                        for i = 1, 30 do
                            self.level_script:removeGameObject(bone_fire[i])
                        end

                        
                    end
                )
            end
        end
    end,
}


local phase_cannon_4 = class{
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                local rot_dummy = self.level_script:createGameObject(self.level_script.prefabs.dummy, 56, 0, -61, 0, 1)
                hint:setText('Boss is this alive, finish him before he runs away')
                self.level_script:wait(2)
                self.level_script:playAnimation(boss, 'brokenrun')
                boss:moveTo(Vector3.New(56,0,-61), 10)
                boss:rotateTo(rot_dummy.go.transform, 720)
                self.level_script:cameraFocusToTransform(boss.go.transform)
                self.level_script:wait(3)
                hint:setText("Let's roll out")
                self.level_script:cameraFocusToPlayer()
                self.level_script:changeCameraFov(50)
            end
        )
    end,

    onUpdate = function(self, dt)
        if Vector3.Distance(boss.go.transform.position, self.level_script:getPlayerPos()) <= 95 then
            self.level_script:battleWithMonster(99)
        end
    end,

    onBattleWin = function(self, id)
        if id == 99 then
            app:startCoroutine(
                function()
                    self.level_script:incQuestProgress(23,1)
                    self.level_script:wait(1)
                    self.level_script:finishLevel(true)
                end
            )
        end
    end,

}
    
-- 关卡 1006 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)

        self.prefabs = {
            churchill = 'Assets/Prefab/Level/level_prefab_kv2.prefab',     --丘吉尔坦克，解救英雄时用到
            boom = 'Assets/Arts/fx/prefab/die.prefab',       --爆炸特效
            camp_trigger = 'Assets/Prefab/Level/OperationTrigger.prefab',    --帐篷触发
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            boss_spider = 'Assets/Prefab/Vehicle/Level_Prefab_Boss_Spider.prefab',    --蜘蛛boss
            chest = 'Assets/Prefab/Level/level_chest.prefab',
            dummy = 'Assets/Prefab/Level/Level_dummy.prefab',
            bait_bullet = 'Assets/Prefab/Level/level_bait_bullet.prefab',       --信号弹摄像机
            bait_bullet_1 = 'Assets/Prefab/Level/level_bait_bullet_1.prefab',   --消灭boss炮弹摄像机
            bait = 'Assets/Prefab/Level/level_bait.prefab',
        }

        -- 预加载
        app:startCoroutine( function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)

        self:addPhases("phase_fps_test", phase_fps_test(self))
        self:addPhases("phase_start", phase_start(self))    --first phase of the chapter
        self:addPhases("phase_chase_1", phase_chase_1(self))
        self:addPhases("phase_chase_2", phase_chase_2(self))
        self:addPhases("phase_chase_3", phase_chase_3(self))
        self:addPhases("phase_cannon_1", phase_cannon_1(self))
        self:addPhases("phase_cannon_2", phase_cannon_2(self))
        self:addPhases("phase_cannon_3", phase_cannon_3(self))
        self:addPhases("phase_cannon_4", phase_cannon_4(self))
        self:changePhase("phase_start")
    end,

    onUpdate = function(self, dt)
        if boss then
            boss:update(dt)
        end
    end,
    
    onEnterPoint = function(self, point_id)
        super.onEnterPoint(self, point_id)
        app:logEvent("level_enter_point_2003_"..tostring(point_id), tostring(point_id))
    end,

    --fps mode fire
    fpsFire = function(self)
        game_state_level:fpsFire()
        --log.info('level script')
    end,
}