local log = logger.get("Game", "LevelScript 1006")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")

--init boss
local boss = nil            --boss level object

local player_movement = {}  --array stores player positions by turn
local player_index = 1      --array index
local boss_index = 0        --boss move index 
local boss_speed = 0
local boss_pos = nil
local boss_leg_1 = nil
local boss_leg_2 = nil
local time = 1   

local distance = 0
local distance_dt = 100      --玩家每走一步boss需要将距离拉近多少
local distance_init = 500
local player_move_count = 0
local distance_boss_need_to_move = 0
local distance_display
local show_boss_move = 99    --显示几次boss在移动

--turn based boss move
local boss_total_turn = 10      --总共移动多少回合
local boss_arrive_turn = 10      --已经移动了多少回合
local boss_player_distance = nil
local player_step_after_mob = 0
local mob_delay_step = 5
local oil_delay_step = 2
local boss_move_distance = 0
local boss_moved = 0        --distance boss moved whenever player enter path points
local boss_lerp = 0         -- 0 为不走，1是走到boss
local lerp_pos = nil

--friendly mobs to buy time
local friend_mob_1 = nil
local friend_mob_2 = nil
local friend_mob_count = 1     --waves of friendly mobs

--chests
local chest_11_go = nil
local chest_11 = false
local chest_27_go = nil
local chest_27 = false
local chest_30_go = nil
local chest_30 = false

--oil factory related
local oil_6 = nil
local oil_15 = nil
local oil_20 = nil
local oil_destroy_count = 0
--油井路点依次为 6， 15， 20
--宝箱点 11，27 30

local des_1, des_2 = nil
local run = true
local is_fps = false
local soldier_test_count = 0
local sniper = nil
local fps_cam = nil
local fps_cam_root = nil

-- local p1 = Vector3.New(253.1, 0, -127.3)    --start point
-- local p2 = Vector3.New(113.4, 0, -78.9)     --first byroad, forward to p4, turn left to p3
-- local p3 = Vector3.New(6.9, 0, -356.7)
-- local p4 = Vector3.New(-964.8, 0, -153.3)   --second byroad, forward to p6, turn left to p5
-- local p5 = Vector3.New(-984.2, 0, -353)
-- local p6 = Vector3.New(-1404, 0, -351)      --third byroad, forward to p7, turn left to p8
-- local p7 = Vector3.New(-1674, 0, -415)
-- local p8 = Vector3.New(-1057.2, 0, -831)    --last byroad, left to p10, right to p9
-- local p9 = Vector3.New(-1058, 0, -1143)
-- local p10 = Vector3.New(-804, 0, -892)
-- local p11 = Vector3.New(-401.2, 0, 16)

local p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11 = nil
local fps_path_init = {p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11}
local fps_path_name = {'p1','p2','p3','p4','p5','p6','p7','p8','p9','p10','p11'}
local fps_path_list = {}
--local fps_path_list = {p1,p2,p4,p6,p8,p10}


local path_count = 1

local is_broken = false
local mob_1, mob_2, mob_3, mob_4, mob_5, mob_6 = 0
local mob_1_hp = 2
local mob_2_hp = 2
local mob_3_hp = 2
local mob_4_hp = 2
local mob_5_hp = 2
local mob_6_hp = 2
local player_force_stop = false
-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用

--测试vector3之间运算
local phase_00 = class {
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                local boss_created = function()
                    self.level_script:changePhase('phase_7')
                end
                --self.level_script:wait(2)
                --self.level_script:battleWithMonster(97, false)
                self.level_script:wait(5)
                self.level_script:battleWithMonster(97,false)
                boss = self.level_script:createGameObject(self.level_script.prefabs.boss_spider, 492.1, 0, 202.2, -100, 0.8, boss_created)
            end
        )
    end,
}

local phase_soldier_api_test = class{
    super = phase_base,

    onEnter = function(self)
    end,

    onEnterPoint = function(self, id)
        if soldier_test_count == 0 then
            sniper = self.level_script:createGameObject(self.level_script.prefabs.sniper, 472.5, 0, -123, 0, 1)
        elseif soldier_test_count == 1 then
            sniper:playSoldierAnimation('attack')
        elseif soldier_test_count == 2 then
            sniper:moveTo(Vector3.New(267.9, 0, -84.5), 30)
        elseif soldier_test_count == 3 then
            sniper:playSoldierAnimation('run')
        end
        soldier_test_count = soldier_test_count + 1
    end,
}

local phase_fps_test = class{
    super = phase_base,

    onEnter = function(self)

        p1 = self.level_script:findGameObject('p1').transform.position
        p2 = self.level_script:findGameObject('p2').transform.position
        p3 = self.level_script:findGameObject('p3').transform.position
        p4 = self.level_script:findGameObject('p4').transform.position
        p5 = self.level_script:findGameObject('p5').transform.position
        p6 = self.level_script:findGameObject('p6').transform.position
        p7 = self.level_script:findGameObject('p7').transform.position
        p8 = self.level_script:findGameObject('p8').transform.position
        p9 = self.level_script:findGameObject('p9').transform.position
        p10 = self.level_script:findGameObject('p10').transform.position
        p11 = self.level_script:findGameObject('p11').transform.position
        fps_path_list = {p1,p2,p4,p6,p8,p10}

        self.hit_count = 0
        self.mob_hit_count = 0
        local boss_created = function()
            boss:initBossStates()
            boss:moveInPath(fps_path_list, 20)
            
            self:player_endless_move()
            cam_root = self.level_script:createGameObject(self.level_script.prefabs.dummy, 0,0,0,0,1)
            --这里非常重要啊，boss是一个levelgameobject，先取他的gameobject，再取这个gameobject中boscollider组件，
            --然后将这个collider的gameobject的name赋值，然后在raycasthit里面去判断
            boss.go:GetComponentInChildren(UnityEngine.BoxCollider).gameObject.name = 'boss'        
        end
        boss = self.level_script:createGameObject(self.level_script.prefabs.boss_spider, 849, 0, -123, -88.799, 1.5, boss_created)
        --self.level_script:createGameObject(self.level_script.prefabs.churchill, fps_path_list[i].x, 0, fps_path_list[i].z, 0, 1)
    end,

    hitEnemy = function(self, hit_rst)
        if not hit_rst.collider then
            return
        end

        local go = hit_rst.collider.gameObject
        --log.error('HHHH tag name is '..go.tag)
        if go.name == 'boss' then
            hint:setText('Hit')
            boss:hit()
        elseif go.name == 'mob_1' and mob_1 then
            mob_1_hp = mob_1_hp - 1
            if mob_1_hp <= 0 then
                self.mob_1_dead = true
                local fx = self.level_script:createGameObject(self.level_script.prefabs.boom, mob_1.go.transform.position.x, 0, mob_1.go.transform.position.z, 0, 1)
                app:startCoroutine(
                    function()
                        self.level_script:removeGameObject(mob_1)
                        self.level_script:wait(2)
                        self.level_script:removeGameObject(fx)
                    end
                )
            end
        elseif go.name == 'mob_2' and mob_2 then
            mob_2_hp = mob_2_hp - 1
            if mob_2_hp <= 0 then
                self.mob_2_dead = true
                local fx = self.level_script:createGameObject(self.level_script.prefabs.boom, mob_2.go.transform.position.x, 0, mob_2.go.transform.position.z, 0, 1)
                app:startCoroutine(
                    function()
                        self.level_script:removeGameObject(mob_2)
                        self.level_script:wait(2)
                        self.level_script:removeGameObject(fx)
                    end
                )
            end
        elseif go.name == 'mob_3' and mob_3 then
            mob_3_hp = mob_3_hp - 1
            if mob_3_hp <= 0 then
                self.mob_3_dead = true
                local fx = self.level_script:createGameObject(self.level_script.prefabs.boom, mob_3.go.transform.position.x, 0, mob_3.go.transform.position.z, 0, 1)
                app:startCoroutine(
                    function()
                        self.level_script:removeGameObject(mob_3)
                        self.level_script:wait(2)
                        self.level_script:removeGameObject(fx)
                    end
                )
            end
            
        end
    end,

    player_endless_move = function(self)
        if player_force_stop == true then
            return
        end
        self.level_script:breakPlayerInput()
        
        local random_pos = fps_path_list[path_count]
        if not random_pos then
            -- 结束了
            log.error('return')
            return
        end
        
        --log.error('move call back, count =  '..path_count)    
        path_count = path_count + 1        
        
        self.level_script:playerMoveTo(random_pos, 40, 
        function()
            log.info("### on callback called!")
            self:player_endless_move()
        end)
        end,

    onEnterPoint = function(self, id)
        if not is_fps then
            is_fps = true
            local pos = self.level_script.level.player:getPosition()
            pos.y = 13.29
            local rot = Quaternion.LookRotation(boss.transform.position - self.level_script.level.player.transform.position, Vector3.up)
            self.level_script:breakPlayerInput()
            -- self:playerKeepMoving()
            game_state_level:setFPSMode(is_fps, pos, rot, true, cam_root.transform, function(hit_rst)
                if hit_rst then
                    --log.info('call hit enemy')
                    --self.level_script.level.player.cs_inst.transform
                    self:hitEnemy(hit_rst)
                else
                    --log.info('not enter')
                end
            end)

            fps_cam = game_state_level.level_manager.FPSCamera
        end
    end,

    onUpdate = function(self, dt)
        boss:rotateTo(self.level_script.level.player.transform, 720)
        local player_pos = self.level_script:getPlayerPos()
        if cam_root then
            cam_root.transform.position = player_pos
        end

        if self.mob_1_dead and self.mob_2_dead and self.mob_3_dead then
            log.error('player resume moving')
            self:player_endless_move()
            player_force_stop = false
            self.mob_1_dead = false
        end
    end,

    onEnterTrigger = function(self, trigger_name)
        if trigger_name == 'Trigger01' then
            --log.error('enter trigger01')
            local fps_mob_created = function()
                mob_1.go:GetComponentInChildren(UnityEngine.CapsuleCollider).gameObject.name = 'mob_1'
                mob_2.go:GetComponentInChildren(UnityEngine.CapsuleCollider).gameObject.name = 'mob_2'
                mob_3.go:GetComponentInChildren(UnityEngine.CapsuleCollider).gameObject.name = 'mob_3'

                
                app:startCoroutine(
                    function()
                        for i = 1, 100 do
                            if mob_1 then
                                self.level_script:playAnimation(mob_1, 'attack')
                                self.level_script:shootBullet(10010, self.level_script:findChild(mob_1.transform,"shoot"),self.level_script:getPlayerPos(),300)
                                self.level_script:wait(math.random(0,0.3))
                            end

                            if mob_2 then
                                self.level_script:playAnimation(mob_2, 'attack')
                                self.level_script:shootBullet(10010, self.level_script:findChild(mob_2.transform,"shoot"),self.level_script:getPlayerPos(),300)
                                self.level_script:wait(math.random(0,0.3))
                            end

                            if mob_3 then
                                self.level_script:playAnimation(mob_3, 'attack')
                                self.level_script:shootBullet(10010, self.level_script:findChild(mob_3.transform,"shoot"),self.level_script:getPlayerPos(),300)
                                self.level_script:wait(math.random(0,0.3))
                            end
                        end
                    end
                )
            end

            mob_1 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -590.5, 0, 107.9, 111.876, 2)
            mob_2 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -610.1, 0, 57.2, 93.273, 2)
            mob_3 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -575.6, 0, 9.8, 77.985, 2,fps_mob_created)
            --self.level_script:playerStopMove()
        elseif trigger_name == 'Trigger02' then
            --log.error('trigger02')
            hint:setText('糟糕，前面的去路被拦住了，快点消灭他们')
            player_force_stop = true
            mob_1:rotateTo(self.level_script.level.player.transform,180)
            mob_2:rotateTo(self.level_script.level.player.transform,180)
            mob_3:rotateTo(self.level_script.level.player.transform,180)
            self.level_script:playerStopMove()

        end
    end,

}
--测试蜘蛛滑步
local phase_spider_walk = class{
    super = phase_base,

    onEnter = function(self)

        game_state_level.gui:showSpeedTest()
        local boss_created = function()
            self.level_script:cameraFocusToTransform(boss.transform,true)
            self.level_script:playAnimation(boss,'run')
        end

        boss = self.level_script:createGameObject(self.level_script.prefabs.boss_spider, 207.1893, 0, -80.31165, -88.799, 0.8, boss_created)
        des_1 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -1392, 0, -430, -88.799, 0.8)
        des_2 = self.level_script:createGameObject(self.level_script.prefabs.churchill, 160, 0, -72, -88.799, 0.8)
    end,

    onExit = function(self)
        game_state_level.gui:hideSpeedTest()
    end,

    onEnterPoint = function(self, id)
        local speed = 60
        if game_state_level.gui:returnSpeed() then
            speed = game_state_level.gui:returnSpeed()
        end

        if run == true then
            boss:rotateTo(des_1.transform,1000)
            self.level_script:gameObjectMoveTo(boss, des_1.transform.position, speed)
            run = false
        elseif run == false then
            boss:rotateTo(des_2.transform,1000)
            self.level_script:gameObjectMoveTo(boss, des_2.transform.position, speed)
            run = true
        end
    end,
}
local phase_0 = class {
    super = phase_base,

    onEnter = function(self)
        --call back to play animation after create boss
        --level_script:finishLevel(true)
        local boss_created = function()
            self.level_script:playAnimation(boss,'idle')
        end
        boss = self.level_script:createGameObject(self.level_script.prefabs.boss_spider, 492.1, 0, 202.2, -100, 0.8, boss_created)
        

        self.level_script:playDialog(200301)
    end,

    onBattleWin = function(self, index)
        app:startCoroutine(
            function()
                if index == 87 then
                    local dialogCB239 = function()
                        app:startCoroutine(
                            function()
                                self.level_script:wait(0.5)
                                self.level_script:cameraFocusToPlayer()
                                self.level_script:changePhase('phase_6')        --演示时可以在这里切换模式
                            end
                        )
                    end
                    self.level_script:wait(0.5)
                    self.level_script:cameraFocusToTransform(boss.transform,true)
                    self.level_script:playAnimation(boss,'born')
                    self.level_script:wait(3.5)
                    self.level_script:playDialog(200302,dialogCB239)
                    self.level_script:wait(6.67 - 3.5)
                    self.level_script:playAnimation(boss,'idle')
                end
            end
        )
    end,
}
--boss按玩家路径行走
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)
        --init
        player_movement[player_index] = self.level_script:getPlayerPos()
        player_index = player_index + 1

        
        --log.error('enter')
    end,

    onEnterPoint = function(self, point_id)
        --add new elements to array
        player_movement[player_index] = self.level_script:getPlayerPos()
        player_index = player_index + 1
        --boss start run animation
        self.level_script:playAnimation(boss,'run')

        --on stop play random idle animation
        local boss_stopped = function()
            --play random idle animation after stopped
            local dice = math.random()
            if dice >= 0.5 then
                self.level_script:playAnimation(boss,'idle')
            else
                self.level_script:playAnimation(boss,'idle_1')
            end
        end

        --见level_game_object中rotateTo函数
        local self_trans = boss.transform
        app:startCoroutine(
            function()
                while true do
                    coroutine.yield(nil)
                    local rt = Quaternion.LookRotation(player_movement[player_index - 2] - self_trans.position)
                    self_trans.rotation = 
                        Quaternion.RotateTowards(
                            boss.transform.rotation, 
                            rt,
                            Time.deltaTime * 180)
                    if self_trans.rotation == rt then
                        self.level_script:gameObjectMoveTo(boss,player_movement[player_index - 2],40,boss_stopped)
                        break   --你敢去掉试试
                    end 
                end
            end
        )
    end,

    onUpdate = function(self, dt)
        local distance = nil

        distance = Vector3.Distance(boss.transform.position,self.level_script:getPlayerPos())
        if distance <= 30 then
            self.level_script:playAnimation(boss,'attack_1')
            --log.error('BOSS CATCH U!')
            --self.level_script:removeGameObject(boss)
            --self.level_script:changePhase('phase_2')
        end
    end,
}

--boss按回合移动，距离使用实际距离
local phase_2 = class{
    super = phase_base,

    onEnter = function(self)
        distance = Vector3.Distance(boss.transform.position,self.level_script:getPlayerPos())   --init distance
    end,

    onEnterPoint = function(self)
        app:startCoroutine(
            function()
                player_move_count = player_move_count + 1
                distance_boss_need_to_move = player_move_count * distance_dt
                boss_arrive_turn = boss_arrive_turn - 1
                distance = Vector3.Distance(boss.transform.position,self.level_script:getPlayerPos())

                if distance > 150 then
                    self.level_script:playAnimation(boss,'run')
                else
                    self.level_script:playAnimation(boss,'walk')
                    self.level_script:playCameraAnim('shake11')
                end
                
                --展现boss在追
                if distance_display > 200 then
                    self.level_script:cameraFocusToTransform(boss.transform,true)
                end

                --开始追
                self.level_script:gameObjectMoveTo(boss,self.level_script:getPlayerPos(),30)
                boss:rotateTo(self.level_script.level.player.transform,100)
                self.level_script:wait(2)
                self.level_script:cameraFocusToPlayer()
            end
        )
    end,

    onUpdate = function(self, dt)
        
        --在UI上显示boss距离
        distance_display = Vector3.Distance(boss.transform.position,self.level_script:getPlayerPos())
        time = time + dt
        local text = boss_arrive_turn..'回合'

        if boss_arrive_turn > 6 then
            game_state_level.gui:showBossDistance(text,distance_display)
        elseif distance_display <= 300 then
            if time >= 0.3 and time <= 1 then
                game_state_level.gui:showBossDistance(text,distance_display)
            elseif time > 1 then
                time = 0
            elseif time < 0.3 then
                game_state_level.gui:blinkBossDistance()
            end
        end

        if distance_display <= 500 - distance_boss_need_to_move then
            self.level_script:playAnimation(boss,'idle')
            boss:stopMove()
            boss:stopRotate()
        end

        if distance_display <= 150 then
            if friend_mob_count > 0 and oil_destroy_count < 3 then
                self.level_script:playAnimation(boss,'idle')
                boss:stopMove()
                boss:stopRotate()
                player_move_count = player_move_count - 3
                self.level_script:changePhase('phase_4')
            else
                app:startCoroutine(
                    function()
                        boss:stopMove()
                        boss:stopRotate()
                        self.level_script:playAnimation(boss,'attack_1')
                        self.level_script:wait(2)
                        self.level_script:changePhase('phase_5')
                        self.level_script:battleWithMonster(97,false)       --97 非常厉害的boss，98 正常难度boss
                    end
                )
            end
        end
        --log.error(distance..'  '..boss_speed)
    end,
}

--boss实时移动，距离使用实际距离
local phase_3 = class{
    super = phase_base,

    onEnter = function(self)
        --log.error('enter p3')
        self.level_script:playAnimation(boss,'run')
    end,

    onUpdate = function(self, dt)
        if not self.move_dt then
            self.move_dt = 1.0
        end

        distance = Vector3.Distance(boss.transform.position,self.level_script:getPlayerPos())

        if distance >= 300 then
            boss_speed = 60 - oil_destroy_count * 7
        else
            boss_speed = 40 - oil_destroy_count * 7
        end 

        --log.error('boss speed '..boss_speed)
        --不要在Update中疯狂的每帧调用，要有节制
        self.move_dt = self.move_dt + dt
        if self.move_dt >= 1.0 then
            
            if distance > 150 then
                self.level_script:playAnimation(boss,'run')
            else
                self.level_script:playAnimation(boss,'walk')
                self.level_script:playCameraAnim('shake11')
            end

            if distance >= 110 then
                self.level_script:gameObjectMoveTo(boss,self.level_script:getPlayerPos(),boss_speed)
                boss:rotateTo(self.level_script.level.player.transform,100)
            elseif distance < 110 then
                boss:stopMove()
                boss:stopRotate()
                self.level_script:playAnimation(boss,'attack_1')
                if friend_mob_count > 0 then
                    self.level_script:changePhase('phase_4')
                else
                    app:startCoroutine(
                        function()
                            self.level_script:playAnimation(boss,'attack_1')
                            self.level_script:wait(2)
                            self.level_script:changePhase('phase_5')
                            self.level_script:battleWithMonster(97,false)       --97 非常厉害的boss，98 正常难度boss
                        end
                    )
                end
            end
            self.move_dt = 0
        end

        
        --在UI上显示boss距离
        time = time + dt
        if distance > 300 then
            game_state_level.gui:showBossDistance(math.ceil(distance),distance)
        elseif distance <= 300 then
            if time >= 0.3 and time <= 1 then
                game_state_level.gui:showBossDistance(math.ceil(distance),distance)
            elseif time > 1 then
                time = 0
            elseif time < 0.3 then
                game_state_level.gui:blinkBossDistance()
            end
        end
        --log.error(distance..'  '..boss_speed)
    end,
}

--boss接近后的逻辑处理
local phase_4 = class{
    super = phase_base,

    onEnter = function(self)
        --log.error('enter p4')
        local pos = self.level_script:getPlayerPos()
        self.level_script:breakPlayerInput()
        local dialog256 = function()
            self.level_script:createGameObject(self.level_script.prefabs.boom,friend_mob_1.transform.position.x, 0, friend_mob_1.transform.position.z, 0, 1)
            self.level_script:createGameObject(self.level_script.prefabs.boom,friend_mob_2.transform.position.x, 0, friend_mob_2.transform.position.z, 0, 1)
            self.level_script:removeGameObject(friend_mob_1)
            self.level_script:removeGameObject(friend_mob_2)
            self.level_script:cameraFocusToPlayer()
            self.level_script:resumePlayerInput()
            self.level_script:changePhase('phase_6')        --演示切换
        end

        local mob_move_finish = function()
            --log.error('mob move')
            boss_arrive_turn = boss_arrive_turn + mob_delay_step
            app:startCoroutine(
                function()
                    --self.level_script:cameraFocusToPlayer()
                        -- mob delay boss
                    for i = 1, 6 do
                        local boss_body_1 = self.level_script:findChild(boss.transform,'Bone009')
                        local boss_body_2 = self.level_script:findChild(boss.transform,'Bone001')
                        self.level_script:playAnimation(friend_mob_1,'attack')
                        self.level_script:playAnimation(friend_mob_2,'attack')
                        self.level_script:wait(0.2)
                        self.level_script:shootBullet(10010,friend_mob_1:findChild('shoot'), boss_body_1.position,100)
                        self.level_script:wait(0.1)
                        self.level_script:shootBullet(10010,friend_mob_2:findChild('shoot'),boss_body_2.position,100)
                        self.level_script:playAnimation(boss,'attack_1')
                        self.level_script:wait(0.7)
                    end
                    self.level_script:wait(0.3)
                    --坦克攻击会持续一段时间，此时boss不再追玩家，一段时间后，镜头回到boss，boss杀死小怪，继续追击玩家
   
                    --self.level_script:wait(0.5)
                    --hint:setText('你还有【'..friend_mob_count..'】波友军支援')
                    --self.level_script:cameraFocusToTransform(boss.transform,true)
                    self.level_script:playDialog(200303,dialog256)
                end
            )
        end

        local dialog250 = function()
            app:startCoroutine(
                function()


                    boss_pos = boss.transform.position

                    if boss_pos and boss.transform then
                        --friend_mob_1:rotateTo(boss_leg_2, 720)
                        --friend_mob_2:rotateTo(boss_leg_1, 720)
                        
                        boss_leg_1 = self.level_script:findChild(boss.transform,'IK Chain005')
                        boss_leg_2 = self.level_script:findChild(boss.transform,'IK Chain001')

                        local mob_1_dest = ( boss_leg_1.position + self.level_script:getPlayerPos()) / 2    --vector 3
                        local mob_2_dest = ( boss_leg_2.position + self.level_script:getPlayerPos()) / 2

                        self.level_script:gameObjectMoveTo(friend_mob_1, Vector3.New(mob_1_dest.x, 0, mob_1_dest.z), 60)
                        self.level_script:gameObjectMoveTo(friend_mob_2, Vector3.New(mob_2_dest.x, 0, mob_2_dest.z), 60,mob_move_finish)
                    else
                        log.error('Can not find boss position or transform')
                    end
                end
            )
        end

        local mob_created = function()
            self.level_script:cameraFocusToTransform(friend_mob_1.transform,true)
            self.level_script:playDialog(200304,dialog250)
        end

        friend_mob_count = friend_mob_count - 1

        --获取小怪出生点
        local getMobPoint = function(boss_pos,player_pos,offset)
            local front = Vector3.Normalize(boss_pos - player_pos)
            local right = Vector3(front.z, 0, -front.x)
            local left = -right
            return player_pos + left*offset, player_pos + right*offset
            
        end

        local p1, p2 = getMobPoint(boss.transform.position, self.level_script:getPlayerPos(),20)

        boss_leg_1 = self.level_script:findChild(boss.transform,'IK Chain005')
        boss_leg_2 = self.level_script:findChild(boss.transform,'IK Chain001')

        --log.info("leg1:"..tostring(boss_leg_1.position)) -- 左边的
        --log.info("leg2:"..tostring(boss_leg_2.position)) -- 右边的

        local r1 = Quaternion.LookRotation(boss_leg_1.position - p1)
        local r2 = Quaternion.LookRotation(boss_leg_2.position - p2)

        --获取小怪旋转值
        local getRotYaw = function(rot)
            local angle
            local axis
            angle, axis = rot:ToAngleAxis()
            if axis.y < 0 then
                angle = -angle
            end
            return 180 * angle/3.14159
        end

        
        friend_mob_1 = self.level_script:createGameObject(self.level_script.prefabs.churchill,p1.x, 0, p1.z, getRotYaw(r1), 1.5)
        friend_mob_2 = self.level_script:createGameObject(self.level_script.prefabs.churchill,p2.x, 0, p2.z, getRotYaw(r2), 1.5, mob_created)
    end,

    onBattleWin = function(self, index)     --index为entity的索引编号
        self.level_script:changePhase('phase_6')
    end,

    -- 一场战斗失败
    onBattleLose = function(self, index)
        self.level_script:changePhase('phase_6')
    end,
}

--boss按照回合移动，距离使用回合概念
local phase_6 = class{
    super = phase_base,

    onEnter = function(self)
        distance = Vector3.Distance(boss.transform.position,self.level_script:getPlayerPos())   --init distance
        log.info('Initiall Boss to Player Distance = '..distance)
    end,

    onEnterPoint = function(self)
        app:startCoroutine(
            function()
                if oil_destroy_count == 3 then
                    self.level_script:changePhase('phase_5')
                    self.level_script:battleWithMonster(97,false)
                end

                self.level_script:breakPlayerInput()
                boss_arrive_turn = boss_arrive_turn - 1
                distance = Vector3.Distance(boss.transform.position,self.level_script:getPlayerPos())

                boss_lerp = 1 - (boss_arrive_turn) / (boss_arrive_turn + 1)
                lerp_pos = Vector3.Lerp(boss.transform.position, self.level_script:getPlayerPos(), boss_lerp)
                --log.error('boss_lerp = '..boss_lerp)

                --if boss_arrive_turn > 2 then
                    self.level_script:cameraFocusToTransform(boss.transform,true)
                --end

                local boss_move_finish = function()
                    self.level_script:playAnimation(boss,'idle')
                    self.level_script:resumePlayerInput()
                    --log.error('boss stopped')
                    
                    if boss_arrive_turn == 1 and friend_mob_count > 0 then
                        self.level_script:changePhase('phase_4')
                    elseif boss_arrive_turn == 0 then
                        app:startCoroutine(
                            function()
                                self.level_script:playAnimation(boss,'attack_1')
                                self.level_script:wait(2)
                                self.level_script:changePhase('phase_5')
                                self.level_script:battleWithMonster(97,false)       --97 非常厉害的boss，98 正常难度boss
                            end
                        )
                    end
                end

                --boss start chasing
                self.level_script:playAnimation(boss,'run')
                self.level_script:gameObjectMoveTo(boss, lerp_pos, 32, boss_move_finish)
                boss:rotateTo(self.level_script.level.player.transform,100)
                self.level_script:wait(2)
                self.level_script:cameraFocusToPlayer()
            end
        )
    end,

    onUpdate = function(self, dt)
        --UI display boss arrive in how many turns
        local text = boss_arrive_turn..'回合'
        game_state_level.gui:showBossDistance(text,boss_arrive_turn)
        
        if boss_arrive_turn > 6 then
            game_state_level.gui:showBossDistance(text,boss_arrive_turn)
        elseif boss_arrive_turn <= 6 then
            if time >= 0.3 and time <= 1 then
                game_state_level.gui:showBossDistance(text,boss_arrive_turn)
            elseif time > 1 then
                time = 0
            elseif time < 0.3 then
                game_state_level.gui:blinkBossDistance()
            end
        end
    end,
}


--boss战斗后的逻辑处理
local phase_5 = class{
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                hint:setText('临时的BOSS战')
            end
        )
    end,

    onBattleWin = function(self, id)
        if id == 97 then
            local dialog246CB = function()
                self.level_script:finishLevel(true)
            end
            self.level_script:removeGameObject(boss)
            self.level_script:incQuestProgress(12,1)
            self.level_script:playDialog(200305,dialog246CB)
        end
    end,

    onBattleLose = function(self,id)
        if id == 97 then
            hint:setText('BOSS的技能过于强大，下次一定要好好打断哟，GOOD LUCK')
            self.level_script:wait(3)
            self.level_script:finishLevel(false)
        end
    end
}

local phase_7 = class{
    super = phase_base,

    onEnter = function(self)
        local burn = function()
            app:startCoroutine(
                function()
                    local player_pos = self.level_script:getPlayerPos()
                    local boss_pos = boss.transform.position
                    local burn_points = {}
                    local burn_go = {}
                    local bone = {}
                    local bone_fire = {}

                    for i = 1, 75 do
                        burn_points[i] = Vector3.Lerp(boss_pos, player_pos, 1- (i / 75) )
                        burn_go[i] = self.level_script:createGameObject(self.level_script.prefabs.fire, burn_points[i].x + math.random(-5,5), 2, burn_points[i].z + math.random(-5,5), 0, 1)
                        self.level_script:cameraFocusToTransform(burn_go[i].transform)
                        self.level_script:wait(0.05)
                        --self.level_script:removeGameObject(burn_go[i])
                    end

                    self.level_script:playAnimation(boss, 'broken')

                    self.level_script:wait(0.1)

                    for i = 1, 30 do
                        if i <= 9 then
                            bone[i] = 'Bone00'..i
                        elseif i >= 10 and i <= 59 then
                            bone[i] = 'Bone0'..i
                        end
                        --log.error(bone[i])
                    end

                    self.level_script:wait(0.1)

                    for i = 1, 30 do
                        local x, y, z   
                        x = self.level_script:findChild(boss.transform, tostring(bone[i])).position.x
                        y = self.level_script:findChild(boss.transform, tostring(bone[i])).position.y
                        z = self.level_script:findChild(boss.transform, tostring(bone[i])).position.z

                        bone_fire[i] = self.level_script:createGameObject(self.level_script.prefabs.fire, x, y, z, 0, 1)
                    end

                    self.level_script:wait(1)

                    for i = 1, 75 do
                        self.level_script:removeGameObject(burn_go[i])
                        self.level_script:wait(0.05)
                    end

                    self.level_script:wait(1)

                    for i = 1, 30 do
                        self.level_script:removeGameObject(bone_fire[i])
                    end

                    self.level_script:playAnimation(boss, 'idle')
                end
            )
        end
        self.level_script:createOpTrigger(100,1,0,burn)
    end,
}
-- 关卡 1006 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)

        self.prefabs = {
            churchill = 'Assets/Prefab/Level/level_prefab_kv2.prefab',     --丘吉尔坦克，解救英雄时用到
            boom = 'Assets/Arts/fx/prefab/die.prefab',       --爆炸特效
            camp_trigger = 'Assets/Prefab/Level/OperationTrigger.prefab',    --帐篷触发
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            repair_kit = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Battery.prefab',   --修复桥梁的物品
            progess_text = 'Assets/Prefab/Level/Level_progress_text.prefab',    --进度条文字
            boss_spider = 'Assets/Prefab/Vehicle/Level_Prefab_Boss_Spider.prefab',    --蜘蛛boss
            chest = 'Assets/Prefab/Level/level_chest.prefab',
            oil_factory = 'Assets/Prefab/Level/level_oil_factory.prefab',
            fire = 'Assets/Prefab/Level/level_fire.prefab',
            sniper = 'Assets/Prefab/Level/level_soldier_sniper.prefab',
            dummy = 'Assets/Prefab/Level/Level_dummy.prefab',
        }

        -- 预加载
        app:startCoroutine( function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)
        self:addPhases("phase_spider_walk", phase_spider_walk(self))
        self:addPhases("phase_fps_test", phase_fps_test(self))
        self:addPhases("phase_soldier_api_test", phase_soldier_api_test(self))
        
        self:addPhases("phase_00", phase_00(self))
        self:addPhases("phase_0", phase_0(self))
        self:addPhases("phase_1", phase_1(self))
        self:addPhases("phase_2", phase_2(self))
        self:addPhases("phase_3", phase_3(self))
        self:addPhases("phase_4", phase_4(self))
        self:addPhases("phase_5", phase_5(self))
        self:addPhases("phase_6", phase_6(self))
        self:addPhases("phase_7", phase_7(self))
        --self:changePhase("phase_spider_walk")
        self:changePhase("phase_fps_test")
        --self:changePhase("phase_soldier_api_test")
        --self:changePhase("phase_0")
        --chests
        --chest_27_go = self:createGameObject(self.prefabs.chest, -431.1, 0, -35.3, 0, 1)
        chest_11_go = self:createGameObject(self.prefabs.chest, -825.3, 0, 110.8, 0, 1)
        --chest_30_go = self:createGameObject(self.prefabs.chest, -892, 0, -55, 0, 1)
        -- oil field trigger, path point 6, 15, 20
        -- oil_6 = self:createGameObject(self.prefabs.oil_factory,-619, 0, -5, 57.256, 0.5)
        -- oil_15 = self:createGameObject(self.prefabs.oil_factory,-1200.3, 0, -252.2, 46.22, 0.5)
        -- oil_20 = self:createGameObject(self.prefabs.oil_factory,-914.5445, 0, -533.1, 55.294, 0.5)

        local burnburn = function()
            app:startCoroutine(
                function()
                    local player_pos = self:getPlayerPos()
                    local boss_pos = boss.transform.position
                    local burn_points = {}
                    local burn_go = {}
                    local bone = {}
                    local bone_fire = {}
        
                    for i = 1, 100 do
                        burn_points[i] = Vector3.Lerp(boss_pos, player_pos, 1- (i / 100) )
                        burn_go[i] = self:createGameObject(self.prefabs.fire, burn_points[i].x + math.random(-5,5), 2, burn_points[i].z + math.random(-10,10), 0, 1)
                        self:cameraFocusToTransform(burn_go[i].transform)
                        self:wait(0.05)
                        --self:removeGameObject(burn_go[i])
                    end
        
                    self:playAnimation(boss, 'broken')
                    if oil_destroy_count < 3 then
                        hint:setText('你点燃了油井，熊熊大火拖延了蜘蛛的行动')
                    end
                    self:wait(0.1)
        
                    for i = 1, 30 do
                        if i <= 9 then
                            bone[i] = 'Bone00'..i
                        elseif i >= 10 and i <= 59 then
                            bone[i] = 'Bone0'..i
                        end
                        --log.error(bone[i])
                    end
        
                    self:wait(0.1)
        
                    for i = 1, 30 do
                        local x, y, z   
                        x = self:findChild(boss.transform, tostring(bone[i])).position.x
                        y = self:findChild(boss.transform, tostring(bone[i])).position.y
                        z = self:findChild(boss.transform, tostring(bone[i])).position.z
        
                        bone_fire[i] = self:createGameObject(self.prefabs.fire, x, y, z, 0, 1)
                    end
        
                    self:wait(2)
                    self:cameraFocusToPlayer()
                    for i = 1, 100 do
                        self:removeGameObject(burn_go[i])
                        --self:wait(0.05)
                    end
        
                    --self:wait(1)
        
                    for i = 1, 30 do
                        self:removeGameObject(bone_fire[i])
                    end
        
                    self:playAnimation(boss, 'idle')
                end
            )
        end

        local destroy6 = function()
            app:startCoroutine(
                function()
                    local boom_oil = self:createGameObject(self.prefabs.boom,-614.5, 44.85, -19.8,0,1)
                    self:removeOpTrigger(1)
                    self:incQuestProgress(11,1)
                    oil_destroy_count = oil_destroy_count + 1

                    burnburn()

                    boss_arrive_turn = boss_arrive_turn + oil_delay_step
                    if oil_destroy_count == 3 then
                        hint:setText('你破坏了所有油井，可以打boss了')
                    end
                    self:wait(0.3)
                    self:playAnimation(oil_6, 'ruins')
                    self:removeGameObject(boom_oil)
                end    
            )
        end
        
        local destroy15 = function()
            app:startCoroutine(
                function()
                    local boom_oil = self:createGameObject(self.prefabs.boom,-1261.2, 44.85, -214.6,0,1)
                    self:removeOpTrigger(2)
                    self:incQuestProgress(11,1)
                    oil_destroy_count = oil_destroy_count + 1
                    
                    burnburn()

                    boss_arrive_turn = boss_arrive_turn + oil_delay_step
                    if oil_destroy_count == 3 then
                        hint:setText('你破坏了所有油井，可以打boss了')
                    end
                    self:wait(0.3)
                    self:playAnimation(oil_15, 'ruins')
                    self:removeGameObject(boom_oil)
                end    
            )
        end

        local destroy20 = function()
            app:startCoroutine(
                function()
                    local boom_oil = self:createGameObject(self.prefabs.boom,-927.9, 44.85, -571.4,0,1)
                    self:removeOpTrigger(3)
                    self:incQuestProgress(11,1)
                    oil_destroy_count = oil_destroy_count + 1
                    
                    burnburn()

                    boss_arrive_turn = boss_arrive_turn + oil_delay_step
                    if oil_destroy_count == 3 then
                        hint:setText('你破坏了所有油井，可以打boss了')
                    end
                    self:wait(0.3)
                    self:playAnimation(oil_20, 'ruins')
                    self:removeGameObject(boom_oil)
                end    
            )
        end
        self:createOpTrigger(1, 5, 6, destroy6)
        self:createOpTrigger(2, 5, 15, destroy15)
        self:createOpTrigger(3, 5, 20, destroy20)
    end,

    onEnterPoint = function(self, point_id)
        ------------NEVER EVER FORGET THIS LINE--------------------
        super.onEnterPoint(self, point_id)

        if point_id == 11 and chest_11 == false then
            self:removeGameObject(chest_11_go)
            chest_11 = true
            self:getGiftBagReward(8)
        end
    end,

    onUpdate = function(self, dt)
        if boss then
            boss:update(dt)
        end
    end,

    --fps mode fire
    fpsFire = function(self)
        game_state_level:fpsFire()
        --log.info('level script')
    end,
}