local log = logger.get("Game", "LevelScript 1006")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")


-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用

local fire_1 = true             --whether enemy burn village entity id 80
local fire_2 = true             --entity 85
local fire_3 = true             --entity 86
local fire_array_1 = {}         --fires in first village    
local npc = nil                 -- captain Luke game object
local phase_1_dialog = true     --whether to play phase1 dialog

local militia_1 = nil           --militias to be saved
local militia_2 = nil
local militia_3 = nil
local militia = {false,false,false}     --militia is saved status

local ship = nil                --ship block
local ship_check = false
local boom1, boom2, boom3 = nil
--第一个阶段，击败放火的敌人，获得营救指挥官的任务
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                self.level_script:wait(0.5)
                
                for i = 1, 40 do
                    fire_array_1[i] = self.level_script:createGameObject(self.level_script.prefabs.fire, -147.1 + math.random(-50,50), 0, -599.4 + math.random(-20,20), 0, 1)
                end

                npc = self.level_script:createGameObject(self.level_script.prefabs.churchill, -197.3, 0, -594.1, -41.7, 2,
                    function(go)
                        go:setHeadIcon("Assets/Prefab/Level/Texture/exclamation.png")
                    end)

                while fire_1 == true do
                    self.level_script:entityShootBullet(80,10006,Vector3.New(-197.7,0,-552.6),10)
                    self.level_script:wait(4)
                end
            end
        )
    end,

    onEnterPoint = function(self, point_id)
        app:startCoroutine(
            function()
                if point_id == 3 and phase_1_dialog == true then   --走到npc队长那里
                    
                    local dialog274 = function()
                        app:startCoroutine(
                            function()
                                self.level_script:getGiftBagReward(12)
                                self.level_script:wait(2)

                                for i = 1, 40 do
                                    temp = fire_array_1[i]
                                    temp_pos = fire_array_1[i].transform.position
                                    self.level_script:removeGameObject(fire_array_1[i])
                                    fire_array_1[i] = self.level_script:createGameObject(self.level_script.prefabs.op_effect, temp_pos.x, temp_pos.y, temp_pos.z, 0, 1)
                                end

                                self.level_script:wait(1)
                                for i = 1, 40 do
                                    self.level_script:removeGameObject(fire_array_1[i])
                                end
                                phase_1_dialog = false
                                level_script:changePhase('phase_2')
                            end
                        )
                    end

                    local dialog275 = function()
                    end

                    local choice272 = function(var)
                        choice = var
                        if choice == 1 then
                            --help npc
                            self.level_script:playDialog(274, dialog274)
                            --supply -2
                        elseif choice == 2 then
                            --ignore npc
                            self.level_script:playDialog(275, dialog275)
                        end
                    end

                    local dialog272 = function()
                        self.level_script:showDialogOption('level_script_110',{'level_script_111', 'level_script_112'}, choice272)
                    end
                    
                    local dialog268 = function()
                        app:startCoroutine(
                            function()
                                npc:setHeadIcon(nil)
                                self.level_script:incQuestProgress(13,1)
                                self.level_script:wait(2)
                                self.level_script:playDialog(272, dialog272)
                            end
                        )
                    end

                    self.level_script:playDialog(268, dialog268)
                end
            end
        )
    end,

    onBattleWin = function(self, id)
        if id == 85 then    --第一个怪
            fire_1 = false
        end
    end,

}


--开始救人到救完三个指挥官
local phase_2 = class{
    super = phase_base,

    onEnter = function(self)

        local militia_3CB = function()
            --Quaternion.Euler表示旋转后的结果，Quaternion.AngleAxis (45, new Vector3 (1, 1, 1))表示按照某根轴旋转指定角度，其中的Vector3是向量不是坐标
            militia_3.transform.rotation = Quaternion.Euler(-0.235, 130.934, -30.899)
            --level_script:changePhase('phase_3')
        end

        militia_1 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -416.8, 0, -548.3, 52.824, 2)
        militia_2 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -589.6, 0, -325.4, 78.73901, 2)
        militia_3 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -500.4374, -6.8, -138.0167, 0, 2, militia_3CB)

        --[[while fire_2 == true do
            self.level_script:entityShootBullet(85,10006,Vector3.New(-395.3,0,-519.2),10)
            self.level_script:wait(4)
        end

        while fire_3 == true do
            self.level_script:entityShootBullet(86,10006,Vector3.New(-543,0,-315.7),10)
            self.level_script:wait(4)
        end]]
    end,

    onEnterPoint = function(self, id)

        militia_3.transform.rotation = Quaternion.Euler(-0.235, 130.934, -30.899)

        if id == 11 and militia[1] == false then
            militia[1] = true
            self.level_script:removeGameObject(militia_1)
            self.level_script:playDialog(276)
            self.level_script:incQuestProgress(14,1)
        elseif id == 12 and militia[2] == false then
            militia[2] = true
            self.level_script:removeGameObject(militia_2)
            self.level_script:playDialog(280)
            self.level_script:incQuestProgress(14,1)
        elseif id == 16 and militia[3] == false then
            

            local choice285 = function(var)
                app:startCoroutine(
                    function()
                        choice = var
                        if choice == 1 then
                            hint:setText('挖掘过程中有几把铲子损坏了')
                            --铲子-1
                            self.level_script:wait(1)
                            militia_3.transform.rotation = Quaternion.Euler(0, 130.934, 0)
                            militia_3.transform.position = Vector3.New(-500.4374, 0, -138.0167)
                        elseif choice == 2 then
                            hint:setText('指挥官们徒手刨了几个小时弄得浑身是伤')
                            network_sender:levelChangeHeroProp(-0.1, 0)
                            self.level_script:wait(1)
                            militia_3.transform.rotation = Quaternion.Euler(0, 130.934, 0)
                            militia_3.transform.position = Vector3.New(-500.4374, 0, -138.0167)
                        end
                        militia[3] = true
                        self.level_script:incQuestProgress(14,1)
                    end
                )
            end

            local dialog285 = function()
                self.level_script:showDialogOption('level_script_113', {'level_script_114', 'level_script_115'},choice285)
            end

            self.level_script:playDialog(285, dialog285)
            
        elseif id == 7 and ship_check == false then
            self.level_script:playDialog(283)
            ship_check = true
        end
    end,

    onBattleWin = function(self, id)
        if id == 85 then
            fire_2 = false
        elseif id == 86 then
            fire_3 = false
        end
    end,

    onUpdate = function(self, dt)
        if militia[1] == true and militia[2] == true and militia[3] == true then
            level_script:changePhase('phase_3')
        end
    end,
}

local phase_3 = class {
    super = phase_base,

    onEnter = function(self)
        app:startCoroutine(
            function()
                
                local dialog291 = function()
                    app:startCoroutine(
                        function()
                            self.level_script:wait(1)
                            self.level_script:cameraFocusToTransform(ship.transform, true)
                            self.level_script:breakPlayerInput()
                            local m1 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -546.7, 0, -380, 0, 2)
                            local m1_des = Vector3.New(-546.7, 0, -293.2)
                            local m2 = self.level_script:createGameObject(self.level_script.prefabs.churchill, -421.5, 0, -368.3, -25.476, 2)
                            local m2_des = Vector3.New(-476.6, 0, -264.1)
                            
                            militia_3:rotateTo(ship.transform, 180)
                            self.level_script:wait(0.5)
                            local militiaMoveCB = function()
                                app:startCoroutine(
                                    function()
                                        for i = 1, 8 do
                                            self.level_script:playAnimation(militia_3,'attack')
                                            self.level_script:playAnimation(m1,'attack')
                                            self.level_script:playAnimation(m2,'attack')
            
                                            local pos = Vector3.New(-506.8 + math.random(-10, 10), math.random(5, 15), -185.2 + math.random(-10, 10))
                                            self.level_script:shootBullet(10010, militia_3:findChild('shoot'), pos,300)
            
                                            pos = Vector3.New(-552 + math.random(-15, 15), math.random(0, 9), -219.9 + math.random(-10, 10))
                                            self.level_script:shootBullet(10010, m1:findChild('shoot'), pos,300)
                                            
                                            pos = Vector3.New(-533 + math.random(-15, 15), math.random(0, 9), -205.3 + math.random(-10, 10))
                                            self.level_script:shootBullet(10010, m2:findChild('shoot'), pos,300)
            
                                            self.level_script:wait(math.random(0.5))
                                        end
                                        
                                        self.level_script:wait(0.3)

                                        for i = 1, 3 do
                                            boom_1 = self.level_script:createGameObject(self.level_script.prefabs.boom, -553.7, 26.23, -227.1)
                                            self.level_script:wait(0.3)
                                            boom_2 = self.level_script:createGameObject(self.level_script.prefabs.boom, -535.2, 4.7, -203.7)
                                            self.level_script:wait(0.3)
                                            boom_3 = self.level_script:createGameObject(self.level_script.prefabs.boom, -510.3, 17.7, -192.4)
                                            self.level_script:wait(0.3)
                                        end

                                        self.level_script:gameObjectMoveTo(ship, Vector3.New(-533.1, -70.7, -204), 30)
                                        self.level_script:setPathPointType(7,0)
                                        
                                        self.level_script:removeGameObject(boom_1)
                                        self.level_script:removeGameObject(boom_2)
                                        self.level_script:removeGameObject(boom_3)
                                        
                                        self.level_script:resumePlayerInput()
                                        self.level_script:cameraFocusToPlayer()
                                        self.level_script:removeGameObject(militia_3)
                                        self.level_script:removeGameObject(m1)
                                        self.level_script:removeGameObject(m2)
                                        level_script:changePhase('phase_4')
                                    end
                                )
                            end
            
                            self.level_script:gameObjectMoveTo(m1, m1_des, 45)
                            self.level_script:gameObjectMoveTo(m2, m2_des, 45, militiaMoveCB)
                        end
                    )
                end
                self.level_script:playDialog(291, dialog291)
                
            end
        )
    end,
}

local phase_4 = class{
    super = phase_base,

    onEnter = function(self)
    end,

    onBattleWin = function(self, id)
        if id == 87 then
            local dialog287 = function()
                app:startCoroutine(
                    function()
                        self.level_script:incQuestProgress(15,1)
                        self.level_script:wait(0.5)
                        self.level_script:finishLevel(true)
                    end
                )
            end
            self.level_script:playDialog(287, dialog287)
        end
    end,
}
-- 关卡 1006 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)

        self.prefabs = {
            churchill = 'Assets/Prefab/Level/level_prefab_kv2.prefab',     --丘吉尔坦克，解救英雄时用到
            boom = 'Assets/Arts/fx/prefab/skill10010_hit.prefab',       --爆炸特效
            camp_trigger = 'Assets/Prefab/Level/OperationTrigger.prefab',    --帐篷触发
            op_effect = 'Assets/Arts/fx/prefab_changjing/Level_effect_whitesmoke.prefab',       --搜索帐篷特效
            repair_kit = 'Assets/Arts/fx8/1/prefab_guanqia/Resource_Battery.prefab',   --修复桥梁的物品
            progess_text = 'Assets/Prefab/Level/Level_progress_text.prefab',    --进度条文字
            boss_spider = 'Assets/Prefab/Vehicle/Prefab_Boss_Spider.prefab',    --蜘蛛boss
            fire_dummy = 'Assets/Prefab/Level/level_dummy_fire.prefab',     --invisible dummy used to set fire
            fire = 'Assets/Prefab/Level/level_fire.prefab',
            ship_block = 'Assets/Prefab/Level/level_ship.prefab',
            boom = 'Assets/Prefab/Level/level_boom.prefab',
        }

        -- 预加载
        app:startCoroutine( function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)


        self:addPhases("phase_1", phase_1(self))
        self:addPhases("phase_2", phase_2(self))
        self:addPhases("phase_3", phase_3(self))
        self:addPhases("phase_4", phase_4(self))
        self:changePhase("phase_1")

        local shipCreated = function()
        end
        ship = self:createGameObject(self.prefabs.ship_block, -533.1, -4.4, -204, -254.376, 186.7716, shipCreated)
    end,
}