local log = logger.get("Game", "LevelScript 3001")
local super = require('level.level_script.level_script_base')
local phase_base = require("level.level_script.level_phase_base")


-----------注意----------
--阶段phase是class，也就是类，而不同于之前的函数类型
--phase中的onEnter,onExit以及自己定义的函数都是类的内容，也就是table的key，所以不能在这些前面增加local 字段
--自定义函数前不能增加local
--可以在onEnter中定义额外函数并能使用local，调用类中全局函数前要使用self.调用，onEnter内部定义函数直接使用函数名调用

local stone1_hp, stone2_hp, stone3_hp = 5

local point_1 = Vector3.New(-453, 0, 32)
local point_2 = Vector3.New(-453, 0, -85)
local point_3 = Vector3.New(-453, 0, -185)
local point_4 = Vector3.New(-453, 0, -285)
local point_5 = Vector3.New(-453, 0, -385)
local point_6 = Vector3.New(-453, 0, -485)

local enemy_1, enemy_2, enemy_3, enemy_4, enemy_5, enemy_6 = nil

local enemy_prefab = {  'Assets/Prefab/Level/FPS Prefab/level_fps_beetle.prefab',
                        'Assets/Prefab/Level/FPS Prefab/level_fps_bike.prefab',
                        'Assets/Prefab/Level/FPS Prefab/level_fps_hovervan.prefab',
                        'Assets/Prefab/Level/FPS Prefab/level_fps_jeep.prefab',
                        'Assets/Prefab/Level/FPS Prefab/level_fps_samurai.prefab',
                        'Assets/Prefab/Level/FPS Prefab/level_fps_tank.prefab',}

local points_arr = {point_1, point_2, point_3, point_4, point_5, point_6}
local enemy_go = {enemy_1, enemy_2, enemy_3, enemy_4, enemy_5, enemy_6}
local array_len = 6

local tag_arr = {'level_fps_beetle', 'level_fps_bike', 'level_fps_hovervan', 'level_fps_jeep', 'level_fps_samurai', 'level_fps_tank'}
local phase_1 = class{
    super = phase_base,

    onEnter = function(self)
        local pos = self.level_script.level.player:getPosition()
        pos.y = 13.29
        local rot = Quaternion.LookRotation(self.level_script.level.player.transform.position - pos, Vector3.up)
        -- self.level_script:breakPlayerInput()
        -- self:playerKeepMoving()
        game_state_level:setFPSMode(true, pos, rot, true, self.level_script.level.player.cs_inst.transform, function(hit_rst)
            if hit_rst then
                log.info('call hit enemy')
                self:hitEnemy(hit_rst)
            else
                log.info('not enter')
            end
        end)

        local fps_cam = game_state_level.level_manager.FPSCamera

        local enemyCreated = function()
            app:startCoroutine(
                function()
                    for i = 1, array_len do
                        local des_pos = Vector3.Lerp(self.level_script.level.player:getPosition(), points_arr[i], 0.2)
                        enemy_go[i]:moveTo(des_pos, 15)
                        enemy_go[i]:rotateTo(self.level_script.level.player.transform, 180)
                    end
                end
            )
        end

        for i = 1, array_len do
            if i == array_len then
                enemy_go[i] = self.level_script:createGameObject(enemy_prefab[i], points_arr[i].x, 0, points_arr[i].z, -90, 1, enemyCreated)
            else
                enemy_go[i] = self.level_script:createGameObject(enemy_prefab[i], points_arr[i].x, 0, points_arr[i].z, -90, 1)
            end
        end


    end,

    onEnterPoint = function(self, point_id)

    end,

    onBattleWin = function(self, id)
    end,

    onExit = function(self)
        --self.level_script:resumePlayerInput()
    end,

    hitEnemy = function(self, hit_rst)
        if not hit_rst.collider then
            return
        end

        local go = hit_rst.collider.gameObject
        log.error('HHHH tag name is '..go.tag)
        if go.tag == 'level_spider' then
            log.error('hit spider')
        else
            log.error('hit other')
        end
    end,

    onUpdate = function(self, dt)
        if not self.time_dt then
            self.time_dt = 1.0
        end

        self.time_dt = self.time_dt + dt
        --log.error('update')
        if self.time_dt >= 1 then
            -- if stone1 == nil then
            --     local pos = self:randomPos()
            --     stone1 = self.level_script:createGameObject(self.level_script.prefabs.stone, pos.x, 0, pos.z, 0, 1)
            --     log.error('re stone1')
            -- elseif stone2 == nil then
            --     local pos = self:randomPos()
            --     stone2 = self.level_script:createGameObject(self.level_script.prefabs.stone2, pos.x, 0, pos.z, 0, 1)
            --     log.error('re stone2')
            -- elseif stone3 == nil then
            --     local pos = self:randomPos()
            --     stone3 = self.level_script:createGameObject(self.level_script.prefabs.stone3, pos.x, 0, pos.z, 0, 1)
            --     log.error('re stone3')
            -- end
            for i = 1, array_len do
                if not enemy_go[i] then
                    enemy_go[i] = self.level_script:createGameObject(enemy_prefab[i], points_arr[i].x, 0, points_arr[i].z, -90, 1)
                    --log.error('create new go, x = '..points_arr[i].x..' y = '..points_arr[i].z)
                else
                    local des_pos = Vector3.Lerp(self.level_script.level.player:getPosition(), points_arr[i], 0.2)
                    enemy_go[i]:moveTo(des_pos, 15)
                    enemy_go[i]:rotateTo(self.level_script.level.player.transform, 180)
                end
            end
            self.time_dt = 0
        end
    end,

    randomPos = function(self)
        math.randomseed(Time.time * 1000)
        local x = math.random(-791, 172)
        local z = math.random(-680, 264)
        local pos = Vector3.New(x, 0, z)
        return pos
    end,

    playerKeepMoving = function(self)
        local playerMoveFinished = function()
            app:startCoroutine(
                function()
                    coroutine.yield(nil)
                    self:playerKeepMoving()
                end
            )
        end
        self.level_script:playerMoveTo(self:randomPos(), 100, playerMoveFinished)
    end,

    enemyMoveToPlayer = function(self)
    end,
}



-- 关卡 3003 对应的脚本
return class{
    super = super,

    -- 初始化
    init = function(self)
        self.prefabs = {
            boss = 'Assets/Prefab/Level/level_prefab_kv2.prefab',     --丘吉尔坦克，解救英雄时用到
            ship01 = 'Assets/Prefab/Level/Chapter3_2/ship01.prefab',
            ship02 = 'Assets/Prefab/Level/Chapter3_2/ship02.prefab',
            stone = 'Assets/Prefab/Level/Chapter3_2/RockB.prefab',
            stone2 = 'Assets/Prefab/Level/Chapter3_2/RockB2.prefab',
            stone3 = 'Assets/Prefab/Level/Chapter3_2/RockB3.prefab',
            boom = 'Assets/Arts/fx/prefab/skill10010_hit.prefab',       --爆炸特效
        }

        -- 预加载
        app:startCoroutine( function() 
            for k, path in pairs(self.prefabs) do
                self.pool:wait_prepare(path, 1)
            end
        end)

        self:addPhases("phase_1", phase_1(self))

        self:changePhase("phase_1")
    end,

    onEnterPoint = function(self, point_id)
        super.onEnterPoint(self)
    end,

    -- 战斗胜利
    onBattleWin = function(self, id)
        super.onBattleWin(self, id)
    end,

    onBattleLose = function(self, id)
        super.onBattleLose(self, id)
    end,

    --fps mode fire
    fpsFire = function(self)
        game_state_level:fpsFire()
        --log.info('level script')
    end,
}
