local log = logger.get("Game", "LevelScript")

-- 一个简单 phase 的例子
local phase_base = class{
    
    ctor = function(self, level_script)
        self.level_script = level_script
    end,

    onEnter = function(self)
    end,

    onUpdate = function(self, dt)
    end,

    onEnterTrigger = function(self, trigger_name)
    end,

    onExitTrigger = function(self, trigger_name)
    end,

    onEnterPoint = function(self, point_id)
    end,

    -- 一场战斗胜利   
    onBattleWin = function(self, index)     --index为entity的索引编号
    end,

    -- 一场战斗失败
    onBattleLose = function(self, index)
    end,

    onExit = function(self)
    end,

    onUseShovel = function(self, point_id)
    end,
}

return phase_base