local log = logger.get("Game", "Achievement Go callback")
require('guide/guide_helper')
require('guide/guide_manager')
--[[
//个人基地对象类型
enum EPersonBaseObjType
{
  EPERSON_BASE_NONE = 0;//none
  EPERSON_BASE_OFFICER = 1;//指挥官
  EPERSON_BASE_STUDIO = 2;//研究所
  EPERSON_BASE_BUILDING = 3;//建筑
  EPERSON_BASE_TRAIN = 4;//训练室
  EPERSON_BASE_STORE = 5;//仓库
  EPERSON_BASE_PARK = 6;//停车场
  EPERSON_BASE_ENTRANCE = 7;//关卡入口
  EPERSON_BASE_DECORATE = 8;//装饰物
  EPERSON_BASE_BLOCK = 9;//障碍物
  EPERSON_BASE_REPAIR_FACTORY = 10;//修理厂
  EPERSON_BASE_ARMORY	= 11;
  EPERSON_BASE_SHOP		= 12;
  EPERSON_BASE_MINE_FIELD = 13;	//产矿建筑
  EPERSON_BASE_CELL		= 16;//牢房
}]]

return {
    go_callback = {
        [0] = function()
        
        end,

        --******************************************************************************
        --******************************************************************************
        --×××××××××××××××***********************************×脱离苦海********************
        --******************************************************************************
        --******************************************************************************
        --------------------------------没劲的分割线------------------------------------------
        --chapter 1 
        [1] = function()    --建造1级突击兵营
            log.info("## go1")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(18)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 18)              --open grid_18 build frame
                end
            )
        end,

        [2] = function()    --训练20个1级突击兵
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    --coroutine.yield(WaitForSeconds(0.1))
                    guide_manager:_doGuide(10005)
                end
            )
        end,

        [3] = function()    --消灭1级荒野盗匪
            log.info("## go3")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10006) then
                        guide_manager:_doGuide(10006)
                    else
                        hint:setText(frame_helper:getLangCfg('guide_25'))
                    end
                end
            )
        end,

        [4] = function()    --进行一次抽卡
            log.info("## go4")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(16)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_tavern')
                    guide_helper:waitForFrame('home_tavern')
                    guide_helper:showWeakButtonGuide('home_tavern', 'content/info/rightOnceBtn')
                end
            )
        end,
--------------------------------------------------Chapter 2--------------------------------------------------------------------
        [5] = function()    --升级2级主基地
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10002) then
                        guide_manager:_doGuide(10002)
                    end
                end
            )
        end,
        
        [6] = function()    --建造1级医务室
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10015) then
                        guide_manager:_doGuide(10015)
                    end
                end
            )
        end,

        [7] = function()    --建造1级研究所
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(12)     --focus to grid 
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 12)              --open grid_18 build frame
                end
            )
        end,

        [8] = function()    --建造研究一个科技
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10008) then
                        guide_manager:_doGuide(10008)
                    end
                end
            )
        end,

        [9] = function()    --消灭2级荒野盗匪
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10016) then
                        guide_manager:_doGuide(10016)
                    else
                        hint:setText(frame_helper:getLangCfg('guide_25'))
                    end
                end
            )
        end,
-------------------------------------------------Chapter 3--------------------------------------------------------------------
        [10] = function()    --建造1级兵工厂
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(15)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 15)              --open grid_18 build frame
                end
            )
        end,

        [11] = function()    --生产一个战车武器
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10009) then
                        guide_manager:_doGuide(10009)
                    end
                end
            )
        end,

        [12] = function()    --建造1级火箭兵训练所
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(20)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 20)              --open grid_18 build frame
                end
            )
        end,

        [13] = function()    --建造1级火箭兵训练所
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(17)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 17)              --open grid_18 build frame
                end
            )
        end,

        [14] = function()    --消灭3级荒野盗匪
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10017) then
                        guide_manager:_doGuide(10017)
                    else
                        hint:setText(frame_helper:getLangCfg('guide_25'))
                    end
                end
            )
        end,
-------------------------------------------------Chapter 4--------------------------------------------------------------------
        [15] = function()    --升级3级主基地
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(4) 
                        game_state_home.home_map:onClickEntity(4)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [16] = function()    --建造1级掷弹兵
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(19)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 19)              --open grid_18 build frame
                end
            )
        end,

        [17] = function()    --训练20个1级掷弹兵
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(19) 
                    game_state_home.home_map:onClickEntity(19)
                    guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_20")
                    guide_helper:disableScreenMask()
                    guide_helper:guideFinished()
                end
            )
        end,

        [18] = function()    --攻打资源船
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10007) then
                        chapter_manager:initChapterResShip()
                        guide_manager:_doGuide(10007)
                    end
                end
            )
        end,

        [19] = function()    --解锁资源船
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10012) then
                        guide_manager:_doGuide(10012)
                    end
                end
            )
        end,
-------------------------------------------------Chapter 5--------------------------------------------------------------------
        [20] = function()    --建造1级交易所
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(8)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 8)              --open grid_18 build frame
                end
            )
        end,

        [21] = function()    --建造1级农场
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(27)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 27)              --open grid_18 build frame
                end
            )
        end,

        [22] = function()    --建造1级炼钢厂
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(24)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 24)              --open grid_18 build frame
                end
            )
        end,

        [23] = function()    --建造1级钛矿
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(25)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 25)              --open grid_18 build frame
                end
            )
        end,

        [24] = function()    --建造1级电池
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(29)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 29)              --open grid_18 build frame
                end
            )
        end,

        [25] = function()    --进行一次资源采集
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10010) then
                        guide_manager:_doGuide(10010)
                    end
                end
            )
        end,
-------------------------------------------------Chapter 6-----------------------------------------------------------------
        [26] = function()    --升级4级主基地
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(4) 
                        game_state_home.home_map:onClickEntity(4)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [27] = function()    --研究科技
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10019) then
                        guide_manager:_doGuide(10019)
                    end
                end
            )
        end,

        [28] = function()    --进攻一次军团怪
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10020) then
                        guide_manager:_doGuide(10020)
                    else
                        hint:setText(frame_helper:getLangCfg('guide_25'))
                    end
                end
            )
        end,

        [29] = function()    --建造1级船员训练室
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    local entity_obj = guide_helper:cameraFocusToHomeEntity(10)     --focus to grid 18
                    coroutine.yield(WaitForSeconds(0.5))
                    frame_manager:show('home_entity_create', self, 10)              --open grid_18 build frame
                end
            )
        end,

        [30] = function()    --训练一名船员
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    if not guide_manager:isGuideComplete(10021) then
                        guide_manager:_doGuide(10021)
                    end
                end
            )
        end,

---------------------------------------------Chapter 7-------------------------------------------------------------
        [31] = function()    --升级5级主基地
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(4) 
                        game_state_home.home_map:onClickEntity(4)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [32] = function()    --升级3级突击兵训练所
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(18) 
                        game_state_home.home_map:onClickEntity(18)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [33] = function()    --升级3级狙击兵
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(17) 
                        game_state_home.home_map:onClickEntity(17)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [34] = function()    --升级3级火箭兵
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(20) 
                        game_state_home.home_map:onClickEntity(20)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [35] = function()    --消灭2号资源船敌军
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    hint:setText('Capture enemy vessel like before')
                    -- if not guide_manager:isGuideComplete(10022) then
                    --     log.error('1')
                    --     chapter_manager:initChapterResShip()
                    --     log.error('2')
                    --     guide_manager:_doGuide(10022)
                    --     log.error('3')
                    -- end
                end
            )
        end,

        [36] = function()    --解锁2号资源船
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    hint:setText('Capture enemy vessel like before')
                end
            )
        end,

 -------------------------------------------Chapter 8---------------------------------------------------------     
        [37] = function()    --升级6级主基地
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(4) 
                        game_state_home.home_map:onClickEntity(4)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [38] = function()    --升级4级医院
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    
                    local entity = home_info:getUpgradingEntity()
                    if not entity then
                        local entity_obj = guide_helper:cameraFocusToHomeEntity(13) 
                        game_state_home.home_map:onClickEntity(13)
                        guide_helper:waitForceHomeEntityButtonGuide(entity_obj, "content/layout/operator_2")
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                    elseif home_info:isBuildInFreeTime(entity.id) then
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    else
                        hint:setText(frame_helper:getLangCfg('guide_35'))
                        guide_helper:disableScreenMask()
                        guide_helper:guideFinished()
                        return
                    end
                end
            )
        end,

        [39] = function()    --拥有1个10级指挥官
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    guide_helper:waitForceButtonGuide("home", "new/buttomLeft/bg/layout/carBtn")
                    --coroutine.yield(WaitForSeconds(1))
                    coroutine.yield(guide_helper:waitForFrame('hero_list'))
                    coroutine.yield(WaitForSeconds(0.5))
                    guide_helper:disableScreenMask()
                    guide_helper:showWeakButtonGuide("hero_list", "BG/Scroll View/Viewport/Content/Hero_30")
                    
                    --log.error('1')
                    coroutine.yield(guide_helper:waitForFrame('officer'))
                    --log.error('2')
                    guide_helper:showWeakButtonGuide("officer", "BG/Content/Right/Top/FillBG/Plus")
                    guide_helper:showWeakButtonGuide("officer", "BG/UseExp/BG/Scroll View/Viewport/Content/Panel/Buttons/Use")
                    
                    guide_helper:guideFinished()
                end
            )
        end,

        [40] = function()    --拥有1个2星指挥官
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:enableScreenMask()
                    guide_helper:waitForceButtonGuide("home", "new/buttomLeft/bg/layout/carBtn")
                    --coroutine.yield(WaitForSeconds(1))
                    coroutine.yield(guide_helper:waitForFrame('hero_list'))
                    coroutine.yield(WaitForSeconds(0.5))
                    guide_helper:disableScreenMask()
                    guide_helper:showWeakButtonGuide("hero_list", "BG/Scroll View/Viewport/Content/Hero_41")
                    
                    --log.error('1')
                    coroutine.yield(guide_helper:waitForFrame('officer'))
                    --log.error('2')
                    guide_helper:showWeakButtonGuide("officer", "BG/Content/Right/Center/FillBG/StarupBG/StarupBtn")
                    guide_helper:guideFinished()
                end
            )
        end,

        [41] = function()    --消灭1级黑巢
            log.info("## go5")
            app:startCoroutine(
                function()
                    frame_manager:hide('chapter_achievement')
                    guide_helper:waitForceButtonGuide("home", "new/buttomLeft/bg/homeBtn")

                    -- 等待 worldMap 界面加载
                    guide_helper:waitForFrame('worldMap')
                    
                    -- 搜索按钮
                    guide_helper:waitForceButtonGuide("worldMap", "new/buttomRight/SearchBtn")

                    -- 等搜索界面改版
                    -- 搜索界面开启
                    guide_helper:waitForFrame('world_map_search')
                end
            )
        end,
    },
}