local log = logger.get("Game", "Dialogue Manager")
require("systems.dialog_sys.dialog_helper")

local dialog_manager_cls = class{
    ctor = function(self)
        self.scenario_cfg = {}
    end,

    init = function(self)
        if not self.is_inited then
            self.is_inited = true
            self.scenario_cfg = dialog_helper:getScenarioCfg()
        end
    end,

    play = function(self, scenario_id, callback)
        log.error("dialog_manager:play 被废弃，改用 playScenario!")
        --[[
        local scenario = self.scenario_cfg[scenario_id]
        if not scenario then
            log.error("Failed to find dialog scenario:"..tostring(id))
            return
        end
        frame_manager:show("dialog", nil, {scenario=scenario, callback=callback})]]
    end,

    playScenario = function(self, scenario_id, callback)
        local scenario = self.scenario_cfg[scenario_id]
        if not scenario then
            log.error("Failed to find dialog scenario:"..tostring(id))
            return
        end
        frame_manager:show("dialog", nil, {scenario=scenario, callback=callback})
    end,

}

dialog_manager = dialog_manager_cls()

return dialog_manager