local log = logger.get("Game", "fame manager")
local fame_cls = require('systems.fame_sys.fame')

-- 声望管理
local fame_manager_cls = class{
    ctor = function(self)
        self.fames = {}
    end,

    --[[
    message MFameInfo
    {
        required REPUTATION_TYPE type  = 1;  //声望类型
        required uint32 level  		   = 2;  //等级
        required uint32 curExp         = 3;  //经验
        optional uint32 nextLvExp      = 4;  //下一级升级所需经验
    }]]
    -- 刷新声望
    refresh = function(self, fame_list)
        for _,fame_info in ipairs(fame_list) do
            self:setFame(fame_info.type, fame_info.level, fame_info.curExp, fame_info.nextLvExp or 100)
        end
    end,

    -- 设置声望
    setFame = function(self, group_id, level, exp, max_exp)
        self.fames[group_id] = fame_cls(group_id, level, exp, max_exp)
    end,

    -- 获取声望
    getFame = function(self, group_id)
        if self.fames[group_id] then
            return self.fames[group_id]
        else
            -- 测试用数据
            return fame_cls(group_id, 99, 50, 10000)
        end
    end,
}

fame_manager = fame_manager_cls()
return fame_manager