local log = logger.get("Game", "Formation Helper")

-- 阵型辅助函数
return {
    -- 自动布阵 heros-英雄列表 整数数组，包括正式英雄和杂鱼英雄
    autoFormation = function(self, heros, formation_id, is_story)
        log.info("#### autoFormation, heros:"..#heros..", formation_id:"..formation_id)

        local formation_result = {}    -- 布阵结果，长度为 16 的数组
        local formation_cfg = config.formation_lists[formation_id].list
        formation_cfg = loadstring("return "..formation_cfg)()

        local hero_list = {}    -- 取得所有英雄实例
        for _,hero_id in ipairs(heros) do
            local hero = nil
            if not is_story then
                hero = hero_manager:getHero(hero_id)
            else
                hero = story_hero_manager:getHero(hero_id)
            end
   
            if not hero then
                log.error("## failed to find hero:"..hero_id)
            else
                table.insert(hero_list, hero)
                log.info("## add hero:"..hero.id)
            end
        end

        -- 从英雄配置列表中找到所需类型英雄并且设置到阵型中
        local findHeroAndAssign = function(form_idx)
            local tank_type = formation_cfg[form_idx] -- 所需战车类型

            if tank_type then
                local hero_idx, hero = self:findHero(hero_list, "type"..tank_type)
                if hero_idx then
                    --log.info("### find hero:"..hero.id)
                    table.insert(formation_result, {heroId = hero.id, location = form_idx})
                    table.remove(hero_list, hero_idx)
                    return true
                end
            end
            return false
        end

        -- 遍历阵型的的中间两列，优先放置真的英雄
        for row=1,4 do
            local form_idx = (row-1) * 4 + 2
            findHeroAndAssign(form_idx)

            form_idx = form_idx + 1
            findHeroAndAssign(form_idx)
        end

        -- 遍历阵型的两侧
        for row=1,4 do
            local form_idx = (row-1) * 4 + 1
            findHeroAndAssign(form_idx)

            form_idx = form_idx + 3
            findHeroAndAssign(form_idx)
        end

        return formation_result
    end,

    -- 从 hero_cfgs 中找对应类型的英雄。优先找 is_hero == 1 的
    findHero = function(self, hero_list, type)
        -- 优先找 is_hero == 1
        for idx, hero in ipairs(hero_list) do
            if hero.tank_cfg.type == type and hero.tank_cfg.is_hero == 1 then -- todo: 这里用 hero 上的标记会比较好
                return idx, hero
            end
        end

        for idx,hero in ipairs(hero_list) do
            if hero.tank_cfg.type == type then
                return idx, hero
            end
        end

        return nil
    end,
}