local log = logger.get("Game", "Shop")
local shop_item_cls = require('systems.shop_sys.shop_item')

return class{
    ctor = function(self, id, currency_item_ids)
        self.id = id
        self.currency_item_ids = currency_item_ids  -- 消耗品 id
        self.items = {} -- 以数组方式保存的商品列表
    end,

    -- 刷新商品列表
    refresh = function(self, shop_item_list, currency_item_ids)
        self.currency_item_ids = currency_item_ids

        self.items = {}
        for index, item_info in ipairs(shop_item_list) do

            log.info("### shop refresh item:"..item_info.itemId)
            self.items[index] = shop_item_cls(item_info)
        end
    end,

    -- 打印商店信息
    print = function()
        local str = ""
        for index, item in ipairs(self.items) do
            str = str..item:toString().."\n"
        end

        log.info(str)

        for _,currency in ipairs(self.currency_item_ids) do
            log.info("currency:"..tostring(currency))
        end
    end,
}