-- 商店中的一个商品

return class{
    --[[商店道具信息
    
    //奖励信息
    message RewardItem
    {
        required uint32  ItemTemId           = 1;       //物品模板编号
        required uint32  Count               = 2;       //个数
    }

    message MShopItemInfo
    {
        required uint32  itemId             = 1;       //物品id
        required uint32  count              = 2;       //获得物品的个数
        required uint32  index              = 3;       //索引
        required RewardItem  cost		   = 4;       //花费
        required uint32  isCanBuy           = 5;       //是否可购买0，不可购买，1可购买      
        optional uint32  discount           = 6;		  //打折信息
    }]]
    ctor = function(self, shop_item_info)

        self.index = shop_item_info.index               -- 商品在商店中的顺序号
        self.cfg_id = shop_item_info.itemId             -- 商品在道具表中的 id
        self.cfg = item_helper:getItemCfg(self.cfg_id)  -- 道具配置
        self.count = shop_item_info.count               -- 获得的道具数量
        self.cost_item_id = shop_item_info.cost.ItemTemId -- 货币道具类型
        self.cost = shop_item_info.cost.Count             -- 货币数量
        self.can_buy = shop_item_info.isCanBuy          -- 是否开放购买
        self.discount = shop_item_info.discount         -- 折扣
    end,

    toString = function(self)
        local str = ""
        for k,v in pairs(self) do
            if type(v) == "number" then
                str = str..tostring(k)..':'..v..", "
            end
        end
        return str
    end,
}