local shop_cls = require('systems.shop_sys.shop')

-- 商店管理器
local shop_manager_cls = class{
    ctor = function(self)
        self.shops = {} -- 所有商店
        self.events = require('base.event').new()
    end,

    -- 刷新一个商店
    refreshShop = function(self, shop_id, shop_item_list, currency_item_ids)
        if not self.shops[shop_id] then
            self.shops[shop_id] = shop_cls(shop_id, currency_item_ids)
        end
        self.shops[shop_id]:refresh(shop_item_list, currency_item_ids)

        self.events:dispatch("onShopRefreshed", shop_id)
    end,

    -- 获取一个商店
    getShop = function(self, shop_id)
        return self.shops[shop_id]
    end,
}

shop_manager = shop_manager_cls()

return shop_manager