local Object = UnityEngine.Object
local Scheduler = require "base.scheduler"
local Connection = require "base.connection"
local logger = require "base.logger"
local locale = require "base.locale"
local Frame = require "ui.frame"

-- Slua.ToString(native_bytes) as lua_lstring
-- Slua.ToBytes(lua_lstring) as native_bytes

if Fenix.Game.Agent then 
	local SAgent = class {
		__create = function (self)
			return Fenix.Game.Agent()
		end,

		Set = function (self, key, value)
			logger("lua.sagent.set", key, value)
			self.__base:Set(key, value)
		end,
	}

	local agent = SAgent.new()

	agent:Set(10, 20)
	agent:Add(10, 4)
	logger("get prop in lua", agent:Get(10))
end

local function TryLoadGUI()
	print("try load gui")
	local frame = Frame.CreateFrame {
		template = "ui.test_frame", 
		parent = "/GUI/Canvas", 
		name = "测试界面1", 
		asset = "Assets/Data/UI/frame.prefab",
		OnLoad = function (self)
			print("OnLoad ... ", self.name)
		end, 
	}
end

return function ()
	local app = Fenix.App.GetInstance()
	local sch = Scheduler.new(app.gameObject) 
	local net = Connection.new(app.gameObject) 

	--print("try __tostring", agent)
	logger("hello, updater 2016.3")
	
	locale:foreach(function (lang)
		if Fenix.App.GetStringProvider():AddLanguage(lang) then
			logger.locale("add language", lang) 
		end
	end)
	TryLoadGUI()
	net:Connect(SERVER_IP, 20127)
    logger.sys("on data loaded, begin connect")
	logger.net("发起网络连接")

	net.OnConnected = function (self)
		local echo = Fenix.pb.Echo()
		echo.str = "test消息测试"
		echo.data = Slua.ToBytes("test")
		echo.f32 = 123.456

		logger.net("net connected", echo.str)
		self:Send(echo)
	end

	net.OnMessage = function (self, msg)
		logger.net.recv("got net message", msg.message_id, msg.str, msg.f32)
	end

    logger("try scheduler")
	-- local timer1, timer2
	-- timer1 = sch:CreateTimer(1, 3, function ()
	-- 	logger("timer1.actived")
	-- 	if timer1.repeated == 2 then 
	-- 		timer2.enabled = false
	-- 	end
	-- end)
	-- timer2 = sch:CreateTimer(0.5, 5, function ()
	-- 	logger("timer2.actived")
	-- end)

	Fenix.Assets.Helper.Instantiate("Assets/Data/Sample/GameObject.prefab", function (go)
		go.name = "camera test"
	end)
	
	Fenix.Assets.Helper.Instantiate("Assets/Data/Sample/Sphere.prefab", function (go)
		go.name = "sphere test"
	end)
	
	local loader = app.gameObject:AddComponent(Fenix.Assets.AssetLoader)

	loader:LoadAsync("Assets/Data/Sample/Sphere.prefab", function (self)
		local prefab = self.asset:Get()
		local instance = Object.Instantiate(prefab)

		instance.name = "Sphere test 2"
		sch:CreateTimer(3, 1, function ()
			Object.Destroy(instance)
			Object.Destroy(loader)
		end)
	end)
end
