local class = require "base.class"
local super = require "ui.frame"
local console = (require "base.logger").module("ui").category("test")
local Time = UnityEngine.Time

return class {
    typename = "测试界面",
    super = super,

    ctor = function (self, parent, name)
        super.ctor(self, parent, name)
    end, 

    OnLoad = function (self, inst)
        super.OnLoad(self, inst)

        if self._error then
            return 
        end
        self:setScript("click", "TestButton", self.OnClick_Test)
        self:setScript("click", "ExitButton", self.OnClick_Exit)
        self:setScript("click", "HahaButton", self.OnClick_Haha)
        self:setScript("updown", "Image", self.OnUpDown_Image)
        self:setScript("hover", "Image", self.OnHover_Image)

        app:startCoroutine(function ()
            console.log("my lua coroutine ... ", Time.time, Time.frameCount)
            coroutine.yield()
            -- console.log("my lua coroutine ... ", Time.time, Time.frameCount)
            -- coroutine.yield(UnityEngine.WaitForSeconds(5))
            -- console.log("my lua coroutine ... ", Time.time, Time.frameCount)
            -- coroutine.yield()
            -- console.log("my lua coroutine ... ", Time.time, Time.frameCount)
            -- coroutine.yield(UnityEngine.WaitForSeconds(math.random(3, 6)))
            -- console.log("my lua coroutine ... ", Time.time, Time.frameCount)
            -- coroutine.yield()
            -- console.log("my lua coroutine ... ", Time.time, Time.frameCount)
        end)
    end, 

    -- 语言发生变化时自动回调 
    OnLocalizationChanged = function (self, provider)
        console.log("language changed", provider.language)
    end, 

    OnHover_Image = function (self, sender, evt, phase)
        console.log("test image hover", sender, phase)

        local btn = self:FindButton("TestButton")
        btn.count = btn.count and btn.count + 1 or 1
        btn.text = "Hover." .. phase .. btn.count
    end,

    OnUpDown_Image = function (self, sender, evt, phase)
        console.log("test image updown", sender, phase)

        local btn = self:FindButton("TestButton")
        btn.count = btn.count and btn.count + 1 or 1
        btn.text = "Pointer." .. phase .. btn.count
    end,

    OnClick_Haha = function (self, sender)
        local btn = self:FindButton("TestButton")
        btn.count = btn.count and btn.count + 1 or 1
        btn.text = "fjfjfj-2018." .. btn.count
    end, 

    OnClick_Exit = function (self, sender)
        UnityEngine.Application.Quit()
    end, 

    OnClick_Test = function (self, sender)
        local provider = Fenix.App.GetStringProvider()
        provider.language = provider.language == "zhCN" and "enUS" or "zhCN"

        if self.image_tick then 
            local img = self:SetSprite("Image", "Assets/Data/Icon/Spell/test_a.png")
            img:SetAnimatorEnabled(false)
            -- img:Stop()
            self.image_tick = false
        else
            local img = self:SetSprite("Image", "Assets/Data/Icon/Spell/test_b.png")
            img:SetAnimatorEnabled(true)
            -- img:Play("image_move")
            self.image_tick = true
        end
    end, 

    -- OnEnable = function (self)
    --     console.log("test frame enabled")
    -- end, 

    -- OnDisable = function (self)
    --     console.log("test frame disabled")
    -- end, 
}