local ip = "192.168.0.119"
local port = 6226
require "protocol_pb"

local tcp = class {
    super = require("base.tcp"), 

    onInit = function (self, args)
        self.map = {
            -- 协议类型映射
            [protocol_pb.HELLOWORLD] = protocol_pb.SCHelloWorld, 
        }
    end, 

    createInstance = function (self, cmd)
        local pb = self.map and self.map[cmd]
        return pb and pb()
    end, 
}.new()

tcp:on("close", function (refused)
    if refused then 
        print("无法连接服务器")
    else
        print("连接关闭")
    end
end)

tcp:on("connect", function ()
    print("连接成功")
    startcoroutine(function ()
        while true do 
            coroutine.yield(WaitForSeconds(2))
            
            local msg = protocol_pb.CSHelloWorld()

            msg.int_test = 99
            local pos = msg.pos_test
            pos.x, pos.y, pos.z = 12, 34, 56
            msg.string_test = "hello, 你好"
            tcp:send(protocol_pb.HELLOWORLD, msg)
        end
    end)
end)

tcp:on("message", function (cmd, msg)
    print("收到协议", cmd, msg)
    if cmd == protocol_pb.HELLOWORLD then 
        print(msg.int_test, msg.pos_test.x, msg.pos_test.y, msg.pos_test.z, msg.string_test)
    end
end)

tcp:connect(ip, port)

return tcp

