
local t_base = class {}
local t = class {
    typename = "my-tester", 
    super = t_base, 

    foo = function (self, a, b)
        print(a, b)
    end, 

    __features = {
        debug.deprecated("foo", "use foo_v2 instead."), 

        debug.testable {
            run = function (self)
                --print("test run")
            end, 

            fail = function (self)
                error("something wrong")
            end, 

            fail2 = function (self)
                print(1 .. nil)
            end, 

            fail3 = function (self)
                assert(false, "assert failed")
            end, 

            check = function (self)
                assert(self:isSubClassOf(t_base), "isSubClassOf?")
                assert(self.class:isClass(), "isClass?")
                assert(not self:isClass(), "() isClass?")
                assert(not self.class:isClassInstance(), "isClassInstance?")
                assert(self:isClassInstance(), "() isClassInstance?")
            end, 
        }, 
    }, 
}

debug.runtests(t) -- 如果指定了具体类, 那么执行该类的测试, 否则执行所有已经注册的类的测试
t():foo(1, 2)
