local log = logger.get("Game", "UnitTest")
local trace = require('debug.trace')

return 
{
    check = function(self)

        local callback = function(go)
            local tank = go:GetComponent('Tank')

           -- trace.trace('tank', tank)

            log.info('!!Search on CS')
            print(debug.log, debug.profile, logger.get_level())

            -- fast
            debug.profile('Search on CS', function()
                local c
                for i=0,10000,1 do
                    c = self:searchOnCS(go, tank)
                end
            
            end)
            
            -- slow
            debug.profile('Search on Lua', function()
                local c
                for i=0, 10000, 1 do
                    self:searchOnLua(go, tank)
                end
            end)

        end

        local root = app.gameObject.transform
        app:startCoroutine(
            function()
                coroutine.yield(WaitForInstantiate('Assets/Arts/test/Prefab/kv.prefab', root, callback))
            end)

    end,    -- check


    searchOnCS = function(self, go, tank)
        local c = tank:FindChild('shoot')
        return c
    end,

    searchOnLua = function(self, go, tank)

        local c = self:_DoFindChild(go.transform, 'shoot')
        return c
    end,

    _DoFindChild = function(self, t, name)
        if t.name == name then
            return t
        else
            for i=0,t.childCount-1,1 do
                local found = self:_DoFindChild(t:GetChild(i), name)
                if found then
                    return found
                end
            end
        end

        return nil
    end,

}