local log = logger.get("Game", "Mine Hold")
local super = require('world_map.base_hold')

-- 玩家据点
return class
{
    super = super,

    ctor = function(self, pos, hold_info, events, root)
        self.info = hold_info
        self.id = hold_info.resHoldId
        self.coordX = hold_info.posX
        self.coordY = hold_info.posY
        self.events = events
        self.type = hold_types.mine
        self.root = root
        self.pos = pos

        self.cfg_id = hold_info.resCfgId
        self.cfg = config.worldmap_resources[self.cfg_id] or {}

        self.main_res = item_helper:getItemCfg(self.cfg.item)
        self.name_id = self.cfg.nameid
        super.ctor(self, self.id, self.cfg_id, self.coordX, self.coordY)

        --self:init(pos, root)
    end,

    init = function(self, pos, root)
        local prefab_path = self.cfg.modelid
        local uobject = game_director.pool:instantiate(prefab_path)
        self.inited = true

        local callback = function (go)
            -- callback
            if go ~= nil then
                if not game_director:isWorldMapState() then
                    go:SetActive(false)
                    return
                end
                self.gameObject = go
                self.gameObject.name = 'mine_hold_' .. self.id
                self:initUI(pos, root)
                self:setNameText()
                --[[self.transform = self.gameObject.transform
                self.transform.parent = root.transform
                self.transform.position = pos
                self.info_ui = self.transform:Find("info") or self.transform:GetChild(0):Find("info")
                self.operate = self.transform:Find("operate") or self.transform:GetChild(0):Find("operate")
                self:enabledInfo(false)]]
                --go.parent = self.transform
                self.cs_inst = self:addWorldMapActorMono(go, prefab_path)
                if self.cs_inst then
                    self.cs_inst.id = tostring(self.id)
                    self.is_initialized = true
                    --[[self.cs_inst.isMine = true;
                    self.cs_inst.isPlayerHold = false;
                    self.cs_inst.isVehicle = false;
                    self.cs_inst.isMonster = false;
                    self.cs_inst.isGuild = false;
                    self.cs_inst.isMineField = false;]]
                    self.cs_inst:setType(hold_types.mine)
                end
                self.events:dispatch("mine_hold_loaded", self)
            else
                log.error('loadResource go is nil')
            end
        end

        if uobject.isLoaded then 
            callback(uobject)
        else 
            uobject.onLoaded = callback
        end

    end,

}