local log = logger.get("Game", "Monster Hold")
local super = require('world_map.base_hold')

-- 怪物据点
return class
{
    super = super,

    ctor = function(self, pos, monster_info, events, root)
        self.info = monster_info
        self.id = monster_info.objinfo.instid
        self.coordX = monster_info.objinfo.posx
        self.coordY = monster_info.objinfo.posy
        self.events = events
        self.type = hold_types.monster
        self.root = root
        self.pos = pos

        self.cfg_id = monster_info.objinfo.cfgid
        self.cfg = config.worldmap_monsters[self.cfg_id]
        
        if self.cfg then
            self.name_id = self.cfg.monstername
        else
            log.error("########## monster hold cfg error ! id", monster_info.objinfo.cfgid)
        end
        
        super.ctor(self, self.id, self.cfg_id, self.coordX, self.coordY)

        self.anim_name = "idle"

        --self:init(pos, root)
    end,

    onQuery = function(self, info)
        self.info = info
    end,

    init = function(self, pos, root)
        local prefab_path = self.cfg.monstermodel
        local uobject = game_director.pool:instantiate(prefab_path)
        self.inited = true
        self.is_loading = true

        local callback = function (go)
            -- callback
            if go ~= nil then
                if not game_director:isWorldMapState() then
                    go:SetActive(false)
                    return
                end
                self.gameObject = go
                self.gameObject.name = 'monster_hold_' .. self.id
                self:initUI(pos, root)
                self:setNameText()
                self.cs_inst = self:addWorldMapActorMono(go, prefab_path)
                if self.cs_inst then
                    self.cs_inst.id = tostring(self.id)
                    self.is_initialized = true
                    self.cs_inst:setType(hold_types.monster)
                    self.cs_inst:PlayAnimation(self.anim_name)
                end
                self.is_loading = false
            else
                log.error('loadResource go is nil')
            end
        end

        if uobject.isLoaded then 
            callback(uobject)
        else 
            uobject.onLoaded = callback
        end

    end,

    destroy = function(self)
        super.destroy(self)
    end,
}