local super = require('world_map.base_hold')

return class {
    super = super,

    ctor = function(self, id, cfg_id, cfg_type, pos, events, root)
        self.id = id
        self.cfg_id = cfg_id
        self.cfg_type = cfg_type
        self.pos = pos
        self.events = events
        self.type = hold_types.temp
        self.root = root
        self.pos = pos
        self.cfg = config.union_union_buildings[self.cfg_id] or {}
        
        self:init(pos, root)
    end,

    init = function(self, pos, root)
        local prefab_path = self.cfg.Prefab
        local uobject = game_director.pool:instantiate(prefab_path)

        local callback = function (go)
            -- callback
            if go ~= nil then
                if not game_director:isWorldMapState() then
                    go:SetActive(false)
                    return
                end
                self.gameObject = go
                self.gameObject.name = 'temp_hold_' .. self.id
                self:initUI(pos, root)
                self.cs_inst = self:addWorldMapActorMono(go, prefab_path)
                --frame_helper:setChildLayer(go.transform, 'Temp')
                if self.cs_inst then
                    self.cs_inst.id = tostring(self.id)
                    self.is_initialized = true
                    self.cs_inst:setType(hold_types.temp)

                    self.cs_inst:SetColor(Color(1,1,1,0.5))
                    --self.cs_inst:SetRenderQueue(3010)
                end

                self.events:dispatch("guild_temp_hold_loaded", self)
            else
                log.error('loadResource go is nil')
            end
        end

        if uobject.isLoaded then 
            callback(uobject)
        else 
            uobject.onLoaded = callback
        end

    end,

    destroy = function(self)
        if self.gameObject then
           self.gameObject:destroy()
        end
    end,

    setPos = function(self, pos)
        self.transform.position = pos
    end,

    setValid = function(self, is_valid)
        if is_valid then
            self.cs_inst:SetColor(Color(1,1,1,0.5))
        else
            self.cs_inst:SetColor(Color(1,0,0,0.5))
        end
    end,

    getOperators = function(self)
        print("获取操作功能")
        local cancel = {
            icon_name = "Assets/Arts/ui/atlas/icon/home/Building_button_5_normal.png",
            click_callback = function()
                print("取消")
                self.events:dispatch('destroy_hold', self)
            end,
        }
        local confirm = {
            icon_name = "Assets/Arts/ui/atlas/icon/home/Building_button_10_normal.png",
            click_callback = function()
                print("确定")
                self.events:dispatch('create_hold', self)
            end,
        }

        return {cancel, confirm}
    end,

    -- hideOperator = function(self)
    --     print("隐藏操作界面")
    -- end,
}