local log = logger.get("Game", "Titanium Hold")
local super = require('world_map.base_hold')

-- 玩家据点
return class
{
    super = super,

    ctor = function(self, pos, hold_info, events, root)
        self.info = hold_info
        self.id = hold_info.objinfo.instid
        self.coordX = hold_info.objinfo.posx
        self.coordY = hold_info.objinfo.posy
        self.events = events
        self.type = hold_types.titanMine
        self.root = root
        self.pos = pos

        self.cfg_id = hold_info.objinfo.cfgid
        self.cfg = config.worldmap_titaniums[self.cfg_id] or {}

        self.main_res = item_helper:getItemCfg(self.cfg.item)
        self.name_id = self.cfg.nameid

        self:setName()
        super.ctor(self, self.id, self.cfg_id, self.coordX, self.coordY)

        --self:init(pos, root)
    end,

    setName = function(self)
        if string.len(self.info.playerId) == 0 then
            self.name = frame_helper:getLangCfg(self.name_id)
            self.is_holding = false
        else
            self.name = self.info.playerName
            if string.len(self.info.familyShortName) > 2 then
                self.name = string.format( "[%s]%s", self.info.familyShortName, self.name )
            end

            self.is_holding = true
        end
    end,

    refresh = function(self, info)
        self.info = info
        self:setName()
        self:setNameText()
        super.refresh(self)
    end,

    setQueryInfo = function(self, info)
        self.info = info
    end,

    init = function(self, pos, root)
        local prefab_path = self.cfg.modelid
        local uobject = game_director.pool:instantiate(prefab_path)
        self.inited = true

        local callback = function (go)
            -- callback
            if go ~= nil then
                if not game_director:isWorldMapState() then
                    go:SetActive(false)
                    return
                end
                self.gameObject = go
                self.gameObject.name = 'titanium_hold_' .. self.id
                self:initUI(pos, root)
                self:setNameText()
                self.cs_inst = self:addWorldMapActorMono(go, prefab_path)
                if self.cs_inst then
                    self.cs_inst.id = tostring(self.id)
                    self.is_initialized = true
                    
                    self.cs_inst:setType(hold_types.titanMine)
                end
                --self.events:dispatch("mine_hold_loaded", self)
            else
                log.error('loadResource go is nil')
            end
        end

        if uobject.isLoaded then 
            callback(uobject)
        else 
            uobject.onLoaded = callback
        end

    end,

}